





#include "rtl8305s.h"
#include "rtl8305sc.h"
#include "assert.h"

#define RTL8305SC_ASIC_DRIVER


int32 rtl8305sc_setAsicVlanEnable(int8 enabled) {
	rtl8305s_smiWriteBit(0, 18, 8, enabled==FALSE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicVlanEnable(int8 *enabled) {
	uint8 bitValue;
	
	rtl8305s_smiReadBit(0, 18, 8, &bitValue);
	*enabled = bitValue == 0? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicVlanTagAware(int8 enabled) {
	rtl8305s_smiWriteBit(0, 16, 10, enabled==FALSE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicVlanTagAware(int8 *enabled) {
	uint8 bitValue;
	
	rtl8305s_smiReadBit(0, 16, 10, &bitValue);
	*enabled = bitValue == 0? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicVlanIngressFilter(int8 enabled) {
	rtl8305s_smiWriteBit(0, 16, 9, enabled==FALSE?1:0);
	return SUCCESS;
}

int32 rtl8305sc_getAsicVlanIngressFilter(int8 *enabled) {
	uint8 bitValue;
	
	rtl8305s_smiReadBit(0, 16, 9, &bitValue);
	*enabled = bitValue == 0? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicVlanTaggedOnly(int8 enabled) {
	rtl8305s_smiWriteBit(0, 16, 8, enabled==FALSE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicVlanTaggedOnly(int8 *enabled) {
	uint8 bitValue;
	
	rtl8305s_smiReadBit(0, 16, 8, &bitValue);
	*enabled = bitValue == 0? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicVlanPriorityThreshold(uint16 highPriorityThreshold) {
	uint16 value;

	rtl8305s_smiRead(4, 21, &value);
	value = (value & 0x1FFF) | ((highPriorityThreshold<<13)&0xE000);
	rtl8305s_smiWrite(4, 21, value);
	return SUCCESS;
}


int32 rtl8305sc_getAsicVlanPriorityThreshold(uint16 * highPriorityThreshold) {
	
	rtl8305s_smiRead(4, 21, highPriorityThreshold);
	*highPriorityThreshold = (*highPriorityThreshold >> 13)&0x7;

	return SUCCESS;
}


int32 rtl8305sc_setAsicVlan(uint16 vlanIndex, uint16 vid, uint16 memberPortMask) {
	uint16 regValue;

	switch(vlanIndex) {
		case 0:
		rtl8305s_smiRead(0, 25, &regValue);
		regValue = (regValue & 0xF000) | (vid & 0xFFF);
		rtl8305s_smiWrite(0, 25, regValue);
		rtl8305s_smiRead(0, 24, &regValue);
		regValue = (regValue & 0xFFE0) | (memberPortMask & 0x1F);
		rtl8305s_smiWrite(0, 24, regValue);
		break;
		case 1:
		rtl8305s_smiRead(1, 25, &regValue);
		regValue = (regValue & 0xF000) | (vid & 0xFFF);
		rtl8305s_smiWrite(1, 25, regValue);
		rtl8305s_smiRead(1, 24, &regValue);
		regValue = (regValue & 0xFFE0) | (memberPortMask & 0x1F);
		rtl8305s_smiWrite(1, 24, regValue);
		break;
		case 2:
		rtl8305s_smiRead(2, 25, &regValue);
		regValue = (regValue & 0xF000) | (vid & 0xFFF);
		rtl8305s_smiWrite(2, 25, regValue);
		rtl8305s_smiRead(2, 24, &regValue);
		regValue = (regValue & 0xFFE0) | (memberPortMask & 0x1F);
		rtl8305s_smiWrite(2, 24, regValue);
		break;
		case 3:
		rtl8305s_smiRead(3, 25, &regValue);
		regValue = (regValue & 0xF000) | (vid & 0xFFF);
		rtl8305s_smiWrite(3, 25, regValue);
		rtl8305s_smiRead(3, 24, &regValue);
		regValue = (regValue & 0xFFE0) | (memberPortMask & 0x1F);
		rtl8305s_smiWrite(3, 24, regValue);
		break;
		case 4:
		rtl8305s_smiRead(4, 25, &regValue);
		regValue = (regValue & 0xF000) | (vid & 0xFFF);
		rtl8305s_smiWrite(4, 25, regValue);
		rtl8305s_smiRead(4, 24, &regValue);
		regValue = (regValue & 0xFFE0) | (memberPortMask & 0x1F);
		rtl8305s_smiWrite(4, 24, regValue);
		break;
		case 5:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(0, 27, vid);
		rtl8305s_smiWrite(0, 26, memberPortMask);
		break;
		case 6:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(1, 27, vid);
		rtl8305s_smiWrite(1, 26, memberPortMask);
		break;
		case 7:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(2, 27, vid);
		rtl8305s_smiWrite(2, 26, memberPortMask);
		break;
		case 8:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(3, 27, vid);
		rtl8305s_smiWrite(3, 26, memberPortMask);
		break;
		case 9:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(4, 27, vid);
		rtl8305s_smiWrite(4, 26, memberPortMask);
		break;
		case 10:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(0, 29, vid);
		rtl8305s_smiWrite(0, 28, memberPortMask);
		break;
		case 11:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(1, 29, vid);
		rtl8305s_smiWrite(1, 28, memberPortMask);
		break;
		case 12:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(2, 29, vid);
		rtl8305s_smiWrite(2, 28, memberPortMask);
		break;
		case 13:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(3, 29, vid);
		rtl8305s_smiWrite(3, 28, memberPortMask);
		break;
		case 14:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(4, 29, vid);
		rtl8305s_smiWrite(4, 28, memberPortMask);
		break;
		case 15:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiWrite(0, 31, vid);
		rtl8305s_smiWrite(0, 30, memberPortMask);
		break;
		default:
			return FAILED;
	}
	return SUCCESS;
}


int32 rtl8305sc_getAsicVlan(uint16 vlanIndex, uint16 *vid, uint16 *memberPortMask) {

	if(vid == NULL || memberPortMask == NULL)
		return FAILED;
	switch(vlanIndex) {
		case 0:
		rtl8305s_smiRead(0, 25, vid);
		rtl8305s_smiRead(0, 24, memberPortMask);
		break;
		case 1:
		rtl8305s_smiRead(1, 25, vid);
		rtl8305s_smiRead(1, 24, memberPortMask);
		break;
		case 2:
		rtl8305s_smiRead(2, 25, vid);
		rtl8305s_smiRead(2, 24, memberPortMask);
		break;
		case 3:
		rtl8305s_smiRead(3, 25, vid);
		rtl8305s_smiRead(3, 24, memberPortMask);
		break;
		case 4:
		rtl8305s_smiRead(4, 25, vid);
		rtl8305s_smiRead(4, 24, memberPortMask);
		break;
		case 5:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(0, 27, vid);
		rtl8305s_smiRead(0, 26, memberPortMask);
		break;
		case 6:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(1, 27, vid);
		rtl8305s_smiRead(1, 26, memberPortMask);
		break;
		case 7:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(2, 27, vid);
		rtl8305s_smiRead(2, 26, memberPortMask);
		break;
		case 8:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(3, 27, vid);
		rtl8305s_smiRead(3, 26, memberPortMask);
		break;
		case 9:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(4, 27, vid);
		rtl8305s_smiRead(4, 26, memberPortMask);
		break;
		case 10:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(0, 29, vid);
		rtl8305s_smiRead(0, 28, memberPortMask);
		break;
		case 11:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(1, 29, vid);
		rtl8305s_smiRead(1, 28, memberPortMask);
		break;
		case 12:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(2, 29, vid);
		rtl8305s_smiRead(2, 28, memberPortMask);
		break;
		case 13:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(3, 29, vid);
		rtl8305s_smiRead(3, 28, memberPortMask);
		break;
		case 14:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(4, 29, vid);
		rtl8305s_smiRead(4, 28, memberPortMask);
		break;
		case 15:
		rtl8305s_smiWriteBit(0, 16, 15, 1); 
		rtl8305s_smiRead(0, 31, vid);
		rtl8305s_smiRead(0, 30, memberPortMask);
		break;
		default:
			return FAILED;
	}
	*vid = *vid & 0xFFF;
	*memberPortMask = *memberPortMask & 0x1F;
	return SUCCESS;
}


int32 rtl8305sc_setAsicPortVlanIndex(uint16 port, uint16 vlanIndex) {
	uint16 regValue;

	if(port>=RTL8305S_PORT_NUMBER)
		return FAILED;
	rtl8305s_smiRead(port, 24, &regValue);
	regValue = (regValue & 0xFFF) | (vlanIndex<<12);
	rtl8305s_smiWrite(port, 24, regValue);
	return SUCCESS;
}


int32 rtl8305sc_getAsicPortVlanIndex(uint16 port, uint16 *vlanIndex) {
	if(port>=RTL8305S_PORT_NUMBER || vlanIndex == NULL)
		return FAILED;
	rtl8305s_smiRead(port, 24, vlanIndex);
	*vlanIndex = (*vlanIndex>>12)&0xF;
	return SUCCESS;
}



int32 rtl8305sc_getAsicMacAddressTableEntry(uint16 index, int8 * macAddress, uint16 *age, int8 * isStatic, uint16 * port, int8 * isValid) {
	uint16 value;
	uint32 idleCounter;

	if(macAddress == NULL || age == NULL || isStatic == NULL || port == NULL || isValid == NULL)
		return FAILED;
	rtl8305s_smiWriteBit(0, 16, 13, 1);
	rtl8305s_smiWrite(4, 18, (index&0xFF)<<8 | ((index>>8)&0x3)); 
	rtl8305s_smiWrite(4, 16, 0x3); 
	idleCounter = 0;
	do {
		rtl8305s_smiRead(4, 16, &value);
		idleCounter++;
	}while((value &0x2) && idleCounter < RTL8305S_IDLE_TIMEOUT);
	if(idleCounter == RTL8305S_IDLE_TIMEOUT)
		return FAILED;
	rtl8305s_smiRead(4, 17, &value);
	*port = value & 0xF;
	switch((value>>4)&0x3) {
		case 0: *age = 0; break;
		case 1: *age = 100; break;
		case 2: *age = 300; break;
		case 3: *age = 200; break;
	}
	*isStatic = value&0x40?TRUE:FALSE;
	*isValid =value&0x70?TRUE:FALSE;
	rtl8305s_smiRead(4, 18, &value);
	macAddress[4] = (int8)value&0xFF;
	macAddress[5] = (value>>8)&0xFF;
	rtl8305s_smiRead(4, 19, &value);
	macAddress[2] = (int8)value&0xFF;
	macAddress[3] = (value>>8)&0xFF;
	rtl8305s_smiRead(4, 20, &value);
	macAddress[0] = (int8)value&0xFF;
	macAddress[1] = (value>>8)&0xFF;
	
	rtl8305s_smiWriteBit(0, 16, 13, 0);
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicMacAddressTableEntry(int8 * macAddress, uint16 age, int8 isStatic, uint16 port) {
	uint16 value;
	uint32 idleCounter;

	if(macAddress == NULL)
		return FAILED;
	rtl8305s_smiWriteBit(0, 16, 13, 1);
	value = port & 0xF;
	if(age>200)
		value |= 0x20;
	else if(age>100)
		value |= 0x30;
	else if(age>0)
		value |= 0x10;
	if(isStatic == TRUE) 
		value |= 0x40;
	rtl8305s_smiWrite(4, 17, value);
	rtl8305s_smiWrite(4, 18, macAddress[5]<<8 | macAddress[4]);
	rtl8305s_smiWrite(4, 19, macAddress[3]<<8 | macAddress[2]);
	rtl8305s_smiWrite(4, 20, macAddress[1]<<8 | macAddress[0]);
	rtl8305s_smiWrite(4, 16, 0x2); 
	idleCounter=0;
	do {
		rtl8305s_smiRead(4, 16, &value);
		idleCounter++;
	}while((value &0x2)&& idleCounter<RTL8305S_IDLE_TIMEOUT);
	if(idleCounter == RTL8305S_IDLE_TIMEOUT)
		return FAILED;
	
	rtl8305s_smiWriteBit(0, 16, 13, 0);
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicLoopDetection(int8 enabled) {
	rtl8305s_smiWriteBit(0, 16, 2, enabled==TRUE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicLoopDetection(int8 *enabled) {
	uint8 bitValue;

	if(enabled == NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 16, 2, &bitValue);
	*enabled = bitValue == 1? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_asicSoftReset(void) {
	rtl8305s_smiWriteBit(0, 16, 12, 1);
	return SUCCESS;
}


int32 rtl8305sc_setAsicAgressiveBackoff(int8 enabled) {
	rtl8305s_smiWriteBit(0, 18, 15, enabled==TRUE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicAgressiveBackoff(int8 *enabled) {
	uint8 bitValue;

	if(enabled==NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 18, 15, &bitValue);
	*enabled = bitValue == 1? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicLongReceivedPacketLength(int8 enabled1552) {

	rtl8305s_smiWriteBit(0, 18, 14, enabled1552==TRUE?0:1);
	return SUCCESS;
}


int32 rtl8305sc_getAsicLongReceivedPacketLength(int8 *enabled1552) {
	uint8 bitValue;

	if(enabled1552==NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 18, 14, &bitValue);
	*enabled1552 = bitValue == 0? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicBroadcastInputDrop(int8 enabled) {

	rtl8305s_smiWriteBit(0, 18, 13, enabled==TRUE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicBroadcastInputDrop(int8 *enabled) {
	uint8 bitValue;

	if(enabled==NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 18, 13, &bitValue);
	*enabled = bitValue == 1? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicForward1dReservedAddress(int8 enabled) {

	rtl8305s_smiWriteBit(0, 18, 12, enabled==TRUE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicForward1dReservedAddress(int8 *enabled) {
	uint8 bitValue;

	if(enabled==NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 18, 12, &bitValue);
	*enabled = bitValue == 1? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicLeakyVlan(int8 enabled) {

	rtl8305s_smiWriteBit(0, 18, 11, enabled==FALSE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicLeakyVlan(int8 *enabled) {
	uint8 bitValue;

	if(enabled==NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 18, 11, &bitValue);
	*enabled = bitValue == 0? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_setAsicBroadcastStormControl(int8 enabled) {

	rtl8305s_smiWriteBit(0, 18, 2, enabled==FALSE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicBroadcastStormControl(int8 *enabled) {
	uint8 bitValue;

	if(enabled==NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 18, 2, &bitValue);
	*enabled = bitValue == 0? TRUE: FALSE;

	return SUCCESS;
}


int32 rtl8305sc_setAsicArpVlan(int8 enabled) {

	rtl8305s_smiWriteBit(0, 18, 10, enabled==FALSE?1:0);
	return SUCCESS;
}


int32 rtl8305sc_getAsicArpVlan(int8 *enabled) {
	uint8 bitValue;

	if(enabled==NULL)
		return FAILED;
	rtl8305s_smiReadBit(0, 18, 10, &bitValue);
	*enabled = bitValue == 0? TRUE: FALSE;
		
	return SUCCESS;
}


int32 rtl8305sc_asicRealtekCableTester(uint16 port, int8 isTxDir, uint32 * cableStatus, uint32 * length) {
	uint32 idleCounter;
	uint16 value;
	
	if(port >= RTL8305S_PORT_NUMBER || cableStatus == NULL || length == NULL)
		return FAILED;

	rtl8305s_smiWrite(3, 31, 0x0000);
	rtl8305s_smiWrite(3, 30, 0x07FA);
	rtl8305s_smiWrite(3, 29, 0xFC29);
	rtl8305s_smiWrite(3, 28, 0x7AB5);
	rtl8305s_smiWrite(3, 27, 0xA458);
	
	rtl8305s_smiWriteBit(0, 16, 11, 1);
	rtl8305s_smiWrite(0, 28, 0x300 | (port & 0x7));
	rtl8305s_smiWrite(4, 27, 0);
	rtl8305s_smiWrite(4, 27, isTxDir==TRUE?0x1000: 0x9000);
	idleCounter = 0;
	do {
		rtl8305s_smiRead(4, 27, &value);
		idleCounter++;
	}while(!(value&0x800) && idleCounter<RTL8305S_IDLE_TIMEOUT);
	if(idleCounter == RTL8305S_IDLE_TIMEOUT)
		return FAILED;
	if(value & 0x400)
		*cableStatus = RTL8305SC_RTCT_SHORT;
	else if (value & 0x200)
		*cableStatus = RTL8305SC_RTCT_OPEN;
	else
		*cableStatus = RTL8305SC_RTCT_NORMAL;
	*length = value & 0x1FF;
	
	rtl8305s_smiWriteBit(0, 16, 11, 1);
	return SUCCESS;
}

#define RTL8305SC_TABLE_DRIVER

