
#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvFwd.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_battlenet.h"


#define MAX_SC_CLIENT 8
static uint32 clientIpList[MAX_SC_CLIENT]={0};

void  rtl8651_l4AliasHandleBattlenetReInit(void)
{
	int i;
	for(i=0;i<MAX_SC_CLIENT;i++) clientIpList[i]=0;
}


int32 rtl8651_l4AliasHandleBattlenetClientInbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
		if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_BATTLENET)==0) return SUCCESS;

		if(pip->ip_p==IPPROTO_TCP)
		{
			struct tcphdr *th = NULL;
			uint8 *data;
			uint32   hlen, tlen, dlen;
	
			th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
			hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
			tlen = ntohs(pip->ip_len);
			dlen = tlen - hlen;	
			data = (uint8 *)(th + 1);
			if(data[0]==0xff)
			{
				if((dlen>23)&&(data[1]==0x09)) 
				{
					uint16 result_port;
					int i;
					
					
					for(i=0;i<MAX_SC_CLIENT;i++)
					{
						if(clientIpList[i]== tb->insideLocalIpAddr)  
						{
							break;
						}
						else if(clientIpList[i]==0)
						{
							clientIpList[i]= tb->insideLocalIpAddr;
							_rtl8651_removeNaptConnectionByIntIPandPort(FALSE,tb->insideLocalIpAddr,6112);
							_rtl8651_addNaptConnection(TRUE, TRUE,UDP_FLOW, tb->insideLocalIpAddr, 6112, &tb->insideGlobalIpAddr, &result_port,0,0);
							break;
						}					
					}				
				}
				
			}
		}

	return SUCCESS;
}


