

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_cs.h"

static ipaddr_t localip=0;

void rtl8651_l4AliasHandleCsReInit(void)
{
	localip=0;
}

int32 rtl8651_l4AliasHandleCSClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_CS)==0) return FWDENG_USER_DROP;

	if(localip!=tb->insideLocalIpAddr)
	{
		localip=tb->insideLocalIpAddr;
		
#ifdef _RTL_UPNP
	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 6003,
		tb->insideLocalIpAddr, 6003);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 7002,
		tb->insideLocalIpAddr, 7002);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27005,
		tb->insideLocalIpAddr, 27005);
	
	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27010,
		tb->insideLocalIpAddr, 27010);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27011,
		tb->insideLocalIpAddr, 27011);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27012,
		tb->insideLocalIpAddr, 27012);
	
	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27015,
		tb->insideLocalIpAddr, 27015);

#endif 
	}
	
	return SUCCESS;
}

