


#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"

#include "rtl8651_alg_sip.h"

#define _RTL8651_L4_MAX_SIP_ALIAS_BUF_SIZE 1520

static uint8 *_rtl8651_l4_sip_alias_buf[1];

static uint16 o_port=0,i_port=0;

int32 rtl8651_l4AliasHandleSipClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct ip *spip;
	struct udphdr *udp,*sudp;
	int32 tlen, dlen, off_set, i ,j, k;
	int32 size_delta=0;
	int8 *sptr, *newpacket,*data;

	char localip[16];
	int8	localip_len;
	char globalip[16];
	int8	globalip_len;
	char key[32];
	int8 key_len;
	int8 old_cl_len=0; 
	int8 new_cl_len=0; 

	struct rtl_mBuf *m = pkthdrPtr->ph_mbuf;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_SIP)==0) return SUCCESS;

	

	
	
	
	

		
	udp = (struct udphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = (uint8 *)(udp+1);
	
	tlen = ntohs(pip->ip_len);
	dlen = tlen-sizeof(struct udphdr)-((pip->ip_vhl &0xf) << 2);

			
	off_set = ((uint8 *)pip) - m->m_data;
	if(off_set < 0 || off_set > 40 || tb == NULL) return FAILED;


	
	newpacket =  (int8 *)_rtl8651_l4_sip_alias_buf[0];
	
	
	mBuf_copyToUserBuffer(m, off_set, m->m_pkthdr->ph_len - off_set, newpacket);

	
	spip = (struct ip*)newpacket;
	sudp = (struct udphdr *) ((int8 *) spip + ((spip->ip_vhl &0xf) << 2));
	sptr = (int8 *)(sudp+1);
	
	sprintf(localip,"%u.%u.%u.%u",(tb->insideLocalIpAddr>>24)&0xff,(tb->insideLocalIpAddr>>16)&0xff,(tb->insideLocalIpAddr>>8)&0xff,(tb->insideLocalIpAddr)&0xff);
	localip_len=strlen(localip);

	sprintf(globalip,"%u.%u.%u.%u",(tb->insideGlobalIpAddr>>24)&0xff,(tb->insideGlobalIpAddr>>16)&0xff,(tb->insideGlobalIpAddr>>8)&0xff,(tb->insideGlobalIpAddr)&0xff);
	globalip_len=strlen(globalip);	

	sprintf(key,"\r\nContent-Length: ");
	key_len=18;	
		
	for(i=0,j=0;i<dlen;i++,j++)
	{

		if(data[i]<0x20&&data[i]!=0x0d&&data[i]!=0x0a)  return SUCCESS; 

		if(i+4<=dlen)
		{
			if(memcmp(&data[i],"\r\nm=",4)==0)
			{
				int flag=0;
				i_port=0;
				for(k=i+4;k<dlen;k++)
				{
					if(data[k]==' ')
					{
						if(flag==0) flag=k;
						else
						{
							
							_rtl8651_addAlgQosUpnpMap(UPNP_PERSIST|UPNP_ALG_QOS, 0, 0, 
							tb->insideGlobalIpAddr, i_port,
							tb->insideLocalIpAddr, i_port,RTL8651_ALG_SIP_IDX);
							
							break;
						}
					}
					else if(flag!=0) i_port=(data[k]-'0')+i_port*10;
				}
			}
		}


		if((i+key_len<=dlen)&&(memcmp(&data[i],key,key_len)==0))
		{

			
			int32 datalen=0;
			char tempStr[16];
			int32 CntIpInMsgBody=0;
			
			rtl8651_memcpy(&sptr[j],key,key_len);
			j+=key_len;
			i+=key_len;
			for(k=i;((k<i+5)&&(k<dlen));k++)
			{
				if((data[k]>='0')&&(data[k]<='9'))
				{
					datalen=data[k]-'0'+datalen*10;
				}
				else  break;
			}
			old_cl_len=k-i;
			i=k-1;

			
			for(k=i+2;k<=dlen-localip_len;k++)
			{			
				if(memcmp(&data[k],localip,localip_len)==0)
				{
					CntIpInMsgBody++;
				}
			}
			
			new_cl_len=sprintf(tempStr,"%u",datalen+(CntIpInMsgBody*(globalip_len-localip_len)));
			memcpy(&sptr[j],tempStr,new_cl_len);
			j+=(new_cl_len-1);

		}	
		else if((i+localip_len<=dlen)&&(memcmp(&data[i],localip,localip_len)==0))
		{
			
			rtl8651_memcpy(&sptr[j],globalip,globalip_len);
			i+=(localip_len-1);
			j+=(globalip_len-1);
			size_delta+=(globalip_len-localip_len);				
		}
		else
		{
			sptr[j]=data[i];
		}

	}

	
	spip->ip_len = htons(ntohs(spip->ip_len)+size_delta+new_cl_len-old_cl_len);	
	sudp->uh_ulen = htons(ntohs(sudp->uh_ulen)+size_delta+new_cl_len-old_cl_len);	


	
	
	
	
	sudp->uh_sum = 0;
	spip->ip_sum = 0;				
	sudp->uh_sum = _rtl8651_tcpChecksum(spip); 
	spip->ip_sum = _rtl8651_ipChecksum(spip);	
		
	mBuf_copyToMbuf(m, off_set, ntohs(spip->ip_len), newpacket);
	
	assert(m->m_len == m->m_pkthdr->ph_len);

#ifdef _RTL_UPNP
	if(tb->insideLocalPort==5060)
	{
		
		rtl8651_addUpnpMap(UPNP_PERSIST, 0,5060, 
			tb->insideGlobalIpAddr, 5060,
			tb->insideLocalIpAddr, 5060);
		tb->insideGlobalPort=5060;	
	}
#endif 	
	

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleSipClientInbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct ip *spip;
	struct udphdr *udp,*sudp;
	int32 tlen, dlen, off_set, i ,j, k;
	int32 size_delta=0;
	int8 *sptr, *newpacket,*data;

	char localip[16];
	int8	localip_len;
	char globalip[16];
	int8	globalip_len;
	char key[32];
	int8 key_len;
	int8 old_cl_len=0; 
	int8 new_cl_len=0; 

	
	struct rtl_mBuf *m = pkthdrPtr->ph_mbuf;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_SIP)==0) return SUCCESS;

	
	
	
	
	
	

	udp = (struct udphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = (uint8 *)(udp+1);
	
	tlen = ntohs(pip->ip_len);
	dlen = tlen-sizeof(struct udphdr)-((pip->ip_vhl &0xf) << 2);

			
	off_set = ((uint8 *)pip) - m->m_data;
	if(off_set < 0 || off_set > 40 || tb == NULL)  return FAILED;


	
	newpacket =  (int8 *)_rtl8651_l4_sip_alias_buf[0];
	
	
	mBuf_copyToUserBuffer(m, off_set, m->m_pkthdr->ph_len - off_set, newpacket);

	
	spip = (struct ip*)newpacket;
	sudp = (struct udphdr *) ((int8 *) spip + ((spip->ip_vhl &0xf) << 2));
	sptr = (int8 *)(sudp+1);

	sprintf(localip,"%u.%u.%u.%u",(tb->insideLocalIpAddr>>24)&0xff,(tb->insideLocalIpAddr>>16)&0xff,(tb->insideLocalIpAddr>>8)&0xff,(tb->insideLocalIpAddr)&0xff);
	localip_len=strlen(localip);

	sprintf(globalip,"%u.%u.%u.%u",(tb->insideGlobalIpAddr>>24)&0xff,(tb->insideGlobalIpAddr>>16)&0xff,(tb->insideGlobalIpAddr>>8)&0xff,(tb->insideGlobalIpAddr)&0xff);
	globalip_len=strlen(globalip);

	sprintf(key,"\r\nContent-Length: ");
	key_len=18;	
		
	for(i=0,j=0;i<dlen;i++,j++)
	{
		if(data[i]<0x20&&data[i]!=0x0d&&data[i]!=0x0a)  return SUCCESS; 
		
	
		if(i+4<=dlen)
		{
			if(memcmp(&data[i],"\r\nm=",4)==0)
			{
				int flag=0;
				o_port=0;
				for(k=i+4;k<dlen;k++)
				{
					if(data[k]==' ')
					{
						if(flag==0) flag=k;
						else
						{							
							#ifdef _RTL_UPNP
							
							
							
							#endif 	
							
							break;
						}
					}
					else if(flag!=0) o_port=(data[k]-'0')+o_port*10;
				}
			}
		}


		if((i+key_len<=dlen)&&(memcmp(&data[i],key,key_len)==0))
		{

			
			int32 datalen=0;
			char tempStr[16];
			int32 CntIpInMsgBody=0;
			
			rtl8651_memcpy(&sptr[j],key,key_len);
			j+=key_len;
			i+=key_len;
			for(k=i;((k<i+5)&&(k<dlen));k++)
			{
				if((data[k]>='0')&&(data[k]<='9'))
				{
					datalen=data[k]-'0'+datalen*10;
				}
				else  break;
			}
			old_cl_len=k-i;
			i=k-1;

			
			for(k=i+2;k<=dlen-globalip_len;k++)
			{			
				if(memcmp(&data[k],globalip,globalip_len)==0)
				{
					CntIpInMsgBody++;
				}
			}
			
			new_cl_len=sprintf(tempStr,"%u",datalen+(CntIpInMsgBody*(localip_len-globalip_len)));
			memcpy(&sptr[j],tempStr,new_cl_len);
			j+=(new_cl_len-1);

		}		

		else if(((i+globalip_len<=dlen))&&(memcmp(&data[i],globalip,globalip_len)==0))
		{
			
			rtl8651_memcpy(&sptr[j],localip,localip_len);
			i+=(globalip_len-1);
			j+=(localip_len-1);
			size_delta+=(localip_len-globalip_len);	
				
		}
		else
		{
			sptr[j]=data[i];
		}
	}
	
	spip->ip_len = htons(ntohs(spip->ip_len)+size_delta+new_cl_len-old_cl_len);	
	sudp->uh_ulen = htons(ntohs(sudp->uh_ulen)+size_delta+new_cl_len-old_cl_len);

	
	sudp->uh_sum = 0;
	spip->ip_sum = 0;				
	sudp->uh_sum = _rtl8651_tcpChecksum(spip); 
	spip->ip_sum = _rtl8651_ipChecksum(spip);	

	mBuf_copyToMbuf(m, off_set, ntohs(spip->ip_len), newpacket);
	
	assert(m->m_len == m->m_pkthdr->ph_len);


	return SUCCESS;	
}

static int32 init_sip = 0;

void rtl8651_l4AliasSipReInit(void)
{
	o_port=0;
	i_port=0;
}

int32 rtl8651_l4AliasSipInit(void *arg){
	
	
	if(init_sip)
		return SUCCESS;

	_rtl8651_l4_sip_alias_buf[0] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_SIP_ALIAS_BUF_SIZE);
	assert(_rtl8651_l4_sip_alias_buf[0]);

	init_sip = 1;
	return SUCCESS;
}


