


#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"

#include "rtl8651_alg_tftp.h"


int32 rtl8651_l4AliasHandleTftpClientOutbound (
	struct rtl_pktHdr *pkthdrPtr,
	struct ip *pip,
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct udphdr *ud = NULL;
	struct tftpRequest *tftp = NULL;

	if ((alg_supports[pkthdrPtr->ph_dsid] & RTL8651_ALG_TFTP) == 0)
	{
		return SUCCESS;
	}

	if (	( pkthdrPtr == NULL ) ||
		( pip == NULL ) ||
		( tb == NULL ))
	{
		goto out;
	}

	
	if (	( pip->ip_p != IPPROTO_UDP ) ||
		( IS_FRAGMENT_REMAIN(pip->ip_off) ) )
	{
		
		goto out;
	}

	ud = (struct udphdr*)L4HDR_ADDR(pip);

	if ( ud->uh_dport != TFTP_UDP_DPORT )
	{
		goto out;
	}

	tftp = (struct tftpRequest *)((uint32)ud + sizeof(struct udphdr));

	switch ( ntohs(tftp->opcode) )
	{
		case TFTP_RRQ:
		case TFTP_WRQ:
			
			break;
		default:
			goto out;
	}

	
	rtl8651_addUpnpMapLeaseTime(
		UPNP_ONESHOT,				
		tb->dstIpAddr,				
		0,							
		tb->insideGlobalIpAddr,		
		tb->insideGlobalPort,			
		tb->insideLocalIpAddr,			
		tb->insideLocalPort,			
		TFTP_FLOW_CACHE_TIMEOUT	
		);
out:
	return SUCCESS;
}

