


#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "rtl_glue.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_tblDrvStatistic.h"
#include "rtl8651_tblDrv.h"
#include "rtl8651_dos.h"
#include "rtl8651_dos_local.h"


#include "rtl8651_jhash.h"

#ifdef RTL865X_TEST
#define printk	printf
#endif 
#define MAX(a,b) ((a>b)?a:b)
#define MIN(a,b) ((a>b)?b:a)


void _rtl8651_dosTurnOn(uint32 dsid, uint32 enableItem);
void _rtl8651_dosTurnOff(uint32 dsid);
void _rtl8651_dosIgnoreTypeFlush(void);
uint32 _rtl8651_dosIgnoreTypeAdd(uint32);
uint32 _rtl8651_dosIgnoreTypeDel(uint32);

static int32 _rtl8651_dosSynFlood(uint32 dsid,struct ip*,struct tcphdr *,uint32*);
static int32 _rtl8651_dosStealthFin(uint32 dsid,struct ip *,struct tcphdr *,uint32*);
static int32 _rtl8651_dosScan(struct ip*,struct tcphdr *);
static int32 _rtl8651_dosTcpLand(struct ip *,struct tcphdr *);
static int32 _rtl8651_dosSynWithData(struct ip *,struct tcphdr *);
static int32 _rtl8651_dosUdpBomb(struct ip *,struct udphdr *);
static int32 _rtl8651_dosUdpEchoChargen(struct ip *, struct udphdr *);
static int32 _rtl8651_dosUdpLand(struct ip *,struct udphdr *);
static int32 _rtl8651_dosUdpFlood(uint32 dsid,struct ip *,struct udphdr *,uint32*);
static int32 _rtl8651_dosPingOfDeath(struct ip *,struct icmp *); 
static int32 _rtl8651_dosIcmpFlood(uint32 dsid,struct ip *,struct icmp *, uint32*);
static int32 _rtl8651_dosIcmpLand(struct ip *,struct icmp *);
static int32 _rtl8651_dosSmurf(struct ip *,struct icmp *, uint16);
static int32 _rtl8651_dosIpSpoof(struct ip *, uint16, uint8);
static void _rtl8651_dosPreProcess(uint32, uint32, uint32); 
static void _rtl8651_dosSwitch(void);
static void _rtl8651_dosACLSet(void);


static int8 _tcpDosScanBitmap[64];


uint32		_rtl8651_dos_enable = FALSE;
uint32		_rtl8651_dos_sw[RTL8651_MAX_DIALSESSION] = {0};
static uint32	_rtl8651_dos_ignoreType;	

static int32 _rtl8651_local_syn_counter[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_fin_counter[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_icmp_counter[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_udp_counter[RTL8651_MAX_DIALSESSION];

static int32 _rtl8651_local_syn_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_fin_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_icmp_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_udp_threshold[RTL8651_MAX_DIALSESSION];


static int32 _rtl8651_local_tcpConn_threshold;
static int32 _rtl8651_local_udpConn_threshold;
static int32 _rtl8651_local_tcpudpConn_threshold;

#define DOS_PERSRC_PKT_TRACK_SYSTEM

typedef struct _rtl8651_dos_PktCnt_s {
	
	uint8	item;
	uint32	recordTime;
	ipaddr_t	ip;
	uint32	count;
	
	
	struct _rtl8651_dos_PktCnt_s	**hdr;
	struct _rtl8651_dos_PktCnt_s	*prev;
	struct _rtl8651_dos_PktCnt_s	*next;
	
	struct _rtl8651_dos_PktCnt_s	*lru_prev;
	struct _rtl8651_dos_PktCnt_s	*lru_next;
	
	struct _rtl8651_dos_PktCnt_s	*list_prev;
	struct _rtl8651_dos_PktCnt_s	*list_next;
} _rtl8651_dos_PktCnt_t;

static uint32	_rtl8651_SrcTracking_enable = TRUE;

#define RTL8651_DOS_HASHTBL_SIZE		32
#define RTL8651_DOS_HASH_RAND			31



static _rtl8651_dos_PktCnt_t	*synHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t	*finHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t	*udpHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t	*icmpHash[RTL8651_DOS_HASHTBL_SIZE];


static uint32 synLimit	= 0;
static uint32 finLimit	= 0;
static uint32 udpLimit	= 0;
static uint32 icmpLimit	= 0;
static uint32 synCnt	= 0;
static uint32 finCnt		= 0;
static uint32 udpCnt	= 0;
static uint32 icmpCnt	= 0;


static _rtl8651_dos_PktCnt_t	*lru_hdr = NULL;
static _rtl8651_dos_PktCnt_t *lru_tail = NULL;

#define RTL8651_DOS_SRCTRACK_NONE	0
#define RTL8651_DOS_SRCTRACK_SYN		1
#define RTL8651_DOS_SRCTRACK_FIN		2
#define RTL8651_DOS_SRCTRACK_UDP		3
#define RTL8651_DOS_SRCTRACK_ICMP		4


static int32 _rtl8651_perSrc_syn_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_perSrc_fin_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_perSrc_udp_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_perSrc_icmp_threshold[RTL8651_MAX_DIALSESSION];




static _rtl8651_dos_PktCnt_t	*tcpConnHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t *udpConnHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t *tcpudpConnHash[RTL8651_DOS_HASHTBL_SIZE];


static uint32 tcpConnLimit		= 0;
static uint32 udpConnLimit		= 0;
static uint32 tcpudpConnLimit	= 0;
static uint32 tcpConnCnt		= 0;
static uint32 udpConnCnt		= 0;
static uint32 tcpudpConnCnt	= 0;


static _rtl8651_dos_PktCnt_t *connInuseList = NULL;
static _rtl8651_dos_PktCnt_t *connFreeList = NULL;

#define RTL8651_DOS_CONNTRACK_NONE		0
#define RTL8651_DOS_CONNTRACK_TCP		1
#define RTL8651_DOS_CONNTRACK_UDP		2
#define RTL8651_DOS_CONNTRACK_TCPUDP		3
#define RTL8651_DOS_CONNTRACK_MAXTYPE	4	


static int32 _rtl8651_perSrc_tcpConn_threshold;
static int32 _rtl8651_perSrc_udpConn_threshold;
static int32 _rtl8651_perSrc_tcpudpConn_threshold;


static int32 _rtl8651_dosSrcTracking_init(rtl8651_fwdEngineInitPara_t *);
static int32 _rtl8651_dosSrcTracking_reinit(void);

static __inline__ uint32 _rtl8651_dosHash(ipaddr_t);
static __inline__ void _rtl8651_dosSrcTrackingLink(_rtl8651_dos_PktCnt_t **, _rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingUnlink(_rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingLruUnlink(_rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToTail(_rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToHead(_rtl8651_dos_PktCnt_t *);
static __inline__ int32 _rtl8651_dosSrcTrackingListRemoveFromList(_rtl8651_dos_PktCnt_t **list, _rtl8651_dos_PktCnt_t *entry);
static __inline__ void _rtl8651_dosSrcTrackingListAddToHead(_rtl8651_dos_PktCnt_t **, _rtl8651_dos_PktCnt_t *);


static uint32 _rtl8651_dosSrcTrackingCount(uint32, ipaddr_t);


static int32 _rtl8651_dosSrcSynFlood(uint32,struct ip*,struct tcphdr *, uint32 *);
static int32 _rtl8651_dosSrcStealthFin(uint32,struct ip*,struct tcphdr *, uint32 *);
static int32 _rtl8651_dosSrcUdpFlood(uint32,struct ip *, uint32 *);
static int32 _rtl8651_dosSrcIcmpFlood(uint32,struct ip *,struct icmp *, uint32 *);


static inline int32 _rtl8651_connSrcTracking_FindEntry(uint8, ipaddr_t, _rtl8651_dos_PktCnt_t ***, _rtl8651_dos_PktCnt_t **, uint32 **, uint32 **);
static inline uint32 _rtl8651_connSrcTracking_getConnCount(uint8, ipaddr_t);
static inline void _rtl8651_connSrcTrackingRemove(uint32 *, _rtl8651_dos_PktCnt_t *);
static inline void _rtl8651_connSrcTrackingUpdate(uint8, ipaddr_t, uint32);
static void _rtl8651_connSrcTrackingFlush(uint8);

static inline int32 _rtl8651_dosSrcConnCtrl(uint8, ipaddr_t);
static inline int32 _rtl8651_dosConnCtrl(uint8);

#define DOS_PERSRC_SUSPECTFLOW_CACHE_SYSTEM

typedef struct _rtl8651_dos_SuspectFlowCache_s {
	
	uint32	expire;
	ipaddr_t	sip;
	uint8	direction;	
	uint32	dsid;
	rtl8651_tblDrv_vlanTable_t *vlan;
	
	uint32	SynDstIpMask;
	uint32	SynSrcPortMask;
	uint32	SynDstPortMask;
	uint16	SynComplainCnt;
	
	uint32	FinDstIpMask;
	uint32	FinSrcPortMask;
	uint32	FinDstPortMask;
	uint16	FinComplainCnt;
	
	uint32	AckDstIpMask;
	uint32	AckSrcPortMask;
	uint32	AckDstPortMask;
	uint16	AckComplainCnt;
	
	uint32	UdpDstIpMask;
	uint32	UdpSrcPortMask;
	uint32	UdpDstPortMask;
	uint16	UdpComplainCnt;
	
	uint16	TotalComplainCnt;

	
	
	struct _rtl8651_dos_SuspectFlowCache_s	**hdr;
	struct _rtl8651_dos_SuspectFlowCache_s	*prev;
	struct _rtl8651_dos_SuspectFlowCache_s	*next;
	
	struct _rtl8651_dos_SuspectFlowCache_s	*lru_prev;
	struct _rtl8651_dos_SuspectFlowCache_s	*lru_next;
} _rtl8651_dos_SuspectFlowCache_t;


static uint32	_rtl8651_ScanTrackingSystem_enable = FALSE;	
static uint32	_rtl8651_ScanTrackingSystem_turnON = FALSE;	


static _rtl8651_dos_SuspectFlowCache_t	*SuspectFlowCacheHash[RTL8651_DOS_HASHTBL_SIZE] = {NULL};

static _rtl8651_dos_SuspectFlowCache_t *lru_SuspectFlowCache_hdr = NULL;
static _rtl8651_dos_SuspectFlowCache_t *lru_SuspectFlowCache_tail = NULL;

static _rtl8651_dos_SuspectFlowCache_t *SuspectFlowCache_ptr = NULL;
static uint32 SuspectFlowCache_Cnt = 0;

static uint32 _rtl8651_scan_monitor_window = RTL8651_DOS_SCAN_MOINTOR_WIN_DEFAULT;
static uint32 _rtl8651_scan_threshold[RTL8651_MAX_DIALSESSION] = {0};


static int32 _rtl8651_dosScanTracking_init(rtl8651_fwdEngineInitPara_t *);
static int32 _rtl8651_dosScanTracking_reinit(void);
static __inline__ void _rtl8651_dosScanTrackingLink(_rtl8651_dos_SuspectFlowCache_t**, _rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingUnlink(_rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingLruUnlink(_rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingLruMoveToTail(_rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingLruMoveToHead(_rtl8651_dos_SuspectFlowCache_t *);
static _rtl8651_dos_SuspectFlowCache_t *_rtl8651_dosScanTrackingFindEntry(ipaddr_t);
static int32 _rtl8651_dosTcpUdpScan(_rtl8651_dos_SuspectFlowCache_t *, uint16, uint8);



#ifdef _RTL_NEW_LOGGING_MODEL
#define DOS_LOG(logType,dsid,sip,dip,l4proto,direction,sport,dport,icmpType,icmpId,logAction) \
	do { \
		if ( (_loggingModule[(dsid)] & RTL8651_LOGMODULE_DOS) && _pUserLoggingFunc ) \
		{ \
			rtl8651_logInfo_t info;\
			info.infoType = RTL8651_LOG_INFO_PKT; \
			info.pkt_dsid = (dsid); \
			info.pkt_sip = (sip); \
			info.pkt_dip = (dip); \
			info.pkt_proto = (l4proto); \
			info.pkt_direction = (direction); \
			info.pkt_sport = ((sport)?(sport):(0xffff)); \
			info.pkt_dport = ((dport)?(dport):(0xffff)); \
			info.pkt_icmpType	= (icmpType); \
			info.pkt_icmpId = ((icmpId)?(icmpId):(0xffff)); \
			info.action = (logAction); \
			(*_pUserLoggingFunc) (RTL8651_LOGMODULE_DOS, (logType), &info); \
		} \
	} while (0);
#else
#define DOS_LOG(dsid,sip,dip,l4proto,direction,sport,dport,icmpType,logAction,msg) \
	do { \
		if ( (_loggingModule[(dsid)] & RTL8651_LOGMODULE_DOS) && _pUserLoggingFunc ) \
		{ \
			(*_pUserLoggingFunc) ( \
			(dsid), \
			RTL8651_LOGMODULE_DOS, \
			(unsigned char)(l4proto), \
			(unsigned char)(direction), \
			(unsigned long)(sip), \
			(unsigned long)(dip), \
			(unsigned short)((sport)?(sport):0xffff), \
			(unsigned short)((dport)?(dport):0xffff), \
			(unsigned short)(icmpType), \
			(logAction), \
			(msg));\
		} \
	} while (0);
#endif




void _rtl8651_dos_init(rtl8651_fwdEngineInitPara_t *para){
	uint32 i;
	memset(&_tcpDosScanBitmap[0], 0, sizeof(_tcpDosScanBitmap));
	
	
	
	
	
	
	
	
	
	
	_tcpDosScanBitmap[0]=_tcpDosScanBitmap[3]=_tcpDosScanBitmap[8]=_tcpDosScanBitmap[9]=
	_tcpDosScanBitmap[32]=_tcpDosScanBitmap[33]=_tcpDosScanBitmap[40]=_tcpDosScanBitmap[41]=
	_tcpDosScanBitmap[58]=_tcpDosScanBitmap[63]=1;
	for (i=0;i<RTL8651_MAX_DIALSESSION;i++){
		_rtl8651_local_syn_threshold[i]		= RTL8651_DOS_SYN_THRESHOLD_DEFAULT;
		_rtl8651_local_fin_threshold[i]		= RTL8651_DOS_FIN_THRESHOLD_DEFAULT;
		_rtl8651_local_icmp_threshold[i]		= RTL8651_DOS_ICMP_THRESHOLD_DEFAULT;
		_rtl8651_local_udp_threshold[i]		= RTL8651_DOS_UDP_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_syn_threshold[i]		= RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_fin_threshold[i]		= RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udp_threshold[i]		= RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_icmp_threshold[i]	= RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT;

		_rtl8651_local_tcpConn_threshold		= RTL8651_DOS_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_udpConn_threshold	= RTL8651_DOS_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_tcpudpConn_threshold	= RTL8651_DOS_TCPUDPCONN_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_tcpConn_threshold	= RTL8651_DOS_PERSRC_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udpConn_threshold	= RTL8651_DOS_PERSRC_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_tcpudpConn_threshold= RTL8651_DOS_PERSRC_TCPUDPCONN_THRESHOLD_DEFAULT;
		
		_rtl8651_dosTurnOff(i);
	}
	_rtl8651_dosSrcTracking_init(para);
	_rtl8651_dosScanTracking_init(para);
	_rtl8651_procDoSPkt_init(para);
	_rtl8651_dosIgnoreTypeFlush();
}

void _rtl8651_dos_Reinit()
{
	uint32 i;
	memset(&_tcpDosScanBitmap[0], 0, sizeof(_tcpDosScanBitmap));
	
	
	
	
	
	
	
	
	
	
	_tcpDosScanBitmap[0]=_tcpDosScanBitmap[3]=_tcpDosScanBitmap[8]=_tcpDosScanBitmap[9]=
	_tcpDosScanBitmap[32]=_tcpDosScanBitmap[33]=_tcpDosScanBitmap[40]=_tcpDosScanBitmap[41]=
	_tcpDosScanBitmap[58]=_tcpDosScanBitmap[63]=1;
	for (i=0;i<RTL8651_MAX_DIALSESSION;i++){
		_rtl8651_local_syn_threshold[i]		= RTL8651_DOS_SYN_THRESHOLD_DEFAULT;
		_rtl8651_local_fin_threshold[i]		= RTL8651_DOS_FIN_THRESHOLD_DEFAULT;
		_rtl8651_local_icmp_threshold[i]		= RTL8651_DOS_ICMP_THRESHOLD_DEFAULT;
		_rtl8651_local_udp_threshold[i]		= RTL8651_DOS_UDP_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_syn_threshold[i]		= RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_fin_threshold[i]		= RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udp_threshold[i]		= RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_icmp_threshold[i]	= RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT;

		_rtl8651_local_tcpConn_threshold		= RTL8651_DOS_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_udpConn_threshold	= RTL8651_DOS_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_tcpudpConn_threshold	= RTL8651_DOS_TCPUDPCONN_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_tcpConn_threshold	= RTL8651_DOS_PERSRC_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udpConn_threshold	= RTL8651_DOS_PERSRC_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_tcpudpConn_threshold= RTL8651_DOS_PERSRC_TCPUDPCONN_THRESHOLD_DEFAULT;

		_rtl8651_dosTurnOff(i);
	}
	_rtl8651_dosSrcTracking_reinit();
	_rtl8651_dosScanTracking_reinit();
	_rtl8651_procDosPkt_reinit();
	_rtl8651_dosIgnoreTypeFlush();
}

void rtl8651a_setDosStatus(uint32 dsid,uint32 enableItem)
{
	
	if(enableItem)
		_rtl8651_dosTurnOn(dsid, enableItem);
	else
		_rtl8651_dosTurnOff(dsid);
}

void rtl8651a_setDosThreshold(uint32 dsid,uint32 type,uint32 threshold)
{
	assert(dsid < rtl8651_tblDrvPara.dialSessionNumber);
	switch(type)
	{
		case RTL8651_DOS_SYN_THRESHOLD:
			_rtl8651_local_syn_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_FIN_THRESHOLD:
			_rtl8651_local_fin_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_UDP_THRESHOLD:
			_rtl8651_local_udp_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_ICMP_THRESHOLD:
			_rtl8651_local_icmp_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_TCPCONN_THRESHOLD:
			_rtl8651_local_tcpConn_threshold = threshold;
			break;
		case RTL8651_DOS_UDPCONN_THRESHOLD:
			_rtl8651_local_udpConn_threshold = threshold;
			break;
		case RTL8651_DOS_TCPUDPCONN_THRESHOLD:
			_rtl8651_local_tcpudpConn_threshold = threshold;
			break;
	}
}

void rtl8651a_setPerSrcDosThreshold(uint32 dsid, uint32 type, uint32 threshold)
{
	assert(dsid < rtl8651_tblDrvPara.dialSessionNumber);
	switch(type)
	{
		case RTL8651_DOS_SYN_THRESHOLD:
			_rtl8651_perSrc_syn_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_FIN_THRESHOLD:
			_rtl8651_perSrc_fin_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_UDP_THRESHOLD:
			_rtl8651_perSrc_udp_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_ICMP_THRESHOLD:
			_rtl8651_perSrc_icmp_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_TCPCONN_THRESHOLD:
			_rtl8651_perSrc_tcpConn_threshold = threshold;
			break;
		case RTL8651_DOS_UDPCONN_THRESHOLD:
			_rtl8651_perSrc_udpConn_threshold = threshold;
			break;
		case RTL8651_DOS_TCPUDPCONN_THRESHOLD:
			_rtl8651_perSrc_tcpudpConn_threshold = threshold;
			break;
	}
}


static void _rtl8651_dosPreProcess(uint32 dsid, uint32 oldSW, uint32 newSW)
{
	
	if ( (oldSW & RTL8651_DOS_SRC_TCPCONNOVERFLOW) != (newSW & RTL8651_DOS_SRC_TCPCONNOVERFLOW) )
	{
		_rtl8651_connSrcTrackingFlush(RTL8651_DOS_CONNTRACK_TCP);
	}
	if ( (oldSW & RTL8651_DOS_SRC_UDPCONNOVERFLOW) != (newSW & RTL8651_DOS_SRC_UDPCONNOVERFLOW) )
	{
		_rtl8651_connSrcTrackingFlush(RTL8651_DOS_CONNTRACK_UDP);
	}
	if ( (oldSW & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW) != (newSW & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW) )
	{
		_rtl8651_connSrcTrackingFlush(RTL8651_DOS_CONNTRACK_TCPUDP);
	}
}

static void _rtl8651_dosSwitch(void)
{
	uint32 idx;
	uint32 enable;

	
	enable = FALSE;
	for (idx = 0 ; idx < RTL8651_MAX_DIALSESSION ; idx ++)
	{
		if (_rtl8651_dos_sw[idx])
			enable = TRUE;
	}
	_rtl8651_dos_enable = enable;

	
	enable = FALSE;
	for (idx = 0 ; idx < RTL8651_MAX_DIALSESSION ; idx ++)
	{
		if (_rtl8651_dos_sw[idx] & RTL8651_DOS_PORTSCAN)
			enable = TRUE;
	}
	_rtl8651_ScanTrackingSystem_turnON = enable;
}
void _rtl8651_dosACLSet(void)
{
	uint32 i;
	uint32 addVlanMask;
	uint32 delVlanMask;

	
	addVlanMask = 0xffffffff;		 
	delVlanMask = 0xffffffff;		

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_LAN)
	{	
		rtl8651_tblDrv_vlanTable_t *vlanp;
		for (i = 0 ; i < RTL8651_VLAN_NUMBER ; i ++)
		{
			vlanp = &DrvTbl.vlan[i];
			if (vlanp->internal)
			{	
				addVlanMask &= ~(1<<i);
			}
		}
	}

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_WAN)
	{	
		rtl8651_tblDrv_vlanTable_t *vlanp;
		for (i = 0 ; i < RTL8651_VLAN_NUMBER ; i ++)
		{
			vlanp = &DrvTbl.vlan[i];
			if (!(vlanp->internal))
			{	
				addVlanMask &= ~(1<<i);
			}
		}
	}
	
	
	
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD|RTL8651_DOS_SYNWITHDATA|RTL8651_DOS_TCPLAND|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_TCP_SYNFLOOD, TRUE, addVlanMask);
			break;
		}
		
		_rtl8651_enableDoS(RTL8651_TCP_SYNFLOOD, FALSE, delVlanMask);
	}
	
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_TCP_STEALTHFIN, TRUE, addVlanMask);
			break;
		}
		
		_rtl8651_enableDoS(RTL8651_TCP_STEALTHFIN, FALSE, delVlanMask);
	}
	
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_SCAN))
		{
			_rtl8651_enableDoS(RTL8651_TCP_FULLXMASSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_FULLSAPUSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_FINSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_SYNFINSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_NULLSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_NMAPXMASSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_VECNASCAN, TRUE, addVlanMask);
			break;
		}
		
		_rtl8651_enableDoS(RTL8651_TCP_FULLXMASSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_FULLSAPUSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_FINSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_SYNFINSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_NULLSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_NMAPXMASSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_VECNASCAN, FALSE, delVlanMask);
	}

	
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_IPSPOOF))
		{
			_rtl8651_enableDoS(RTL8651_IP_SPOOFING, TRUE, addVlanMask);
			break;
		}
		
		_rtl8651_enableDoS(RTL8651_IP_SPOOFING, FALSE, delVlanMask);
	}

	
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_ECHOCHARGEN))
		{
			_rtl8651_enableDoS(RTL8651_UDP_ECHOCHARGENBOMB, TRUE, addVlanMask);
			break;
		}
		
		_rtl8651_enableDoS(RTL8651_UDP_ECHOCHARGENBOMB, FALSE, delVlanMask);
	}

	
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD|RTL8651_DOS_UDPBOMB|RTL8651_DOS_UDPLAND|RTL8651_DOS_UDPCONNOVERFLOW|RTL8651_DOS_SRC_UDPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_UDP_FLOOD, TRUE, addVlanMask);
			break;
		}
		
		_rtl8651_enableDoS(RTL8651_UDP_FLOOD, FALSE, delVlanMask);
	}
	
	
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_PORTSCAN|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_TCPUDP_PORTSCAN, TRUE, addVlanMask);
			break;
		}
		
		_rtl8651_enableDoS(RTL8651_TCPUDP_PORTSCAN, FALSE, delVlanMask);
	}
	return;
}

void _rtl8651_dosTurnOn(uint32 dsid, uint32 enableItem)
{
	
	_rtl8651_dosPreProcess(dsid, _rtl8651_dos_sw[dsid], enableItem);
	
	_rtl8651_dos_sw[dsid] = enableItem;
	
	_rtl8651_dosSwitch();
	
	if (_rtl8651_dos_enable == TRUE)
		rtl8651_enableNaptAutoAdd(FALSE);
	_rtl8651_dosACLSet();
}

void _rtl8651_dosTurnOff(uint32 dsid)
{
	
	_rtl8651_dosPreProcess(dsid, _rtl8651_dos_sw[dsid], 0);
	
	_rtl8651_dos_sw[dsid] = 0;
	
	_rtl8651_dosSwitch();
	
	_rtl8651_dosACLSet();
}

void _rtl8651_dosIgnoreTypeFlush(void)
{
	_rtl8651_dos_ignoreType = 0;
	_rtl8651_dosACLSet();	
}

uint32 _rtl8651_dosIgnoreTypeAdd(uint32 add)
{
	_rtl8651_dos_ignoreType |= add;
	_rtl8651_dosACLSet();	
	return _rtl8651_dos_ignoreType;
}

uint32 _rtl8651_dosIgnoreTypeDel(uint32 del)
{
	_rtl8651_dos_ignoreType &= ~(del);
	_rtl8651_dosACLSet();	
	return _rtl8651_dos_ignoreType;
}


uint8 _rtl8651_dosIgnoreTypeCheck(uint8 direction)
{
	
	if ((1 << direction) & _rtl8651_dos_ignoreType)
		return TRUE;

	
	return FALSE;
}


int32 rtl8651_dosOneSecondTimer(){
	uint32 i;

	for (i=0;i<RTL8651_MAX_DIALSESSION;i++){
		_rtl8651_local_syn_counter[i]		= 0;
		_rtl8651_local_fin_counter[i]		= 0;
		_rtl8651_local_icmp_counter[i]	= 0;
		_rtl8651_local_udp_counter[i]		= 0;
	}
	return SUCCESS;
}

#define DOS_PERSRC_PKT_TRACK_SYSTEM_FUNCTIONS
static int32 _rtl8651_dosSrcTracking_init(rtl8651_fwdEngineInitPara_t *para)
{
	_rtl8651_dos_PktCnt_t *ptr;
	int32 idx;
	int32 tblsize;						

	assert(para);

	if (!para)
		goto err;

	

	
	if ((!para->dos_total_trackCnt) &&
		((!para->dos_SynFlood_trackCnt) || (!para->dos_StealthFin_trackCnt) || (!para->dos_UdpFlood_trackCnt) || (!para->dos_IcmpFlood_trackCnt)))
		goto err;

	
	if (para->dos_total_trackCnt)
	{
		if (para->dos_SynFlood_trackCnt && para->dos_StealthFin_trackCnt && para->dos_UdpFlood_trackCnt && para->dos_IcmpFlood_trackCnt)
		{
			tblsize = MIN(para->dos_total_trackCnt, (para->dos_SynFlood_trackCnt + para->dos_StealthFin_trackCnt + para->dos_UdpFlood_trackCnt + para->dos_IcmpFlood_trackCnt));
		}else
		{
			tblsize = para->dos_total_trackCnt;
		}
	}else
	{
		tblsize = (para->dos_SynFlood_trackCnt + para->dos_StealthFin_trackCnt + para->dos_UdpFlood_trackCnt + para->dos_IcmpFlood_trackCnt);
	}

	
	synLimit		= (para->dos_SynFlood_trackCnt)?para->dos_SynFlood_trackCnt:tblsize;
	finLimit		= (para->dos_StealthFin_trackCnt)?para->dos_StealthFin_trackCnt:tblsize;
	udpLimit		= (para->dos_UdpFlood_trackCnt)?para->dos_UdpFlood_trackCnt:tblsize;
	icmpLimit	= (para->dos_IcmpFlood_trackCnt)?para->dos_IcmpFlood_trackCnt:tblsize;

	
	synCnt		= 0;
	finCnt		= 0;
	udpCnt		= 0;
	icmpCnt		= 0;

	
	lru_hdr = rtlglue_malloc(tblsize*sizeof(_rtl8651_dos_PktCnt_t));
	if (!lru_hdr)
		goto err;

	memset(lru_hdr, 0, tblsize*sizeof(_rtl8651_dos_PktCnt_t));

	
	lru_tail = lru_hdr + (tblsize - 1);

	
	ptr = lru_hdr;
	for (idx = 0 ; idx < tblsize ; idx ++, ptr ++)
	{
		if (idx != 0)
		{
			ptr->lru_prev = ptr - 1;
		}
		if (idx != (tblsize - 1))
		{
			ptr->lru_next = ptr + 1;
		}
	}

	
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		synHash[idx]			= NULL;
		finHash[idx]			= NULL;
		udpHash[idx]			= NULL;
		icmpHash[idx]		= NULL;
	}

	
	
	if ((!para->dos_totalConn_trackCnt) &&
		((!para->dos_TcpConn_trackCnt) || (!para->dos_UdpConn_trackCnt) || (!para->dos_TcpUdpConn_trackCnt)))
		goto err;

	
	if (para->dos_totalConn_trackCnt)
	{
		if (para->dos_TcpConn_trackCnt && para->dos_UdpConn_trackCnt && para->dos_TcpUdpConn_trackCnt)
		{
			tblsize = MIN(para->dos_total_trackCnt, (para->dos_TcpConn_trackCnt + para->dos_UdpConn_trackCnt + para->dos_TcpUdpConn_trackCnt));
		}else
		{
			tblsize = para->dos_totalConn_trackCnt;
		}
	}else
	{
		tblsize = (para->dos_TcpConn_trackCnt + para->dos_UdpConn_trackCnt + para->dos_TcpUdpConn_trackCnt);
	}

	
	tcpConnLimit		= (para->dos_TcpConn_trackCnt)?para->dos_TcpConn_trackCnt:tblsize;
	udpConnLimit	= (para->dos_UdpConn_trackCnt)?para->dos_UdpConn_trackCnt:tblsize;
	tcpudpConnLimit	= (para->dos_TcpUdpConn_trackCnt)?para->dos_TcpUdpConn_trackCnt:tblsize;

	
	tcpConnCnt		= 0;
	udpConnCnt		= 0;
	tcpudpConnCnt	= 0;

	
	connInuseList = NULL;
	connFreeList = rtlglue_malloc(tblsize*sizeof(_rtl8651_dos_PktCnt_t));
	if (!connFreeList)
		goto err;

	memset(connFreeList, 0, tblsize*sizeof(_rtl8651_dos_PktCnt_t));

	
	ptr = connFreeList;
	for (idx = 0 ; idx < tblsize ; idx ++, ptr ++)
	{
		if (idx != 0)
		{
			ptr->list_prev = ptr - 1;
		}
		if (idx != (tblsize - 1))
		{
			ptr->list_next = ptr + 1;
		}
	}

	
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		tcpConnHash[idx]			= NULL;
		udpConnHash[idx]		= NULL;
		tcpudpConnHash[idx]		= NULL;
	}

	
	_rtl8651_SrcTracking_enable = TRUE;
	return SUCCESS;
err:
	_rtl8651_SrcTracking_enable = FALSE;
	return FAILED;
}
static int32 _rtl8651_dosSrcTracking_reinit(void)
{
	uint32 idx;
	_rtl8651_dos_PktCnt_t	*ptr;

	if (_rtl8651_SrcTracking_enable == FALSE)
		return FAILED;

	

	
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		synHash[idx]			= NULL;
		finHash[idx]			= NULL;
		udpHash[idx]			= NULL;
		icmpHash[idx]		= NULL;
	}

	
	ptr = lru_hdr;
	if (!ptr)
		goto err;
	while (ptr)
	{
		ptr->recordTime	= 0;
		ptr->ip			= 0;
		ptr->count		= 0;
		ptr->item		= RTL8651_DOS_SRCTRACK_NONE;
		ptr->hdr			= NULL;
		ptr->prev		= NULL;
		ptr->next		= NULL;

		ptr = ptr->lru_next;
	}

	
	synCnt		= 0;
	finCnt		= 0;
	udpCnt		= 0;
	icmpCnt		= 0;

	

	
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		tcpConnHash[idx]		= NULL;
		udpConnHash[idx]	= NULL;
		tcpudpConnHash[idx]	= NULL;
	}

	
	ptr = connInuseList;
	while (ptr)
	{
		_rtl8651_dosSrcTrackingListRemoveFromList(&connInuseList, ptr);
		_rtl8651_dosSrcTrackingListAddToHead(&connFreeList, ptr);
		ptr = connInuseList;
	}

	
	tcpConnCnt		= 0;
	udpConnCnt		= 0;
	tcpudpConnCnt	= 0;
	
	return SUCCESS;
err:
	_rtl8651_SrcTracking_enable = FALSE;
	return FAILED;
}
static __inline__ uint32 _rtl8651_dosHash(ipaddr_t ip)
{
	return (ip % RTL8651_DOS_HASHTBL_SIZE);

}
static __inline__ void _rtl8651_dosSrcTrackingLink(_rtl8651_dos_PktCnt_t **hdr, _rtl8651_dos_PktCnt_t *entry)
{	
	entry->hdr = hdr;		
	entry->next = (*hdr);		
	if (*hdr)	{
		(*hdr)->prev = entry;	
	}

	(*hdr) = entry;			
}
static __inline__ void _rtl8651_dosSrcTrackingUnlink(_rtl8651_dos_PktCnt_t *entry)
{	
	_rtl8651_dos_PktCnt_t **hdr = entry->hdr;
	if (!hdr) {	
		goto clearLink;
	}
	if (entry->prev)
		entry->prev->next = entry->next;
	if (entry->next)
		entry->next->prev = entry->prev;

	if ((*hdr) == entry)
		(*hdr) = entry->next;
clearLink:
	entry->hdr	= NULL;
	entry->prev	= NULL;
	entry->next	= NULL;
}
static __inline__ void _rtl8651_dosSrcTrackingLruUnlink(_rtl8651_dos_PktCnt_t *entry)
{
	if (entry->lru_prev)
		entry->lru_prev->lru_next = entry->lru_next;
	if (entry->lru_next)
		entry->lru_next->lru_prev = entry->lru_prev;
	if (lru_hdr == entry)
		lru_hdr = entry->lru_next;
	if (lru_tail == entry)
		lru_tail = entry->lru_prev;
	entry->lru_next = NULL;
	entry->lru_prev = NULL;
}
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToTail(_rtl8651_dos_PktCnt_t *entry)
{	
	if (lru_tail == entry)
		return;

	assert(lru_hdr != lru_tail);	
	_rtl8651_dosSrcTrackingLruUnlink(entry);
	entry->lru_prev = lru_tail;
	if (lru_tail)
		lru_tail->lru_next = entry;
	lru_tail = entry;
}
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToHead(_rtl8651_dos_PktCnt_t *entry)
{	
	if (lru_hdr == entry)
		return;

	assert(lru_hdr != lru_tail);	
	_rtl8651_dosSrcTrackingLruUnlink(entry);
	entry->lru_next = lru_hdr;
	if (lru_hdr)
		lru_hdr->lru_prev = entry;
	lru_hdr = entry;
}
static __inline__ int32 _rtl8651_dosSrcTrackingListRemoveFromList(_rtl8651_dos_PktCnt_t **list, _rtl8651_dos_PktCnt_t *entry)
{
	if ( (list == NULL) ||(*list == NULL) ||(entry == NULL) )
		return FAILED;

	if (entry->list_prev)
		entry->list_prev->list_next = entry->list_next;
	if (entry->list_next)
		entry->list_next->list_prev = entry->list_prev;

	if (*list == entry)
		*list = entry->list_next;

	entry->list_prev = NULL;
	entry->list_next = NULL;

	return SUCCESS;
}
static __inline__ void _rtl8651_dosSrcTrackingListAddToHead(_rtl8651_dos_PktCnt_t **list, _rtl8651_dos_PktCnt_t *entry)
{
	if ( (list == NULL) ||(entry == NULL) )
		return;

	entry->list_prev = NULL;
	entry->list_next = *list;
	if (*list)
		(*list)->list_prev = entry;
	*list = entry;

	return;
}
#define DOS_PERSRC_PKT_TRACK_SYSTEM_FOR_FLOODCHECK

static uint32 _rtl8651_dosSrcTrackingCount(uint32 item, ipaddr_t sip)
{
	_rtl8651_dos_PktCnt_t **hdr = NULL, *ptr = NULL;
	uint32 hash = _rtl8651_dosHash(sip);
	uint32 *cntPtr, *limitPtr;
	int32 pktCnt = 0;

	if (_rtl8651_SrcTracking_enable == FALSE)
		goto noentry_out;
	switch (item)
	{
		case RTL8651_DOS_SRCTRACK_SYN:
			hdr = &synHash[hash];
			cntPtr = &synCnt;
			limitPtr = &synLimit;
			break;
		case RTL8651_DOS_SRCTRACK_FIN:
			hdr = &finHash[hash];
			cntPtr = &finCnt;
			limitPtr = &finLimit;
			break;
		case RTL8651_DOS_SRCTRACK_UDP:
			hdr = &udpHash[hash];
			cntPtr = &udpCnt;
			limitPtr = &udpLimit;
			break;
		case RTL8651_DOS_SRCTRACK_ICMP:
			hdr = &icmpHash[hash];
			cntPtr = &icmpCnt;
			limitPtr = &icmpLimit;
			break;
		default:
			goto noentry_out;
	}
	ptr = (*hdr);
	while (ptr)
	{
		if (ptr->ip == sip)
		{	
			if (ptr->recordTime < _sysUpSeconds)	
			{
				ptr->recordTime = _sysUpSeconds;
				ptr->count = 1;	
				pktCnt = 1;
			}else
			{
				pktCnt = ++(ptr->count);
			}
			_rtl8651_dosSrcTrackingLruMoveToTail(ptr);
			goto out;
		}
		ptr = ptr->next;
	}
	
	ptr = lru_hdr;
	if ((*limitPtr) && ((*cntPtr) >= (*limitPtr)))
	{	
		while (ptr)
		{
			if (ptr->recordTime >= _sysUpSeconds)
				goto noentry_out;	

			if (ptr->item == item)
			{
				goto recycle_entry;
			}
			ptr = ptr->lru_next;	
		}
		goto noentry_out;	
	}else
	{	
		if ((ptr) && (ptr->recordTime < _sysUpSeconds))	
		{	
			
			switch (ptr->item)
			{
				case RTL8651_DOS_SRCTRACK_SYN:
					synCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_FIN:
					finCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_UDP:
					udpCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_ICMP:
					icmpCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_NONE:
					break;	
			}
			
			*cntPtr = *cntPtr + 1;
recycle_entry:
			
			_rtl8651_dosSrcTrackingUnlink(ptr);
			
			ptr->item			= item;
			ptr->ip				= sip;
			ptr->recordTime		= _sysUpSeconds;
			ptr->count			= 1;
			
			_rtl8651_dosSrcTrackingLink(hdr, ptr);
			
			_rtl8651_dosSrcTrackingLruMoveToTail(ptr);
			pktCnt = 1;	
			goto out;
		}
		goto noentry_out;	
	}
out:
	return pktCnt;
noentry_out:
	return 1;	
}

#if 0
static void _rtl8651_dosSrcTrackingRemove(uint32 item, ipaddr_t sip)
{
	_rtl8651_dos_PktCnt_t *ptr;
	uint32 *cntPtr;
	uint32 hash = _rtl8651_dosHash(sip);

	if (_rtl8651_SrcTracking_enable == FALSE)
		return;

	switch (item)
	{
		case RTL8651_DOS_SRCTRACK_SYN:
			ptr = synHash[hash];
			cntPtr = &synCnt;
			break;
		case RTL8651_DOS_SRCTRACK_FIN:
			ptr = finHash[hash];
			cntPtr = &finCnt;
			break;
		case RTL8651_DOS_SRCTRACK_UDP:
			ptr = udpHash[hash];
			cntPtr = &udpCnt;
			break;
		case RTL8651_DOS_SRCTRACK_ICMP:
			ptr = icmpHash[hash];
			cntPtr = &icmpCnt;
			break;
		default:
			return;
	}

	while (ptr)
	{
		if (ptr->ip == sip)
		{	
			
			_rtl8651_dosSrcTrackingUnlink(ptr);
			
			ptr->recordTime = 0;							
			ptr->item = RTL8651_DOS_SRCTRACK_NONE;		
			_rtl8651_dosSrcTrackingLruMoveToHead(ptr);
			
			*cntPtr = *cntPtr - 1;
			return;
		}
		ptr = ptr->next;
	}
	return;
}
#endif

static int32 _rtl8651_dosSrcSynFlood(uint32 dsid,struct ip*ip,struct tcphdr *tc, uint32* NeedLog)
{
	ipaddr_t	sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 	pktCnt;

	*NeedLog = FALSE;
	if (tc->th_flags & TH_SYN)
	{
		pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_SYN, sip);
		if ( pktCnt >= _rtl8651_perSrc_syn_threshold[dsid])
		{	
			
			if (pktCnt == _rtl8651_perSrc_syn_threshold[dsid])
			{
				*NeedLog = TRUE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}
static int32 _rtl8651_dosSrcStealthFin(uint32 dsid,struct ip*ip,struct tcphdr *tc, uint32* NeedLog)
{
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 pktCnt;
	
	*NeedLog = FALSE;
	if (tc->th_flags & TH_FIN)
	{
		pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_FIN, sip);
		if (pktCnt >= _rtl8651_perSrc_fin_threshold[dsid])
		{	
			
			if (pktCnt == _rtl8651_perSrc_fin_threshold[dsid])
			{
				*NeedLog = TRUE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}
static int32 _rtl8651_dosSrcUdpFlood(uint32 dsid,struct ip *ip, uint32* NeedLog)
{
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 pktCnt;
	
	*NeedLog = FALSE;
	pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_UDP, sip);
	if (pktCnt >= _rtl8651_perSrc_udp_threshold[dsid])
	{	
		
		if (pktCnt == _rtl8651_perSrc_udp_threshold[dsid])
		{
			*NeedLog = TRUE;
		}
		return SUCCESS;
	}
	return FAILED;
}
static int32 _rtl8651_dosSrcIcmpFlood(uint32 dsid,struct ip *ip,struct icmp *ic, uint32* NeedLog)
{
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 pktCnt;

	*NeedLog = FALSE;


		pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_ICMP, sip);
		if (pktCnt >= _rtl8651_perSrc_icmp_threshold[dsid])
		{	
			
			if (pktCnt == _rtl8651_perSrc_icmp_threshold[dsid])
			{
				*NeedLog = TRUE;
			}
			return SUCCESS;
		}

	return FAILED;
}
#define DOS_PERSRC_PKT_TRACK_SYSTEM_FOR_CONNECTIONCONTROL

#define GET_COUNT_FROM_NAPT_SYSTEM(ip,tcpCntp,udpCntp) \
	do { \
		_rtl8651_countNaptConnectionByIP( (ip), (tcpCntp), (udpCntp)); \
	} while ( 0 );



static inline int32 _rtl8651_connSrcTracking_FindEntry(uint8 flowType, ipaddr_t ip, _rtl8651_dos_PktCnt_t ***phdr, _rtl8651_dos_PktCnt_t **ppe, uint32 **ppcnt, uint32 **pplimit)
{
	_rtl8651_dos_PktCnt_t **hdr = NULL, *ptr = NULL;
	uint32 *pcnt = NULL, *plimit = NULL;
	uint32 hash = _rtl8651_dosHash(ip);

	switch (flowType)
	{
		case RTL8651_DOS_CONNTRACK_TCP:
			hdr = &tcpConnHash[hash];
			pcnt = &tcpConnCnt;
			plimit = &tcpConnLimit;
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			hdr = &udpConnHash[hash];
			pcnt = &udpConnCnt;
			plimit = &udpConnLimit;
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			hdr = &tcpudpConnHash[hash];
			pcnt = &tcpudpConnCnt;
			plimit = &tcpudpConnLimit;
			break;
		default:
			return FAILED;
	}
	ptr = (*hdr);
	while (ptr)
	{
		if (ptr->ip == ip)
		{
			goto out;
		}
		ptr = ptr->next;
	}
	ptr = NULL;

out:
	if (phdr)
	{
		*phdr = hdr;
	}
	if (ppe)
	{
		*ppe = ptr;
	}
	if (ppcnt)
	{
		*ppcnt = pcnt;
	}
	if (pplimit)
	{
		*pplimit = plimit;
	}
	return SUCCESS;
}


static inline uint32 _rtl8651_connSrcTracking_getConnCount(uint8 flowType, ipaddr_t ip)
{
	_rtl8651_dos_PktCnt_t **hdr = NULL, *ptr = NULL;
	uint32 *cntPtr, *limitPtr;
	uint32 connCnt = 0;

	if (_rtl8651_SrcTracking_enable == FALSE)
	{
		goto out;
	}

	if (_rtl8651_connSrcTracking_FindEntry(flowType, ip, &hdr, &ptr, &cntPtr, &limitPtr) != SUCCESS)
	{
		goto out;
	}

	
	if ( ptr )
	{
		connCnt = ptr->count;
		goto out;
	}

	
	{
		uint32 tmpTcp;
		uint32 tmpUdp;

		GET_COUNT_FROM_NAPT_SYSTEM(ip, &tmpTcp, &tmpUdp);

		switch (flowType)
		{
			case RTL8651_DOS_CONNTRACK_TCP:
				connCnt = tmpTcp;
				break;
			case RTL8651_DOS_CONNTRACK_UDP:
				connCnt = tmpUdp;
				break;
			case RTL8651_DOS_CONNTRACK_TCPUDP:
				connCnt = tmpTcp + tmpUdp;
				break;
		}

		
		if ( (*cntPtr) < (*limitPtr) )
		{
			
			if ( connFreeList )
			{
				ptr = connFreeList;
				_rtl8651_dosSrcTrackingListRemoveFromList(&connFreeList, ptr);
				_rtl8651_dosSrcTrackingListAddToHead(&connInuseList, ptr);
				_rtl8651_dosSrcTrackingLink(hdr, ptr);

				ptr->ip = ip;
				ptr->count = connCnt;
				ptr->item = flowType;

				(*cntPtr) ++;
			}
		}
		
	}

out:
	return connCnt;
}

static inline void _rtl8651_connSrcTrackingUpdate(uint8 flowType, ipaddr_t ip, uint32 isDecrease)
{
	_rtl8651_dos_PktCnt_t *ptr;
	uint32 *cntPtr;

	if (_rtl8651_SrcTracking_enable == FALSE)
	{
		return;
	}

	if ( (_rtl8651_connSrcTracking_FindEntry(flowType, ip, NULL, &ptr, &cntPtr, NULL) == SUCCESS) &&
		(ptr) )
	{
		if (isDecrease)
		{	
			ptr->count --;

			if (ptr->count == 0)
			{
				_rtl8651_connSrcTrackingRemove(cntPtr, ptr);
			}

		} else
		{	
			ptr->count ++;
		}
	}
}


static void _rtl8651_connSrcTrackingFlush(uint8 flowType)
{
	_rtl8651_dos_PktCnt_t *ptr, *next;
	uint32 *cntPtr = NULL;

	switch (flowType)
	{
		case RTL8651_DOS_CONNTRACK_NONE:
			cntPtr = NULL;
			tcpConnCnt = 0;
			udpConnCnt = 0;
			tcpudpConnCnt = 0;
			break;
		case RTL8651_DOS_CONNTRACK_TCP:
			cntPtr = &tcpConnCnt;
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			cntPtr = &udpConnCnt;
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			cntPtr = &tcpudpConnCnt;
			break;
		default:
			return;
	}

	ptr = connInuseList;
	while ( ptr )
	{
		next = ptr->list_next;
		if ( (flowType == RTL8651_DOS_CONNTRACK_NONE)||(ptr->item == flowType) )
		{
			_rtl8651_connSrcTrackingRemove(cntPtr, ptr);
		}
		ptr = next;
	}

	assert( (!cntPtr)||((*cntPtr) == 0) );
}

static inline void _rtl8651_connSrcTrackingRemove(uint32 *cntPtr, _rtl8651_dos_PktCnt_t *ptr)
{
	_rtl8651_dosSrcTrackingListRemoveFromList(&connInuseList, ptr);
	_rtl8651_dosSrcTrackingListAddToHead(&connFreeList, ptr);
	_rtl8651_dosSrcTrackingUnlink(ptr);
	if (cntPtr)
	{
		(*cntPtr) --;
	}
}


inline int32 _rtl8651_connSrcTrackingRemoveByFlowtypeIp(uint8 flowType, ipaddr_t ip)
{
	_rtl8651_dos_PktCnt_t *ptr = NULL;
	uint32 *cntPtr = NULL;
	int32 retval = 0;

	if (_rtl8651_SrcTracking_enable == FALSE)
	{
		return 0;
	}

	while ((_rtl8651_connSrcTracking_FindEntry(flowType, ip, NULL, &ptr, &cntPtr, NULL) == SUCCESS) &&
		(ptr))
	{	 
		_rtl8651_connSrcTrackingRemove(cntPtr, ptr);
		retval ++;
	}
	return retval;
}


inline int32 _rtl8651_connSrcTrackingRemoveByIp(ipaddr_t ip)
{
	int32 idx;
	int32 delCnt = 0;

	for ( idx = 0 ; idx < RTL8651_DOS_CONNTRACK_MAXTYPE ; idx ++)
	{
		delCnt += _rtl8651_connSrcTrackingRemoveByFlowtypeIp(idx, ip);
	}
	
	return delCnt;
}




void rtl8651_dumpConnCtrl(void)
{
	int connType;
	int idx;

	rtlglue_drvMutexLock();

	rtlglue_printf("Connection Counting Control System:\n");
	
	rtlglue_printf("\tConfiguration (whole system constraint):\n");
	
	rtlglue_printf("\t\t\t\tTCP\tUDP\tBOTH\n");
	rtlglue_printf("\t\tThreshold\t%d\t%d\t%d\n",
			_rtl8651_local_tcpConn_threshold,
			_rtl8651_local_udpConn_threshold,
			_rtl8651_local_tcpudpConn_threshold);
	rtlglue_printf("\t\tFlowCnt\t\t%d\t%d\t%d\n",
			rtl8651_tblDrvNaptCounter.dosCountedTcpCnt,
			rtl8651_tblDrvNaptCounter.dosCountedUdpCnt,
			(rtl8651_tblDrvNaptCounter.dosCountedTcpCnt+rtl8651_tblDrvNaptCounter.dosCountedUdpCnt));
	rtlglue_printf("\t\tInternalFlow\t%d\t%d\t%d\n",
			rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt,
			rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt,
			(rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt+rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt));
	
	rtlglue_printf("\tConfiguration (per-source constraint):\n");
	
	rtlglue_printf("\t\tThreshold\tTCP\tUDP\tBOTH\n");
	rtlglue_printf("\t\t\t\t%d\t%d\t%d\n",
			_rtl8651_perSrc_tcpConn_threshold,
			_rtl8651_perSrc_udpConn_threshold,
			_rtl8651_perSrc_tcpudpConn_threshold);
	
	rtlglue_printf("\n\t=====================================================\n");
	
	for (connType = 0 ; connType < RTL8651_DOS_CONNTRACK_MAXTYPE ; connType ++)
	{
		
		_rtl8651_dos_PktCnt_t **hdr[RTL8651_DOS_CONNTRACK_MAXTYPE] =
							{NULL, tcpConnHash, udpConnHash, tcpudpConnHash};
		uint32 connCnt[RTL8651_DOS_CONNTRACK_MAXTYPE] =
							{0, tcpConnCnt, udpConnCnt, tcpudpConnCnt};
		char* connStr[RTL8651_DOS_CONNTRACK_MAXTYPE] =
							{"", "TCP", "UDP", "Both"};
		_rtl8651_dos_PktCnt_t *ptr = NULL;

		if ( hdr[connType] == NULL )
		{
			continue;
		}
		for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx ++)
		{
			ptr = (hdr[connType])[idx];
			while (ptr)
			{
				rtlglue_printf("\t[%s] %u.%u.%u.%u\t-- %d\n", connStr[connType],
						NIPQUAD(ptr->ip), ptr->count);

				assert(ptr->item == connType);
				ptr = ptr->next;
			}
		}
		if ( connCnt[connType] == 0 )
		{
			rtlglue_printf("\t\t === <Empty> ===\n");
		}

		rtlglue_printf("\t\t\t\t\t%s -- TrackCnt: %d\n", connStr[connType], connCnt[connType]);
	}
	rtlglue_printf("\t=====================================================\n");

	rtlglue_drvMutexUnlock();

}


inline void _rtl8651_dosSrcConnCtrlUpdateConnection(uint8 isDecrease, uint8 isTcp, ipaddr_t ip)
{

	if (_rtl8651_dos_enable == FALSE)
	{
		return;
	}

	if ( isTcp )
	{	
		if (_rtl8651_dos_sw[0] & RTL8651_DOS_SRC_TCPCONNOVERFLOW)
		{
			_rtl8651_connSrcTrackingUpdate(RTL8651_DOS_CONNTRACK_TCP, ip, isDecrease);
		}
	} else
	{	
		if (_rtl8651_dos_sw[0] & RTL8651_DOS_SRC_UDPCONNOVERFLOW)
		{
			_rtl8651_connSrcTrackingUpdate(RTL8651_DOS_CONNTRACK_UDP, ip, isDecrease);
		}
	}

	
	if (_rtl8651_dos_sw[0] & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW)
	{
		_rtl8651_connSrcTrackingUpdate(RTL8651_DOS_CONNTRACK_TCPUDP, ip, isDecrease);
	}
}


static inline int32 _rtl8651_dosSrcConnCtrl(uint8 flowType, ipaddr_t ip)
{
	switch (flowType)
	{
		case RTL8651_DOS_CONNTRACK_TCP:
			if ( _rtl8651_connSrcTracking_getConnCount(flowType, ip) >= _rtl8651_perSrc_tcpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			if ( _rtl8651_connSrcTracking_getConnCount(flowType, ip) >= _rtl8651_perSrc_udpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			if ( _rtl8651_connSrcTracking_getConnCount(flowType, ip) >= _rtl8651_perSrc_tcpudpConn_threshold )
			{
				goto success;
			}
			break;
	}
	return FAILED;
success:
	return SUCCESS;
}




static inline int32 _rtl8651_dosConnCtrl(uint8 flowType)
{
	int32 tcpCnt, udpCnt, totalCnt;

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_LAN)
	{
		tcpCnt = rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt;
		udpCnt = rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt;
	}else
	{
		tcpCnt = rtl8651_tblDrvNaptCounter.dosCountedTcpCnt;
		udpCnt = rtl8651_tblDrvNaptCounter.dosCountedUdpCnt;
	}

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_WAN)
	{
		tcpCnt -= (rtl8651_tblDrvNaptCounter.dosCountedTcpCnt -
					rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt);
		udpCnt -= (rtl8651_tblDrvNaptCounter.dosCountedUdpCnt -
					rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt); 
	}

	assert( tcpCnt >= 0 && udpCnt >= 0 );
	totalCnt = tcpCnt + udpCnt;

	switch ( flowType )
	{
		case RTL8651_DOS_CONNTRACK_TCP:
			if ( tcpCnt >= _rtl8651_local_tcpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			if ( udpCnt >= _rtl8651_local_udpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			if ( totalCnt >= _rtl8651_local_tcpudpConn_threshold )
			{
				goto success;
			}
			break;
	}

	return FAILED;
success:
	return SUCCESS;
}


#define DOS_PERSRC_SUSPECTFLOW_CACHE_SYSTEM_FUNCTIONS

static int32 _rtl8651_dosScanTracking_init(rtl8651_fwdEngineInitPara_t *para)
{
	uint32 idx;

	
	_rtl8651_ScanTrackingSystem_enable = FALSE;

	SuspectFlowCache_Cnt = para->dos_total_portScan_trackCnt;

	if (SuspectFlowCache_Cnt == 0)
		goto out;	

	
	_rtl8651_scan_monitor_window = RTL8651_DOS_SCAN_MOINTOR_WIN_DEFAULT;
	
	for (idx = 0 ; idx < RTL8651_MAX_DIALSESSION ; idx ++)
		_rtl8651_scan_threshold[idx] = RTL8651_DOS_SCAN_THRESHOLD_DEFAULT;

	
	SuspectFlowCache_ptr = (_rtl8651_dos_SuspectFlowCache_t*) rtlglue_malloc(SuspectFlowCache_Cnt*sizeof(_rtl8651_dos_SuspectFlowCache_t));
	if (!SuspectFlowCache_ptr)
		goto out;	

	
	_rtl8651_ScanTrackingSystem_enable = TRUE;

	
	_rtl8651_dosScanTracking_reinit();

out:
	return SUCCESS;
}
static int32 _rtl8651_dosScanTracking_reinit(void)
{
	_rtl8651_dos_SuspectFlowCache_t *ptr;
	int32 idx;

	if (_rtl8651_ScanTrackingSystem_enable != TRUE)
		return FAILED;

	
	_rtl8651_ScanTrackingSystem_enable = FALSE;

	
	memset(SuspectFlowCache_ptr, 0, SuspectFlowCache_Cnt * sizeof(_rtl8651_dos_SuspectFlowCache_t));
	
	lru_SuspectFlowCache_hdr = SuspectFlowCache_ptr;
	lru_SuspectFlowCache_tail = SuspectFlowCache_ptr + (SuspectFlowCache_Cnt - 1);
	
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx ++)
		SuspectFlowCacheHash[idx] = NULL;

	
	ptr = SuspectFlowCache_ptr;
	for (idx = 0 ; idx < SuspectFlowCache_Cnt ; idx ++, ptr ++)
	{
		if (idx > 0)
			ptr->lru_prev = ptr - 1;
		if (idx < (SuspectFlowCache_Cnt - 1))
			ptr->lru_next = ptr + 1;
	}

	
	_rtl8651_ScanTrackingSystem_enable = TRUE;

	return SUCCESS;
}



static __inline__ void _rtl8651_dosScanTrackingLink(_rtl8651_dos_SuspectFlowCache_t**hdr, _rtl8651_dos_SuspectFlowCache_t *entry)
{	
	entry->hdr = hdr;		
	entry->next = (*hdr);		
	if (*hdr)	{
		(*hdr)->prev = entry;	
	}

	(*hdr) = entry;			
}
static __inline__ void _rtl8651_dosScanTrackingUnlink(_rtl8651_dos_SuspectFlowCache_t *entry)
{	
	_rtl8651_dos_SuspectFlowCache_t **hdr = entry->hdr;
	if (!hdr) {	
		goto clearLink;
	}
	if (entry->prev)
		entry->prev->next = entry->next;
	if (entry->next)
		entry->next->prev = entry->prev;

	if ((*hdr) == entry)
		(*hdr) = entry->next;
clearLink:
	entry->hdr	= NULL;
	entry->prev	= NULL;
	entry->next	= NULL;
}
static __inline__ void _rtl8651_dosScanTrackingLruUnlink(_rtl8651_dos_SuspectFlowCache_t *entry)
{	
	if (entry->lru_prev)
		entry->lru_prev->lru_next = entry->lru_next;
	if (entry->lru_next)
		entry->lru_next->lru_prev = entry->lru_prev;
	if (lru_SuspectFlowCache_hdr == entry)
		lru_SuspectFlowCache_hdr = entry->lru_next;
	if (lru_SuspectFlowCache_tail == entry)
		lru_SuspectFlowCache_tail = entry->lru_prev;
	entry->lru_next = NULL;
	entry->lru_prev = NULL;
}
static __inline__ void _rtl8651_dosScanTrackingLruMoveToTail(_rtl8651_dos_SuspectFlowCache_t *entry)
{	
	if (lru_SuspectFlowCache_tail == entry)
		return;

	assert(lru_SuspectFlowCache_hdr != lru_SuspectFlowCache_tail);	
	_rtl8651_dosScanTrackingLruUnlink(entry);
	entry->lru_prev = lru_SuspectFlowCache_tail;
	if (lru_SuspectFlowCache_tail)
		lru_SuspectFlowCache_tail->lru_next = entry;
	lru_SuspectFlowCache_tail = entry;
}
static __inline__ void _rtl8651_dosScanTrackingLruMoveToHead(_rtl8651_dos_SuspectFlowCache_t *entry)
{	
	if (lru_SuspectFlowCache_hdr == entry)
		return;

	assert(lru_SuspectFlowCache_hdr != lru_SuspectFlowCache_tail);	
	_rtl8651_dosScanTrackingLruUnlink(entry);
	entry->lru_next = lru_SuspectFlowCache_hdr;
	if (lru_SuspectFlowCache_hdr)
		lru_SuspectFlowCache_hdr->lru_prev = entry;
	lru_SuspectFlowCache_hdr = entry;
}

static _rtl8651_dos_SuspectFlowCache_t *_rtl8651_dosScanTrackingFindEntry(ipaddr_t sip)
{
	uint32 hash;
	_rtl8651_dos_SuspectFlowCache_t *ptr;

	hash = _rtl8651_dosHash(sip);

	ptr = SuspectFlowCacheHash[hash];
	while (ptr && (ptr->sip != sip))
		ptr = ptr->next;
	if (!ptr)
	{	

			ptr = lru_SuspectFlowCache_hdr;
			if (ptr && ptr->expire <= _sysUpSeconds)
			{	
				_rtl8651_dosScanTrackingUnlink(ptr);
				_rtl8651_dosScanTrackingLink(&(SuspectFlowCacheHash[hash]), ptr);
				_rtl8651_dosScanTrackingLruMoveToTail(ptr);
			}else
				return NULL;	
			assert(ptr);
			
			ptr->sip = sip;
			
			ptr->direction = 0;
			ptr->vlan = 0;
			ptr->dsid = 0;
			
		resetEntryInfo:
			ptr->expire = _sysUpSeconds + _rtl8651_scan_monitor_window;
			ptr->SynDstIpMask = 0;
			ptr->SynSrcPortMask = 0;
			ptr->SynDstPortMask = 0;
			ptr->SynComplainCnt = 0;
			ptr->FinDstIpMask = 0;
			ptr->FinSrcPortMask = 0;
			ptr->FinDstPortMask = 0;
			ptr->FinComplainCnt = 0;
			ptr->AckDstIpMask = 0;
			ptr->AckSrcPortMask = 0;
			ptr->AckDstPortMask = 0;
			ptr->AckComplainCnt = 0;
			ptr->UdpDstIpMask = 0;
			ptr->UdpSrcPortMask = 0;
			ptr->UdpDstPortMask = 0;
			ptr->UdpComplainCnt = 0;
			ptr->TotalComplainCnt = 0;
	} else if (ptr->expire <= _sysUpSeconds)
	{	
		_rtl8651_dosScanTrackingLruMoveToTail(ptr);
		goto resetEntryInfo;
	}
	assert(ptr);
	return ptr;
}

static int32 _rtl8651_dosTcpUdpScan(_rtl8651_dos_SuspectFlowCache_t *ptr, uint16 dsid, uint8 l4Type)
{
	if (ptr->TotalComplainCnt == _rtl8651_scan_threshold[dsid])
	{	
		if (!ptr->vlan)
		{
			
			#ifdef RTL865X_DEBUG
			rtlglue_printf("[%s:%d] Warning: Tracking Count is zero, but the complain count has exceed threshold [%d]\n", __FUNCTION__, __LINE__, _rtl8651_scan_threshold[dsid]);
			#endif
			return FAILED;
		}
		
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{	
			uint32 totalComplainWeight;
#ifdef _RTL_NEW_LOGGING_MODEL
			rtl8651_logInfo_t info;
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= ptr->dsid;
			info.pkt_sip		= ptr->sip;
			info.pkt_dip		= 0;
			info.pkt_proto		= l4Type;
			info.pkt_direction	= ptr->direction;
			info.pkt_sport		= 0xffff;
			info.pkt_dport		= 0xffff;
			info.pkt_icmpType	= 0xff;
			info.pkt_icmpId	= 0xffff;
			info.action		= RTL8651_LOGACTION_NONE;

			totalComplainWeight = (ptr->TotalComplainCnt - 1) * RTL8651_DOS_SCAN_DECIDE_WEIGHT_NUMERATOR;
			
			

			if ((ptr->SynComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_SYN, &info);
			}else if ((ptr->FinComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_FIN, &info);
			}else if ((ptr->AckComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_ACK, &info);
			}else if ((ptr->UdpComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_UDP, &info);
			}else
			{	
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_HYBRID, &info);
			}
#else
			char *synScan = "SYN Scan";
			char *finScan = "FIN Scan";
			char *ackScan = "ACK Scan";
			char *udpScan = "UDP Scan";
			char *hybridScan = "Hybrid Scan";
			char *msg = NULL;

			totalComplainWeight = (ptr->TotalComplainCnt - 1) * RTL8651_DOS_SCAN_DECIDE_WEIGHT_NUMERATOR;

			
			if ((ptr->SynComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				msg = synScan;
				goto WRITE_LOG;
			}
			if ((ptr->FinComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				msg = finScan;
				goto WRITE_LOG;
			}
			if ((ptr->AckComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				msg = ackScan;
				goto WRITE_LOG;
			}
			if ((ptr->UdpComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	
				msg = udpScan;
				goto WRITE_LOG;
			}
			msg = hybridScan;

			WRITE_LOG:
			(*_pUserLoggingFunc)(
				ptr->dsid,
				RTL8651_LOGMODULE_DOS,
				(unsigned char)l4Type,				
				(unsigned char)ptr->direction,		
				(unsigned long)ptr->sip,			
				(unsigned long)0,					
				(unsigned short)0,					
				(unsigned short)0,					
				0,								
				RTL8651_LOGACTION_FORWARD,	
				msg );							
#endif
		}
		
		if (ptr && ptr->vlan)
		{
			assert(ptr->dsid < RTL8651_MAX_DIALSESSION);
			assert(ptr->sip);
			_rtl8651_procDoSIP(RTL8651_DOS_PORTSCAN, ptr->dsid, ptr->vlan->vid, ptr->sip);
		}
		return SUCCESS;
	}
	return FAILED;
}


void _rtl8651_dosScanTracking(struct rtl_pktHdr*pkt, struct ip *ip, uint8 l4Type, void*l4hdr)
{
	uint32 hash;
	ipaddr_t sip;
	_rtl8651_dos_SuspectFlowCache_t* ptr;

	if ((_rtl8651_ScanTrackingSystem_enable != TRUE)||(_rtl8651_ScanTrackingSystem_turnON != TRUE))
		goto out;

	if (ntohs(ip->ip_off) & (IP_OFFMASK))
		goto out;

	if ((l4Type != IPPROTO_TCP) && (l4Type != IPPROTO_UDP))
		goto out;

	
	sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	if (!sip)
		goto out;

	
	hash = _rtl8651_dosHash(sip);
	ptr = SuspectFlowCacheHash[hash];
	while (ptr && (ptr->sip != sip))
		ptr = ptr->next;
	if (!ptr)
		goto out;	
	
	if (ptr->expire <= _sysUpSeconds)
	{	
		_rtl8651_dosScanTrackingUnlink(ptr);
		_rtl8651_dosScanTrackingLruMoveToHead(ptr);
		goto out;
	}
	
	
	
	{
		uint8 th_flags;
		struct tcphdr *tc;
		struct udphdr *ud;
		ipaddr_t dip;
		uint16 sport, dport;
		uint32 dipMask, sportMask, dportMask;

		
		ptr->vlan = &DrvTbl.vlan[pkt->ph_vlanIdx & (RTL8651_VLAN_NUMBER - 1)];
		ptr->direction = ((ptr->vlan)->internal?0:1);
		ptr->dsid = pkt->ph_dsid;

		if (l4Type == IPPROTO_TCP)
		{	
			tc = (struct tcphdr*)l4hdr;
			th_flags = tc->th_flags;
			
			dip		= PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
			sport	= ntohs(tc->th_sport);
			dport	= ntohs(tc->th_dport);
			
			dipMask		= 1 << (dip & 0x0000001f);
			sportMask	= 1 << (sport & 0x0000001f);
			dportMask	= 1 << (dport & 0x0000001f);
			
			if (th_flags & TH_SYN)
			{
				ptr->SynDstIpMask	|= dipMask;
				ptr->SynSrcPortMask	|= sportMask;
				ptr->SynDstPortMask	|= dportMask;
			}
			if (th_flags & TH_FIN)
			{
				ptr->FinDstIpMask		|= dipMask;
				ptr->FinSrcPortMask	|= sportMask;
				ptr->FinDstPortMask	|= dportMask;
			}
			if (th_flags & TH_ACK)
			{
				ptr->AckDstIpMask	|= dipMask;
				ptr->AckSrcPortMask	|= sportMask;
				ptr->AckDstPortMask	|= dportMask;
			}
		}else
		{	
			ud = (struct udphdr*)l4hdr;
			
			dip		= PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
			sport	= ntohs(ud->uh_sport);
			dport	= ntohs(ud->uh_dport);
			
			ptr->UdpDstIpMask	|= (1 << (dip & 0x0000001f));
			ptr->UdpSrcPortMask	|= (1 << (sport & 0x0000001f));
			ptr->UdpDstPortMask	|= (1 << (dport & 0x0000001f));
		}
	}
out:
	return;
}
int32 _rtl8651_dosScanCheckComplain(uint16 dsid, struct ip *ip)
{
	ipaddr_t dip;
	_rtl8651_dos_SuspectFlowCache_t *ptr = NULL;
	struct tcphdr *tc = NULL;
	struct icmp *ic = NULL;
	uint8 l4Type;

	if ((_rtl8651_ScanTrackingSystem_enable != TRUE)||(_rtl8651_ScanTrackingSystem_turnON != TRUE))
		goto NoAttackOut;

	if (ntohs(ip->ip_off) & (IP_OFFMASK))
		goto NoAttackOut;

	l4Type = ip->ip_p;
	switch(l4Type)
	{
		case IPPROTO_TCP:	
			tc = (struct tcphdr*)((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
			if (!(tc->th_flags & TH_RST))
				goto NoAttackOut;
			break;
		case IPPROTO_ICMP:	
			ic = (struct icmp*)((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
#if 1
			
			if (ic->icmp_type != ICMP_UNREACH)
				goto NoAttackOut;
			else if (ic->icmp_code != ICMP_UNREACH_PORT)
				goto NoAttackOut;
#else
			if ((ic->icmp_type != ICMP_UNREACH) || (ic->icmp_code != ICMP_UNREACH_PORT))
				goto NoAttackOut;
#endif
			break;
		default:
			goto NoAttackOut;
	}

	
	dip = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
	if ((ptr = _rtl8651_dosScanTrackingFindEntry(dip)) == NULL)
		goto NoAttackOut;
	
	assert(ptr);
	{
		ipaddr_t sip;
		uint16 sport, dport;
		uint32 dipMask, sportMask, dportMask;

		
		sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		if (l4Type == IPPROTO_TCP)
		{	
			sport = ntohs(tc->th_sport);
			dport = ntohs(tc->th_dport);
		}else
		{	
			struct ip*eip;
			struct udphdr *eud;
			eip = &ic->icmp_ip;
			if (eip->ip_p != IPPROTO_UDP)
				goto NoAttackOut;
			eud = (struct udphdr *)((int8 *) eip + ( (eip->ip_vhl & 0x0f) << 2));
			
			sport = ntohs(eud->uh_dport);
			dport = ntohs(eud->uh_sport);
		}

		
		dipMask		= 1 << (sip & 0x0000001f);
		sportMask	= 1 << (dport & 0x0000001f);
		dportMask	= 1 << (sport & 0x0000001f);

		if (l4Type == IPPROTO_TCP)
		{	
			uint8 newComplain = FALSE;
			
			if ((ptr->SynDstIpMask & dipMask) &&
				(ptr->SynSrcPortMask & sportMask) &&
				(ptr->SynDstPortMask & dportMask))
			{
				ptr->SynComplainCnt ++;		
				newComplain = TRUE;
			}
			
			if ((ptr->FinDstIpMask & dipMask) &&
				(ptr->FinSrcPortMask & sportMask) &&
				(ptr->FinDstPortMask & dportMask))
			{
				ptr->FinComplainCnt ++;		
				newComplain = TRUE;
			}
			
			if ((ptr->AckDstIpMask & dipMask) &&
				(ptr->AckSrcPortMask & sportMask) &&
				(ptr->AckDstPortMask & dportMask))
			{
				ptr->AckComplainCnt ++;		
				newComplain = TRUE;
			}
			if (newComplain == TRUE)
				ptr->TotalComplainCnt ++;
		}else
		{	
			
			if ((ptr->UdpDstIpMask & dipMask) &&
				(ptr->UdpSrcPortMask & sportMask) &&
				(ptr->UdpDstPortMask & dportMask))
			{
				ptr->UdpComplainCnt ++;		
				ptr->TotalComplainCnt ++;
			}
		}
		
		return _rtl8651_dosTcpUdpScan(ptr, dsid, (l4Type == IPPROTO_TCP?IPPROTO_TCP:IPPROTO_UDP));
	}
	
NoAttackOut:
	return FAILED;
}

int32 _rtl8651_dosScanCheckTcpOutboundFailUnusual(uint16 dsid, struct ip *ip, struct tcphdr *tc)
{
	uint8 tcpFlag;
	ipaddr_t sip;
	_rtl8651_dos_SuspectFlowCache_t *ptr;

	if ((_rtl8651_ScanTrackingSystem_enable != TRUE)||(_rtl8651_ScanTrackingSystem_turnON != TRUE))
		goto NoAttackOut;

	if (ntohs(ip->ip_off) & IP_OFFMASK)
		goto NoAttackOut;

	tcpFlag = tc->th_flags;

	if (tcpFlag & TH_RST)
		goto NoAttackOut;	

	sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);

	
	if ((ptr = _rtl8651_dosScanTrackingFindEntry(sip)) == NULL)
		goto NoAttackOut;	

	
	assert(ptr);
	{
		if (tcpFlag & (TH_FIN|TH_ACK))
			ptr->TotalComplainCnt ++;
		if (tcpFlag & TH_FIN)
			ptr->FinComplainCnt ++;
		if (tcpFlag & TH_ACK)
			ptr->AckComplainCnt ++;
		
	}
	
	
	return _rtl8651_dosTcpUdpScan(ptr, dsid, IPPROTO_TCP);

NoAttackOut:
	return FAILED;
}

int32 rtl8651_dosScanTrackingSetPara(uint32 dsid, uint32 windowSize, uint32 threshold)
{
	uint32 wSize, tHold;

	if (_rtl8651_ScanTrackingSystem_enable != TRUE)
		return FAILED;
	
	if (dsid >= RTL8651_MAX_DIALSESSION)
		return FAILED;
	wSize = windowSize;
	tHold = threshold;
	if (wSize < RTL8651_DOS_SCAN_MIN_MONITOR_WIN)
		wSize = RTL8651_DOS_SCAN_MIN_MONITOR_WIN;
	if (tHold < RTL8651_DOS_SCAN_MIN_THRESHOLD)
		tHold = RTL8651_DOS_SCAN_MIN_THRESHOLD;

	rtlglue_drvMutexLock();	
	
	_rtl8651_scan_threshold[dsid] = tHold;
	
	_rtl8651_scan_monitor_window = wSize;
	
	_rtl8651_dosScanTracking_reinit();	

	rtlglue_drvMutexUnlock();	
	return SUCCESS;
}

#define DOS_NORMAL_ATTACK_ITEM_FUNCTIONS

static int32 _rtl8651_dosPingOfDeath(struct ip *ip,struct icmp *ic){
	uint16 ip_off = ntohs(ip->ip_off);
	uint32 val;

	if((ip_off & IP_MF) == 0 && (ip_off & IP_OFFMASK))
	{
		ip_off &= IP_OFFMASK;
		val = (ip_off << 3) + ntohs(ip->ip_len) -((ip->ip_vhl & 0x0f) << 2);
		if(val > 65535)
			return SUCCESS;	
	}
	return FAILED;
}

static int32 _rtl8651_dosSynFlood(uint32 dsid,struct ip *ip,struct tcphdr *tc,uint32* NeedLog){

	if (tc->th_flags & TH_SYN)
	{
		_rtl8651_local_syn_counter[dsid]++;

		if (_rtl8651_local_syn_counter[dsid] > _rtl8651_local_syn_threshold[dsid])
		{
			if (_rtl8651_local_syn_counter[dsid] == (_rtl8651_local_syn_threshold[dsid]+1))
			{
				*NeedLog = TRUE;
			}
			else
			{
				*NeedLog = FALSE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}

static int32 _rtl8651_dosStealthFin(uint32 dsid,struct ip *ip,struct tcphdr *tc,uint32 *NeedLog){

	if (tc->th_flags & TH_FIN)
	{
		_rtl8651_local_fin_counter[dsid] ++;

		if (_rtl8651_local_fin_counter[dsid] > _rtl8651_local_fin_threshold[dsid])
		{
			if (_rtl8651_local_fin_counter[dsid] == (_rtl8651_local_fin_threshold[dsid]+1))
			{
				*NeedLog = TRUE;
			}
			else
			{
				*NeedLog = FALSE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}

static int32 _rtl8651_dosIcmpFlood(uint32 dsid,struct ip *ip,struct icmp *ic, uint32* NeedLog){
	


		_rtl8651_local_icmp_counter[dsid]++;
		if(_rtl8651_local_icmp_counter[dsid] > _rtl8651_local_icmp_threshold[dsid])
		{
			if (_rtl8651_local_icmp_counter[dsid] == (_rtl8651_local_icmp_threshold[dsid] + 1))
			{
				*NeedLog = TRUE;
			}
			else
			{
				*NeedLog = FALSE;
			}
			return SUCCESS;		
		}

	return FAILED;
}

static int32 _rtl8651_dosTcpLand(struct ip *ip,struct tcphdr *tc){
	

		uint32 ip_s, ip_d;
		ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		ip_d = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
		if(ip_s == ip_d){
			return SUCCESS;
		}

	return FAILED;
}

static int32 _rtl8651_dosUdpLand(struct ip *ip,struct udphdr *ud){
	

		uint32 ip_s, ip_d;
		ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		ip_d = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
		if(ip_s == ip_d){
			return SUCCESS;
		}

	return FAILED;
}

static int32 _rtl8651_dosIcmpLand(struct ip *ip,struct icmp *ic){
	uint32 ip_s, ip_d;
	ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	ip_d = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
	if(ip_s == ip_d) return SUCCESS;
	return FAILED;
}

static int32 _rtl8651_dosSmurf(struct ip *ip,struct icmp *ic, uint16 vid){
	
	if(ic->icmp_type == ICMP_ECHO){
		
		
		rtl8651_tblDrv_routeTable_t *tb;
		uint32 ip_s;
		ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		
		tb = _rtl8651_getRoutingEntry(ip_s);			
		
		
		if(!tb || (tb->dvid != vid &&FALSE==_rtl8651_isLanSideIpUnnumberedIpAddr(ip_s))){
			return SUCCESS;
		}		
	}
	return FAILED;
}


static int32 _rtl8651_dosIpSpoof(struct ip *ip, uint16 vid,uint8 direction){
			
	rtl8651_tblDrv_routeTable_t *tb;
	uint32 ip_s;

	ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);			
	tb = _rtl8651_getRoutingEntry(ip_s);

	
	if (direction == 1)
	{
		if (tb)	
		{
			if (tb->dvid == vid)
			{
				
			} else
			{
				if (	(tb->nextHopType == RTL8651_LL_PPTP) ||
					(tb->nextHopType == RTL8651_LL_L2TP)	)
				{	
					if (	(tunnel.valid) &&
						((tb->dvid == tunnel.wanVid) ||(tb->dvid == tunnel.loopBackVid)) &&
						((vid == tunnel.wanVid)||(vid == tunnel.loopBackVid)))
					{
						goto legal;
					}
				}
				
				return SUCCESS;
			}
		}
	
		if ((tb!=NULL) &&(tb->dvid!=vid)) return SUCCESS;
	}
	else 
	{
		if((tb==NULL)||(tb->dvid!=vid)) return SUCCESS;
	}	
legal:
	return FAILED;
}


static int32 _rtl8651_dosScan(struct ip *ip,struct tcphdr *tc){

	if(_tcpDosScanBitmap[tc->th_flags&0x3f])
		return SUCCESS;
	return FAILED;
}

static int32 _rtl8651_dosUdpFlood(uint32 dsid,struct ip *ip,struct udphdr *ud,uint32 *NeedLog){

	_rtl8651_local_udp_counter[dsid]++;

	if (_rtl8651_local_udp_counter[dsid] > _rtl8651_local_udp_threshold[dsid])
	{
		if (_rtl8651_local_udp_counter[dsid] == (_rtl8651_local_udp_threshold[dsid]+1))
		{
			*NeedLog = TRUE;
		}
		else
		{
			*NeedLog = FALSE;
		}
		return SUCCESS;
	}
	return FAILED;
}

static int32 _rtl8651_dosUdpBomb(struct ip *ip,struct udphdr *ud){
	uint32 ipPayLoadLength;

	
	if (!(ip->ip_off & (IP_OFFMASK|IP_MF)))
	{	
		ipPayLoadLength = ntohs(ip->ip_len) - ((ip->ip_vhl & 0x0f) << 2);
		
		if (ipPayLoadLength > ntohs(ud->uh_ulen))
			return SUCCESS;
	}

	return FAILED;
}			

static int32 _rtl8651_dosUdpEchoChargen(struct ip *ip, struct udphdr *ud) {
	if(	(ud->uh_dport==htons(7)||ud->uh_dport==htons(17)||ud->uh_dport==htons(19))||
		(ud->uh_sport==htons(7)||ud->uh_sport==htons(17)||ud->uh_sport==htons(19))){
		return SUCCESS;
	}
	return FAILED;
}

static int32 _rtl8651_dosSynWithData(struct ip *ip,struct tcphdr *tc)
{
	if(tc->th_flags == TH_SYN )
	{
		uint32 datalen= ntohs(ip->ip_len)-((ip->ip_vhl & 0xf)<<2)- ((( tc->th_off_x>>4)&0xf)<<2);		
		if(datalen>0)
		{
			return SUCCESS;
		}
		if (htons(ip->ip_off) & IP_MF)
		{
			return SUCCESS;
		}
	}
	return FAILED;
}

#define DOS_FRAGMENT_ATTACK_DETECTION_FUNCTIONS




int32 rtl8651a_dosFragmentCheck(uint32 dsid, struct ip* ip, struct rtl_pktHdr* pktHdr){
	uint8 *l4hdr = NULL;
	uint32 Attack = 0;
	rtl8651_tblDrv_vlanTable_t *vlanp;
	uint8 direction;
	uint16 vid;
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;
#endif

	if (_rtl8651_dos_enable == FALSE) return FAILED;

	
	vlanp = &DrvTbl.vlan[pktHdr->ph_vlanIdx & (RTL8651_VLAN_NUMBER - 1)];
	vid = vlanp->vid;
	
	if(vlanp->internal)
		direction = 0;
	else
		direction = 1;
	
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	l4hdr = (uint8 *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
	
	if((_rtl8651_dos_sw[dsid]&RTL8651_DOS_PINGOFDEATH) && _rtl8651_dosPingOfDeath(ip,(struct icmp*)l4hdr) == SUCCESS){	
		Attack |= RTL8651_DOS_PINGOFDEATH;
	}


	if (Attack)
	{
		
		
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
			if (Attack & RTL8651_DOS_PINGOFDEATH)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_ICMP;
				info.pkt_direction	= direction;
				info.pkt_icmpType	= ((ntohs(ip->ip_off)&IP_OFFMASK)?(0xff):(((struct icmp*)l4hdr)->icmp_type));
				info.pkt_icmpId	= ((ntohs(ip->ip_off)&IP_OFFMASK)?(0xffff):(ntohs(((struct icmp*)l4hdr)->icmp_type)));
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpPingOfDeath, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, 
				    (unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)0xffffffff, 
					(unsigned short)0xffffffff, 
					((ip->ip_off&IP_OFFMASK)?(0xff):(((struct icmp*)l4hdr)->icmp_type)), 
					RTL8651_LOGACTION_DROP, 
					"ICMP Ping Of Death" );
#endif
			}
		}
		
		_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;
}





int32 rtl8651a_dosFragUdpBombCheck(uint32 dsid, uint16 vid, struct ip* ip, struct udphdr*ud, uint8 direction, uint32 IpTotalLen, struct rtl_pktHdr* pktHdr)
{
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	
#endif
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	if((_rtl8651_dos_sw[dsid] & RTL8651_DOS_UDPBOMB) &&
		(IpTotalLen > ntohs(ud->uh_ulen))){
		
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= direction;
			info.pkt_sport		= ntohs(ud->uh_sport);
			info.pkt_dport		= ntohs(ud->uh_dport);
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpBomb, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    	(unsigned char)ip->ip_p, 
			    	(unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)(ntohs(ud->uh_sport)),
				(unsigned short)(ntohs(ud->uh_dport)),
				0xff,
				RTL8651_LOGACTION_DROP, 
				"UDP Bomb" );
#endif
		}
			
			_rtl8651_procDoSPkt(RTL8651_DOS_UDPBOMB, dsid, vid, ip, direction, pktHdr);
			return SUCCESS;
	}
	return FAILED;
}






int32 rtl8651a_dosTearDropLogging(uint32 dsid, uint16 vid, struct ip* ip, uint8 direction, struct rtl_pktHdr* pktHdr)
{
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	if(_rtl8651_dos_sw[dsid] & RTL8651_DOS_TEARDROP)
	{
		struct udphdr *ud;
		struct tcphdr *tc;
		struct icmp *ic;
		uint32 sport = 0xffffffff;
		uint32 dport = 0xffffffff;
		uint8 type = 0xff;
		uint16 id = 0xffff;
#ifdef _RTL_NEW_LOGGING_MODEL
		rtl8651_logInfo_t info;
#endif
		if (!(ntohs(ip->ip_off) & IP_OFFMASK))
		{
			switch (ip->ip_p)
			{
				case IPPROTO_TCP:
					tc = (struct tcphdr *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
					sport = ntohs(tc->th_sport);
					dport = ntohs(tc->th_dport);
					break;
				case IPPROTO_UDP:
					ud = (struct udphdr *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
					sport = ntohs(ud->uh_sport);
					dport = ntohs(ud->uh_dport);
					break;
				case IPPROTO_ICMP:
					ic = (struct icmp *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
					type = ic->icmp_type;
					id = ntohs(ic->icmp_id);
					break;
			}
		}

		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= ip->ip_p;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.pkt_icmpType	= type;
			info.pkt_icmpId	= id;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TearDrop, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    	(unsigned char)ip->ip_p, 
			    	(unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				type,
				RTL8651_LOGACTION_DROP, 
				"IP TearDrop" );
#endif
		}
			
			_rtl8651_procDoSPkt(RTL8651_DOS_TEARDROP, dsid, vid, ip, direction, pktHdr);
			return SUCCESS;
	}
	return FAILED;
}

#define DOS_NORMAL_ATTACK_DETECTION_FUNCTIONS
int32 _rtl8651_dosNaptConnCheck(uint8 isTcp, ipaddr_t ip, uint8 direction)
{
#define DOS_CONNCTRL_TCP_CHECKLIST	(RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW)
#define DOS_CONNCTRL_UDP_CHECKLIST	(RTL8651_DOS_SRC_UDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW|RTL8651_DOS_UDPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW)

	uint32 dos_checkList = _rtl8651_dos_sw[0];
	uint32 Attack = 0;

	if (_rtl8651_dos_enable == FALSE) return SUCCESS;

	
	
	if ( isTcp )
	{
		dos_checkList &= DOS_CONNCTRL_TCP_CHECKLIST;
	} else
	{
		dos_checkList &= DOS_CONNCTRL_UDP_CHECKLIST;
	}
	
	
	
	if ( (dos_checkList & RTL8651_DOS_SRC_TCPCONNOVERFLOW) &&
		(_rtl8651_dosSrcConnCtrl(RTL8651_DOS_CONNTRACK_TCP, ip) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_SRC_TCPCONNOVERFLOW;
	}

	
	if ( (dos_checkList & RTL8651_DOS_SRC_UDPCONNOVERFLOW) &&
		(_rtl8651_dosSrcConnCtrl(RTL8651_DOS_CONNTRACK_UDP, ip) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_SRC_UDPCONNOVERFLOW;
	}

	
	if ( (dos_checkList & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW) &&
		(_rtl8651_dosSrcConnCtrl(RTL8651_DOS_CONNTRACK_TCPUDP, ip) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW;
	}

	
	if ( (dos_checkList & RTL8651_DOS_TCPCONNOVERFLOW) &&
		(_rtl8651_dosConnCtrl(RTL8651_DOS_CONNTRACK_TCP) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_TCPCONNOVERFLOW;
	}
	
	if ( (dos_checkList & RTL8651_DOS_UDPCONNOVERFLOW) &&
		(_rtl8651_dosConnCtrl(RTL8651_DOS_CONNTRACK_UDP) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_UDPCONNOVERFLOW;
	}
	
	if ( (dos_checkList & RTL8651_DOS_TCPUDPCONNOVERFLOW) &&
		(_rtl8651_dosConnCtrl(RTL8651_DOS_CONNTRACK_TCPUDP) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_TCPUDPCONNOVERFLOW;
	}

	
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return SUCCESS;
	
	if (Attack)
	{
		rtl8651_tblDrv_routeTable_t *tb;
		tb = _rtl8651_getRoutingEntry(ip);

		
		if ( tb && tb->valid )
		{
			_rtl8651_procDoSIP(Attack, RTL8651_DSID_ALL, tb->dvid, ip);	
		}

		

		
		return FAILED;
	}
	return SUCCESS;
}





int32 rtl8651a_dosTcpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction,uint32 wanStatus, struct rtl_pktHdr *pktHdr, uint8 checkType){
	struct tcphdr *tc = NULL;
	uint32 sport, dport;
	uint32 NeedLog;
	uint32 Attack = 0;
	uint32 l3Only = (ntohs(ip->ip_off) & (IP_OFFMASK));	
	uint32 dos_checkList = _rtl8651_dos_sw[dsid];
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	
#endif
	
	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);

	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	assert(ip);
	tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));

	#define DOS_TCP_L3_CHECKLIST		(RTL8651_DOS_IPSPOOF|RTL8651_DOS_TCPLAND|RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD|RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN)
	#define DOS_TCP_FAST_CHECKLIST	(RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD|RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN)

	if (checkType == RTL8651_DOS_FAST_CHECK)
		dos_checkList &= DOS_TCP_FAST_CHECKLIST;
	else
		dos_checkList &= ~DOS_TCP_FAST_CHECKLIST;

	if (l3Only)
	{
		dos_checkList &= DOS_TCP_L3_CHECKLIST;
		sport = 0xffffffff;
		dport = 0xffffffff;
	}else
	{
		sport = (uint32)ntohs(tc->th_sport);
		dport = (uint32)ntohs(tc->th_dport);
	}



	if((dos_checkList&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, 
				RTL8651_LOGACTION_DROP, 
				"IP Spoofing" );
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}

	
	
	if((dos_checkList&RTL8651_DOS_SYNFLOOD) && _rtl8651_dosSynFlood(dsid,ip,tc,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_TCP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_SynFlood, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, 
				    (unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, 
					RTL8651_LOGACTION_DROP, 
					"TCP SYN Flood" );
#endif
			}
		}
		Attack |= RTL8651_DOS_SYNFLOOD;
 	}	

	
	if ((dos_checkList&RTL8651_DOS_SRC_SYNFLOOD) && _rtl8651_dosSrcSynFlood(dsid,ip,tc, &NeedLog) == SUCCESS) {
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostSynFlood, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, 
				RTL8651_LOGACTION_DROP, 
				"HOST Attack: TCP SYN Flood" );
#endif
		}
		Attack |= RTL8651_DOS_SRC_SYNFLOOD;
	}

	if((dos_checkList&RTL8651_DOS_STEALTHFIN) && _rtl8651_dosStealthFin(dsid,ip,tc,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_TCP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_StealthFin, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, 
				    (unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, 
					RTL8651_LOGACTION_DROP, 
					"TCP Stealth FIN Port Scan" );
#endif
			}
		}
		Attack |= RTL8651_DOS_STEALTHFIN;
	}

	if((dos_checkList&RTL8651_DOS_SRC_STEALTHFIN) && _rtl8651_dosSrcStealthFin(dsid,ip,tc,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostStealthFin, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, 
				RTL8651_LOGACTION_DROP, 
				"HOST Attack: TCP Stealth FIN Port Scan" );
#endif
		}
		Attack |= RTL8651_DOS_SRC_STEALTHFIN;
	}



	if((dos_checkList&RTL8651_DOS_TCPLAND)  && _rtl8651_dosTcpLand(ip,tc) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpLand, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, 
				RTL8651_LOGACTION_DROP, 
				"Land" );
#endif
		}
		Attack |= RTL8651_DOS_TCPLAND;
	}		
	
	if((dos_checkList&RTL8651_DOS_SCAN) && _rtl8651_dosScan(ip,tc) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;	
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpScan, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, 
				RTL8651_LOGACTION_DROP, 
				"TCP Scan" );
#endif
		}
		Attack |= RTL8651_DOS_SCAN;
	}

	if((dos_checkList&RTL8651_DOS_SYNWITHDATA) && _rtl8651_dosSynWithData(ip,tc) == SUCCESS){		
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpSynWithData, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, 
				RTL8651_LOGACTION_DROP, 
				"TCP SYN with Data" );
#endif
		}
		Attack |= RTL8651_DOS_SYNWITHDATA;
	}


	if (Attack)
	{	
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;	
}






int32 rtl8651a_dosIpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction ,uint32 wanStatus, struct rtl_pktHdr* pktHdr){
	uint32 Attack = 0;
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	
#endif

	
	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;
	
	
	
	assert(ip);
	if((_rtl8651_dos_sw[dsid]&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= ip->ip_p;
			info.pkt_direction	= direction;
			info.pkt_sport		= 0xffff;
			info.pkt_dport		= 0xffff;
			info.pkt_icmpType	= 0xff;
			info.pkt_icmpId	= 0xffff;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, 
				(unsigned short)0xffffffff, 
				0, 
				RTL8651_LOGACTION_DROP, 
				"IP Spoofing" );
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}

	if (Attack)
	{	
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;	

}






int32 rtl8651a_dosIcmpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction,uint32 wanStatus, struct rtl_pktHdr* pktHdr){
	struct icmp *ic = NULL;
	uint8 icmpType;
	uint16 icmpId;
	uint32 Attack = 0;
	uint32 NeedLog;
	uint32 l3Only = (ntohs(ip->ip_off) & (IP_OFFMASK));	
	uint32 dos_checkList = _rtl8651_dos_sw[dsid];
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	
#endif

	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);
	
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;
	assert(ip);

	ic = (struct icmp *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));

	#define DOS_ICMP_L3_CHECKLIST (RTL8651_DOS_IPSPOOF|RTL8651_DOS_ICMPLAND|RTL8651_DOS_PINGOFDEATH|RTL8651_DOS_ICMPFLOOD|RTL8651_DOS_SRC_ICMPFLOOD)

	if (l3Only)
	{
		dos_checkList &= DOS_ICMP_L3_CHECKLIST;
		icmpType = 0xff;
		icmpId = 0xffff;
	}else
	{
		icmpType = ic->icmp_type;
		icmpId = ntohs(ic->icmp_id);
	}



	if((dos_checkList&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, 
				(unsigned short)0xffffffff, 
				icmpType, 
				RTL8651_LOGACTION_DROP, 
				"IP Spoofing" );
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}

	
	if((dos_checkList&RTL8651_DOS_ICMPLAND) && _rtl8651_dosIcmpLand(ip,ic) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL		
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpLand, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, 
				(unsigned short)0xffffffff, 
				icmpType, 
				RTL8651_LOGACTION_DROP, 
				"ICMP Land" );
#endif
		}
		Attack |= RTL8651_DOS_ICMPLAND;
	}

	if((dos_checkList&RTL8651_DOS_PINGOFDEATH) && _rtl8651_dosPingOfDeath(ip,ic) == SUCCESS){	
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpPingOfDeath, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, 
				(unsigned short)0xffffffff, 
				icmpType, 
				RTL8651_LOGACTION_DROP, 
				"ICMP Ping Of Death" );
#endif
		}
		Attack |= RTL8651_DOS_PINGOFDEATH;
	}

	if((dos_checkList&RTL8651_DOS_ICMPFLOOD) && _rtl8651_dosIcmpFlood(dsid,ip,ic, &NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_ICMP;
				info.pkt_direction	= direction;
				info.pkt_icmpType	= icmpType;
				info.pkt_icmpId	= icmpId;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpFlood, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, 
				    (unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)0xffffffff, 
					(unsigned short)0xffffffff, 
					icmpType, 
					RTL8651_LOGACTION_DROP, 
					"ICMP Flood" );
#endif
			}
		}
		Attack |= RTL8651_DOS_ICMPFLOOD;
	}

	if((dos_checkList&RTL8651_DOS_SRC_ICMPFLOOD)&&_rtl8651_dosSrcIcmpFlood(dsid,ip,ic,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostIcmpFlood, &info); 
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, 
				(unsigned short)0xffffffff, 
				icmpType, 
				RTL8651_LOGACTION_DROP, 
				"HOST Attack: ICMP Flood" );
#endif
		}
		Attack |= RTL8651_DOS_SRC_ICMPFLOOD;
	}



	if((dos_checkList&RTL8651_DOS_SMURF) && _rtl8651_dosSmurf(ip,ic,vid) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpSmurf, &info); 
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, 
				(unsigned short)0xffffffff, 
				icmpType, 
				RTL8651_LOGACTION_DROP, 
				"ICMP Smurf" );
#endif
		}
		Attack |= RTL8651_DOS_SMURF;
	}	


	if (Attack)
	{	
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;	
}







int32 rtl8651a_dosUdpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction,uint32 wanStatus, struct rtl_pktHdr* pktHdr, uint8 checkType){
	struct udphdr *ud = NULL;
	uint32 sport, dport;
	uint32 Attack = 0;
	uint32 NeedLog;
	uint32 l3Only = (ntohs(ip->ip_off) & (IP_OFFMASK));	
	uint32 dos_checkList = _rtl8651_dos_sw[dsid];
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	
#endif
	
	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	ud = (struct udphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));

	#define DOS_UDP_L3_CHECKLIST		(RTL8651_DOS_IPSPOOF|RTL8651_DOS_UDPLAND|RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD)
	#define DOS_UDP_FAST_CHECKLIST	(RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD|RTL8651_DOS_UDPBOMB)

	if (checkType == RTL8651_DOS_FAST_CHECK)
		dos_checkList &= DOS_UDP_FAST_CHECKLIST;
	else
		dos_checkList &= ~DOS_UDP_FAST_CHECKLIST;

	
	if (l3Only)
	{
		dos_checkList &= DOS_UDP_L3_CHECKLIST;
		sport = 0xffffffff;
		dport = 0xffffffff;
	}else
	{
		sport = (uint32)ntohs(ud->uh_sport);
		dport = (uint32)ntohs(ud->uh_dport);
	}



	if((dos_checkList&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport, 
				(unsigned short)dport, 
				0, 
				RTL8651_LOGACTION_DROP, 
				"IP Spoofing" );
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}


	if((dos_checkList&RTL8651_DOS_UDPFLOOD) && _rtl8651_dosUdpFlood(dsid,ip,ud,&NeedLog)==SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpFlood, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, 
				    (unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, 
					RTL8651_LOGACTION_DROP, 
					"UDP Flood" );
#endif
			}
		}
		Attack |= RTL8651_DOS_UDPFLOOD;
	}

	if((dos_checkList&RTL8651_DOS_SRC_UDPFLOOD) && _rtl8651_dosSrcUdpFlood(dsid,ip,&NeedLog)==SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostUdpFlood, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, 
			    (unsigned char)direction, 
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, 
				RTL8651_LOGACTION_DROP, 
				"HOST Attack: UDP Flood" );
#endif
		}
		Attack |= RTL8651_DOS_SRC_UDPFLOOD;
	}



		if((dos_checkList&RTL8651_DOS_UDPLAND) && _rtl8651_dosUdpLand(ip,ud) == SUCCESS){
			*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
			
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpLand, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, 
				    (unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, 
					RTL8651_LOGACTION_DROP, 
					"UDP Land" );
#endif
			}
			Attack |= RTL8651_DOS_UDPLAND;
		}		
	
		if((dos_checkList&RTL8651_DOS_UDPBOMB) && _rtl8651_dosUdpBomb(ip,ud)==SUCCESS){
			*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
			
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpBomb, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
					(unsigned char)ip->ip_p, 
					(unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, 
					RTL8651_LOGACTION_DROP, 
					"UDP Bomb" );
#endif
			}
			Attack |= RTL8651_DOS_UDPBOMB;
		}

		if((dos_checkList&RTL8651_DOS_ECHOCHARGEN) && _rtl8651_dosUdpEchoChargen(ip,ud)==SUCCESS){
			*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
			
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpEchoChargen, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, 
				    (unsigned char)direction, 
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, 
					RTL8651_LOGACTION_DROP, 
					"UDP Echo Chargen" );
#endif
			}
			Attack |= RTL8651_DOS_ECHOCHARGEN;
		}



	if (Attack)
	{	
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;
}

