

#include "rtl_types.h"
#include "assert.h"
#include "rtl8651_tblAsicDrv.h"
#include "rtl8651_layer2fwdLocal.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvPatch.h"
#include "rtl8651_tblDrvStatistic.h"
#include "asicRegs.h"
#include "asicTabs.h"
#include "rtl_glue.h"
#include "rtl_queue.h"
#include "rtl_utils.h"
#ifdef RTL865X_TEST
#include <string.h>
#endif
#ifdef CONFIG_RTL865X_ROMEPERF
#include "../romeperf.h"
#endif



#ifdef CONFIG_RTL865XB
#define RTL865XB_EXTPORT_VLAN_PATCH
#endif
#define CHIP_BUG_PATCH


#define L2ENG_INTERNAL_VARIABLES








static int32  (*_arpAgent)(struct rtl_pktHdr *pkthdrPtr,struct rtl_mBuf *mbufPtr,uint16 vid) = NULL;








#define _RTL865XB_EXTPORTMASKS   7
__DRAM_EXTDEV static uint8 extPortMaskToPortNum[_RTL865XB_EXTPORTMASKS+1];
static uint8 _extPortMaskToPortNum[_RTL865XB_EXTPORTMASKS+1] =
{
	0, 1, 2, 0, 3, 0, 0, 0
};


__DRAM_EXTDEV static _rtl8651_extDevice_t rtl8651_extDevList[_RTL8651_EXTDEV_DEVCOUNT];



static uint32 rtl8651_usrSettingMemberDevMask[RTL8651_VLAN_NUMBER];			
__DRAM_EXTDEV static uint32 rtl8651_vlanMemberDevMask[RTL8651_VLAN_NUMBER];	
static uint32 _rtl8651_vlanMemberDevMask[RTL8651_VLAN_NUMBER];

#define VLAN_MEMDEV_LID_CHECK(linkId, vid, mask)	(mask[rtl8651_vlanTableIndex(vid)] & (1<<_RTL8651_EXTDEV_LINKID2IDX(linkId)))
#define VLAN_MEMDEV_IDX_CHECK(idx, vid, mask)		(mask[rtl8651_vlanTableIndex(vid)] & (1<<(idx)))
#define VLAN_MEMDEV_LID_CLR(linkId, vid, mask)		(mask[rtl8651_vlanTableIndex(vid)] &= ~(1<<_RTL8651_EXTDEV_LINKID2IDX(linkId)))
#define VLAN_MEMDEV_IDX_CLR(idx, vid, mask)			(mask[rtl8651_vlanTableIndex(vid)] &= ~(1<<(idx)))
#define VLAN_MEMDEV_LID_SET(linkId, vid, mask)		(mask[rtl8651_vlanTableIndex(vid)] |= (1<<_RTL8651_EXTDEV_LINKID2IDX(linkId)))
#define VLAN_MEMDEV_IDX_SET(idx, vid, mask)			(mask[rtl8651_vlanTableIndex(vid)] |= (1<<(idx)))


static int32 rtl8651_bridgeEnable = FALSE;
static int32 rtl8651_extDevCnt = 0;

static int32 _rtl8651_fwdEngineExtDeviceInit(void);

static int32 _rtl8651_fwdEngineSetExtDeviceVlanProperty(uint32 linkID, uint16 vid, uint32 property);
static inline void _rtl8651_extDeviceVlanMbrClr(uint32 linkID);

static int32 _rtl8651_fwdEngineRegExtDevice(uint32 portNumber, uint16 defaultVID, uint32 *linkID_p, void *extDevice);
static int32 _rtl8651_fwdEngineUnregExtDevice(uint32 linkID);

static _rtl8651_extDevice_t *_rtl8651_fwdEngineGetExtDevEntryByExtDevPtr(void *extDevice);


static int32  _rtl8651_fwdEnginePciSend(void *data, int16 dvid, int32 iphdrOffset);
static void _rtl8651_extPortRecvL2Lookup(uint8 *data, uint16 myvid, uint32 myportmask, uint32 linkID);
static void _rtl8651_ExtPortChecksumProcess(struct rtl_mBuf *mbuf);
static int32  _rtl8651_fwdEnginePciSend(void * data, int16 dvid, int32 iphdrOffset);




static void _rtl8651_fwdEngineRearrangeExtDevBridge(void);
static int32 _rtl8651_fwdEngineExtDevBridge(	uint8 *data,
												struct rtl_pktHdr* pktHdr,
												uint32 linkID,
												rtl8651_tblDrv_vlanTable_t * vlan_p);


static int32 _rtl8651_fwdEngineSWExtDevSend(	struct rtl_pktHdr* pktHdr,
													rtl8651_tblDrv_vlanTable_t *vlan_p,
													uint8 priority,
													int32 linkID);


#define RTL8651_NEW_L2TPBUFF_FILL_CODE	

static int rtl8651_pptp_ppp_compress = FALSE;

static int32 _rtl8651_pptpL2tpInput(	int32 inbound,
									struct rtl_pktHdr *pkthdrPtr,
									rtl8651_tblDrv_vlanTable_t *local_vlanp,
									uint16 ethtype,
									rtl8651_tblDrv_pppTable_t **ppp);

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
static int32 _rtl8651_fwdEngineSend_PptpL2tp(	struct rtl_pktHdr * pkthdrPtr,
													rtl8651_tblDrv_vlanTable_t *local_vlanp,
													struct ip *ip,
													rtl8651_tblDrv_routeTable_t *rt_t,
													uint32* pDestPortMask );
#endif

#ifdef RTL8651_NEW_L2TPBUFF_FILL_CODE
static inline void _rtl8651_forgeL2tpBuffer(uint8 **l2tpBuff, uint8 *pL2tpLength, uint8 *pL2tpLengthBit, ipaddr_t gatewayIp, ipaddr_t serverIp, uint16 tunnelID, uint16 sessionID);
#endif 



static int32 _rtl8651_fwdEngineSend_FromPS(	struct rtl_pktHdr * pkthdrPtr,
												rtl8651_tblDrv_vlanTable_t *local_vlanp,
												uint32* pDestPortMask );

static int32 _rtl8651_fwdEngineSend_ExtDevSend(	uint32 property,
														struct rtl_pktHdr * pkthdrPtr,
														rtl8651_tblDrv_vlanTable_t *local_vlanp,
														struct ip *ip,
														uint32* pDestPortMask );

static int32 _rtl8651_fwdEngineHWVlanSend(	struct rtl_pktHdr *pktHdr,
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
												struct ip *pip,
#endif
												uint32 txPortMask,
												uint32 tagTxPortMask,
												uint16 vid,
												uint8 priority);

#ifdef RTL865XB_DCUT_SWVLAN
static int32 _rtl8651_fwdEngineSWVlanSend(	struct rtl_pktHdr *pktHdr,
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
												struct ip *pip,
#endif
												uint32 txPortMask,
												uint32 tagTxPortMask,
												uint16 vid,
												uint8 priority);
#endif 

static int32  _rtl8651_layer2Passthrough(struct rtl_pktHdr *pkthdrPtr, rtl8651_tblDrv_vlanTable_t *local_vlanp, uint8 *m_data, uint16 ethtype);
static int32 _rtl8651_l2PhysicalPortRelay(struct rtl_mBuf *inMbufPtr);
static int32 _rtl8651_l2switch(	struct rtl_pktHdr *pkthdrPtr,
								rtl8651_tblDrv_vlanTable_t *local_vlanp,
								uint8 *m_data,
								uint16 ethtype);



#if 0
void config_dram(unsigned int base, unsigned int size)
{
    __asm__ __volatile__(
        ".set\tnoreorder\n\t"
        "mfc0\t$8,$12\n\t"
        "nop\n\t"
        "nop\n\t"
        "or\t$8,0x80000000\n\t"
        "mtc0\t$8,$12\n\t"
        "nop\n\t"
        "nop\n\t"
        "mtc0\t$0,$20\n\t"
        "nop\n\t"
        "nop\n\t"
        "li\t$8,0x3\n\t"
        "mtc0\t$8,$20\n\t"
        "nop\n\t"
        "nop\n\t"
        "move\t$8,$4\n\t"
        "la\t$9,0x0ffffc00\n\t"
        "and\t$8,$8,$9\n\t'"
        "mtc3\t$8,$4\n\t"
        "nop\n\t"
        "nop\n\t"
        "mtc3\t$8,$4\n\t" 
        "nop\n\t"
        "nop\n\t"
        "add\t$8,$8,$5\n\t"
        "addiu\t$8,$8,-1\n\t"
        "mtc3\t$8,$5\n\t"
        "nop\n\t"
        "nop\n\t"
        "mtc0\t$0,$20\n\t"
        "nop\n\t"
        "nop\n\t"
        ".set\treorder\n\t");
}
#endif



static void _rtl8651_fwdEngineVlanProcess(	uint8 pktIsTag,
												uint8 txNeedTag,
												struct rtl_pktHdr *pktHdr,
												uint16 vid,
												uint8 priority);

static void _rtl8651_fwdEngineStripVlanTag(struct rtl_pktHdr * pPkthdr);
static void _rtl8651_fwdEngineModifyVlanTag(	struct rtl_pktHdr *pktHdr,
												uint16 vid,
												uint8 priority);
static void _rtl8651_fwdEngineAddVlanTag(	struct rtl_pktHdr *pktHdr,
												uint16 vid,
												uint8 priority);




#ifdef RTL865X_DEBUG
static void _rtl8651_layer2fwd_debug(int idx, struct rtl_pktHdr * pPkthdr);
#endif








#define L2ENG_MAIN_PROCESS


int32 _rtl8651_layer2fwd_init(void)
{
	_rtl8651_fwdEngineExtDeviceInit();

	return SUCCESS;
}


void _rtl8651_layer2fwd_reinit(void)
{
#if 0 
	_rtl8651_fwdEngineExtDeviceInit();
#endif
}



#define L2ENG_ARP_PROCESS


void rtl8651_installArpAgent (int32 (*arpAgent)(	struct rtl_pktHdr *pkthdrPtr, 
												struct rtl_mBuf *mbufPtr,
												uint16 vid))
{
	rtlglue_drvMutexLock();
	_arpAgent = arpAgent;
	rtlglue_drvMutexUnlock();
}



#define L2ENG_MISC

#ifdef RTL865X_DEBUG
static void _rtl8651_layer2fwd_debug(int idx, struct rtl_pktHdr * pPkthdr)
{
	struct rtl_mBuf *pMbuf=pPkthdr->ph_mbuf;
	uint8 *data = pMbuf->m_data;
	if(idx==1){
		
		printk("(%d)Rcvd===============================len:%d\n",pPkthdr->ph_rxdesc,pPkthdr->ph_len);
		printk("  vidx: %d srcExt:0x%x, dstExt:0x%x, portlist: 0x%x vtag=%d\n", 
			pPkthdr->ph_vlanIdx, pPkthdr->ph_srcExtPortNum,
			pPkthdr->ph_extPortList, pPkthdr->ph_portlist, pPkthdr->ph_vlanTagged);
		memDump(data, 64, "NIC Rx");
		if(wlan_acc_debug>4)
			memDump(pPkthdr, 32, "pkthdr");
	}else if (idx==2){
		
		rtlglue_printf("  ===Recv len:%d\n",pPkthdr->ph_len);
		rtlglue_printf("  vidx: %d srcExt:0x%x, dstExt:0x%x, portlist: 0x%x vtag=%d\n", 
			pPkthdr->ph_vlanIdx, pPkthdr->ph_srcExtPortNum,
			pPkthdr->ph_extPortList, pPkthdr->ph_portlist, pPkthdr->ph_vlanTagged);
		if(wlan_acc_debug>3 &&pPkthdr->ph_portlist==6){
			memDump(data, 64, "NIC Rx");
		}
	}else if (idx==3){
		
		uint8 macStr[18];	
		rtlglue_printf("\nNIC Tx ");
		if(ether_ntoa_r((ether_addr_t *)&data[6], macStr)==0)
			rtlglue_printf(" 0x%x %s->", pPkthdr->ph_portlist, macStr);
		if(ether_ntoa_r((ether_addr_t *)&data[0], macStr)==0)
			rtlglue_printf("%s  %02x%02x %dB",macStr,data[12],data[13], pPkthdr->ph_len);
		rtlglue_printf("(v%d s%d d%d p%d)...\n",pPkthdr->ph_vlanIdx,pPkthdr->ph_srcExtPortNum,pPkthdr->ph_extPortList,pPkthdr->ph_portlist);
		if(wlan_acc_debug>3){
			memDump(&data[12],64,"NIC Tx content");
		}
	}else if(idx==4){
		uint8 macStr[18];
		ether_ntoa_r((ether_addr_t *)&data[6], macStr);
		rtlglue_printf("\nNIC Rx:(%d)%s->",pPkthdr->ph_rxdesc,macStr);
		ether_ntoa_r((ether_addr_t *)&data[0], macStr);
		rtlglue_printf("%s s%d d%d p%d %dB\n",macStr, pPkthdr->ph_srcExtPortNum,pPkthdr->ph_extPortList,pPkthdr->ph_portlist,pPkthdr->ph_len);
	}else if(idx==5){
		
		uint8 macStr[18];
		ether_ntoa_r((ether_addr_t *)&data[6], macStr);
		rtlglue_printf("PCI Rx/NIC Tx,%s->", macStr);
		ether_ntoa_r((ether_addr_t *)&data[0], macStr);
		rtlglue_printf("%s  %x %dB\n",macStr,*((uint16 *)(data+12)), pPkthdr->ph_len);
		memDump(&data[12],40,"");
	}
}
#endif



#define L2ENG_RX_PREPROCESS_TX_POSTPROCESS

__IRAM_L2_FWD int32 rtl8651_rxPktPreprocess(struct rtl_pktHdr * pPkthdr)
{
	uint32 destExtPortList , srcPortNum;
	
#ifdef CONFIG_RTL865XB
	destExtPortList = pPkthdr->ph_extPortList;
	srcPortNum=pPkthdr->ph_portlist;
	pPkthdr->ph_extPortList&=0xf; 
	if(srcPortNum>=7) {
		
		
		
		pPkthdr->ph_extPortList &= ~(1<<(pPkthdr->ph_srcExtPortNum-1)); 
		if(pPkthdr->ph_extPortList==0){
			
			
			return FAILED;
		}else if (pPkthdr->ph_extPortList<8){
			
			
			
			srcPortNum=extPortMaskToPortNum[pPkthdr->ph_extPortList]+RTL8651_PORT_NUMBER-1;
			pPkthdr->ph_portlist=srcPortNum;

#if 1
			
			if (RtkHomeGatewayChipRevisionID < 0x02)
#else
			if((destExtPortList&0x78)!=0x8)
				
#endif
			{
				pPkthdr->ph_vlanIdx=DrvTbl.aggregator[srcPortNum].pvid&(RTL8651_VLAN_NUMBER-1);
			}
		}else{
			
			pPkthdr->ph_portlist=pPkthdr->ph_srcExtPortNum+RTL8651_PORT_NUMBER-1;
		}
		
	}else{
		
		pPkthdr->ph_srcExtPortNum=0;
		if((pPkthdr->ph_extPortList&0xf)<8){ 
			
			
			
			if(pPkthdr->ph_extPortList){
				
				srcPortNum=extPortMaskToPortNum[pPkthdr->ph_extPortList]+RTL8651_PORT_NUMBER-1;
				pPkthdr->ph_portlist=srcPortNum;
			}
#if 1
			
			if (RtkHomeGatewayChipRevisionID < 0x02)
#else
			if(destExtPortList&0x70)
				
#endif
			{
				pPkthdr->ph_vlanIdx=DrvTbl.aggregator[srcPortNum].pvid&(RTL8651_VLAN_NUMBER-1);
			}
		}
	}		

	{
		uint16 svid = 0;
		uint8 priority = 0;

		
		pPkthdr->ph_fwd_property = 0;

		
		if ( pPkthdr->ph_vlanTagged )
		{
			
			pPkthdr->ph_fwd_property |= PH_FWD_PROPER_INGRESSTAG;

			
			uint16 vlanTagField = ntohs(*((uint16 *)(pPkthdr->ph_mbuf->m_data + 14)));
			svid = vlanTagField & 0x0fff;
			priority = (vlanTagField & 0xe000) >> 13;

			
			if (	((1<<pPkthdr->ph_portlist) & peripheralExtPortMask) &&
				(pPkthdr->ph_extPortList < 8))
			{
			} else
			{
				_rtl8651_fwdEngineStripVlanTag( pPkthdr );
				pPkthdr->ph_vlanTagged = 0;
			}
		}

		pPkthdr->ph_svid = svid;
		pPkthdr->ph_priority = priority;
	}

#endif 
	
	return SUCCESS;
}


__IRAM_L2_FWD int32 rtl8651_txPktPostProcessing(struct rtl_pktHdr * pPkt)
{
	uint32 destPortMask=pPkt->ph_portlist;

	destPortMask&= ~0x40; 

	if(destPortMask){
		
		if(destPortMask & RTL8651_MII_PORTMASK && miiPhyAddress<0)
			destPortMask&=~RTL8651_MII_PORTMASK;

		pPkt->ph_srcExtPortNum=pPkt->ph_extPortList=0;
		pPkt->ph_flags &= ~(PKTHDR_BRIDGING|PKTHDR_HWLOOKUP);
		destPortMask&=~rtl8651_allExtPortMask;
	}
#ifdef CONFIG_RTL865XB
	else if(pPkt->ph_srcExtPortNum){
		pPkt->ph_flags |=PKTHDR_HWLOOKUP; 
		destPortMask=7; 

	}else
#endif 
		pPkt->ph_flags &= ~(PKTHDR_BRIDGING|PKTHDR_HWLOOKUP); 
	pPkt->ph_portlist=destPortMask;

	return SUCCESS;

}	

#define L2ENG_EXTDEV_PROCESS




static int32 _rtl8651_fwdEngineExtDeviceInit(void)
{
	
	memset(rtl8651_extDevList, 0, sizeof(rtl8651_extDevList));
	memcpy(extPortMaskToPortNum, _extPortMaskToPortNum, sizeof(extPortMaskToPortNum));

	
	memcpy(rtl8651_vlanMemberDevMask, _rtl8651_vlanMemberDevMask, sizeof(rtl8651_vlanMemberDevMask));
	memset(rtl8651_vlanMemberDevMask, 0, sizeof(rtl8651_vlanMemberDevMask));
	memset(rtl8651_usrSettingMemberDevMask, 0, sizeof(rtl8651_usrSettingMemberDevMask));
	_rtl8651_arrangeAllExtDeviceVlanMbr();

	rtl8651_bridgeEnable = FALSE;
	rtl8651_extDevCnt = 0;

	return SUCCESS;
}


int32 rtl8651_fwdEngineDumpExtDev(void)
{
	int32 idx, seq;
	rtl8651_tblDrv_filterDbTableEntry_t *dal2Entry;

	rtlglue_printf("\n\tExtension Device Count\t: %d\n", rtl8651_extDevCnt);
	rtlglue_printf("\tBridge mode\t\t: %s\n\n", (rtl8651_bridgeEnable == TRUE)?"ON":"OFF");

	seq = 1;
	rtlglue_printf("\tExtension Device Table:\n");
	rtlglue_printf("\n\tNO\tLinkID\tExtDevice\t\tPortMask\n");
	rtlglue_printf("\t=============================================================\n");
	for ( idx = 0 ; idx < _RTL8651_EXTDEV_DEVCOUNT ; idx ++ )
	{
		if ( rtl8651_extDevList[idx].linkID )
		{
			uint32 showMask = rtl8651_extDevList[idx].portMask;
			uint32 portNum, pos;

			for ( portNum = 0 ; showMask != 1 ; portNum ++ )
			{
				showMask >>= 1;
			}

			rtlglue_printf(	"\t%2d\t%2d\t0x%p\t\t",
						seq ++,
						rtl8651_extDevList[idx].linkID,
						rtl8651_extDevList[idx].extDevice);

			pos = 0;
			while ( pos++ < portNum )
			{
				rtlglue_printf("  ");
			}
			rtlglue_printf("%d\n", portNum);

		}
	}
	rtlglue_printf("\t=============================================================\n\n");

	seq = 1;
	rtlglue_printf("\tVLAN Tx Filtering Table:\n");
	rtlglue_printf("\n\tNO\tLinkID\t\tLegal TX VLAN\n");
	rtlglue_printf("\t=============================================================\n");
	for ( idx = 0 ; idx < _RTL8651_EXTDEV_DEVCOUNT ; idx ++ )
	{
		if ( rtl8651_extDevList[idx].linkID )
		{
			uint32 vidx;

			rtlglue_printf(	"\t%2d\t%2d\t\t",
						seq ++,
						rtl8651_extDevList[idx].linkID);

			for ( vidx = 0 ; vidx < RTL8651_VLAN_NUMBER ; vidx ++ )
			{
				if (VLAN_MEMDEV_IDX_CHECK(	idx,
												vidx,
												rtl8651_vlanMemberDevMask))
				{
					rtlglue_printf("[%4d]", DrvTbl.vlan[vidx].vid);
				}
			}
			rtlglue_printf("\n");

		}
	}
	rtlglue_printf("\t=============================================================\n\n");


	rtlglue_printf("\tExtension Arp Table:\n\n");
	rtlglue_printf("\tLinkID\tVID\tMAC\t\t\tPortMask\n");
	rtlglue_printf("\t=============================================================\n");

	for ( idx = 0 ; idx < RTL8651_L2TBL_ROW ; idx ++ )
	{
		SLIST_FOREACH(dal2Entry, &(DrvTbl.filterDB[0].database[idx]), nextFDB)
		{
			if (dal2Entry->linkId > 0)
			{
				uint32 showMask = dal2Entry->memberPortMask;
				uint32 portNum, pos;

				rtlglue_printf(	"\t%d\t%d\t[%02x:%02x:%02x:%02x:%02x:%02x]\t",
							dal2Entry->linkId,
							dal2Entry->vid,
							dal2Entry->macAddr.octet[0],
							dal2Entry->macAddr.octet[1],
							dal2Entry->macAddr.octet[2],
							dal2Entry->macAddr.octet[3],
							dal2Entry->macAddr.octet[4],
							dal2Entry->macAddr.octet[5]);

				for ( portNum = 0 ; showMask != 1 ; portNum ++ )
				{
					showMask >>= 1;
				}

				pos = 0;
				while ( pos++ < portNum )
				{
					rtlglue_printf("  ");
				}
				rtlglue_printf("%d\n", portNum);
			}
		}
	}
	rtlglue_printf("\t=============================================================\n\n");

	return SUCCESS;
}



int32 rtl8651_fwdEngineSetExtDeviceVlanProperty(uint32 linkID, uint16 vid, uint32 property)
{
	int32 retval = FAILED;

	rtlglue_drvMutexLock();
	retval = _rtl8651_fwdEngineSetExtDeviceVlanProperty(linkID, vid, property);
	rtlglue_drvMutexUnlock();

	return retval;
}

static int32 _rtl8651_fwdEngineSetExtDeviceVlanProperty(	uint32 linkID,
																uint16 vid,
																uint32 property)
{
	uint32 idx;

	idx = _RTL8651_EXTDEV_LINKID2IDX(linkID);

	

	if (	(idx < 0) ||
		(idx >= _RTL8651_EXTDEV_DEVCOUNT))
	{
		return TBLDRV_EINVALIDINPUT;
	}

	if (vid == 0)
	{
		return TBLDRV_EINVALIDINPUT;
	}


	if (rtl8651_extDevList[idx].linkID == 0)
	{
		return TBLDRV_EENTRYNOTFOUND;
	}

	if (	(DrvTbl.vlan[rtl8651_vlanTableIndex(vid)].valid == FALSE) ||
		(DrvTbl.vlan[rtl8651_vlanTableIndex(vid)].vid != vid) ||
		((DrvTbl.vlan[rtl8651_vlanTableIndex(vid)].memberPortMask & rtl8651_extDevList[idx].portMask) == 0)	)
	{
		return TBLDRV_EINVALIDINPUT;
	}

	
	switch (property)
	{
		
		case RTL8651_EXTDEV_VLANPROPER_ISMBR:
		{
			VLAN_MEMDEV_IDX_SET(idx, vid, rtl8651_usrSettingMemberDevMask);
			break;
		}
		
		case RTL8651_EXTDEV_VLANPROPER_NOTMBR:
		{
			VLAN_MEMDEV_IDX_CLR(idx, vid, rtl8651_usrSettingMemberDevMask);
			break;
		}
	}

	
	_rtl8651_arrangeAllExtDeviceVlanMbr();

	return SUCCESS;
}


void _rtl8651_arrangeAllExtDeviceVlanMbr(void)
{
	uint32 extDevIdx;
	uint32 vidx;


	

	memcpy(	rtl8651_vlanMemberDevMask,
				rtl8651_usrSettingMemberDevMask,
				sizeof(rtl8651_vlanMemberDevMask));

	

	for ( extDevIdx = 0 ; extDevIdx < _RTL8651_EXTDEV_DEVCOUNT ; extDevIdx ++ )
	{

		

		
		if (	(rtl8651_l2protoPassThrough & PASSTHRU_PPPOE) &&
			(rtl8651_gPPPoEPassthruVlanID != RTL8651_PPPOEPASSTHRU_VLANID_IS_NOT_SET))
		{
			VLAN_MEMDEV_IDX_SET(	extDevIdx,
									rtl8651_gPPPoEPassthruVlanID,
									rtl8651_vlanMemberDevMask);
		}
		if (	(rtl8651_l2protoPassThrough & PASSTHRU_IPV6) &&
			(rtl8651_gIPv6PassthruVlanID != RTL8651_PPPOEPASSTHRU_VLANID_IS_NOT_SET))
		{
			VLAN_MEMDEV_IDX_SET(	extDevIdx,
									rtl8651_gIPv6PassthruVlanID,
									rtl8651_vlanMemberDevMask);
		}
		if (	(rtl8651_l2protoPassThrough & PASSTHRU_IPX) &&
			(rtl8651_gIPXPassthruVlanID != RTL8651_PPPOEPASSTHRU_VLANID_IS_NOT_SET))
		{
			VLAN_MEMDEV_IDX_SET(	extDevIdx,
									rtl8651_gIPXPassthruVlanID,
									rtl8651_vlanMemberDevMask);
		}
		if (	(rtl8651_l2protoPassThrough & PASSTHRU_NETBIOS) &&
			(rtl8651_gNetbiosPassthruVlanID != RTL8651_PPPOEPASSTHRU_VLANID_IS_NOT_SET))
		{
			VLAN_MEMDEV_IDX_SET(	extDevIdx,
									rtl8651_gNetbiosPassthruVlanID,
									rtl8651_vlanMemberDevMask);
		}

		
	}

	
	for ( vidx = 0 ; vidx < RTL8651_VLAN_NUMBER ; vidx ++ )
	{
		
		if (DrvTbl.vlan[vidx].valid == FALSE)
		{
			for ( extDevIdx = 0 ; extDevIdx < _RTL8651_EXTDEV_DEVCOUNT ; extDevIdx ++ )
			{
				VLAN_MEMDEV_IDX_CLR(	extDevIdx,
										vidx,
										rtl8651_vlanMemberDevMask);
			}
		} else
		{
			
		
			
			for ( extDevIdx = 0 ; extDevIdx < _RTL8651_EXTDEV_DEVCOUNT ; extDevIdx ++ )
			{
				if ((DrvTbl.vlan[vidx].memberPortMask & rtl8651_extDevList[extDevIdx].portMask) == 0)
				{
					VLAN_MEMDEV_IDX_CLR(	extDevIdx,
											vidx,
											rtl8651_vlanMemberDevMask);
				}
			}
		}
	}
}


static inline void _rtl8651_extDeviceVlanMbrClr(uint32 linkID)
{
	uint32 idx;

	for ( idx = 0 ; idx < RTL8651_VLAN_NUMBER ; idx ++ )
	{
		VLAN_MEMDEV_LID_CLR(	linkID,
								
								idx,
								rtl8651_usrSettingMemberDevMask);
	}
	_rtl8651_arrangeAllExtDeviceVlanMbr();
}


int32 rtl8651_fwdEngineRegExtDevice(	uint32 portNumber,
											uint16 defaultVID,
											uint32 *linkID_p,
											void *extDevice)
{
	int32 retval = FAILED;

	rtlglue_drvMutexLock();
	retval = _rtl8651_fwdEngineRegExtDevice(portNumber, defaultVID, linkID_p, extDevice);
	rtlglue_drvMutexUnlock();

	return retval;
}


static int32 _rtl8651_fwdEngineRegExtDevice(	uint32 portNumber,
												uint16 defaultVID,
												uint32 *linkID_p,
												void *extDevice)
{
	_rtl8651_extDevice_t *extDev = NULL;
	int32 idx = 0;

	if (	(portNumber < RTL8651_PORT_NUMBER) ||
		(portNumber >= (RTL8651_PORT_NUMBER + rtl8651_totalExtPortNum))	||
		(extDevice == NULL) ||
		(linkID_p == NULL))
	{
		return TBLDRV_EINVALIDINPUT;
	}

	if (	(defaultVID > 0) &&
		(	(DrvTbl.vlan[rtl8651_vlanTableIndex(defaultVID)].valid == FALSE) ||							
			(DrvTbl.vlan[rtl8651_vlanTableIndex(defaultVID)].vid != defaultVID) ||						
			((DrvTbl.vlan[rtl8651_vlanTableIndex(defaultVID)].memberPortMask & (1 << portNumber)) == 0)	
		)
	)
	{
		return TBLDRV_EINVALIDINPUT;
	}

	
	extDev = _rtl8651_fwdEngineGetExtDevEntryByExtDevPtr(extDevice);

	
	if (extDev)
	{
		_rtl8651_fwdEngineUnregExtDevice(extDev->linkID);
	}

	
	for ( idx = 0 ; idx < _RTL8651_EXTDEV_DEVCOUNT ; idx ++ )
	{
		if ( rtl8651_extDevList[idx].extDevice == NULL )
		{
			extDev = &(rtl8651_extDevList[idx]);
			break;
		}
	}

	if (idx >= _RTL8651_EXTDEV_DEVCOUNT)
	{
		return TBLDRV_ENOFREEBUFFER;
	}


	if (_rtl8651_addPeripheralExtPort(portNumber) != SUCCESS)
	{
		return TBLDRV_EINVALIDINPUT;
	}

	assert(extDev);

	
	extDev->extDevice = extDevice;
	extDev->portMask = 1<<portNumber;
	extDev->linkID = _RTL8651_EXTDEV_IDX2LINKID(idx);

	
	_rtl8651_extDeviceVlanMbrClr(extDev->linkID);
	if (defaultVID > 0)
	{
		_rtl8651_fwdEngineSetExtDeviceVlanProperty(	extDev->linkID,
													defaultVID,
													RTL8651_EXTDEV_VLANPROPER_ISMBR);
	}

	
	rtl8651_extDevCnt ++;

	RTL_NOTICE(RTL_MSG_EXTDEV,
				"Add Extension Device [%d] : PortMask(0x%x) extDevice(0x%p) defaultVID (%d)",
				extDev->linkID,
				extDev->portMask,
				extDev->extDevice,
				defaultVID);

	_rtl8651_fwdEngineRearrangeExtDevBridge();

	
	*linkID_p = extDev->linkID;

	return SUCCESS;
}


int32 rtl8651_fwdEngineUnregExtDevice(uint32 linkID)
{
	int32 retval = FAILED;
 
	rtlglue_drvMutexLock();
	retval = _rtl8651_fwdEngineUnregExtDevice(linkID);
	rtlglue_drvMutexUnlock();

	return retval;
}


static int32 _rtl8651_fwdEngineUnregExtDevice(uint32 linkID)
{
	int32 idx;

	idx = _RTL8651_EXTDEV_LINKID2IDX(linkID);

	if (	(idx < 0) ||
		(idx >= _RTL8651_EXTDEV_DEVCOUNT))
	{
		return TBLDRV_EINVALIDINPUT;
	}

	if (rtl8651_extDevList[idx].linkID == 0)
	{
		return TBLDRV_EENTRYNOTFOUND;
	}

	RTL_NOTICE(RTL_MSG_EXTDEV,
				"Remove Extension Device [%d] : PortMask(0x%x) extDevice(0x%p)",
				rtl8651_extDevList[idx].linkID,
				rtl8651_extDevList[idx].portMask,
				rtl8651_extDevList[idx].extDevice);

	
	_rtl8651_removeArpAndNaptFlowWhenLinkDown(-1, &linkID);

	
	{
		int32 i;
		int32 extPortInused = FALSE;

		for ( i = 0 ; i < _RTL8651_EXTDEV_DEVCOUNT ; i ++ )
		{
			if (	(i == idx) ||
				(rtl8651_extDevList[idx].linkID == 0))
			{
				continue;
			}

			
			if (rtl8651_extDevList[idx].portMask == rtl8651_extDevList[i].portMask)
			{
				extPortInused = TRUE;
				break;
			}
		}

		if (extPortInused == FALSE)
		{
			uint32 removePortMask = rtl8651_extDevList[idx].portMask;

			for ( i = 0 ; removePortMask != 1 ; i ++ )
			{
				removePortMask >>= 1;
			}

			RTL_NOTICE(	RTL_MSG_EXTDEV,
							"Remove Peripheral Port Number (%d) (mask 0x%x)",
							i,
							rtl8651_extDevList[idx].portMask);
			
			_rtl8651_delPeripheralExtPort(i);
		}
	}

	
	_rtl8651_extDeviceVlanMbrClr(linkID);

	
	memset(&(rtl8651_extDevList[idx]), 0, sizeof(_rtl8651_extDevice_t));

	
	rtl8651_extDevCnt --;

	_rtl8651_fwdEngineRearrangeExtDevBridge();

	return SUCCESS;
}



int32 rtl8651_fwdEngineGetLinkIDByExtDevice(void *extDevice)
{
	int32 linkID = 0;
	_rtl8651_extDevice_t *extDev = NULL;

	if (extDevice == NULL)
	{
		goto out;
	}

	rtlglue_drvMutexLock();

	extDev = _rtl8651_fwdEngineGetExtDevEntryByExtDevPtr(extDevice);
	if (extDev)
	{
		linkID = extDev->linkID;
	}

	rtlglue_drvMutexUnlock();

out:
	return linkID;
}

static _rtl8651_extDevice_t *_rtl8651_fwdEngineGetExtDevEntryByExtDevPtr(void *extDevice)
{
	int32 idx;

	for ( idx = 0 ; idx < _RTL8651_EXTDEV_DEVCOUNT ; idx ++ )
	{
		if (	(rtl8651_extDevList[idx].extDevice == extDevice) &&
			(rtl8651_extDevList[idx].linkID != 0) )
		{
			assert(rtl8651_extDevList[idx].portMask != 0);

			return &(rtl8651_extDevList[idx]);
		}
	}

	return NULL;
}


int32 rtl8651_fwdEngineEnableWDS (int32 flag)
{
	RTL_WARN(	RTL_MSG_EXTDEV,
				"This API ( %s ) would not take effect now. WDS Enable/Disable would be automatically done by Rome Driver.",
				__FUNCTION__);

	return SUCCESS;
}


static void _rtl8651_fwdEngineRearrangeExtDevBridge(void)
{
	if ( rtl8651_extDevCnt > 1 )
	{	
		rtl8651_bridgeEnable = TRUE;
	} else
	{	
		rtl8651_bridgeEnable = FALSE;
	}

	RTL_NOTICE(RTL_MSG_EXTDEV,
				"Registered Extension Device Count: %d : Bridge module [%s]",
				rtl8651_extDevCnt,
				(rtl8651_bridgeEnable == TRUE)?"ENABLE":"DISABLE");

}


int32 rtl8651_fwdEngineRemoveHostsOnExtLinkID (uint32 linkID)
{
	if (linkID == 0)
	{
		return FAILED;
	}

	rtlglue_drvMutexLock();
	_rtl8651_removeArpAndNaptFlowWhenLinkDown(-1, &linkID);
	rtlglue_drvMutexUnlock();

	return SUCCESS;
}

static void _rtl8651_extPortRecvL2Lookup(uint8 *data, uint16 myvid, uint32 myportmask, uint32 linkID)
{
	uint8 *smac=data+6; 
	rtl8651_tblDrv_filterDbTableEntry_t * thisFDBentry;
	rtl8651_tblDrv_vlanTable_t *thisVlan;
	
	thisVlan= &DrvTbl.vlan[ myvid&(RTL8651_VLAN_NUMBER-1)];
	assert(thisVlan);
	 thisFDBentry=_rtl8651_getVlanFilterDatabaseEntry(myvid, (ether_addr_t*)smac);
	
	
	
	if(!thisFDBentry){
		int32 retval;
		int32 l2type;
		
		if(thisVlan->macAddrNumber){
			
			if(memcmp(smac, &thisVlan->macAddr,6)==0) 
				return;
		}
		if(smac[0]&1) 
			return;
		


		
		if(myportmask>RTL8651_PHYSICALPORTMASK)
			l2type=RTL8651_L2_TYPEII;
		else
			l2type=RTL8651_L2_TYPEIII;
		retval=_rtl8651_addVlanRefFilterDatabaseEntry(l2type, 0, myvid, (ether_addr_t *)smac, RTL8651_FORWARD_MAC,myportmask);

		if(!retval)
			_rtl8651_modifyVlanRefFilterDatabaseEntry(0,  (ether_addr_t *)smac,NULL,NULL, &linkID, L2_AUTO);

		#ifdef RTL865X_DEBUG
		if(wlan_acc_debug)
		{
			uint8 macStr[18];
			ether_ntoa_r((ether_addr_t *)smac, macStr);
			rtlglue_printf("=====adding %s on PCI to L2 table , linkId=%d, errno=%d.\n ", macStr,linkID,retval);
		}
		#endif
		
	} else if(thisFDBentry->memberPortMask!=myportmask ||(thisFDBentry->linkId!=linkID)){
		#ifdef RTL865X_DEBUG
		
		uint32 oldmask=thisFDBentry->memberPortMask;
		uint32 oldid=thisFDBentry->linkId;
		

		if(wlan_acc_debug)
		{
			uint8 macStr[18];
			ether_ntoa_r((ether_addr_t *)smac, macStr);
			rtlglue_printf("=====SA %s moved from portmask 0x%x(%d) to 0x%x(%d)....", macStr, oldmask,oldid, myportmask, linkID);
		}
		#endif

		_rtl8651_modifyVlanRefFilterDatabaseEntry(0, (ether_addr_t *)smac,&myportmask, NULL,&linkID, L2_AUTO);
	}
}

__IRAM_EXTDEV static void _rtl8651_ExtPortChecksumProcess(struct rtl_mBuf *mbuf)
{
	
	uint8 *pkt = mbuf->m_data;
	uint16 byte2;
	uint32 etherPos = 12;
	struct ip *pip = NULL;

nextRound:
	byte2 = *(uint16*)(&pkt[etherPos]);
	switch (byte2)
	{
		case 0x0800:
			pip = (struct ip *)(&pkt[(etherPos+2)]);
			break;
		case 0x8864:
			byte2 = ntohs(*((uint16 *)(&pkt[etherPos + 8])));
			if (byte2 == 0x2100)
			{
				pip = (struct ip *)(&pkt[(etherPos + 10)]);
				break;
			} else
			{
				goto check_done;
			}
		case 0x8100:	
			if ( pkt[etherPos + 2] & 0x10 )
			{	
				goto check_done;
			}
			etherPos += 4;
			goto nextRound;
		default:	
			goto check_done;
	}

	assert(pip);

	if ((pip->ip_vhl & 0xf0) != 0x40)
	{
		goto check_done;
	}

	if (	(!IS_FRAGMENT(pip->ip_off)) &&
		(pip->ip_p == IPPROTO_UDP))
	{
		struct udphdr *ud = (struct udphdr*)L4HDR_ADDR(pip);

		if (ud->uh_sum == 0)
		{
			ud->uh_sum = 0;
			pip->ip_sum = 0;
			ud->uh_sum = _rtl8651_tcpChecksum(pip);
			pip->ip_sum = _rtl8651_ipChecksum(pip);
		}
	}

check_done:
	return;
}

__IRAM_EXTDEV static int32  _rtl8651_fwdEnginePciSend(void * data, int16 dvid, int32 iphdrOffset)
{
	struct rtl_pktHdr * pkthdrPtr=(struct rtl_pktHdr *)data;

	struct rtl_mBuf *mbuf;
	rtl8651_tblDrv_vlanTable_t *local_vlanp;	

	mbuf=pkthdrPtr->ph_mbuf;
	pkthdrPtr->ph_vlanIdx= dvid & (RTL8651_VLAN_NUMBER-1);
	local_vlanp = &DrvTbl.vlan[pkthdrPtr->ph_vlanIdx ];

	if(peripheralExtPortMask>RTL8651_PHYSICALPORTMASK){
		
		
		pkthdrPtr->ph_srcExtPortNum=
			extPortMaskToPortNum[ (pkthdrPtr->ph_portlist>>RTL8651_PORT_NUMBER)&_RTL865XB_EXTPORTMASKS];
	#ifdef RTL865X_DEBUG
		if(wlan_acc_debug>1)
			rtlglue_printf("\tpci to swcore from ext %d ", pkthdrPtr->ph_srcExtPortNum);
	#endif
		pkthdrPtr->ph_portlist=0; 
	}else
		pkthdrPtr->ph_srcExtPortNum=0;
	pkthdrPtr->ph_portlist |= rtl8651_tblDrvCpuMirrorPortMask;
	
	rtlglue_drvSend((void*)data);
		
	return SUCCESS;
}



__IRAM_EXTDEV int32 rtl8651_fwdEngineExtPortRecv(	void *id,
														uint8 *data,
														uint32 len,
														uint16 myvid,
														uint32 myportmask,
														uint32 linkID)
{
#define UNCACHE_MASK		0xa0000000
#define UNCACHE(x)			((uint32)x|UNCACHE_MASK)

	struct rtl_pktHdr *	pktHdr	= NULL;	
	struct rtl_mBuf*	m		= NULL;
	int32			retval	= FAILED;
	rtl8651_tblDrv_vlanTable_t *thisVlan;

	thisVlan = &DrvTbl.vlan[ myvid & (RTL8651_VLAN_NUMBER-1)];

#ifdef CONFIG_RTL865XB	
	
	REG32(WDTCNR)|=WDTCLR;
#endif

	if (linkID == 0)
	{
		rtlglue_printf("packet from illegal-device-LinkID (%d)\n", linkID);
		goto unlock_out;
	}

	assert(data);

	rtlglue_drvMutexLock();

	if ((data[0] & 1) || (*((uint16 *)(data+12)) != htons(0x0800)))
	{
		
		_rtl8651_extPortRecvL2Lookup(data, myvid, myportmask, linkID);
	}

	
	m = mBuf_attachHeader((void*)UNCACHE(data),(uint32)(id),m_clusterSize, len,0);
	if (!m)
	{
		#ifdef RTL865X_DEBUG
		rtlglue_printf("X");
		#endif
		goto out;
	}

	SETBITS(m->m_flags, MBUF_EXT);

	pktHdr = m->m_pkthdr;
	pktHdr->ph_property = PH_PROPER_EXTDEV;
	pktHdr->ph_portlist = myportmask;

	
	pktHdr->ph_flags &= ~(CSUM_IP| CSUM_L4|PKTHDR_BRIDGING);

	
	if (rtl8651_bridgeEnable)
	{
		if (_rtl8651_fwdEngineExtDevBridge (	data,
											pktHdr,
											linkID,
											thisVlan) > 0)
		{
			retval = SUCCESS;
			goto out;
		}
	}

	
	_rtl8651_ExtPortChecksumProcess(m);

	
	_rtl8651_fwdEnginePciSend((void*)pktHdr, myvid, -1);

	retval = SUCCESS;
out:
	rtlglue_drvMutexUnlock();
unlock_out:

	return retval;	
}

#define L2ENG_EXTDEV_TX






static int32 _rtl8651_fwdEngineExtDevBcast(	struct rtl_pktHdr *pktHdr,
												rtl8651_tblDrv_vlanTable_t *vlan_p,
												uint32 txPortFilterMask,
												uint32 incomingLinkID,
												uint8 priority,
												uint8 freeOrgPkt)
{
	_rtl8651_extDevice_t *extDev;

	uint32 memberPortMask = 0;
	uint32 txPortMask = 0;
	uint32 untagMemberPortMask = 0;
	int32 idx;
	uint16 vid;
	int32 pktIsTagged = FALSE, pktTagIsChecked = FALSE;

	

#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pktHdr->ph_property == PH_PROPER_DRVFWD) &&
		(pktHdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
	{
		rtl8651_tblDrv_swVlanTable_t *swVlanPtr;

		
		swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(pktHdr->ph_svid)];

		vid = pktHdr->ph_svid;
		memberPortMask = swVlanPtr->memberPortMask;
		untagMemberPortMask = swVlanPtr->untagPortMask;
	}
	else
#endif 
	{
		if (vlan_p)
		{
			vid = vlan_p->vid;
			memberPortMask = vlan_p->memberPortMask;
			untagMemberPortMask = vlan_p->untagPortMask;
		} else
		{
			

			vid = 0;	
			memberPortMask = 0xffffffff;
			untagMemberPortMask = VLAN_TAGGED(pktHdr->ph_mbuf->m_data)?0:0xffffffff;
		}
	}

	
	txPortMask = memberPortMask & txPortFilterMask;

	if ( freeOrgPkt == TRUE )
	{
		struct rtl_mBuf *txMbuf;
		uint32 txCnt;

		

		
		txCnt = 0;
		for ( idx = 0, extDev = &(rtl8651_extDevList[0]) ; idx < rtl8651_extDevCnt ; idx ++, extDev ++ )
		{
			
#ifdef RTL865XB_DCUT_SWVLAN
			if (	(pktHdr->ph_property == PH_PROPER_DRVFWD) &&
				(pktHdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
			{
			} else
#endif 
			{
				if (	(vid > 0) &&
					(VLAN_MEMDEV_IDX_CHECK(idx, vid, rtl8651_vlanMemberDevMask) == 0))
				{
					continue;
				}
			}

			if (	(extDev->linkID != incomingLinkID) &&
				(extDev->portMask & txPortMask)	)
			{
				txCnt ++;
			}
		}
		
		if (txCnt == 0)
		{
			
			mBuf_freeMbufChain(pktHdr->ph_mbuf);
		} else
		{
			

			pktIsTagged = VLAN_TAGGED(pktHdr->ph_mbuf->m_data)?TRUE:FALSE;

			for ( idx = 0, extDev = &(rtl8651_extDevList[0]) ; ((txCnt > 0) && (idx < rtl8651_extDevCnt)) ; idx ++, extDev ++ )
			{
				
#ifdef RTL865XB_DCUT_SWVLAN
				if (	(pktHdr->ph_property == PH_PROPER_DRVFWD) &&
					(pktHdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
				{
				} else
#endif 
				{
					if (	(vid > 0) &&
						(VLAN_MEMDEV_IDX_CHECK(idx, vid, rtl8651_vlanMemberDevMask) == 0))
					{
						continue;
					}
				}

				if (	(extDev->linkID != incomingLinkID) &&
					(extDev->portMask & txPortMask))
				{
					
					if (txCnt > 1)
					{
						txMbuf = mBuf_dupPacket(pktHdr->ph_mbuf, MBUF_DONTWAIT);
					} else
					{
						txMbuf = pktHdr->ph_mbuf;
					}

					
					if ( txMbuf )
					{
						RTL_INFO(	RTL_MSG_EXTDEV,
									"Bcast to Extension device [%p] (linkID %d)",
									extDev->extDevice,
									extDev->linkID);

						if (	(vid == 0	) ||
							((pktIsTagged == FALSE) && (extDev->portMask & untagMemberPortMask)))
						{
							
						} else
						{
							_rtl8651_fwdEngineVlanProcess(	pktIsTagged,
															((extDev->portMask & untagMemberPortMask) == 0),
															txMbuf->m_pkthdr,
															vid,
															priority);
						}

						
						rtlglue_extDeviceSend(txMbuf->m_pkthdr, extDev->extDevice);
					}

					
					txCnt --;
				}
			}
		}
	} else
	{
		struct rtl_mBuf *newMbuf;

		
		for ( idx = 0, extDev = &(rtl8651_extDevList[0]) ; idx < rtl8651_extDevCnt ; idx ++, extDev ++ )
		{
			
#ifdef RTL865XB_DCUT_SWVLAN
			if (	(pktHdr->ph_property == PH_PROPER_DRVFWD) &&
				(pktHdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
			{
			} else
#endif 
			{
				if (	(vid > 0) &&
					(VLAN_MEMDEV_IDX_CHECK(idx, vid, rtl8651_vlanMemberDevMask) == 0))
				{
					continue;
				}
			}

			if (	(extDev->linkID != incomingLinkID) &&
				(extDev->portMask & txPortMask )	)
			{
				if (pktTagIsChecked == FALSE)
				{
					pktIsTagged = VLAN_TAGGED(pktHdr->ph_mbuf->m_data)?TRUE:FALSE;
				}

				newMbuf = mBuf_dupPacket(pktHdr->ph_mbuf, MBUF_DONTWAIT);

				if (newMbuf)
				{
					RTL_INFO(	RTL_MSG_EXTDEV,
								"Bcast to Extension device [0x%p] (linkID %d)",
								extDev->extDevice,
								extDev->linkID);

					if (	(vid == 0	) ||
						((pktIsTagged == FALSE) && (extDev->portMask & untagMemberPortMask)))
					{
						
					} else
					{
						_rtl8651_fwdEngineVlanProcess(	pktIsTagged,
														((extDev->portMask & untagMemberPortMask) == 0),
														newMbuf->m_pkthdr,
														vid,
														priority);
					}

					
					rtlglue_extDeviceSend(newMbuf->m_pkthdr, extDev->extDevice);
				}
			}
		}
	}

	return SUCCESS;
}


__IRAM_EXTDEV static int32 _rtl8651_fwdEngineExtDevUcast(	struct rtl_pktHdr *pktHdr,
																rtl8651_tblDrv_vlanTable_t *vlan_p,
																uint32 txLinkID,
																uint8 priority)
{
	_rtl8651_extDevice_t *extDev;
	uint16 vid;
	uint32 memberPortMask = 0;
	uint32 untagMemberPortMask = 0;

	

#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pktHdr->ph_property == PH_PROPER_DRVFWD) &&
		(pktHdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
	{
		rtl8651_tblDrv_swVlanTable_t *swVlanPtr;

		
		swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(pktHdr->ph_svid)];

		vid = pktHdr->ph_svid;
		memberPortMask = swVlanPtr->memberPortMask;
		untagMemberPortMask = swVlanPtr->untagPortMask;
	}
	else
#endif 
	{
		vid = vlan_p->vid;
		memberPortMask = vlan_p->memberPortMask;
		untagMemberPortMask = vlan_p->untagPortMask;
	}

	if (	(txLinkID <= 0) ||
		(_RTL8651_EXTDEV_LINKID2IDX(txLinkID) >= _RTL8651_EXTDEV_DEVCOUNT))
	{
		RTL_EMERG(	RTL_MSG_EXTDEV,
					"Illegal LinkID (%d)",
					txLinkID);

		mBuf_freeMbufChain(pktHdr->ph_mbuf);
		return FAILED;
	}

	
	extDev = &(rtl8651_extDevList[_RTL8651_EXTDEV_LINKID2IDX(txLinkID)]);

	if (	((extDev->portMask & memberPortMask) == 0) ||
		(extDev->extDevice == NULL))
	{
		RTL_WARN(	RTL_MSG_EXTDEV,
					"Packet Egress Filtered: DROP !!");

		RTL_WARN(	RTL_MSG_EXTDEV,
					"Packet TX to Extension device(%d) with TX port mask(0x%x) of VLAN (%d, mbr 0x%x)",
					txLinkID,
					extDev->portMask,
					vid,
					memberPortMask);

		mBuf_freeMbufChain(pktHdr->ph_mbuf);
		goto out;
	}

	
#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pktHdr->ph_property == PH_PROPER_DRVFWD) &&
		(pktHdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
	{
	} else
#endif 
	{
		if (VLAN_MEMDEV_LID_CHECK(txLinkID, vid, rtl8651_vlanMemberDevMask) == 0)
		{
			RTL_WARN(	RTL_MSG_EXTDEV,
						"Packet TX to Extension device(%d) with VID (%d memDev 0x%x) is filtered by member device filtering",
						txLinkID,
						vid,
						rtl8651_vlanMemberDevMask[rtl8651_vlanTableIndex(vid)]);

			mBuf_freeMbufChain(pktHdr->ph_mbuf);
			goto out;
		}
	}

	if (	(extDev->portMask & untagMemberPortMask) &&
		(!VLAN_TAGGED(pktHdr->ph_mbuf->m_data)))
	{
		
	} else
	{
		_rtl8651_fwdEngineVlanProcess(	VLAN_TAGGED(pktHdr->ph_mbuf->m_data),
										((extDev->portMask & untagMemberPortMask) == 0),
										pktHdr,
										vid,
										priority);
	}

	RTL_INFO(	RTL_MSG_EXTDEV,
				"Ucast to Extension device [0x%p] (linkID %d)",
				extDev->extDevice,
				txLinkID);

	
	rtlglue_extDeviceSend(pktHdr, extDev->extDevice);

out:
	return SUCCESS;
}




static int32 _rtl8651_fwdEngineExtDevBridge(	uint8 *data,
												struct rtl_pktHdr* pktHdr,
												uint32 linkID,
												rtl8651_tblDrv_vlanTable_t * vlan_p)
{
	if (data[0] & 0x1)
	{
		

		if (vlan_p->valid)
		{
			uint8 priority = 0;
			if (VLAN_TAGGED(pktHdr->ph_mbuf->m_data))
			{
				priority = VLAN_PRIORITY(pktHdr->ph_mbuf->m_data);
			}
			_rtl8651_fwdEngineExtDevBcast(	pktHdr,
											vlan_p,
											0xffffffff,
											linkID,
											priority,
											FALSE);
		}

		
		return 0;

	} else if (memcmp(data, &(vlan_p->macAddr), sizeof(ether_addr_t)) != 0)
	{
		

		rtl8651_tblDrv_filterDbTableEntry_t *dal2Entry;

		
		dal2Entry = _rtl8651_getVlanFilterDatabaseEntry(vlan_p->vid, (ether_addr_t *)data); 

		if (dal2Entry)
		{
			if  (dal2Entry->linkId > 0)
			{
				
				uint8 priority = 0;

				if (dal2Entry->linkId == linkID)
				{	
					mBuf_freeMbufChain(pktHdr->ph_mbuf);
					return 1;
				}

				if (VLAN_TAGGED(pktHdr->ph_mbuf->m_data))
				{
					priority = VLAN_PRIORITY(pktHdr->ph_mbuf->m_data);
				}

				_rtl8651_fwdEngineExtDevUcast(	pktHdr,
												vlan_p,
												dal2Entry->linkId,
												priority);
				
				return 1;
			}else
			{
				
				assert((dal2Entry->memberPortMask & peripheralExtPortMask) == 0);
			}
		}else
		{
			

			uint8 priority = 0;

			if (VLAN_TAGGED(pktHdr->ph_mbuf->m_data))
			{
				priority = VLAN_PRIORITY(pktHdr->ph_mbuf->m_data);
			}
			_rtl8651_fwdEngineExtDevBcast(	pktHdr,
											vlan_p,
											0xffffffff,
											linkID,
											priority,
											FALSE);
		}
	}
	return 0;	
}




__IRAM_EXTDEV static int32 _rtl8651_fwdEngineHWExtDevUcast(	struct rtl_pktHdr *pktHdr,
																	uint32 txLinkID)
{
	_rtl8651_extDevice_t *extDev;

	if (	(txLinkID <= 0) ||
		(_RTL8651_EXTDEV_LINKID2IDX(txLinkID) >= _RTL8651_EXTDEV_DEVCOUNT))
	{
		RTL_EMERG(	RTL_MSG_EXTDEV,
					"Illegal LinkID (%d)",
					txLinkID);

		mBuf_freeMbufChain(pktHdr->ph_mbuf);
		return FAILED;
	}

	
	extDev = &(rtl8651_extDevList[_RTL8651_EXTDEV_LINKID2IDX(txLinkID)]);

	if (extDev->extDevice == NULL)
	{
		RTL_INFO(	RTL_MSG_EXTDEV,
					"Packet Egress Filtered: DROP !!");

		RTL_INFO(	RTL_MSG_EXTDEV,
					"Packet TX to Extension device(%d) with TX port mask(0x%x)",
					txLinkID,
					extDev->portMask);

		mBuf_freeMbufChain(pktHdr->ph_mbuf);
		goto out;
	}

	RTL_INFO(	RTL_MSG_EXTDEV,
				"Ucast to Extension device [0x%p] (linkID %d)",
				extDev->extDevice,
				txLinkID);

	
	rtlglue_extDeviceSend(pktHdr, extDev->extDevice);

out:
	return SUCCESS;
}



static int32 _rtl8651_fwdEngineSWExtDevSend(	struct rtl_pktHdr* pktHdr,
																rtl8651_tblDrv_vlanTable_t *vlan_p,
																uint8 priority,
																int32 linkID)
{
	if (linkID <= 0)
	{
		_rtl8651_fwdEngineExtDevBcast(	pktHdr,
										vlan_p,
										0xffffffff,
										(uint32)(-linkID),
										priority,
										TRUE);
	} else
	{
		_rtl8651_fwdEngineExtDevUcast(	pktHdr,
										vlan_p,
										(uint32)linkID,
										priority);
	}

	return SUCCESS;
}

#define L2ENG_EXTDEV_FASTPATH


int32 rtl8651_fwdEngineAddWlanSTA(uint8 *smac, uint16 myvid, uint32 myportmask, uint32 linkId)
{
	rtl8651_tblDrv_vlanTable_t *thisVlan;
	rtl8651_tblDrv_filterDbTableEntry_t * thisFDBentry;
	int32 retval=FAILED;

	if (linkId==0)
		return retval;
	
	rtlglue_drvMutexLock();

	
	thisVlan= &DrvTbl.vlan[ myvid&(RTL8651_VLAN_NUMBER-1)];
	assert(thisVlan);
	 thisFDBentry=_rtl8651_getVlanFilterDatabaseEntry(myvid, (ether_addr_t*)smac);
	
	
	
	if(!thisFDBentry){
		int32 retval;
		int32 l2type;
		
		if(thisVlan->macAddrNumber){
			
			if(memcmp(smac, &thisVlan->macAddr,6)==0) 
				goto out;
		}
		if(smac[0]&1){ 
			goto out;
		}
		


		
		assert(myportmask>RTL8651_PHYSICALPORTMASK);
		l2type=RTL8651_L2_TYPEII;
		retval=_rtl8651_addVlanRefFilterDatabaseEntry(l2type, 0, myvid, (ether_addr_t *)smac, RTL8651_FORWARD_MAC,myportmask);

		if(!retval)
			_rtl8651_modifyVlanRefFilterDatabaseEntry(0,  (ether_addr_t *)smac,NULL,NULL, &linkId, L2_AUTO);

		#ifdef RTL865X_DEBUG
		if(wlan_acc_debug)
		{
			uint8 macStr[18];
			ether_ntoa_r((ether_addr_t *)smac, macStr);
			rtlglue_printf("=====adding %s on PCI to L2 table , linkId=%d, errno=%d.\n ", macStr,linkId,retval);
		}
		#endif
		retval=SUCCESS;
	}	else if(thisFDBentry->memberPortMask!=myportmask ||(thisFDBentry->linkId!=linkId)){
		#ifdef RTL865X_DEBUG
		
		uint32 oldmask=thisFDBentry->memberPortMask;
		uint32 oldid=thisFDBentry->linkId;
		

		if(wlan_acc_debug)
		{
			uint8 macStr[18];
			ether_ntoa_r((ether_addr_t *)smac, macStr);
			rtlglue_printf("=====SA %s moved from portmask 0x%x(%d) to 0x%x(%d)....", macStr, oldmask,oldid, myportmask, linkId);
		}
		#endif
		_rtl8651_modifyVlanRefFilterDatabaseEntry(0, (ether_addr_t *)smac,&myportmask, NULL,&linkId, L2_AUTO);
		retval=SUCCESS;
	}
out:
	rtlglue_drvMutexUnlock();
	return retval;
}


int32 rtl8651_fwdEngineDelWlanSTA(uint8 *mac, uint16 myvid)
{
 	rtl8651_tblDrv_vlanTable_t *thisVlan;
	rtl8651_tblDrv_filterDbTableEntry_t * thisFDBentry;
	int32 retval=FAILED;	
	rtlglue_drvMutexLock();
	
	thisVlan= &DrvTbl.vlan[ myvid&(RTL8651_VLAN_NUMBER-1)];
	assert(thisVlan);
	 thisFDBentry=_rtl8651_getVlanFilterDatabaseEntry(myvid, (ether_addr_t*)mac);
	if(thisFDBentry){
		retval=_rtl8651_delVlanRefFilterDatabaseEntry(RTL8651_L2_TYPEII,0,(ether_addr_t *)mac);
	}
	rtlglue_drvMutexUnlock();	
	return retval;
}



__IRAM_EXTDEV int32 rtl8651_fwdEngineExtPortUcastFastRecv(	struct rtl_pktHdr *pkt,
																	uint16 myvid,
																	uint32 myportmask)
{
	rtlglue_drvMutexLock();
	pkt->ph_flags &= ~(CSUM_IP| CSUM_L4|PKTHDR_BRIDGING);
	pkt->ph_portlist = myportmask;
	pkt->ph_vlanIdx= myvid & (RTL8651_VLAN_NUMBER-1);
	pkt->ph_srcExtPortNum= extPortMaskToPortNum[ (myportmask>>RTL8651_PORT_NUMBER)&_RTL865XB_EXTPORTMASKS];
	pkt->ph_portlist=0; 
	pkt->ph_portlist |= rtl8651_tblDrvCpuMirrorPortMask;

	
	_rtl8651_ExtPortChecksumProcess(pkt->ph_mbuf);

	
	rtlglue_drvSend((void*)pkt);
	rtlglue_drvMutexUnlock();

	return SUCCESS;
 }

#define L2ENG_PPTPL2TP


void rtl8651_pptpPppCompress(int enable)
{
	rtlglue_drvMutexLock();
	rtl8651_pptp_ppp_compress = enable;
	rtlglue_drvMutexUnlock();
}

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
#ifdef RTL8651_NEW_L2TPBUFF_FILL_CODE
static inline void _rtl8651_forgeL2tpBuffer(uint8 **l2tpBuff, uint8 *pL2tpLength, uint8 *pL2tpLengthBit, ipaddr_t gatewayIp, ipaddr_t serverIp, uint16 tunnelID, uint16 sessionID)
{
	void *buff;
	struct ip *pip;
	struct udphdr *udp;
	struct wan_l2tp_header *l2tp;
	uint8 *ppp;

	
	if (*l2tpBuff == NULL)
	{
		*l2tpBuff = rtlglue_malloc(RTL8651_MAX_PPTPL2TP_BUFFERSIZE);

		assert(*l2tpBuff);
	}
	buff = *l2tpBuff;

	*pL2tpLength = 0;

	
	pip = (struct ip *)buff;

	pip->ip_vhl = 0x45;
	pip->ip_tos = 0;
	pip->ip_len = 0;			
	pip->ip_id = 1;			
	pip->ip_off = 0;			
	pip->ip_ttl = 0xff;
	pip->ip_p = IPPROTO_UDP;	
	pip->ip_sum = 0;			
	PKTSET_UINT32_UNALIGNED(gatewayIp, &pip->ip_src);
	PKTSET_UINT32_UNALIGNED(serverIp, &pip->ip_dst);

	*pL2tpLength += sizeof(struct ip);

	
	udp = (struct udphdr *)((uint32)buff + sizeof(struct ip));

	udp->uh_sport = htons(1701);	
	udp->uh_dport = htons(1701);	
	udp->uh_ulen = 0;				
	udp->uh_sum = 0;				

	*pL2tpLength += sizeof(struct udphdr);

	
	l2tp = (struct wan_l2tp_header*)((uint32)udp + sizeof(struct udphdr));

	l2tp->flags_type = 0;		
	l2tp->flags_length = 1;		
	l2tp->flags_rsv1 = 0;		
	l2tp->flags_sequence = 0;	
	l2tp->flags_rsv2 = 0;		
	l2tp->flags_offset = 0;		
	l2tp->flags_priority = 0;	
	l2tp->flags_rsv3 = 0;		
	l2tp->flags_version = 2;	

	l2tp->length = 0;						
	l2tp->tunnel_id = ntohs(tunnelID);		
	l2tp->session_id = ntohs(sessionID);	

	*pL2tpLengthBit = TRUE;	
	*pL2tpLength += sizeof(struct wan_l2tp_header);

	
	ppp = (uint8 *)((uint32)l2tp + sizeof(struct wan_l2tp_header));

	ppp[0] = 0xff;
	ppp[1] = 0x03;
	ppp[2] = 0x00;
	ppp[3] = 0x21;

	*pL2tpLength += 4;

}
#endif 

static int32 _rtl8651_pptpL2tpInput(	int32 inbound,
									struct rtl_pktHdr *pkthdrPtr,
									rtl8651_tblDrv_vlanTable_t *local_vlanp,
									uint16 ethtype,
									rtl8651_tblDrv_pppTable_t **ppp)
{
	rtl8651_tblDrv_routeTable_t *rt_t = NULL;
	rtl8651_tblDrv_pppTable_t *pppEntry_t = NULL;	
	uint8 *m_data = pkthdrPtr->ph_mbuf->m_data;

	rt_t = DrvTbl.route + (rtl8651_tblDrvPara.routingTableSize - 1);

	if (rt_t->valid != 0 && rt_t->ifrt_flag == 0)
	{
		if ((rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP) || (rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP))
		{
#if 1
			pppEntry_t = rt_t->rt_nhSession_t;
#else
			pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
#endif
		}
	}
	
	*ppp = pppEntry_t;

	
	
	if (inbound == TRUE)
	{
		struct rtl_mBuf *mbufPtr = pkthdrPtr->ph_mbuf;

		if ((pppEntry_t)&&(ethtype==0x0800))
		{
			struct ip *ip = NULL,*ip2 = NULL;

			if (pkthdrPtr->ph_iphdrOffset)
			{
				ip = (struct ip *)&m_data[pkthdrPtr->ph_iphdrOffset];
			}

			if (ip)
			{
				if(rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP)
				{
					
					if((ip->ip_p==IPPROTO_GRE)&&(ntohs(ip->ip_len)>=28)) 
					{

						struct wan_gre_header *gre;

						uint16 iphlen = IPHDR_LEN(ip);
						uint16 offset=iphlen+8,ip2len=0; 
						uint8 *ptr;
						uint32 gre_seq, gre_ack;
						uint8 gre_type;
				
						gre = (struct wan_gre_header *) ((int8 *) ip + iphlen);
						gre_seq = 0;
						gre_ack = 0;
						gre_type = 0;

						if(gre->flags&16) 
						{
							offset+=4;
							pppEntry_t->lastReceiveSeq_= PKTGET_UINT32_UNALIGNED(&gre->seq);
							gre_seq = pppEntry_t->lastReceiveSeq_;
							gre_type |= RTL8651_PPTPHDR_SEQ_SET;
							

							if(gre->ver&128) 
							{
								offset+=4;
								gre_ack = PKTGET_UINT32_UNALIGNED(&gre->ack);
								gre_type |= RTL8651_PPTPHDR_ACK_SET;
								
								PKTSET_UINT32_UNALIGNED(gre_ack - pppEntry_t->delta_, &gre->ack);
							}
							
						}
						else if(gre->ver&128) 
						{
							offset+=4;
							gre_ack = PKTGET_UINT32_UNALIGNED(&gre->seq);
							gre_type |= RTL8651_PPTPHDR_ACK_SET;
							PKTSET_UINT32_UNALIGNED(gre_ack - pppEntry_t->delta_,&gre->seq);						
							
						}
					
						ptr=(uint8 *)ip;	
						
						if((pppEntry_t->initiated)&&(gre->payload_len))
						{
							
							uint32 grePayloadLen = 0;

							if ((ptr[offset] == 0xff) && (ptr[offset + 1] == 0x03))
							{	
								offset += 2;
								grePayloadLen += 2;
							}

							if (	((ptr[offset] == 0x00) && (ptr[offset + 1] == 0x21) ) ||
								(ptr[offset] == 0x21 ))
							{
								
								if (ptr[offset] == 0x21)
								{	
									offset += 1;
									grePayloadLen += 1;
								} else
								{	
									offset += 2;
									grePayloadLen += 2;
								}

								ip2=(struct ip *)(ptr+offset);

								
								if (	( (grePayloadLen + IPHDR_LEN(ip2)) > ntohs(gre->payload_len) ) ||
									
									( (grePayloadLen + ntohs(ip2->ip_len)) != ntohs(gre->payload_len) ))
								{
									
								} else
								{
								ip2len = ntohs(ip2->ip_len);

								if(ip2len<=local_vlanp->mtu)
								{	
									{
										
										uint16 id = ntohs(ip2->ip_id);
										uint16 offset = ntohs(ip2->ip_off);
										_rtl8651_pptpHdrCache_Add(id, offset, gre_seq, gre_ack, gre_type);

										
										if (pppEntry_t->greOffset2_ == 0)
										{
											
											if (pppEntry_t->greBuf2_ == NULL)
											{
												assert(((uint32)ip2 - (uint32)ip) <= RTL8651_MAX_PPTPL2TP_BUFFERSIZE);
												pppEntry_t->greBuf2_ = rtlglue_malloc(RTL8651_MAX_PPTPL2TP_BUFFERSIZE);	
											}
											
											if (pppEntry_t->greBuf2_)
											{
												pppEntry_t->greOffset2_ = ((uint32)ip2 - (uint32)ip);
												rtl8651_memcpy(pppEntry_t->greBuf2_, (void *)ip, pppEntry_t->greOffset2_);
											}
										}else if (pppEntry_t->greBuf2_)
										{	
											struct ip *ipBuf;
											struct wan_gre_header *greBuf;
											ipBuf = (struct ip *)(pppEntry_t->greBuf2_);
											greBuf = (struct wan_gre_header *)L4HDR_ADDR(ipBuf);
											greBuf->call_id = gre->call_id;
										}
									}
									
									rtl8651_memcpy((uint8 *)(ip2)-14,m_data,14);
									m_data=(uint8 *)(ip2)-14;

									{	
										ipaddr_t dest_ip = PKTGET_UINT32_UNALIGNED(&ip2->ip_dst);
										if (IN_MULTICAST(dest_ip))
										{
											MCAST_IP2MAC(dest_ip, m_data);
										}
										
										if (dest_ip == 0xffffffff)
										{
											BCAST_MAC(m_data);
										}
									}

									pkthdrPtr->ph_flags&=~CSUM_L4;
									pkthdrPtr->ph_flags&=~CSUM_IP;

									pkthdrPtr->ph_len -= offset;
									mbufPtr->m_len -= offset;
									mbufPtr->m_data = m_data;

									if (_rtl8651_fwdEngineSend(FWDENG_TUNNELRX|FWDENG_FROMDRV, (void*)pkthdrPtr,tunnel.loopBackVid,-1) != SUCCESS)
									{
										mBuf_freeMbufChain(pkthdrPtr->ph_mbuf);
									}
									return SUCCESS;
								}
							}
						}
					}
				}
				}
				else if(rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP)
				{
					rtl8651_tblDrv_vlanTable_t *extVlan = &DrvTbl.vlan[(tunnel.loopBackVid & (RTL8651_VLAN_NUMBER-1))];
					assert(extVlan->valid);

					if((ip->ip_p==IPPROTO_UDP)&&(ntohs(ip->ip_len)>=35)&&(ntohs(ip->ip_len)<=extVlan->mtu)) 
					{
						struct udphdr *udp;
						udp = (struct udphdr *)L4HDR_ADDR(ip);
						if(ntohs(udp->uh_dport)==1701)
						{
							struct wan_l2tp_header *l2tp=(struct wan_l2tp_header*)(udp+1);

							if (l2tp->flags_type==0) 
							{
								uint8 *u8p_l2tp = (uint8*)l2tp;
								struct ip *ip2 = NULL;
								uint32 l2tpPppChkLen = 6 ; 

								if (l2tp->flags_length)
								{
									l2tpPppChkLen += 2;
								}
								if (l2tp->flags_offset)
								{
									l2tpPppChkLen += 2;
								}

								
								if ((u8p_l2tp[l2tpPppChkLen] == 0xff) && (u8p_l2tp[l2tpPppChkLen + 1] == 0x03))
								{	
									l2tpPppChkLen += 2;
								}
								if (u8p_l2tp[l2tpPppChkLen] == 0x21)
								{	
									l2tpPppChkLen += 1;
									ip2 = (struct ip *)((uint32)u8p_l2tp + l2tpPppChkLen);
								} else if ((u8p_l2tp[l2tpPppChkLen] == 0x00) && (u8p_l2tp[l2tpPppChkLen + 1] == 0x21))
								{	
									l2tpPppChkLen += 2;
									ip2 = (struct ip *)((uint32)u8p_l2tp + l2tpPppChkLen);
								}

								
								if ( ip2 )
								{
									if (	( (l2tpPppChkLen + IPHDR_LEN(ip2) + sizeof(struct udphdr)) > ntohs(udp->uh_ulen) ) ||
										
										( (l2tpPppChkLen + ntohs(ip2->ip_len) + sizeof(struct udphdr)) != ntohs(udp->uh_ulen)))
									{
										
										ip2 = NULL;
									}
								}

								if ( ip2 )
								{
									uint16 ip2len = ntohs(ip2->ip_len);
								
									if(ip2len<=extVlan->mtu)
									{
										
										if (pppEntry_t->l2tpOffset2_ == 0)
										{
											
											if (pppEntry_t->l2tpBuf2_ == NULL)
											{
												assert(((uint32)ip2 - (uint32)ip) <= RTL8651_MAX_PPTPL2TP_BUFFERSIZE);
												pppEntry_t->l2tpBuf2_ = rtlglue_malloc(RTL8651_MAX_PPTPL2TP_BUFFERSIZE);	
											}
											
											if (pppEntry_t->l2tpBuf2_)
											{
												pppEntry_t->l2tpOffset2_ = ((uint32)ip2 - (uint32)ip);
												rtl8651_memcpy(pppEntry_t->l2tpBuf2_, (void *)ip, pppEntry_t->l2tpOffset2_);
											}
										}

										switch(ip2->ip_p)
										{
											case IPPROTO_ICMP:
												pkthdrPtr->ph_proto = PKTHDR_ICMP;												
												break;
											case IPPROTO_IGMP:
												pkthdrPtr->ph_proto = PKTHDR_IGMP;
												break;
											case IPPROTO_TCP:									
												pkthdrPtr->ph_proto = PKTHDR_TCP;
												break;
											case IPPROTO_UDP:
												pkthdrPtr->ph_proto = PKTHDR_UDP;
												break;										
										}

										pkthdrPtr->ph_flags&=~CSUM_L4;
										pkthdrPtr->ph_flags&=~CSUM_IP;

										
										rtl8651_memcpy((uint8 *)(ip2)-14,m_data,14);
										m_data=(uint8 *)(ip2)-14;

										{	
											ipaddr_t dest_ip = PKTGET_UINT32_UNALIGNED(&ip2->ip_dst);
											if (IN_MULTICAST(dest_ip))
											{
												MCAST_IP2MAC(dest_ip, m_data);
											}
											
											if (dest_ip == 0xffffffff)
											{
												BCAST_MAC(m_data);
											}
										}

										pkthdrPtr->ph_len -= ((uint32)ip2-(uint32)ip);
										mbufPtr->m_len -= ((uint32)ip2-(uint32)ip);
										mbufPtr->m_data = m_data;

										if (_rtl8651_fwdEngineSend(FWDENG_TUNNELRX|FWDENG_FROMDRV, (void*)pkthdrPtr,tunnel.loopBackVid,-1) != SUCCESS)
										{
											mBuf_freeMbufChain(pkthdrPtr->ph_mbuf);
										}
										return SUCCESS;
									}
								} 
							}
							
						}
					}
				}
			}
		}
	}
	else if((pppEntry_t) && (pppEntry_t->initiated))
	{
		
		

		
		if((memcmp(pppEntry_t->macInfo->macAddr.octet,m_data,6)==0) ||
			(m_data[0]==0x01 && m_data[1]==0x00 && m_data[2]==0x5e && memcmp(pppEntry_t->macInfo->macAddr.octet, &m_data[6], 6)!=0)){
			
			
			return _rtl8651_fwdEngineSend(	FWDENG_TUNNELTX|FWDENG_FROMDRV,
											(void*)pkthdrPtr,
											tunnel.wanVid,
											-1); 
		}else{
			
			
		}
	}
	return FAILED;
}


static int32 _rtl8651_fwdEngineSend_PptpL2tp(	struct rtl_pktHdr * pkthdrPtr,
													rtl8651_tblDrv_vlanTable_t *local_vlanp,
													struct ip *ip,
													rtl8651_tblDrv_routeTable_t *rt_t,
													uint32* pDestPortMask )
{
	rtl8651_tblDrv_pppTable_t *pppEntry_t;
	uint32 destPortMask = *pDestPortMask;
	struct rtl_mBuf *mbuf = pkthdrPtr->ph_mbuf;
	int32 retval;

#if 1
	pppEntry_t=rt_t->rt_nhSession_t;
#else
	pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
#endif
	assert( pppEntry_t );

	if ((pppEntry_t->initiated)&&(local_vlanp->vid==tunnel.loopBackVid))
	{	
		
		if(memcmp(mbuf->m_data+6,pppEntry_t->macInfo->macAddr.octet,6)==0)
		{
#ifdef CONFIG_RTL865XB_PPTPL2TP					
			if(tunnel.loopbackPort>=RTL8651_PORT_NUMBER)
			{
				pkthdrPtr->ph_vlanIdx= tunnel.loopBackVid & (RTL8651_VLAN_NUMBER-1);
				pkthdrPtr->ph_srcExtPortNum=extPortMaskToPortNum[CONFIG_RTL865XB_PPTPL2TP_PORT-(RTL8651_PORT_NUMBER-1)];
				pkthdrPtr->ph_portlist= pkthdrPtr->ph_extPortList=0;					

				
				_rtl8651_ExtPortChecksumProcess(mbuf);
			}
#endif 	
			destPortMask = pkthdrPtr->ph_portlist;

			retval = FWDENG_SEND_GOTO_SEND;
			goto out;
		}
#ifdef CONFIG_RTL865XB_PPTPL2TP			
		
		else
		{
		 
			
			{
				ip->ip_sum=0;
				ip->ip_sum=_rtl8651_ipChecksum(ip);
				if (!IS_FRAGMENT(ip->ip_off))
				{
					switch(ip->ip_p)
					{
						struct tcphdr *tc;
						struct udphdr *ud;
						struct icmp *ic;
						struct igmp *ig;
						case IPPROTO_TCP:
							tc = (struct tcphdr *)L4HDR_ADDR(ip);
							tc->th_sum = 0;
							tc->th_sum = _rtl8651_tcpChecksum(ip);
							break;
						case IPPROTO_UDP:
							ud = (struct udphdr *)L4HDR_ADDR(ip);
							if (ud->uh_sum)
							{
								ud->uh_sum = 0;
								ud->uh_sum = _rtl8651_tcpChecksum(ip);
							}
							break;
						case IPPROTO_ICMP:
							ic = (struct icmp *)L4HDR_ADDR(ip);
							ic->icmp_cksum = 0;
							ic->icmp_cksum = _rtl8651_icmpChecksum(ip);
							break;
						case IPPROTO_IGMP:
							ig = (struct igmp *)L4HDR_ADDR(ip);
							ig->igmp_cksum = 0;
							ig->igmp_cksum = _rtl8651_icmpChecksum(ip);
							break;
					}
				}
		 	}
			pkthdrPtr->ph_vlanIdx= tunnel.loopBackVid & (RTL8651_VLAN_NUMBER-1);
			pkthdrPtr->ph_srcExtPortNum=pkthdrPtr->ph_extPortList=0;
			pkthdrPtr->ph_portlist= CONFIG_RTL865XB_PPTPL2TP_PORT;
			if (_rtl8651_pptpL2tpInput(FALSE, pkthdrPtr, &DrvTbl.vlan[pkthdrPtr->ph_vlanIdx], 0x0800, &pppEntry_t) != SUCCESS)
			{
				mBuf_freeMbufChain(pkthdrPtr->ph_mbuf);
			}
			retval = SUCCESS;
			goto out;
		}
#endif			
	}
	else if(local_vlanp->vid==tunnel.wanVid)
	{
		uint16 iplen=ntohs(ip->ip_len);
		
		
		if (rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP)
		{
			if (memcmp(local_vlanp->macAddr.octet, mbuf->m_data + 6 , 6))
			{
				
				pkthdrPtr->ph_portlist = 0;
				pkthdrPtr->ph_srcExtPortNum = 0;	
			}else
			{	
				if(pppEntry_t->greBuf1_==NULL)
				{	
					#if 1
					pppEntry_t->greBuf1_=(uint8*)rtlglue_malloc(40);
					assert(pppEntry_t->greBuf1_);
					#else
					pppEntry_t->greBuf1_=(uint8*)rtlglue_malloc(1061);
					pppEntry_t->greBuf1_=(uint32)pppEntry_t->greBuf1_&0xfffffc00;
					pppEntry_t->greBuf1_+=1024;
					config_dram(pppEntry_t->greBuf1_, 37);
					#endif				
				}
				
				
				if((pppEntry_t->initiated)&&(pkthdrPtr->ph_rxdesc>=0)&& 
					(iplen>=20)&&(iplen<=local_vlanp->mtu))
				{
					struct ip* iphdr;
					uint32 newSeq;
					static int ip_id = 1;

					int offset=40;

					if(rtl8651_pptp_ppp_compress==TRUE)
					{
						offset-=3;
					}
					

					pppEntry_t->delta_++;
					
					newSeq=pppEntry_t->lastSeq_+pppEntry_t->delta_;
					pppEntry_t->greBuf1_[21]|=0x80; 

					if(rtl8651_pptp_ppp_compress==TRUE)
					{
						pppEntry_t->greBuf1_[24]=((iplen+1)>>8)&0xff;
						pppEntry_t->greBuf1_[25]=(iplen+1)&0xff;						
					}
					else						
					{
						pppEntry_t->greBuf1_[24]=((iplen+4)>>8)&0xff;
						pppEntry_t->greBuf1_[25]=(iplen+4)&0xff;
					}
					
					pppEntry_t->greBuf1_[28]=((newSeq)>>24)&0xff;
					pppEntry_t->greBuf1_[29]=((newSeq)>>16)&0xff;
					pppEntry_t->greBuf1_[30]=((newSeq)>>8)&0xff;
					pppEntry_t->greBuf1_[31]=(newSeq)&0xff;						
					pppEntry_t->greBuf1_[32]=(pppEntry_t->lastReceiveSeq_>>24)&0xff;
					pppEntry_t->greBuf1_[33]=(pppEntry_t->lastReceiveSeq_>>16)&0xff;
					pppEntry_t->greBuf1_[34]=(pppEntry_t->lastReceiveSeq_>>8)&0xff;
					pppEntry_t->greBuf1_[35]=pppEntry_t->lastReceiveSeq_&0xff;

					if(rtl8651_pptp_ppp_compress==TRUE)
					{
						pppEntry_t->greBuf1_[36]=0x21; 
					}
					else
					{
						pppEntry_t->greBuf1_[36]=0xff;
						pppEntry_t->greBuf1_[37]=0x03;
						pppEntry_t->greBuf1_[38]=0x00; 
						pppEntry_t->greBuf1_[39]=0x21; 
					}

					iphdr=(struct ip *)pppEntry_t->greBuf1_;

					pkthdrPtr->ph_proto = PKTHDR_IP; 
					pkthdrPtr->ph_flags |= CSUM_IP;	
					pkthdrPtr->ph_flags &= ~CSUM_L4; 

					iphdr->ip_id = htons(ip_id ++);
					iphdr->ip_len = htons(iplen+offset);
					
					rtl8651_memcpy(mbuf->m_data-offset,mbuf->m_data,14);
					rtl8651_memcpy(mbuf->m_data-offset+14,pppEntry_t->greBuf1_,offset);
					if(offset<=128) mbuf->m_data-=offset;
					
					
					if (mbuf->m_data[0]==0x01 && mbuf->m_data[1]==0x00 && mbuf->m_data[2]==0x5e)
					{
						rtl8651_memcpy(mbuf->m_data, &(pppEntry_t->macInfo->macAddr), 6);
					}
					

					pkthdrPtr->ph_len += offset;
					mbuf->m_len += offset;
									
					pkthdrPtr->ph_portlist=1<<(tunnel.wanPort);
					destPortMask = pkthdrPtr->ph_portlist;
					

					retval = FWDENG_SEND_GOTO_SEND;
					goto out;			
				}
				
				
				
				else if((ip->ip_p==IPPROTO_GRE)&&(pkthdrPtr->ph_rxdesc<0) 
					&&(iplen>=28))
				{
					struct wan_gre_header *gre;
					uint16 iphlen = IPHDR_LEN(ip);
					gre = (struct wan_gre_header *) ((int8 *) ip + iphlen);

					if(gre->flags&16) 
					{
						if(gre->ver&128) 
						{
							pppEntry_t->lastSeq_=PKTGET_UINT32_UNALIGNED(&gre->seq);
							pppEntry_t->lastAck_=PKTGET_UINT32_UNALIGNED(&gre->ack);
							
					 		PKTSET_UINT32_UNALIGNED(pppEntry_t->lastSeq_+pppEntry_t->delta_,&gre->seq);
						 	PKTSET_UINT32_UNALIGNED(pppEntry_t->lastAck_+pppEntry_t->delta_,&gre->ack);
						}
						else
						{
							pppEntry_t->lastSeq_=PKTGET_UINT32_UNALIGNED(&gre->seq);
							
							PKTSET_UINT32_UNALIGNED(pppEntry_t->lastSeq_+pppEntry_t->delta_,&gre->seq);
						}
						
						if((pppEntry_t->greBuf1_[26]!=((ntohs(gre->call_id)>>8)&0xff))|| 
							(pppEntry_t->greBuf1_[27]!=((ntohs(gre->call_id)&0xff)))||(pppEntry_t->peerCallId_==0))
						{
							pppEntry_t->peerCallId_=ntohs(gre->call_id);								
							rtl8651_memcpy(pppEntry_t->greBuf1_,ip,28);						
							pppEntry_t->greBuf1_[22]=0x88; 
							pppEntry_t->greBuf1_[23]=0x0b; 
							pppEntry_t->greBuf1_[26]=(pppEntry_t->peerCallId_>>8)&0xff;
							pppEntry_t->greBuf1_[27]=pppEntry_t->peerCallId_&0xff;
							
						}						
				
					}
					else if(gre->ver&128) 
					{
						pppEntry_t->lastAck_=PKTGET_UINT32_UNALIGNED(&gre->seq);
					 	PKTSET_UINT32_UNALIGNED(pppEntry_t->lastAck_+pppEntry_t->delta_,&gre->seq);
					}
					
					retval = FWDENG_SEND_GOTO_SEND;
					goto out;
				}	
			}
		}
		else if (rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP)
		{
			if (memcmp(local_vlanp->macAddr.octet, mbuf->m_data + 6 , 6))
			{
				
				pkthdrPtr->ph_portlist = 0;
				pkthdrPtr->ph_srcExtPortNum = 0;	
			}else
			{	
				if(pppEntry_t->l2tpBuf1_==NULL)
				{	
					pppEntry_t->l2tpBuf1_=(uint8*)rtlglue_malloc(RTL8651_MAX_PPTPL2TP_BUFFERSIZE);
					assert(pppEntry_t->l2tpBuf1_);						
				}

				
				
				if((pppEntry_t->initiated)&&(pkthdrPtr->ph_rxdesc>=0)&& 
					(iplen>=20)&&(iplen<=1452))
				{				

					struct ip *iphdr=(struct ip *)pppEntry_t->l2tpBuf1_;
					struct udphdr *udph = (struct udphdr *) ((int8 *) iphdr + ((iphdr->ip_vhl &0xf) << 2));
					static uint16 ip_id = 1;
													
					
					pkthdrPtr->ph_proto=6; 
					pkthdrPtr->ph_flags|=CSUM_IP;
					pkthdrPtr->ph_flags|=CSUM_L4;
					iphdr->ip_len=htons(iplen+pppEntry_t->l2tpOffset_);
					iphdr->ip_id = htons(ip_id ++);
					udph->uh_ulen=htons(iplen+18); 
						
					if(pppEntry_t->l2tpLengthBit_==1)
					{
						udph->uh_ulen=htons(ntohs(udph->uh_ulen)+2);
						if((pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-2]==0)&&(pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-3]==0x03))
						{
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-10]=((iplen+12)>>8)&0xff; 
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-9]=(iplen+12)&0xff;
						}
						else
						{
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-7]=((iplen+9)>>8)&0xff; 
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-6]=(iplen+9)&0xff;						
						}
					}

					rtl8651_memcpy(mbuf->m_data-pppEntry_t->l2tpOffset_,mbuf->m_data,14);
					rtl8651_memcpy(mbuf->m_data-pppEntry_t->l2tpOffset_+14,pppEntry_t->l2tpBuf1_,pppEntry_t->l2tpOffset_);
					if(pppEntry_t->l2tpOffset_<=128) mbuf->m_data-=pppEntry_t->l2tpOffset_;
				
					
					if (mbuf->m_data[0]==0x01 && mbuf->m_data[1]==0x00 && mbuf->m_data[2]==0x5e)
					{
						rtl8651_memcpy(mbuf->m_data, &(pppEntry_t->macInfo->macAddr), 6);
					}
					

					pkthdrPtr->ph_len += pppEntry_t->l2tpOffset_;
					mbuf->m_len += pppEntry_t->l2tpOffset_;	
					pkthdrPtr->ph_portlist=1<<(tunnel.wanPort);	
					destPortMask = pkthdrPtr->ph_portlist;

					retval = FWDENG_SEND_GOTO_SEND;
					goto out;
				}

				
				else if((ip->ip_p==IPPROTO_UDP)&&(iplen>=34)) 
				{			
					struct udphdr *udp;
					udp = (struct udphdr *)L4HDR_ADDR(ip);
					if(ntohs(udp->uh_dport)==1701)
					{				
						struct wan_l2tp_header *l2tp=(struct wan_l2tp_header*)(udp+1);	
						
						if((ntohs(l2tp->tunnel_id)==0)&&(ntohs(l2tp->session_id)==0))
						{
							pppEntry_t->l2tpBuf1State_=0;
							pppEntry_t->l2tpOffset_=0;
							pppEntry_t->tunnelId_=0;
							pppEntry_t->l2tpSessionId_=0;
							pppEntry_t->l2tpServerIp_=0;
							pppEntry_t->l2tpLengthBit_=0;
						}

#ifdef RTL8651_NEW_L2TPBUFF_FILL_CODE
						
						if (	(pppEntry_t->l2tpBuf1State_ == 0)  &&
						       (l2tp->flags_type == 0) &&
							(l2tp->flags_offset == 0) &&
							(l2tp->flags_sequence == 0) )
						{
							if (pppEntry_t->l2tpBuf1_ == NULL)
							{
								pppEntry_t->l2tpBuf1_ = rtlglue_malloc(RTL8651_MAX_PPTPL2TP_BUFFERSIZE);
								assert(pppEntry_t->l2tpBuf1_);
							}

							if (iplen < RTL8651_MAX_PPTPL2TP_BUFFERSIZE)
							{
								rtl8651_memcpy(pppEntry_t->l2tpBuf1_, ip, iplen);
								pppEntry_t->l2tpOffset_ = (uint32)l2tp - (uint32)ip + 10;

								if(l2tp->flags_length)
								{
									pppEntry_t->l2tpOffset_ += 2;
									pppEntry_t->l2tpLengthBit_= 1;
								}else
								{
									pppEntry_t->l2tpLengthBit_ = 0;
								}
								pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_ - 4] = 0xff;
								pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_ - 3] = 0x03;
								pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_ - 2] = 0x00;
								pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_ - 1] = 0x21;

								
								pppEntry_t->l2tpBuf1State_ = 1;
							}
						} else if (l2tp->flags_type == 1)	
						{
							int32 pureL2tpHdrLen = 8;	
						
							assert(l2tp->flags_length == 1);	

							if (l2tp->flags_sequence)	
							{
								pureL2tpHdrLen += 4;
							}

							if (ntohs(l2tp->length) <= pureL2tpHdrLen)
							{	
							}else
							{	
								int32 totalAVPLengthBudget;
								uint8 *AVP;

								AVP = (uint8 *)((uint32)l2tp + pureL2tpHdrLen);
								
								totalAVPLengthBudget = ntohs(l2tp->length) - pureL2tpHdrLen;
								assert(totalAVPLengthBudget > 0);

								
								while (totalAVPLengthBudget > 0)
								{
									int32 currentAVPLength;
									uint16 attributeType;

									currentAVPLength = ntohs(*(uint16 *)AVP) & 0x3ff;	
									assert(currentAVPLength >= 6);	

									attributeType = ntohs(*(uint16 *)((uint32)AVP + 4));

									
									switch (attributeType)
									{
										case L2TP_AVP_ATTRIBUTE_CTRLMSG:	
										{
											
											if (currentAVPLength == 8)
											{	
												uint16 msgType;

												msgType = ntohs(*(uint16 *)((uint32)AVP + 6));

												switch (msgType)
												{
													case L2TP_CTRLMSG_ICCN:
													{	
														if ((pppEntry_t->l2tpBuf1_) && (pppEntry_t->l2tpOffset_ >= 8))
														{
															*(uint16*)&(pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_ - 8]) = l2tp->tunnel_id;
															*(uint16*)&(pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_ - 6]) = l2tp->session_id;
														}else
														{
															uint16 tunnelID = ntohs(l2tp->tunnel_id);
															uint16 sessionID = ntohs(l2tp->session_id);
															ipaddr_t gatewayIp = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
															ipaddr_t serverIp = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);

															_rtl8651_forgeL2tpBuffer(&pppEntry_t->l2tpBuf1_,
																					 &pppEntry_t->l2tpOffset_,
																					 &pppEntry_t->l2tpLengthBit_,
																					 gatewayIp,
																					 serverIp,
																					 tunnelID,
																					 sessionID);
														}
													}
													break;
												}
											}
											
										}
										break;
									}
									
									AVP = (uint8 *)((uint32)AVP + currentAVPLength);

									assert(totalAVPLengthBudget >= currentAVPLength);
									totalAVPLengthBudget -= currentAVPLength;
								}
							}
						}
#else 
						if((pppEntry_t->l2tpOffset_==0)&&(l2tp->flags_type==0)&&(l2tp->flags_offset==0)&&(l2tp->flags_sequence==0)) 
						{
							
							rtl8651_memcpy(pppEntry_t->l2tpBuf1_,ip,iplen);
							pppEntry_t->l2tpOffset_=(uint32)l2tp-(uint32)ip+10; 
							if(l2tp->flags_length) 
							{
								pppEntry_t->l2tpOffset_+=2;
								pppEntry_t->l2tpLengthBit_=1;
							}
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-4]=0xff;
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-3]=0x03;
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-2]=0x00;
							pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-1]=0x21;						
						}
						
						else if((l2tp->flags_type==1)&&(pppEntry_t->l2tpOffset_)&&(iplen>=28+l2tp->length)) 
						{
							uint8 *avp=(uint8 *)(l2tp)+8;
							if(l2tp->flags_sequence) avp+=4;
							
							if(avp[4]==0&&avp[5]==0&&avp[6]==0) 
							{
								if(avp[7]==12) 
								{
									pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-8]=htons((ntohs(l2tp->tunnel_id)>>8)&0xff);
									pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-7]=htons(ntohs(l2tp->tunnel_id)&0xff);
									pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-6]=htons((ntohs(l2tp->session_id)>>8)&0xff);
									pppEntry_t->l2tpBuf1_[pppEntry_t->l2tpOffset_-5]=htons(ntohs(l2tp->session_id)&0xff);
									
								}
							}
						}
#endif 
						retval = FWDENG_SEND_GOTO_SEND;
						goto out;
					}
				}
			}
		} 
	}		
	
	

	retval = FWDENG_SEND_PASSED;
out:
	*pDestPortMask = destPortMask;
	return retval;
}

#endif 

#define L2ENG_VLAN_PROCESS

static void _rtl8651_fwdEngineVlanProcess(	uint8 pktIsTag,
												uint8 txNeedTag,
												struct rtl_pktHdr *pktHdr,
												uint16 vid,
												uint8 priority)
{
	
	if (pktHdr->ph_property != PH_PROPER_DRVFWD)
	{
		return;
	}

	if (txNeedTag)
	{
		if (pktIsTag)
		{
			
			_rtl8651_fwdEngineModifyVlanTag(	pktHdr,
												vid,
												priority);
		} else
		{
			
			_rtl8651_fwdEngineAddVlanTag(	pktHdr,
											vid,
											priority);
		}
	} else
	{
		if (pktIsTag)
		{
			
			_rtl8651_fwdEngineStripVlanTag(pktHdr);
		} else
		{
			
		}
	}
}


static void _rtl8651_fwdEngineStripVlanTag(struct rtl_pktHdr * pPkthdr)
{
	struct rtl_mBuf *thisMbuf = pPkthdr->ph_mbuf;
	uint8 *data = thisMbuf->m_data;
	uint8 dasa[12];

	memcpy(dasa, data, 12);
	memcpy(data+4, dasa, 12);
	pPkthdr->ph_len -= 4;
	thisMbuf->m_len -= 4;
	thisMbuf->m_data += 4;
}


static void _rtl8651_fwdEngineModifyVlanTag(	struct rtl_pktHdr *pktHdr,
												uint16 vid,
												uint8 priority)
{
	struct rtl_mBuf *mbuf;

	mbuf = pktHdr->ph_mbuf;

	
	if (VLAN_TAGGED(mbuf->m_data))
	{
		
		*(uint16*)(&(mbuf->m_data[14])) = htons(vid);					
		*(uint8*)(&(mbuf->m_data[14])) &= 0x0f;							
		*(uint8*)(&(mbuf->m_data[14])) |= (((uint8)(priority)) << 5);		
	}
}


static void _rtl8651_fwdEngineAddVlanTag(	struct rtl_pktHdr *pktHdr,
												uint16 vid,
												uint8 priority)
{
	ether_addr_t smac, dmac;
	uint8 priorityField;
	struct rtl_mBuf *mbuf;

	mbuf = pktHdr->ph_mbuf;
	priorityField = ((uint8)(priority)) << 5;	

	memcpy(&dmac, mbuf->m_data, sizeof(ether_addr_t));
	memcpy(&smac, &(mbuf->m_data[6]), sizeof(ether_addr_t));
	mbuf->m_data -= 4;
	mbuf->m_len += 4;
	pktHdr->ph_len += 4;

	memcpy(mbuf->m_data, &dmac, sizeof(ether_addr_t));
	memcpy(&(mbuf->m_data[6]), &smac, sizeof(ether_addr_t));

	
	*(uint16*)(&(mbuf->m_data[12])) = htons(0x8100);		
	*(uint16*)(&(mbuf->m_data[14])) = htons(vid);			
	*(uint8*)(&(mbuf->m_data[14])) &= 0x0f;					
	*(uint8*)(&(mbuf->m_data[14])) |= priorityField;			
}



#define L2ENG_LAYER2_OPERATION


static int32 _rtl8651_fwdEngineSend_FromPS(	struct rtl_pktHdr * pkthdrPtr,
												rtl8651_tblDrv_vlanTable_t *local_vlanp,
												uint32* pDestPortMask )
{
	rtl8651_tblDrv_filterDbTableEntry_t *dal2Entry;
	int32 retval;
	uint16 dvid = local_vlanp->vid;
	struct rtl_mBuf *mbuf = pkthdrPtr->ph_mbuf;
	uint32 destPortMask = *pDestPortMask;

	

	
	if ((mbuf->m_data[0] & 1) == 0)
	{
		
		dal2Entry = _rtl8651_getVlanFilterDatabaseEntry(dvid, (ether_addr_t *)&mbuf->m_data[0]);
		if (dal2Entry && (dal2Entry->memberPortMask & local_vlanp->memberPortMask))
		{
			

			
			if (dal2Entry->memberPortMask & peripheralExtPortMask)
			{
				#ifdef RTL865X_DEBUG
				if(wlan_acc_debug>1) 
					rtlglue_printf("\tPS unicast to link ID %d...\n", dal2Entry->linkId);
				#endif

				retval = _rtl8651_fwdEngineExtDevUcast(	pkthdrPtr,
														local_vlanp,
														dal2Entry->linkId,
														((pkthdrPtr->ph_flags & PKTHDR_HPRIORITY)?7:0));

				retval = SUCCESS;
				goto out;
			}

			#ifdef RTL865X_DEBUG
			if(wlan_acc_debug>1) 
				rtlglue_printf("\tPS unicast to port 0x%x  (peripheralExtPortMask=%x)...\n", dal2Entry->memberPortMask,peripheralExtPortMask);
			#endif

			destPortMask =dal2Entry->memberPortMask;
			
			retval = FWDENG_SEND_GOTO_TOSWCORE;
			goto out;

		}

		#ifdef RTL865X_DEBUG			
		if(wlan_acc_debug>1)
			rtlglue_printf("\tunknown unicast "); 
		#endif

		
	}

	
	if ((destPortMask & local_vlanp->memberPortMask) & peripheralExtPortMask)
	{
		_rtl8651_fwdEngineExtDevBcast(	pkthdrPtr,
										local_vlanp,
										0xffffffff,
										0,
										((pkthdrPtr->ph_flags & PKTHDR_HPRIORITY)?7:0),
										FALSE);
	}

	
	destPortMask &= local_vlanp->memberPortMask&RTL8651_PHYSICALPORTMASK;
	destPortMask &= ~peripheralExtPortMask;	
	
	#ifdef RTL865X_DEBUG
	if(wlan_acc_debug>1) 
		rtlglue_printf("\tPS bcast to %s port 0x%x...\n", local_vlanp->internal?"LAN":"WAN", destPortMask);
	#endif
	pkthdrPtr->ph_srcExtPortNum = 0;	
	retval = FWDENG_SEND_GOTO_SEND;
	

out:
	*pDestPortMask = destPortMask;
	return retval;
}



static int32 _rtl8651_fwdEngineSend_ExtDevSend(	uint32 property,
														struct rtl_pktHdr *pkthdrPtr,
														rtl8651_tblDrv_vlanTable_t *local_vlanp,
														struct ip *ip,
														uint32* pDestPortMask )
{
	rtl8651_tblDrv_filterDbTableEntry_t *dal2Entry;
	int32 retval;
	uint32 destPortMask = *pDestPortMask;
	uint32 vlanMbrPortMask;
	struct rtl_mBuf *mbuf = pkthdrPtr->ph_mbuf;
	struct rtl_mBuf *newMbuf;
	uint32 linkId = 0;
	uint16 dvid;

#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pkthdrPtr->ph_property == PH_PROPER_DRVFWD) &&
		(pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
	{
		rtl8651_tblDrv_swVlanTable_t *swVlanPtr;

		
		dvid = pkthdrPtr->ph_svid;
		swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(dvid)];
		vlanMbrPortMask = swVlanPtr->memberPortMask;
	}
	else
#endif 
	{
		dvid = local_vlanp->vid;
		vlanMbrPortMask = local_vlanp->memberPortMask;
	}

		
	if ((mbuf->m_data[0] & 1) == 0)
	{
		dal2Entry = _rtl8651_getVlanFilterDatabaseEntry(dvid, (ether_addr_t *)&mbuf->m_data[0]);

		if (dal2Entry && (dal2Entry->memberPortMask & vlanMbrPortMask))
		{
			linkId = dal2Entry->linkId;
		}
	}

	
	_rtl8651_fwdEngineTxChecksumOffload(ip, TRUE, TRUE);

	
	if ((destPortMask & RTL8651_PHYSICALPORTMASK) == 0)
	{
		
		#ifdef RTL865X_DEBUG
		if(wlan_acc_debug>1) 
			rtlglue_printf("\tunicast ");
		#endif

		_rtl8651_fwdEngineSWExtDevSend(	pkthdrPtr,
											local_vlanp,
											(property & FWDENG_FROMDRV)?
												(pkthdrPtr->ph_priority):
												((pkthdrPtr->ph_flags & PKTHDR_HPRIORITY)?7:0),
											(int32)linkId);

		
		retval = SUCCESS;
		goto out;
	}

	
	newMbuf =  mBuf_dupPacket(mbuf, MBUF_DONTWAIT);
	if (newMbuf)
	{
		#ifdef RTL865X_DEBUG
		if(wlan_acc_debug>1) 
			rtlglue_printf("\tbcast ");
		#endif

		_rtl8651_fwdEngineSWExtDevSend(	newMbuf->m_pkthdr,
											local_vlanp,
											(property & FWDENG_FROMDRV)?
												(newMbuf->m_pkthdr->ph_priority):
												((newMbuf->m_pkthdr->ph_flags & PKTHDR_HPRIORITY)?7:0),
											(int32)linkId);

		
	}

	
	destPortMask &= ~(destPortMask & peripheralExtPortMask & vlanMbrPortMask);
	destPortMask &= ~(1<<(pkthdrPtr->ph_srcExtPortNum-1+RTL8651_MAC_NUMBER));

	#ifdef RTL865X_DEBUG
	if(wlan_acc_debug>2) 
		rtlglue_printf("\tsend to 0x%04x\n", destPortMask);
	#endif

	
	retval = FWDENG_SEND_PASSED;
out:
	*pDestPortMask = destPortMask;
	return retval;
}



__IRAM_L2_FWD int32 _rtl8651_fwdEngineSend(uint32 property, void * data, int16 dvid, int32 iphdrOffset)
{
	struct rtl_pktHdr *pkthdrPtr =( struct rtl_pktHdr *)data;
	struct ip *ip = NULL;
	uint32 destPortMask = pkthdrPtr->ph_portlist;
	uint32 vlanMbrPortMask;
	struct rtl_mBuf *mbuf;
	rtl8651_tblDrv_vlanTable_t *local_vlanp;	
	int32 retval = SUCCESS;
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr = NULL;
#endif

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_FWDENG_SEND);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_EGRESS_ACL);
#endif
	

	assert(dvid);	
	assert((destPortMask & rtl8651_tblDrvCpuMirrorPortMask) == 0);
	assert(pkthdrPtr->ph_mbuf);

	mbuf = pkthdrPtr->ph_mbuf;

#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pkthdrPtr->ph_property == PH_PROPER_DRVFWD) &&
		( pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN ))
	{
		if ( dvid != pkthdrPtr->ph_svid )
		{
			RTL_BUG("Software VLAN packet did NOT do L2 process because VLAN is changed.");
		}

		
		swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(dvid)];
		vlanMbrPortMask = swVlanPtr->memberPortMask;

		pkthdrPtr->ph_vlanIdx = 0;
		local_vlanp = NULL;

		
		goto to_swcore;
	} else
#endif 
	{
		pkthdrPtr->ph_vlanIdx= dvid & (RTL8651_VLAN_NUMBER-1);
		local_vlanp = &DrvTbl.vlan[pkthdrPtr->ph_vlanIdx];
		vlanMbrPortMask = local_vlanp->memberPortMask;
	}

	if (pkthdrPtr->ph_iphdrOffset)
	{
		ip = (struct ip *)&mbuf->m_data[pkthdrPtr->ph_iphdrOffset];
	} else if (iphdrOffset >= 0)
	{
		ip = (struct ip *)&mbuf->m_data[iphdrOffset];
	}

	
	if (rtl8651_drvPacketFastSend == FALSE)
	{
		retval = _rtl8651_egressAcl(	pkthdrPtr->ph_dsid,
									local_vlanp,
									dvid,
									(uint8 *)mbuf->m_data,
									(uint8 *)ip);
		if (retval & FWDENG_DROP)
		{
			return retval;
		}
	}
#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_EGRESS_ACL);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_PPTPL2TP_ENCAP);
#endif

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	{
		rtl8651_tblDrv_routeTable_t *rt_t;

		rt_t = DrvTbl.route+(rtl8651_tblDrvPara.routingTableSize-1);
		if (rt_t->valid != 0 && rt_t->ifrt_flag == 0)
		{
			
			if (((rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP) || (rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP)) &&
			    (ip) ) 
			{
				retval = _rtl8651_fwdEngineSend_PptpL2tp( pkthdrPtr, local_vlanp, ip, rt_t, &destPortMask );
				switch ( retval )
				{
					case FWDENG_SEND_GOTO_SEND:
						goto send;
					case FWDENG_SEND_PASSED:
						break;
					case SUCCESS:
						return SUCCESS;
					default:
						assert( 0 );
						return retval;
				}
			}
		}
	}
#endif

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_PPTPL2TP_ENCAP);
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_FROM_PS);
#endif

	
	if(property & FWDENG_FROMPS)
	{ 
		retval = _rtl8651_fwdEngineSend_FromPS(pkthdrPtr, local_vlanp, &destPortMask );
		switch ( retval )
		{
			case FWDENG_SEND_GOTO_SEND:
				goto send;
			case FWDENG_SEND_GOTO_TOSWCORE:
				goto to_swcore;
			case SUCCESS:
				return SUCCESS;
			default:
				assert( 0 );
				return retval;
		}
	}
	
#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FROM_PS);
#endif


to_swcore:

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_EXTDEV_SEND);
#endif

	destPortMask &= vlanMbrPortMask;

	
	if (destPortMask & peripheralExtPortMask)
	{
		retval = _rtl8651_fwdEngineSend_ExtDevSend(	property,
													pkthdrPtr,
													local_vlanp,
													ip,
													&destPortMask);
		switch ( retval )
		{
			case FWDENG_SEND_PASSED:
				break;
			case SUCCESS:
				return SUCCESS;
			default:
				assert( 0 );
				return retval;
		}
	}
	pkthdrPtr->ph_srcExtPortNum = 0;


send:

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_EXTDEV_SEND);
	#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pkthdrPtr->ph_property == PH_PROPER_DRVFWD) &&
		((pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) == 0) )
	{
		rtl8651_romeperfEnterPoint(ROMEPERF_INDEX_FRAG_2ND_HALF);
	}
	#endif
#endif

	assert((destPortMask & peripheralExtPortMask) == 0);
	destPortMask |= rtl8651_tblDrvCpuMirrorPortMask;	

	
	destPortMask &= phyPortLinkStatus;

	
	if (	rtl8651_tblDrvSpanningTreeEnable &&
		
		(	property & (FWDENG_FROMDRV|FWDENG_OFFLOAD) ||
			((pkthdrPtr->ph_pkt_property & PH_PKT_PROPER_STPCTL) == 0)
		))
	{
		destPortMask &= rtl8651_tblDrvSpanningTreePortFwdStatus;
	}

	
	if (	(destPortMask == 0) && 
		(pkthdrPtr->ph_srcExtPortNum == 0))
	{
		mBuf_freeMbufChain(mbuf);
		return SUCCESS;
	}

	
	if ((property & FWDENG_FROMDRV) == 0)
	{
		pkthdrPtr->ph_portlist = destPortMask;
		goto tx;
	}

	

	
	if (
#ifdef RTL865XB_DCUT_SWVLAN
		(local_vlanp) &&
#endif 
		(local_vlanp->internal == FALSE) &&
		(property & (FWDENG_L34PROC|FWDENG_TUNNELTX)) &&	
		(pkthdrPtr->ph_srcExtPortNum == 0) &&					
		(pkthdrPtr->ph_rxdesc >= 0)
	)
	{
		uint32 swNicRxIndex;

#ifdef RTL865X_TEST
		swNicRxIndex = 0xffff;	
#else
#ifdef CONFIG_RTL865XC
		rtlglue_getRingSize(&swNicRxIndex, NULL, 0); 
#else
		rtlglue_getRingSize(&swNicRxIndex, NULL);
#endif 
#endif 

		if (pkthdrPtr->ph_rxdesc < swNicRxIndex)
		{
			_rtl8651_recordTraffic(pkthdrPtr->ph_dsid, TRUE );
		}
	}

	
	#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pkthdrPtr->ph_property == PH_PROPER_DRVFWD) &&
		(pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
	{
		
		pkthdrPtr->ph_flags &= ~(PKTHDR_VLAN_AUTOADD|CSUM_IP|CSUM_L4);
		pkthdrPtr->ph_vlanTagged = 0;

		if (destPortMask & ~(swVlanPtr->untagPortMask))
		{	
			retval = _rtl8651_fwdEngineSWVlanSend(	pkthdrPtr,
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
													ip,
#endif
													destPortMask,
													(destPortMask & ~(swVlanPtr->untagPortMask)),
													dvid,
													pkthdrPtr->ph_priority);
			if (retval == SUCCESS)
			{
				goto tx_done;
			}
		}

		pkthdrPtr->ph_portlist = destPortMask & swVlanPtr->untagPortMask;
	} else
	#endif 
	{
		
		if (destPortMask & ~(local_vlanp->untagPortMask))
		{
			retval = _rtl8651_fwdEngineHWVlanSend(	pkthdrPtr,
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
													ip,
#endif
													destPortMask,
													(destPortMask & ~(local_vlanp->untagPortMask)),
													dvid,
													pkthdrPtr->ph_priority);
			if (retval == SUCCESS)
			{
				goto tx_done;
			}

			
			pkthdrPtr->ph_portlist = destPortMask & local_vlanp->untagPortMask;
		} else
		{
			
			pkthdrPtr->ph_portlist = destPortMask;

#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
			if ((pkthdrPtr->ph_rxdesc >= 0) && ip)
			{
				_rtl8651_fragmentShortestPathCacheSet_secondHalf(pkthdrPtr, pkthdrPtr->ph_mbuf->m_data, ip);
			}
#endif 
#ifdef CONFIG_RTL865X_ROMEPERF
			rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FRAG_2ND_HALF);
#endif
		}
	}

tx:
	
	rtlglue_drvSend((void*)data);

#ifdef CONFIG_RTL865X_ROMEPERF
	rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FWDENG_SEND);
#endif

tx_done:

	return SUCCESS;
}

static int32 _rtl8651_fwdEngineHWVlanSend(	struct rtl_pktHdr *pktHdr,
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
												struct ip *pip,
#endif
												uint32 txPortMask,
												uint32 tagTxPortMask,
												uint16 vid,
												uint8 priority)
{
	struct rtl_mBuf *mbuf = NULL;
	struct rtl_pktHdr *txPkt = NULL;

	if (txPortMask == tagTxPortMask)
	{	
		mbuf = pktHdr->ph_mbuf;
		txPkt = pktHdr;
	} else
	{
		mbuf = mBuf_dupPacket(pktHdr->ph_mbuf, MBUF_DONTWAIT);
		if (mbuf == NULL)
		{
			goto out;
		}
		txPkt = mbuf->m_pkthdr;
	}

	
	if (txPkt->ph_vlanTagged == FALSE)
	{
		txPkt->ph_flags |= PKTHDR_VLAN_AUTOADD;
	}
	txPkt->ph_portlist = tagTxPortMask;

	{
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
		if (	(pktHdr->ph_rxdesc >= 0) &&
			(pip))
		{
			_rtl8651_fragmentShortestPathCacheSet_secondHalf(txPkt, txPkt->ph_mbuf->m_data, pip);
		}
#endif 
#ifdef CONFIG_RTL865X_ROMEPERF
		rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FRAG_2ND_HALF);
#endif
	}

	rtlglue_drvSend((void*)txPkt);

out:
	if (txPortMask == tagTxPortMask)
	{
		
		return SUCCESS;
	}
	return FWDENG_SEND_PASSED;
}

#ifdef RTL865XB_DCUT_SWVLAN
static int32 _rtl8651_fwdEngineSWVlanSend(	struct rtl_pktHdr *pktHdr,
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
												struct ip *pip,
#endif
												uint32 txPortMask,
												uint32 tagTxPortMask,
												uint16 vid,
												uint8 priority)
{
	struct rtl_mBuf *mbuf = NULL;
	struct rtl_pktHdr *txPkt = NULL;

	if (txPortMask == tagTxPortMask)
	{	
		mbuf = pktHdr->ph_mbuf;
		txPkt = pktHdr;
	} else
	{
		mbuf = mBuf_dupPacket(pktHdr->ph_mbuf, MBUF_DONTWAIT);
		if (mbuf == NULL)
		{
			goto out;
		}
		txPkt = mbuf->m_pkthdr;
	}

	
	if (pktHdr->ph_property == PH_PROPER_DRVFWD)
	{
		_rtl8651_fwdEngineAddVlanTag(	txPkt,
										vid,
										priority);
	}

	txPkt->ph_portlist = tagTxPortMask;

#ifdef RTL865XB_DCUT_SWVLAN
	if (	(pktHdr->ph_property != PH_PROPER_DRVFWD) ||
		((pktHdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) == 0) )
#endif 
	{
#ifdef RTL8651_FRAGMENT_SHORTESTPATH_FWD
		if (	(pktHdr->ph_rxdesc >= 0) &&
			(pip))
		{
			_rtl8651_fragmentShortestPathCacheSet_secondHalf(txPkt, txPkt->ph_mbuf->m_data, pip);
		}
#endif 
#ifdef CONFIG_RTL865X_ROMEPERF
		rtl8651_romeperfExitPoint(ROMEPERF_INDEX_FRAG_2ND_HALF);
#endif
	}

	rtlglue_drvSend((void*)txPkt);

out:
	if (txPortMask == tagTxPortMask)
	{
		
		return SUCCESS;
	}
	return FWDENG_SEND_PASSED;
}
#endif 

static int32  _rtl8651_layer2Passthrough(struct rtl_pktHdr *pkthdrPtr, rtl8651_tblDrv_vlanTable_t *local_vlanp, uint8 *m_data, uint16 ethtype)
{
	
	
	if ( ( rtl8651_l2protoPassThrough & PASSTHRU_PPPOE && ( ethtype == 0x8863 || ethtype == 0x8864 ) ) ||
	     ( rtl8651_l2protoPassThrough & PASSTHRU_IPV6 && ethtype == 0x86DD ) ||
	     ( rtl8651_l2protoPassThrough & PASSTHRU_IPX && ethtype == 0xE0E0 ) ||
	     ( rtl8651_l2protoPassThrough & PASSTHRU_NETBIOS && ethtype == 0xF0F0 ) )
	{
		ether_addr_t vlanGMAC;
		
		

		
		rtl8651_getVlanMacAddress( local_vlanp->vid, &vlanGMAC, NULL );

		
		if ( memcmp( pkthdrPtr->ph_mbuf->m_data, &vlanGMAC, sizeof(ether_addr_t) ) != 0 )
		{
			int32 retval;
			rtl8651_tblDrv_filterDbTableEntry_t *macinfo;
			struct ether_header *ethHdr;
			uint16 srcport;
#if PPPOE_PASSTHRU_NEW_MODEL==1
#else
			uint32 i, j;
			uint16 dvid[RTL8651_VLANTBL_SIZE]; 
			int32 dvid_count;
			uint16 dportmask;
			
			dvid_count = 0;
#endif

			srcport = pkthdrPtr->ph_portlist;
			ethHdr = (struct ether_header*)m_data;
			
			
			if ( rtl8651_drvDropUnknownPppoePADT &&
			     ethtype == 0x8863 )
			{
				pppoeHdr_t *pppoeHdr;
				
				pppoeHdr = (pppoeHdr_t *)(((char*)ethHdr)+sizeof(struct ether_header));

				
				
				if ( local_vlanp->internal==FALSE &&
				     pppoeHdr->code==0xa7 )
				{
					

					
					if ( memcmp( ethHdr->ether_dhost, rtl8651_knownPppoePassthruEthHdr.ether_shost, ETHER_ADDR_LEN ) )
					{
						
						return FWDENG_PPPOE8863;
					}
					else
					{
						
					}
				}

				
				if ( local_vlanp->internal==TRUE )
				{
					rtl8651_knownPppoePassthruEthHdr = *ethHdr;
					
				}
				
			}

#ifdef RTL865X_TEST
			
			uint16 backupVid = local_vlanp->vid;
			local_vlanp->vid = rtl8651_gPPPoEPassthruVlanID;
#endif

#if PPPOE_PASSTHRU_NEW_MODEL==1

#if 0
			
			assert( local_vlanp->vid == rtl8651_gPPPoEPassthruVlanID ||
			        local_vlanp->vid == rtl8651_gIPv6PassthruVlanID );
			if ( local_vlanp->vid != rtl8651_gPPPoEPassthruVlanID &&
			     local_vlanp->vid != rtl8651_gIPv6PassthruVlanID )
				rtlglue_printf("[%s:%d] local_vlanp->vid=%d, rtl8651_gPPPoEPassthruVlanID=%d, rtl8651_gIPv6PassthruVlanID=%d\n",
				                __FILE__, __LINE__,
				                local_vlanp->vid, rtl8651_gPPPoEPassthruVlanID, rtl8651_gIPv6PassthruVlanID );
#endif

			if (( (1<<srcport) & peripheralExtPortMask )  &&
				(pkthdrPtr->ph_extPortList < 8)						   )
			{
				
				
				return FAILED;
			}
			else
			{
				
				macinfo = _rtl8651_getVlanFilterDatabaseEntry( 0, (struct ether_addr_s*) ethHdr->ether_dhost );
				if ( macinfo == NULL )
				{
					
					
					switch ( ethtype )
					{
						case 0x86DD:
							
							pkthdrPtr->ph_portlist = ( DrvTbl.vlan[rtl8651_vlanTableIndex(rtl8651_gIPv6PassthruVlanID)].memberPortMask | peripheralExtPortMask ) & (~(1<<srcport));
							break;
							
						case 0xE0E0:
							
							pkthdrPtr->ph_portlist = ( DrvTbl.vlan[rtl8651_vlanTableIndex(rtl8651_gIPXPassthruVlanID)].memberPortMask | peripheralExtPortMask ) & (~(1<<srcport));
							break;
							
						case 0xF0F0:
							
							pkthdrPtr->ph_portlist = ( DrvTbl.vlan[rtl8651_vlanTableIndex(rtl8651_gNetbiosPassthruVlanID)].memberPortMask | peripheralExtPortMask ) & (~(1<<srcport));
							break;
							
						default:
							
							pkthdrPtr->ph_portlist = ( DrvTbl.vlan[rtl8651_vlanTableIndex(rtl8651_gPPPoEPassthruVlanID)].memberPortMask | peripheralExtPortMask ) & (~(1<<srcport));
							break;
					}
				}
				else
				{
					
					
					pkthdrPtr->ph_portlist = macinfo->memberPortMask & (~(1<<srcport));
				}
			}

			if ( ethtype == 0x8864 )
			{
				pkthdrPtr->ph_pppeTagged = 0; 
				pkthdrPtr->ph_flags &= ~(PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
			}

			#if 0
			rtlglue_printf( "dvid=%d  ph_portlist=0x%x, ph_extPortList=0x%x, ph_srcExtPortNum=0x%x\n", 
			                ethtype==0x86DD?rtl8651_gIPv6PassthruVlanID:rtl8651_gPPPoEPassthruVlanID,
			                pkthdrPtr->ph_portlist, pkthdrPtr->ph_extPortList, pkthdrPtr->ph_srcExtPortNum );
			#endif
			
			retval = _rtl8651_fwdEngineSend( FWDENG_L2PROC|FWDENG_FROMDRV,
							     (void*)pkthdrPtr, 
			                                 ethtype==0x86DD?rtl8651_gIPv6PassthruVlanID:
			                                 ethtype==0xE0E0?rtl8651_gIPXPassthruVlanID:
			                                 ethtype==0xF0F0?rtl8651_gNetbiosPassthruVlanID:
			                                 rtl8651_gPPPoEPassthruVlanID,
			                                 -1 );

			if ( retval != SUCCESS )
			{
				mBuf_freeMbufChain( pkthdrPtr->ph_mbuf );
			}

#else

			
			macinfo = _rtl8651_getVlanFilterDatabaseEntry( 0, (struct ether_addr_s*) ethHdr->ether_dhost );
			if ( macinfo == NULL )
			{
				
				pkthdrPtr->ph_portlist = 0;
				
				
				for( i = 0;
				     i < RTL8651_VLANTBL_SIZE;
				     i++ )
				{
					if ( DrvTbl.vlan[i].valid )
					{
						pkthdrPtr->ph_portlist |= DrvTbl.vlan[i].memberPortMask;
						
					}
				}

				
				pkthdrPtr->ph_portlist &= ~(1<<srcport);
				
			}
			else
			{
				
				pkthdrPtr->ph_portlist = macinfo->memberPortMask;
				
			}

			
			dportmask = pkthdrPtr->ph_portlist;
			for( i = 0;
			     i < RTL8651_VLANTBL_SIZE;
			     i++ )
			{
				if ( dportmask == 0x0000 ) break;
				if ( DrvTbl.vlan[i].valid &&
				     DrvTbl.vlan[i].vid != local_vlanp->vid )
				{
					if ( dportmask & DrvTbl.vlan[i].memberPortMask )
					{
						dvid[dvid_count++] = DrvTbl.vlan[i].vid;
						dportmask &= ~DrvTbl.vlan[i].memberPortMask;
					}
				}
			}
			if ( dvid_count == 0 )
			{
				rtlglue_printf( "PPPoEPassthru: dvid is not set.\n" );
				
				mBuf_freeMbufChain( pkthdrPtr->ph_mbuf );
				goto no_forward_pppoe_passthru;
#if 0
				dvid[dvid_count++] = 1; 
#endif
			}

			
			for( i = 0;
			     i < RTL8651_VLANTBL_SIZE;
			     i++ )
			{
				if ( DrvTbl.vlan[i].valid &&
				     DrvTbl.vlan[i].vid != local_vlanp->vid  )
				{
					
					for( j = 0; j < dvid_count; j++ )
					{
						if ( dvid[j] == DrvTbl.vlan[i].vid )
						{
							struct rtl_mBuf *dup_mBuf = NULL;
							
							
							if ( j != dvid_count-1 )
								dup_mBuf = mBuf_dupPacket( pkthdrPtr->ph_mbuf, MBUF_DONTWAIT );

							
							pkthdrPtr->ph_portlist = DrvTbl.vlan[i].memberPortMask & ~(1<<srcport);
							if ( ethtype == 0x8864 )
							{
								pkthdrPtr->ph_pppeTagged = 0; 
								pkthdrPtr->ph_flags &= ~(PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
							}
							
							retval = _rtl8651_fwdEngineSend(FWDENG_L2PROC|FWDENG_FROMDRV, (void*)pkthdrPtr, dvid[j], -1 );

							if ( retval == SUCCESS )
							{
								
								if ( dup_mBuf )
									dup_mBuf->m_pkthdr->ph_portlist &= ~DrvTbl.vlan[i].memberPortMask;
							}
							else
							{
								
								mBuf_freeMbufChain( pkthdrPtr->ph_mbuf );
							}

							
							if ( dup_mBuf ) 
								pkthdrPtr = dup_mBuf->m_pkthdr;
							else 
								pkthdrPtr = NULL;
						}
					}
				}
			}

			
			assert( pkthdrPtr == NULL );
no_forward_pppoe_passthru:
#endif

#ifdef RTL865X_TEST
			
			local_vlanp->vid = backupVid;
#endif

			return SUCCESS;
		}
		else
		{
			
			
		}
	}
	return FAILED;
}


__IRAM_L2_FWD int32 _rtl8651_fwdEngineL2Input(	struct rtl_pktHdr *pkthdrPtr,
													rtl8651_tblDrv_vlanTable_t *local_vlanp,
													uint8 *m_data,
													uint16 ethtype)
{
	int32 compare;

	

	
	
	if (	((1<<pkthdrPtr->ph_portlist) & peripheralExtPortMask)	 &&
		(pkthdrPtr->ph_extPortList < 8)							 )
	{
		
		rtl8651_tblDrv_filterDbTableEntry_t * dal2Entry;
		uint32 linkId = 0;	
		uint32 txvid = 0;

		
		SLIST_FOREACH(dal2Entry, &(DrvTbl.filterDB[0].database[rtl8651_filterDbIndex((ether_addr_t *)m_data)]), nextFDB)
		{
			if (memcmp(&dal2Entry->macAddr, m_data, sizeof(ether_addr_t)) == 0)
			{
				break;
			}
		}
		if (dal2Entry)
		{
			linkId = dal2Entry->linkId;
			txvid =dal2Entry->vid;
		}

		

		if (linkId > 0)
		{	
			if (RtkHomeGatewayChipRevisionID < 0x02)
			{
				if (	(local_vlanp->untagPortMask & (1 << pkthdrPtr->ph_portlist)	 ) &&
					(VLAN_TAGGED(pkthdrPtr->ph_mbuf->m_data)				 ))
				{
					
					pkthdrPtr->ph_vlanTagged = FALSE;
					_rtl8651_fwdEngineStripVlanTag(pkthdrPtr);
				}
			}

			_rtl8651_fwdEngineHWExtDevUcast(pkthdrPtr, linkId);
		} else
		{
			

			
			if (	(m_data[0] == 0x01 && m_data[1] == 0x00 && m_data[2] == 0x5e) &&
				(pkthdrPtr->ph_iphdrOffset > 0 ) &&
#ifdef CONFIG_RTL865XB_ENRT
				
				(TRUE)
#else
				(rtl8651_getAsicOperationLayer() > 2) &&
				(local_vlanp->softRoute == FALSE) &&
				(local_vlanp->ipAttached == TRUE)
#endif
			)
			{
				
				if (VLAN_TAGGED(pkthdrPtr->ph_mbuf->m_data))
				{
					_rtl8651_fwdEngineStripVlanTag(pkthdrPtr);
					pkthdrPtr->ph_vlanTagged = FALSE;
				}

				
				_rtl8651_fwdEngineExtDevBcast(	pkthdrPtr,
												NULL,		
												(1 << pkthdrPtr->ph_portlist),
												linkId,
												pkthdrPtr->ph_priority,
												TRUE);
			}else
			{
				
				_rtl8651_fwdEngineExtDevBcast(	pkthdrPtr,
												local_vlanp,
												(1 << pkthdrPtr->ph_portlist),
												linkId,
												pkthdrPtr->ph_priority,
												TRUE);
			}
		}

		
		return SUCCESS; 
	}


	

#ifdef RTL865XB_DCUT_SWVLAN
	
	if ( pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN )
	{
		return _rtl8651_l2switch(pkthdrPtr, local_vlanp, m_data, ethtype);
	}
#endif

	

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	{
		rtl8651_tblDrv_pppTable_t *pppEntry_t = NULL;	
		if (local_vlanp->vid == tunnel.loopBackVid)
		{
			int32 ret = _rtl8651_pptpL2tpInput(FALSE, pkthdrPtr,local_vlanp, ethtype, &pppEntry_t);

			if (ret != FAILED)
			{
				return ret;
			}
		}else if (local_vlanp->vid == tunnel.wanVid)
		{
			int32 ret = _rtl8651_pptpL2tpInput(TRUE, pkthdrPtr,local_vlanp, ethtype, &pppEntry_t);

			if (ret != FAILED)
			{
				return ret;
			}
		}
	}
#endif

	

	if (rtl8651_l2protoPassThrough)
	{
		int32 ret = _rtl8651_layer2Passthrough(pkthdrPtr,local_vlanp, m_data, ethtype);

		if (ret != FAILED)
		{
			return ret;
		}
	}

	
	#ifdef RTL865X_DEBUG
	if (wlan_acc_debug>1)
	{
		rtlglue_printf("\n(%d)", pkthdrPtr->ph_rxdesc);
		if(wlan_acc_debug > 2)
		{
			_rtl8651_layer2fwd_debug(4, pkthdrPtr);
		}
	}
	#endif

	
	compare = memcmp (	&m_data[0],
						&local_vlanp->macAddr,
						sizeof(ether_addr_t));
	if (compare == 0)
	{	
		#ifdef RTL865X_DEBUG
		if (wlan_acc_debug>1)
		{
			rtlglue_printf("to myself\n");
		}
		#endif

		return FAILED;	
	} else
	{
		
		return _rtl8651_l2switch(pkthdrPtr,local_vlanp,m_data, ethtype);
	}
}

static int32 _rtl8651_l2PhysicalPortRelay(struct rtl_mBuf *inMbufPtr)
{
	struct rtl_pktHdr *phdr;
	uint16 vid = 0, memberPort = 0;

	phdr = inMbufPtr->m_pkthdr;

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	if (
#ifdef RTL865XB_DCUT_SWVLAN
		(	(phdr->ph_property != PH_PROPER_DRVFWD) ||
			((phdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) == 0)
		) &&
#endif	
		(DrvTbl.vlan[phdr->ph_vlanIdx].vid == tunnel.loopBackVid))
	{
		
	} else
#endif
	{

		struct rtl_mBuf *mbufPtr;

		mbufPtr = mBuf_dupPacket(inMbufPtr, MBUF_DONTWAIT);

		if(mbufPtr == NULL)
		{
			#ifdef RTL865X_DEBUG
			rtlglue_printf("No more mbufs for relaying brdcast pkt\n");
			#endif
			return FAILED;
		}

		
#ifdef RTL865XB_DCUT_SWVLAN
		if (	(phdr->ph_property == PH_PROPER_DRVFWD) &&
			(phdr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) )
		{
			vid = phdr->ph_svid;
			memberPort = DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)].memberPortUpStatus;
		} else
#endif 
		{
			vid = DrvTbl.vlan[phdr->ph_vlanIdx].vid;
			memberPort = DrvTbl.vlan[phdr->ph_vlanIdx].memberPortUpStatus;
		}

		
		mbufPtr->m_pkthdr->ph_flags &= (~(CSUM_IP | CSUM_L4));
		
		mbufPtr->m_pkthdr->ph_portlist = memberPort & ~(1<<phdr->ph_portlist);	
		mbufPtr->m_pkthdr->ph_portlist &=~rtl8651_allExtPortMask;			
		if (_rtl8651_fwdEngineSend(FWDENG_L2PROC|FWDENG_FROMDRV, (void*)mbufPtr->m_pkthdr, vid, -1) != SUCCESS)
		{
			mBuf_driverFreeMbufChain(mbufPtr);
		}
	}

	return SUCCESS;
}


static int32 _rtl8651_l2switch(	struct rtl_pktHdr *pkthdrPtr,
								rtl8651_tblDrv_vlanTable_t *local_vlanp,
								uint8 *m_data,
								uint16 ethtype)
{
	uint16 vid;
	uint32 vlanMbrPortMask;
	struct rtl_mBuf *mbufPtr;	
	rtl8651_tblDrv_filterDbTableEntry_t *dal2Entry=NULL;		
#ifdef RTL865XB_DCUT_SWVLAN
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr = NULL;
#endif

#ifdef RTL865XB_DCUT_SWVLAN
	if ( pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN )
	{
		vid = pkthdrPtr->ph_svid;

		
		swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
		vlanMbrPortMask = swVlanPtr->memberPortMask;

		
		if ( ethtype != 0x0800 )
		{
			_rtl8651_addVlanRefFilterDatabaseEntry(	RTL8651_L2_TYPEI,
													swVlanPtr->fid, 
													vid,
													(ether_addr_t *)(m_data + 6),
													RTL8651_FORWARD_MAC,
													(1 << pkthdrPtr->ph_portlist));

		}
	} else
#endif	
	{
		vid = local_vlanp->vid;
		vlanMbrPortMask = local_vlanp->memberPortMask;
	}

	mbufPtr = pkthdrPtr->ph_mbuf;	

	
	if ( (m_data[0]&1) == 0 )
	{
		
		dal2Entry = _rtl8651_getVlanFilterDatabaseEntry(vid, (ether_addr_t *)&m_data[0]);		

		if (dal2Entry)
		{
			if (dal2Entry->memberPortMask & vlanMbrPortMask)
			{
				
			
				if ((dal2Entry->memberPortMask & peripheralExtPortMask) == 0)
				{
					

					#ifdef RTL865X_DEBUG
					if (wlan_acc_debug>1)
						#ifdef RTL865XB_DCUT_SWVLAN
							{
								if (local_vlanp == NULL)
									rtlglue_printf("L2 unicast to vlan %d\n", vid);
								else
									rtlglue_printf("L2 unicast to %s\n", local_vlanp->internal?"LAN":"WAN");
							}
						#else
							rtlglue_printf("L2 unicast to %s\n", local_vlanp->internal?"LAN":"WAN");
						#endif
					#endif

					
					mbufPtr->m_pkthdr->ph_portlist = dal2Entry->memberPortMask & ~(1<<mbufPtr->m_pkthdr->ph_portlist);

					
					pkthdrPtr->ph_iphdrOffset = 0;
					pkthdrPtr->ph_flags &= ~(CSUM_IP| CSUM_L4);

					return _rtl8651_fwdEngineSend(FWDENG_L2PROC|FWDENG_FROMDRV, (void*)pkthdrPtr, vid, -1);

				}

				if (peripheralExtPortMask)
				{
					

					if ((1<<pkthdrPtr->ph_portlist) & peripheralExtPortMask)
					{	
						goto drop;
					}

					#ifdef RTL865X_DEBUG
					rtlglue_printf("L2 unicast to PCI,");
					#endif 

					if (dal2Entry->linkId == 0)
					{
						RTL_EMERG(	RTL_MSG_EXTDEV,
									"L2 Entry for MAC (%x:%x:%x:%x:%x:%x) to extension port but linkID == %d\n",
									m_data[0],
									m_data[1],
									m_data[2],
									m_data[3],
									m_data[4],
									m_data[5],
									dal2Entry->linkId);
					}

					
					_rtl8651_fwdEngineExtDevUcast(	pkthdrPtr,
													local_vlanp,
													dal2Entry->linkId,
													pkthdrPtr->ph_priority);

					return SUCCESS;
				}
			}
			RTL_BUG("Exist L2 Entry does NOT forward packet to PHYSICAL or EXTENSION Port.");
			goto drop;
		}
	}
	else if	(	(m_data[0] & 1)	

#ifdef RTL865XB_DCUT_SWVLAN
		
				&& ( (pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN) == 0 )
#endif	

			)
	{
#ifdef CONFIG_RTL865X_MULTICAST
		
		if (	rtl8651_drvMulticastProcessEnable &&
			(m_data[0] == 0x01 && m_data[1] == 0x00 && m_data[2] == 0x5e) &&
			(pkthdrPtr->ph_iphdrOffset > 0 ))
		{		
			return FWDENG_IP_MULTICAST;
		}
#endif 

		
		if (	rtl8651_tblDrvSpanningTreeEnable &&
			m_data[0] == 0x01 &&
			m_data[1] == 0x80 &&
			m_data[2] == 0xc2 &&
			m_data[3] == 0x00 &&
			m_data[4] == 0x00 &&
			((m_data[5] <= 0x10) || ((m_data[5] & 0xf0) == 0x20)) )
		{
			return FWDENG_L2_CTRLMSG;
		}
	}

	

	

	if (	(vlanMbrPortMask & peripheralExtPortMask) &&

		
		(pkthdrPtr->ph_srcExtPortNum == 0))
	{
		
		_rtl8651_fwdEngineExtDevBcast(	pkthdrPtr,
										local_vlanp,
										0xffffffff,
										0,
										pkthdrPtr->ph_priority,
										FALSE);
	}

	

#ifdef RTL865XB_DCUT_SWVLAN
	if ( pkthdrPtr->ph_fwd_property & PH_FWD_PROPER_SWVLAN )
	{
		_rtl8651_l2PhysicalPortRelay(mbufPtr);
		goto drop;	
	}
#endif 


	
	if ( m_data[0] & 1 )
	{
		
		
		#ifdef RTL865X_DEBUG
		if (wlan_acc_debug>1)
			rtlglue_printf("vid %d to protostack\n", vid);
		#endif

		
		if (	(m_data[0] == 0x01 && m_data[1] == 0x00 && m_data[2] == 0x5e) &&
			(pkthdrPtr->ph_iphdrOffset > 0 ))
		{
			
			_rtl8651_l2PhysicalPortRelay(mbufPtr);
 			return FWDENG_IP_MULTICAST;
		}

		
		
		if ( rtl8651_drvSoftwareBroadcastEnable[vid & (RTL8651_VLAN_NUMBER - 1)]==TRUE )
		{
			_rtl8651_l2PhysicalPortRelay(mbufPtr);
		}

		
		switch (ethtype)
		{
			case 0x8863:		
			{
				if (m_data[15] == 0x7)
				{	

					#ifdef RTL865X_DEBUG
					uint8 svrMac[24];
					ether_aton_r(m_data+6, svrMac);
					rtlglue_printf("detected PPPoE svr %s on port %d.\n",svrMac, pkthdrPtr->ph_portlist);
					#endif

					
					_rtl8651_addVlanRefFilterDatabaseEntry(	RTL8651_L2_TYPEI,
															local_vlanp->fid,
															local_vlanp->vid,
															(ether_addr_t *)m_data + 6,
															RTL8651_FORWARD_MAC,
															(1<<pkthdrPtr->ph_portlist));
				}
				return FWDENG_PPPOE8863;
			}
				break;
			case 0x0806:
			{
				if (_arpAgent)
				{
					return _arpAgent (pkthdrPtr, mbufPtr, vid);
				}
			}
				break;
		}

		
		return FWDENG_BROADCAST;

	}

	
	#ifdef RTL865X_DEBUG
	if(wlan_acc_debug>1)
		rtlglue_printf("unknown unicast. Drop\n");
	#endif

drop:
	mBuf_freeMbufChain(pkthdrPtr->ph_mbuf);
	
	return SUCCESS;
}

