

#include "rtl_types.h"
#include "types.h"
#include "rtl8651_tblAsicDrv.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_tblDrvStatistic.h"
#include "rtl_queue.h"
#include "assert.h"

extern uint32 rtl8651ExistedNaptIcmpFlows;


void _printDrvNaptFlow(rtl8651_tblDrv_naptTcpUdpFlowEntry_t *thisEntry){
	
	
	
	
	
	

	rtlglue_printf("%c%d",
		thisEntry->fromDrv?'f':'-',	
		thisEntry->hashing
	);

	rtlglue_printf("%cout:%4d %cin:%4d ",
		thisEntry->outListType==NAPT_ASIC_CACHED_OUT?'a':	
			thisEntry->outListType==NAPT_CANDIDATE_OUT?'c':

			thisEntry->outListType==NAPT_ALG_OUT?'l':'X', 
		thisEntry->outboundTblIdx,							
		thisEntry->inListType==NAPT_ASIC_CACHED_IN?'a':
			thisEntry->inListType==NAPT_CANDIDATE_IN?'c':

			thisEntry->inListType==NAPT_ALG_IN?'l':'X',
		 thisEntry->inboundTblIdx
	);
			
	
	rtlglue_printf("%s From %03d.%03d.%03d.%03d:%-5d Use",
		(thisEntry->tcp==1? "TCP": "UDP"),
		thisEntry->insideLocalIpAddr>>24, (thisEntry->insideLocalIpAddr&0x00ff0000)>>16,
		(thisEntry->insideLocalIpAddr&0x0000ff00)>>8, thisEntry->insideLocalIpAddr&0xff,
		thisEntry->insideLocalPort);
	rtlglue_printf(" ExtIp[%d]:", _rtl8651_findHash2ToNexthop(thisEntry->interfaceRoute?thisEntry->dstIpAddr:0,
	                                                          thisEntry->insideGlobalIpAddr));
	rtlglue_printf("%-5d\n\t\tTo %03d.%03d.%03d.%03d:%-5d Age:%d",
		thisEntry->insideGlobalPort, 
		thisEntry->dstIpAddr>>24, (thisEntry->dstIpAddr&0x00ff0000)>>16, 
		(thisEntry->dstIpAddr&0x0000ff00)>>8, thisEntry->dstIpAddr&0xff, 
		thisEntry->dstPort,
		thisEntry->age );
	if ( thisEntry->tcp ) rtlglue_printf(" Flg:%d", thisEntry->tcpFlag+1);
	rtlglue_printf("\n");
}


int32 _rtl8651_dumpAsicNaptTableEntry(uint32 index, uint32 findport)
{
		uint16 insideLocalPort, insideGlobalPort;
		ipaddr_t insideLocalIpAddr;
		int8 entryType, isTcp, isCollision, isValid, tcpFlag;
		uint8 	ipIdx;
		int8 isCollision2, isDedicated, selExtIpIdx;
		uint16 selEIdx;
		uint32	ageSec;

	if (convert_getAsicNaptTcpUdpTable(&ipIdx, index, &insideLocalIpAddr, &insideLocalPort,
		&insideGlobalPort, &ageSec, &entryType, &isTcp, &tcpFlag, &isCollision, &isValid,
		&isCollision2, &isDedicated, &selEIdx, &selExtIpIdx ) == FAILED)
		return FAILED;
	if (isValid == TRUE &&(!findport||findport==insideGlobalPort)) {
		rtlglue_printf("[%4u] %c", 
					index, (entryType&RTL8651_STATIC_NAPT_ENTRY)? 'S': '-' );
		rtlglue_printf("%c", (entryType&RTL8651_LIBERAL_NAPT_ENTRY)?'2':'1');
		
		rtlglue_printf("%s", isTcp?" TCP":" UDP");
		rtlglue_printf(" From %d.%d.%d.%d:%u Use ", insideLocalIpAddr>>24, (insideLocalIpAddr>>16)&0xff, (insideLocalIpAddr>>8)&0xff, insideLocalIpAddr&0xff, insideLocalPort);
		if(entryType&RTL8651_LIBERAL_NAPT_ENTRY)
			rtlglue_printf("ExtIp[%d]:",selExtIpIdx); 
		rtlglue_printf("%-5d EIDX:%d HwAge:%d", insideGlobalPort, selEIdx, ageSec);
		if( (entryType&RTL8651_LIBERAL_NAPT_ENTRY) )
			rtlglue_printf(" %c%c%c", tcpFlag&4?'Q':'-', tcpFlag&2?'D':'b', tcpFlag&2?(tcpFlag&1?'O':'I'):'-');
		else if ( isTcp )
			rtlglue_printf(" flag:%d", tcpFlag+1);
		rtlglue_printf("\n");
		return 1;
	}
	else if ( isCollision != TRUE )
	{
		rtlglue_printf( "[%4u] Col Bit is FALSE !!!  System halted.\n", index );
		assert( 0 );
	}
#if 0
	else if (isCollision == TRUE && 0 ) 
#ifdef RTL8651B
		rtlglue_printf("[%4u] --C-%c\n", index,((entryType&RTL8651_LIBERAL_NAPT_ENTRY==0)&&(ipIdx&1))	?'A':'-');
#else
		
		rtlglue_printf("[%4u] --C\t%c\n", index, isCollision?'F':' ');
#endif
#endif 

	return 0;
}


int32 _rtl8651_dumpNaptTableEntry(uint32 index, uint32 findport) {
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *thisEntry;
	rtl8651DrvNaptLine_t *thisLine;
	int32 j, count=0;
	thisLine=&DrvTbl.tcpudp[index];
	
	thisEntry=SLIST_FIRST(&thisLine->list[NAPT_ASIC_CACHED_OUT]);
	if(!thisEntry){
		thisEntry=SLIST_FIRST(&thisLine->list[NAPT_ASIC_CACHED_IN]);
	}
	if(thisEntry&&(!findport||(findport==thisEntry->insideGlobalPort))){
		rtlglue_printf("\t\tDest:%d.%d.%d.%d:%u SwAge:%u", 	thisEntry->dstIpAddr>>24, (thisEntry->dstIpAddr>>16)&0xff, (thisEntry->dstIpAddr>>8)&0xff, thisEntry->dstIpAddr&0xff, thisEntry->dstPort, thisEntry->age);
		if (thisEntry->tcp)	rtlglue_printf(" flag:%d", thisEntry->tcpFlag+1);
		rtlglue_printf("\n");
	}

	
	for(j=NAPT_ALG_OUT; j<NAPT_TOTAL_LISTS;j+=2)
	{
		SLIST_FOREACH(thisEntry, &thisLine->list[j], nextOut)
		{
			if(thisEntry&&(!findport||(findport==thisEntry->insideGlobalPort))) count++;
		}
	}
	for(j=NAPT_ALG_IN; j<NAPT_TOTAL_LISTS;j+=2)
	{
		SLIST_FOREACH(thisEntry, &thisLine->list[j], nextIn)
		{
			if(thisEntry&&(!findport||(findport==thisEntry->insideGlobalPort))) count++;
		}
	}
	
	for(j=NAPT_ALG_OUT; j<NAPT_TOTAL_LISTS;j+=2){
		SLIST_FOREACH(thisEntry, &thisLine->list[j], nextOut){
			if(thisEntry&&(!findport||(findport==thisEntry->insideGlobalPort))){
				_printDrvNaptFlow(thisEntry);
			}
		}
	}
	for(j=NAPT_ALG_IN; j<NAPT_TOTAL_LISTS;j+=2){
		SLIST_FOREACH(thisEntry, &thisLine->list[j], nextIn){
			if(thisEntry&&(!findport||(findport==thisEntry->insideGlobalPort))){
				_printDrvNaptFlow(thisEntry);
			}
		}
	}
	return count;
}




int32 _rtl8651_dumpAlgCtrlConnections(uint32 index){
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *thisEntry;
	rtl8651DrvNaptLine_t *thisLine;
	int32 count=0;
	thisLine=&DrvTbl.tcpudp[index];
	
	SLIST_FOREACH(thisEntry, &thisLine->list[NAPT_ALG_OUT], nextOut){
		_printDrvNaptFlow(thisEntry);
		count++;
	}
	return count;
}


int32 _rtl8651_dumpNaptIcmpTable() {
	rtl8651_tblDrv_naptIcmpFlowEntry_t *trackEntry;
	uint32 flowTblIdx;

	for(flowTblIdx=0; flowTblIdx<RTL8651_ICMPTBL_SIZE; flowTblIdx++) {
		trackEntry=DrvTbl.icmp[flowTblIdx];
		if (trackEntry != NULL)
			rtlglue_printf("[%d]: \n", flowTblIdx);		
		for(; trackEntry; trackEntry=trackEntry->next) {
			rtlglue_printf("   %s (%d.%d.%d.%d %d %d.%d.%d.%d %d) age(%d) Asic(%d) [%d %d %d]\n", "ICMP",
			trackEntry->insideLocalIpAddr>>24, (trackEntry->insideLocalIpAddr&0x00ff0000)>>16,
			(trackEntry->insideLocalIpAddr&0x0000ff00)>>8, trackEntry->insideLocalIpAddr&0xff,
			trackEntry->insideLocalId, trackEntry->dstIpAddr>>24, 
			(trackEntry->dstIpAddr&0x00ff0000)>>16, (trackEntry->dstIpAddr&0x0000ff00)>>8,
			trackEntry->dstIpAddr&0xff, trackEntry->insideGlobalId, trackEntry->age, trackEntry->toAsic,
			trackEntry->canAsic, trackEntry->fromAsic, trackEntry->fromDrv);
		}
	}
	rtlglue_printf("Napt ICMP total entry: %d\n", rtl8651ExistedNaptIcmpFlows);
	return SUCCESS;
}



int32 rtl8651_getTblDrvNaptIcmpCounter(rtl8651_tblDrvIcmpCounter_t *counter) {
	rtl8651_tblDrv_naptIcmpFlowEntry_t *trackEntry;
	uint32 flowTblIdx;

	if (counter == (rtl8651_tblDrvIcmpCounter_t *)0)
		return FAILED;

	rtl8651_tblDrvIcmpCounter.curActiveCount		= 0;
	rtl8651_tblDrvIcmpCounter.curInactiveCount	 	= 0;
	rtl8651_tblDrvIcmpCounter.curInDriverCount	    = 0;
	rtl8651_tblDrvIcmpCounter.curInAsicCount		= 0;
	rtl8651_tblDrvIcmpCounter.curDiffHashCount	    = 0;
	rtl8651_tblDrvIcmpCounter.curFromAsicCount	    = 0;

	for(flowTblIdx=0; flowTblIdx<RTL8651_ICMPTBL_SIZE; flowTblIdx++) {
		trackEntry = DrvTbl.icmp[flowTblIdx];		
		if(trackEntry->alive==0)
			continue;
		if (trackEntry->age > 0)
			rtl8651_tblDrvIcmpCounter.curActiveCount++;
		else rtl8651_tblDrvIcmpCounter.curInactiveCount++;
		if (trackEntry->toAsic == 1)
			rtl8651_tblDrvIcmpCounter.curInAsicCount++;
		else 
			rtl8651_tblDrvIcmpCounter.curInDriverCount++;
		if (trackEntry->canAsic == 0)
			rtl8651_tblDrvIcmpCounter.curDiffHashCount++;
		if (trackEntry->fromAsic == 1)
			rtl8651_tblDrvIcmpCounter.curFromAsicCount++;

	}
	*counter = rtl8651_tblDrvIcmpCounter;
	return SUCCESS;
}


void rtl8651_getTblDrvNaptInfo( int32 TopN, int32 _listN ) {
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *trackEntry;
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *thisEntry;
	rtl8651DrvNaptLine_t *thisLine;
	int32 index, j;
	uint32 asicCached=0, collisionLines=0, bidirectional=0, unidirectional=0; 
	int32 listN;
	uint32 i;
	uint16 curActiveCount=0,	
		   curInactiveCount=0,	
		   curDrvFreeEntries,
		   curDrvInuseEntries;
 
	uint32 counters[NAPT_TOTAL_LISTS];

	for(index=0; index<RTL8651_TCPUDPTBL_SIZE;index++){
		thisLine=&DrvTbl.tcpudp[index];



		thisEntry=SLIST_FIRST(&thisLine->list[NAPT_ASIC_CACHED_OUT]);
		if(!thisEntry)
			thisEntry=SLIST_FIRST(&thisLine->list[NAPT_ASIC_CACHED_IN]);
		if(thisEntry)
			asicCached++;
		for(j=NAPT_CANDIDATE_OUT; j<NAPT_TOTAL_LISTS;j+=2){
			SLIST_FOREACH(thisEntry, &thisLine->list[j], nextOut){
				if(thisEntry->outboundTblIdx==thisEntry->inboundTblIdx)
					bidirectional++;
				else
					unidirectional++;
			}
		}
	}

	memset(&counters, 0, sizeof(counters));
	
	CTAILQ_FOREACH(trackEntry, &DrvTbl.inuseList.tcpudp, next){
		assert(trackEntry->alive);
		if (trackEntry->age > 0)
			curActiveCount++;
		else 
			curInactiveCount++; 
		counters[(int32)trackEntry->outListType]++;
		counters[(int32)trackEntry->inListType]++;
	}
	curDrvFreeEntries=CTAILQ_TOTAL(&DrvTbl.freeList.tcpudp);
	curDrvInuseEntries=CTAILQ_TOTAL(&DrvTbl.inuseList.tcpudp);

	rtlglue_printf("\n\nTable driver statistics\n\n");
	rtlglue_printf("ASIC lines cached: %d, Force collisioned: %d \n", asicCached, collisionLines);


	rtlglue_printf("Inuse %d (%d active, %d expired)   Free: %d\n\n", curDrvInuseEntries, curActiveCount, curInactiveCount, curDrvFreeEntries);
	rtlglue_printf("cashOut\tcashIn\talgOut\talgIn\tOut\tIn\tsoftOut\tsoftIn\tBidir\tUnidir\n");
	for(i=0;i<NAPT_TOTAL_LISTS;i++)
		rtlglue_printf("%d\t", counters[i]);
	rtlglue_printf("%d\t%d\n", bidirectional, unidirectional);

	rtlglue_printf("Add   attempts: %8d (%8d succeeded, %8d failed)\n", rtl8651_tblDrvNaptCounter.addAttempts, rtl8651_tblDrvNaptCounter.addSucceeded, rtl8651_tblDrvNaptCounter.addAttempts- rtl8651_tblDrvNaptCounter.addSucceeded);
	rtlglue_printf("Protocol added: %8d, removed: %8d\n", rtl8651_tblDrvNaptCounter.protoAddCount, rtl8651_tblDrvNaptCounter.protoDelCount);
	rtlglue_printf("Driver   added: %8d, aged out: %8d\n", rtl8651_tblDrvNaptCounter.drvAddCount, rtl8651_tblDrvNaptCounter.drvAgeoutCount);
	rtlglue_printf("Refilled to ASIC: %8d  \n", rtl8651_tblDrvNaptCounter.threadWriteBackCount);
	rtlglue_printf("Add request per second: %d\n", rtl8651_tblDrvNaptCounter.naptUnitAddCnt);	
	rtlglue_printf("Max add request per second: %d\n", rtl8651_tblDrvNaptCounter.maxNaptUnitAddCnt );	

	
	{
		int16 inIdxCount[RTL8651_TCPUDPTBL_SIZE];
		int32 i, c;

		rtlglue_printf("\nList top %d used inbound index:\n", TopN );
		rtlglue_drvMutexLock();

		memset( inIdxCount, 0, sizeof(inIdxCount) );
		CTAILQ_FOREACH(trackEntry, &DrvTbl.inuseList.tcpudp, next)
		{
			inIdxCount[(trackEntry->inboundTblIdx)&(RTL8651_TCPUDPTBL_SIZE-1)]++;
		}

		
		for( c = curDrvInuseEntries; c >= 0 && TopN > 0; c-- )
		{
			for( i = 0; i < sizeof(inIdxCount)/sizeof(inIdxCount[0]); i++ )
			{
				if ( inIdxCount[i] == c )
				{
					rtlglue_printf("[%4d]%4d: ", i, inIdxCount[i] );

					listN = _listN;
					SLIST_FOREACH(trackEntry, &DrvTbl.tcpudp[i].list[NAPT_CANDIDATE_IN], nextIn)
					{
						if( trackEntry->age > 0 && trackEntry->alive )
						{
							rtlglue_printf( "%c%d="NIPQUAD2STR":%d ", 
							                trackEntry->tcp?'t':'u',
							                trackEntry->insideGlobalPort,
							                NIPQUAD2(trackEntry->dstIpAddr), trackEntry->dstPort );
							listN--;
							if ( listN <= 0 ) break;
						}
					}
					if ( listN > 0 )
						rtlglue_printf("\n");
					else
						rtlglue_printf("...\n");
					
					TopN--;
					if ( TopN <=0 ) break;
				}
			}
		}
		rtlglue_drvMutexUnlock();

	}
}


 

int32 _rtl8651_tblDrvStatisticReset() {

	memset(&rtl8651_tblDrvNaptCounter, 0, sizeof(rtl8651_tblDrvNaptCounter));

	rtl8651_tblDrvIcmpCounter.protoAddCount   		= 0;
	rtl8651_tblDrvIcmpCounter.protoDelCount   	 	= 0;
	rtl8651_tblDrvIcmpCounter.drvAddCount     	 	= 0;
	rtl8651_tblDrvIcmpCounter.drvDelCount      	 	= 0;
	rtl8651_tblDrvIcmpCounter.threadWriteBackCount 	= 0;
	rtl8651_tblDrvIcmpCounter.syncFailure     	 	= 0;
	rtl8651_tblDrvIcmpCounter.diffHashCount		 	= 0;
	rtl8651_tblDrvIcmpCounter.addFailure			= 0;
	return SUCCESS;
}


int32 rtl8651_dumpDriverArpInfo(void) {
	rtl8651_tblDrv_networkIntfTable_t *netif_t;
	rtl8651_tblDrv_ipIntfEntry_t *ipintf_t;
	rtl8651_tblDrv_arpEntry_t *arp_t;
	ether_addr_t *mac;
	uint32 netIdx;

	netif_t = &DrvTbl.netIface[0];
	for(netIdx=0; netIdx<8; netIdx++, netif_t++) {
		if (netif_t->valid == 0)
			continue;
		rtlglue_printf(" %s:\n", netif_t->ifName);
		
		SLIST_FOREACH(ipintf_t, &netif_t->IpHead, nextIp) 
			SLIST_FOREACH(arp_t, &ipintf_t->nextArp, next) {
				if (!arp_t->macInfo)
					continue;
				mac = &arp_t->macInfo->macAddr;
				rtlglue_printf("     arp(%d.%d.%d.%d) %x:%x:%x:%x:%x:%x age(%d) fromDrv(%d) fromApp(%d) pend(%d)\n",
				(arp_t->ipAddr>>24), (arp_t->ipAddr&0x00ff0000)>>16, (arp_t->ipAddr&0x0000ff00)>>8,
				arp_t->ipAddr&0xff, mac->octet[0], mac->octet[1], mac->octet[2], mac->octet[3], mac->octet[4], mac->octet[5], arp_t->age,
				arp_t->fromDrv, arp_t->fromApp, arp_t->dmzIpPending);
			}
	}
	return SUCCESS;		

}




