#ifndef RTONCE_HAL_BASETYPE_H
#define RTONCE_HAL_BASETYPE_H

//=============================================================================
//
//      basetype.h
//
//      Standard types for this architecture.
//
//=============================================================================
//
// Purpose:     Define architecture base types.
// Usage:       Included by <rt/infra/rt_types.h>, do not use directly
//              
//=============================================================================

/*
#include <include\pkgconf\hal.h>
*/
#include "../pkgconf/hal.h"

//-----------------------------------------------------------------------------
// Characterize the architecture

#if defined(RTPKG_HAL_MIPS_MSBFIRST)
# define RT_BYTEORDER           RT_MSBFIRST    // Big endian
#elif defined(RTPKG_HAL_MIPS_LSBFIRST)
# define RT_BYTEORDER           RT_LSBFIRST    // Little endian
#else
# error MIPS endianess not defined by configuration
#endif

#if defined(RTPKG_HAL_MIPS_DOUBLE_MSBFIRST)
# define RT_DOUBLE_BYTEORDER    RT_MSBFIRST    // Big endian
#elif defined(RTPKG_HAL_MIPS_DOUBLE_LSBFIRST)
# define RT_DOUBLE_BYTEORDER    RT_LSBFIRST    // Little endian
#else
# define RT_DOUBLE_BYTEORDER RT_BYTEORDER      // default to CPU endianess
#endif

//-----------------------------------------------------------------------------
// MIPS does not usually use labels with undersores.

//#define RT_LABEL_NAME(_name_) _name_

//-----------------------------------------------------------------------------
// Define the standard variable sizes

// The MIPS architecture uses the default definitions of the base types,
// so we do not need to define any here.

//-----------------------------------------------------------------------------
#endif // RTONCE_HAL_BASETYPE_H
// End of basetype.h
