#ifndef RTONCE_HAL_PLATFORM_INC
#define RTONCE_HAL_PLATFORM_INC
/*
##=============================================================================
##
##	platform.inc
##
##	RTL8601 board assembler header file
##
##=============================================================================
*/

#include "mips.inc"



/* ------------------------------------------------------------------------------
# Monitor initialization.
*/	
#ifndef RTPKG_HAL_MIPS_MON_DEFINED

#if	defined(RT_HAL_STARTUP_ROM) ||			\
	(	defined(RT_HAL_STARTUP_RAM) &&		\
		!defined(RTSEM_HAL_USE_ROM_MONITOR))
	
/*	# If we are starting up from ROM, or we are starting in
	# RAM and NOT using a ROM monitor, initialize the VSR table.
*/
	.macro	hal_mon_init
	la	a0,__default_interrupt_vsr
	la	a1,__default_exception_vsr
	la	a3,hal_vsr_table
	sw	a0,0(a3)
	sw	a1,1*4(a3)
	sw	a1,2*4(a3)
	sw	a1,3*4(a3)
	sw	a1,4*4(a3)
	sw	a1,5*4(a3)
	sw	a1,6*4(a3)
	sw	a1,7*4(a3)
	sw	a1,8*4(a3)
	sw	a1,9*4(a3)
	sw	a1,10*4(a3)
	sw	a1,11*4(a3)
	sw	a1,12*4(a3)
	sw	a1,13*4(a3)
	sw	a1,14*4(a3)
	sw	a1,15*4(a3)

	sw	a1,32*4(a3)
	sw	a1,33*4(a3)
	.endm
	
#elif defined(RT_HAL_STARTUP_RAM) && defined(RTSEM_HAL_USE_ROM_MONITOR)

/*	# Initialize the VSR table entries
	# We only take control of the interrupt vector,
	# the rest are left to the ROM for now...
*/
	.macro	hal_mon_init
	la	a0,__default_interrupt_vsr
	la	a3,hal_vsr_table
	sw	a0,0(a3)
	.endm

#else

	.macro	hal_mon_init
	.endm

#endif
			

#define RTPKG_HAL_MIPS_MON_DEFINED

#endif	

/* ------------------------------------------------------------------------------
# Decide whether the VSR table is defined externally, or is to be defined
# here.
*/
#if defined(RTPKG_HAL_MIPS_SIM) ||        \
    ( defined(RTPKG_HAL_MIPS_TX3904) &&   \
      defined(RT_HAL_STARTUP_RAM) &&      \
      !defined(RTSEM_HAL_USE_ROM_MONITOR) \
    )

/* VSR table defined in linker script	*/

#else
/*
## hal_vsr_table should be redefined to the ROM address carefully
## when burning GDB stubs into ROM
*/
//#define RT_HAL_MIPS_VSR_TABLE_DEFINED

#endif

/* ------------------------------------------------------------------------------ */
#endif // ifndef RTONCE_HAL_PLATFORM_INC
/* end of platform.inc	*/
