#ifndef RTONCE_HAL_VAR_ARCH_H
#define RTONCE_HAL_VAR_ARCH_H

//==========================================================================
//
//      var_arch.h
//
//      Architecture specific abstractions
//
//==========================================================================

/*
#include <include\pkgconf\hal.h>
#include <include\infra\rt_type.h>
*/

#include "../pkgconf/hal.h"
#include "../infra/rt_type.h"

#ifdef RTSEM_HAL_USE_ROM_MONITOR_RtMon
externC int
hal_diag_irq_check(int vector);

#define HAL_DIAG_IRQ_CHECK(_vector_, _ret_) \
RT_MACRO_START                             \
_ret_ =  hal_diag_irq_check((_vector_));    \
RT_MACRO_END
#endif

///////////////////////////////////////////////////////////////////////
//
// soft MAC (Multiply/Divide/Accumulate) support
//

#ifdef RTPKG_HAL_MIPS_8601_MAC

// unsigned operations
//
#define _mul64(x, y)		((x) * (y))
#define _div64(x, y)		((x) / (y))
#define _mod64(x, y)		((x) % (y))
#define _mul32(x, y)		((x) * (y))
#define _div32(x, y)		((x) / (y))
#define _mod32(x, y)		((x) % (y))
externC unsigned long long _divmod64(unsigned long long, unsigned long, unsigned long long*);
externC unsigned long _divmod32(unsigned long, unsigned long, unsigned long*);

// signed operations
//
#define _imul64(x, y)		((x) * (y))
#define _idiv64(x, y)		((x) / (y))
#define _imod64(x, y)		((x) % (y))
#define _imul32(x, y)		((x) * (y))
#define _idiv32(x, y)		((x) / (y))
#define _imod32(x, y)		((x) % (y))
externC long long _idivmod64(long long, long long, long long*);
externC long _idivmod32(long, long, long*);

#else	// RTPKG_HAL_MIPS_8601_MAC

// unsigned operations
//
externC unsigned long long _mul64(unsigned long long, unsigned long long);
externC unsigned long long _div64(unsigned long long, unsigned long long);
externC unsigned long long _mod64(unsigned long long, unsigned long long);
externC unsigned long long _divmod64(unsigned long long, unsigned long long, unsigned long long*);
externC unsigned long _mul32(unsigned long, unsigned long);
externC unsigned long _div32(unsigned long, unsigned long);
externC unsigned long _mod32(unsigned long, unsigned long);
externC unsigned long _divmod32(unsigned long, unsigned long, unsigned long*);

// signed operations
//
externC long long _imul64(long long, long long);
externC long long _idiv64(long long, long long);
externC long long _imod64(long long, long long);
externC long long _idivmod64(long long, long long, long long*);
externC long _imul32(long, long);
externC long _idiv32(long, long);
externC long _imod32(long, long);
externC long _idivmod32(long, long, long*);

#endif	// RTPKG_HAL_MIPS_8601_MAC

// translate unsigned long long (64 bits) value to ASCIIZ string.
// this function should be moved to stdlib, stdio or somewhere later.
// added by xavier
//
externC char* _lltoa(char* dst, unsigned long long val, unsigned int radix);

//--------------------------------------------------------------------------
#endif // RTONCE_HAL_VAR_ARCH_H
// End of var_arch.h
