/*
* ----------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* $Header: /local/cvsroot/uClinux-dist/user/boa/src/rtl865x/board.c,v 1.112 2006/03/09 08:23:05 chenyl Exp $
*
* Abstract: Board specific definitions. Probably this file will be removed, 
*           and a data structure or script file stored in flash is used instead.
*
* $Author: chenyl $ 
*
* $Log: board.c,v $
* Revision 1.112  2006/03/09 08:23:05  chenyl
* *: init data structure before set policy/demand route entry.
*
* Revision 1.111  2006/03/09 02:22:43  alva_zhang
* *: set permit layer2 ACL default turn ON
*
* Revision 1.110  2006/03/08 13:14:27  alva_zhang
* +: add permit layer2 ACL rule to patch bug LAN permit acl rule
*
* Revision 1.109  2006/03/01 11:18:50  chenyl
* +: new 8185 driver : 1.11
*
* Revision 1.108  2006/03/01 05:05:01  yjlou
* *: correct compile flag: from CONFIG_KLIPS to CONFIG_KU_KLIPS
*
* Revision 1.107  2006/02/28 11:09:06  alva_zhang
* +: add function udhcpc_release for dhcpc release
*
* Revision 1.106  2006/02/15 08:09:49  shliu
* *: when sysReinit and past wan type is dhcpc, then kill udhcpc.pid.
*
* Revision 1.105  2006/01/27 16:17:30  chenyl
* *: auto turn ON interfaces with prefix "rtl" at Gateway Mode.
*
* Revision 1.104  2006/01/25 14:53:07  yjlou
* *: fixed the bug of pbnat(Protocol-Base NAT): auto enable when any entry is enabled.
*
* Revision 1.103  2006/01/24 02:30:16  shliu
* *: config protocol stack action for "ping from LAN to PS"
*
* Revision 1.102  2006/01/23 06:16:52  chenyl
* *: default use ExtAntDvry to set dual-antenna because we use di-pole antenna
*    instead of printed antenna.
*
* Revision 1.101  2006/01/16 11:09:18  chenyl
* *: disable dmzMac of 8185 because we don't enable it yet.
*
* Revision 1.100  2006/01/16 10:23:21  chenyl
* *: turn all interfaces down.
*
* Revision 1.99  2006/01/16 02:21:05  chenyl
* *: disable DMZ-MAC of 8185 driver because we don't enable it yet.
*
* Revision 1.98  2006/01/13 03:47:40  chenyl
* *: let WLAN interfaces down when re-init system (let them re-register extension devices).
*
* Revision 1.97  2005/12/28 07:33:43  tony
* *: bug fixed: the DHCP will be killed after ip-up.
*
* Revision 1.96  2005/12/12 03:24:12  tony
* +: new feature: support trusted user in url-filter.
*
* Revision 1.95  2005/12/09 06:21:28  rupert
* +: Add IPSEC NAT Traversal Configuration
*
* Revision 1.94  2005/12/06 07:25:17  shliu
* *: When wan type is unnumbered pppoe, no matter ""NAPT for LAN hosts"
*    feature is turned on or off, we always add napt mapping.
*
* Revision 1.93  2005/12/06 07:17:22  shliu
* *: If wan type is unnumbered pppoe and "NAPT for LAN hosts" feature is
*    turned off, we don't add private LAN ip interface.
*
* Revision 1.92  2005/12/05 11:43:37  tony
* *: fix for ppp secret files.
*
* Revision 1.91  2005/12/02 10:04:46  chenyl
* +: capture Log buffer's snapshot to user space memory under mutex lock/unlock protection.
* *: shliu's new circ_msg write mechanism.
*
* Revision 1.90  2005/12/02 09:07:12  tony
* *: support rp-pppoe v3.7 for multiple-session pppoe.
*
* Revision 1.89  2005/11/30 13:05:20  tony
* *: new features: support PPTP Server
*
* Revision 1.88  2005/11/30 12:56:09  chenyl
* *: bug fix: we need to check if (buf == NULL) when doing
*
* Revision 1.87  2005/11/30 07:51:05  tony
* *: support new rp-pppoe v3.7 for PADT can't handle issue.
*
* Revision 1.86  2005/11/15 16:11:06  chenyl
* +: ALG for TFTP (RFC 1350)
*
* Revision 1.85  2005/11/07 14:42:28  chenyl
* *: when setting PPTP/L2TP use the vid information from CCFG instead of Hard code.
*
* Revision 1.84  2005/11/02 13:20:20  tony
* *: bug fixed for 3G wan type.
*
* Revision 1.83  2005/11/01 05:16:26  shliu
* *: use /etc/TZ to set TZ environment variable when invoking user program
*    by do_exec().
*
* Revision 1.82  2005/10/26 13:05:10  shliu
* *: when sysReinit, call rtl865x_reProbe().
*
* Revision 1.81  2005/10/24 06:53:01  tony
* *: support pppd-2.4.3 for MPPE/MPPC
*
* Revision 1.80  2005/10/19 05:11:45  shliu
* *: when system bootup, previous code does not init all rate policing QoS
*    settings.
*
* Revision 1.79  2005/10/05 13:39:43  rupert
* +: Add MAX_IPSEC_SESSION Definition
*
* Revision 1.78  2005/10/05 09:54:53  chenyl
* +: BOTH setting for WLAN 8185 WPA/WPA2 configurations
* 	- support TKIP/AES clients simultaneously
*
* *: if the second WLAN interface is not installed, the 'Apply' 'Reset' button
* 	in advance setting web-page still must be visitable.
*
* Revision 1.77  2005/10/04 15:32:37  jzchen
* *: Configure ratio parameter when using rtl8651_setAlgQosQueueId
*
* Revision 1.76  2005/09/30 13:00:11  chenyl
* *: new item to reinit wlan interface from console
*
* Revision 1.75  2005/09/26 08:14:21  tony
* +: add SNMP Daemon application.
*
* Revision 1.74  2005/09/25 17:06:01  shliu
* *: add example code for pktOpApp & mac filter testing case
*
* Revision 1.73  2005/09/22 05:31:47  orlando
* fix the pfs always =yes problem
*
* Revision 1.72  2005/09/20 09:24:25  shliu
* *: modify remote management configuration
*
* Revision 1.71  2005/09/16 13:16:05  chenyl
* *: for WEP+radius case, athentication is set to 2 in 8186 platform, so we would set to same with them.
*
* Revision 1.70  2005/09/15 07:06:31  chenyl
* *: use really-gotten ip to set RomeDrv
*
* Revision 1.69  2005/09/14 13:25:18  chenyl
* *: when setting RomeDrv, use the IP which actually gotten instead of set by user.
*
* Revision 1.68  2005/09/14 08:56:53  shliu
* *: modify remote management configuration on multiple session
*
* Revision 1.67  2005/09/14 08:18:35  chenyl
* *: modify authType setting when set WEP/WPA to follow spec.
*
* Revision 1.66  2005/09/09 06:14:16  shliu
* *: modify remote management setting
*
* Revision 1.65  2005/09/07 05:33:54  shliu
* *: enhancement of sysReinit in between PPPoE/unnumbered PPPoe and Multiple
*    PPPoE.
*
* Revision 1.64  2005/09/07 05:15:22  shliu
* *: When PPPoE <--> unnumbered PPPoE wan type change, past network interface
*    won't be deleted.
*    modify sysReinit.
*
* Revision 1.63  2005/09/07 03:58:49  chenyl
* *: wlan_chkKey() can NOT put in CONFIG_RTL8185's compile flag.
*
* Revision 1.62  2005/09/05 08:00:00  chenyl
* +: WPA2 setting
*
* Revision 1.61  2005/08/30 15:27:21  chenyl
* *: typing error to set WLAN
*
* Revision 1.60  2005/08/24 14:23:56  chenyl
* *: decide if 'cts2self' need to be turned ON or OFF depend on user set 'protection' or not.
*
* Revision 1.59  2005/08/23 15:13:17  shliu
* *: When changing WAN type from Unnumbered PPPoE to Static, "eth1:1" network
*    interface still exists. Modify it!
*
* Revision 1.58  2005/08/23 14:38:08  chenyl
* *: kill auth by sending SIGTERM instead of SIGQUIT
*
* Revision 1.57  2005/08/18 10:19:30  shliu
* *: modify remote management data structure default value.
*
* Revision 1.56  2005/08/17 11:07:13  tony
* *: bug fixed: Paser error in mail alert log.
*
* Revision 1.55  2005/08/12 08:49:57  shliu
* *: change protocol stack action registration with ip range instead of subnet mask.
*
* Revision 1.54  2005/08/03 08:42:06  chenyl
* *: modify some WLAN WEP/WPA code to fix bugs
*
* Revision 1.53  2005/08/03 02:34:36  chhuang
* *: enable ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
*
* Revision 1.52  2005/08/03 02:16:41  chenyl
* *: bug fix : set band to 1 when dataRateMode is B-only
*
* Revision 1.51  2005/08/02 13:02:41  chenyl
* *: bug fix : mp_cfg is not in set_mib's subset
*
* Revision 1.50  2005/08/02 07:30:38  tony
* *: bug fixed: crond can't del acl.
*
* Revision 1.49  2005/08/02 03:27:27  orlando
* checkin fixes of PolicyBasedQoS() parameters to give correct uninterested port lower and upper bounds
*
* Revision 1.48  2005/08/01 05:50:31  chhuang
* *: enable rtl8651_addExtNetworkInterface((int8*)"eth0");
*
* Revision 1.47  2005/07/29 12:42:33  chenyl
* *: bug fix: init domain block when system init
*
* Revision 1.46  2005/07/29 09:44:00  chenyl
* +: dns module in ROMEDRV
* +: domain blocking (SDK + RomeDrv)
*
* Revision 1.45  2005/07/29 03:12:26  tony
* *:bug fixed: for pptp server flag
*
* Revision 1.44  2005/07/28 13:01:30  tony
* *: bug fixed: Time Zone - in New York , add PPTP Server UI
*
* Revision 1.43  2005/07/28 02:18:39  chhuang
* *: modify qos page
*
* Revision 1.42  2005/07/20 08:06:29  shliu
* *: add rtl865xB d-cut testing setting for future use.
*
* Revision 1.41  2005/07/19 08:48:13  tony
* *** empty log message ***
*
* Revision 1.40  2005/07/14 10:35:47  shliu
* *: modify stunnel configuration file.
*
* Revision 1.39  2005/07/14 05:10:13  shliu
* *: stunnel setting example addition.
*
* Revision 1.38  2005/07/11 07:20:00  shliu
* *: add feature of remote pptp/l2tp setting.
*
* Revision 1.37  2005/07/09 07:10:10  chenyl
* +: set broadcast flag to DHCP request
*
* Revision 1.36  2005/07/07 14:40:43  chenyl
* *: modify wlan code for reliability
*
* Revision 1.35  2005/07/07 07:38:29  chenyl
* *: re-write WLAN setup process to enhance reliability.
*
* Revision 1.34  2005/07/07 05:04:30  shliu
* *: Modify the case that when dhcp wan type and get a default gateway ip ==
*    wan ip.
*
* Revision 1.33  2005/07/06 13:03:11  tony
* *: bug fixed: for gaming
*
* Revision 1.32  2005/07/06 12:02:36  tony
* +: New Features: Gaming
*
* Revision 1.31  2005/07/06 11:44:45  chenyl
* *: bug fix: modify some 8185 setting code
*
* Revision 1.30  2005/07/04 12:27:17  chenyl
* *: rewrite WLAN setup code to rearrange information (for further midification)
* *: set basic rate when configing 8185
*
* Revision 1.29  2005/07/04 08:53:12  shliu
* *: modify wanlan_init for small bug.
*
* Revision 1.28  2005/06/29 05:47:07  chenyl
* *: In configuration system, we ALWAYS store whole configurations regardless of
* 	compile flags. (ex. PPTP/L2TP, IPSec...)
*
* Revision 1.27  2005/06/29 05:22:19  chenyl
* +: TLV based configuration setting.
*
* Revision 1.26  2005/06/28 06:43:11  tony
* *: kill syslogd when restart wan type.
*
* Revision 1.25  2005/06/28 06:38:59  tony
* *: support remote log
*
* Revision 1.24  2005/06/24 02:30:10  tony
* +: new features: mail alert
*
* Revision 1.23  2005/06/20 06:20:00  shliu
* *: Modify sysReinit function to reset linux eth1 network interface.
*
* Revision 1.22  2005/06/08 14:57:10  rupert
* *: Add UDP Port 500 to Protocol Stack
*
* Revision 1.21  2005/06/08 06:44:09  rupert
* *: fix ipsec restart
*
* Revision 1.20  2005/06/08 03:38:53  shliu
* *: modify sysReinit();
*
* Revision 1.19  2005/06/07 14:54:13  shliu
* *: change addNaptMapping to addDriverNaptMapping
*
* Revision 1.18  2005/06/07 01:18:36  rupert
* *: fix ipsec parameter
*
* Revision 1.17  2005/06/03 08:51:01  tony
* *: rename pppd to pppd-3g in 3G case.
*
* Revision 1.16  2005/06/02 14:09:01  chenyl
* *: reset pRomeCfgParam when system init.
*
* Revision 1.15  2005/06/02 08:38:50  tony
* +: support new wan type - Static USB-ETHERNET
*
* Revision 1.14  2005/05/31 04:40:30  chenyl
* *: bug fix: 8185 driver Rx MP test bug
* +: 8185 driver MP - Tx continuously test can be stopped by keying-in anything.
* *: bug fix: 8185 driver in AP/B+G mode, client with pure Mode B will fail to connect to GW.
*
* Revision 1.13  2005/05/25 07:26:35  chenyl
* *: fix TxPower Setting bug
*
* Revision 1.12  2005/05/24 14:00:26  rupert
* *: Add leftnexthop field to ipsec.conf
*
* Revision 1.11  2005/05/16 06:08:34  shliu
* *: Change wan type without rebooting.
*
* Revision 1.10  2005/05/11 12:28:43  tony
* *: support Upnp presentation tag.
*
* Revision 1.9  2005/05/09 02:06:45  shliu
* *: When configured in Router Mode, RIPd distributes routing info. to WAN.
*
* Revision 1.8  2005/05/06 10:49:12  chenyl
* *: modify wlan-set mechanism for more stable configuration
*
* Revision 1.7  2005/05/06 05:07:41  tony
* *: bug fixed: support PAP,CHAP auth mode by UI.
*
* Revision 1.6  2005/05/04 02:31:27  shliu
* *: add napt/router/bridge mode selection.
*
* Revision 1.5  2005/04/27 07:03:54  chenyl
* +: Add new regulation domain 'Israel' for 8185 driver 1.7
* *: set real-channel number to 8185 driver for 2.4G band (b/g)
*
* Revision 1.4  2005/04/26 12:13:27  rupert
* *: fix ipsec.secrets configuration when there are more than tunnels
*
* Revision 1.3  2005/04/26 05:24:34  chenyl
* +: rearrange WDS interfaces before config them to 8185's driver
*
* Revision 1.2  2005/04/20 02:18:12  chenyl
* *: always turn-off all WDS interfaces before setting WLAN stuff.
*
* Revision 1.1  2005/04/19 04:58:15  tony
* +: BOA web server initial version.
*
* Revision 1.333  2005/04/08 02:47:42  cfliu
* -: Remove unused code
*
* Revision 1.332  2005/03/30 06:59:21  shliu
* *: Bug fix -- LAN cannot access web server thru external IP when DMZ-host
*    feature turned on.
*
* Revision 1.331  2005/03/29 08:31:00  shliu
* *: Let RIPD run on the WAN interface.
*
* Revision 1.330  2005/03/24 16:00:10  chenyl
* *: flush demand route if when dial up successfully.
*
* Revision 1.329  2005/03/09 08:43:57  chenyl
* +: for the new default ACL action: RTL8651_ACL_L34_DROP
*
* Revision 1.328  2005/03/08 15:25:06  shliu
* *: Hanging up the unnumbered PPPoE, changing configuration
*    and then dialing up will cause problems.
*    Try to fix this problem.
*
* Revision 1.327  2005/03/07 07:55:20  shliu
* *: Modify board_ipUp_unnumberedPppoe(),
*    Flush the policy route added in board_ipUp_unnumberedPppoe().
*
* Revision 1.326  2005/03/07 07:28:50  shliu
* *: Modify board_ipUp_unnumberedPppoe()
*
*    When we dial up and get IP address successfully,
*    we should add a policy route for outbound packets.
*
*    If we don't add this policy route,
*    packets trapped to CPU cannot find the route to WAN.
*
*    See function '_rtl8651_l34PacketProcess()' for reference.
*
* Revision 1.325  2005/03/03 15:10:48  chenyl
* *: don't stop DMZ host addition when each of them is failed.
*
* Revision 1.324  2005/02/25 05:34:29  cfliu
* +support reset flash cfg by 8185's EEPROM
*
* Revision 1.323  2005/02/23 11:04:37  chhuang
* *: bug fixed:
*    board_ipDownEventTableDriverAccess(), when return, should release semaphore
*
* Revision 1.322  2005/02/22 08:47:53  rupert
* *: fix the fourth parameter of rtl8651_setPppoeSessionProperty
*
* Revision 1.321  2005/02/22 02:28:14  rupert
* +: Add AES encryption
*
* Revision 1.320  2005/02/17 14:50:54  cfliu
* *: Fix Encryption to No encryption forget to turn off 8021x daemon problem
*
* Revision 1.319  2005/02/17 09:59:40  cfliu
* +:Modify board.c, board.h, rome_Asp.c to support 8185 AP client mode
*
* Revision 1.318  2005/02/03 01:28:44  tony
* *: fix crond script format error.
*
* Revision 1.317  2005/02/02 11:00:17  tony
* +: add crontab ACL scheduling.
*
* Revision 1.316  2005/01/20 10:52:00  ghhuang
* *: Modify web interface of Diffserv DSCP remarking
*
* Revision 1.315  2005/01/20 08:11:33  shliu
* *: Multiple DMZ-host added
*
* Revision 1.314  2005/01/19 09:38:17  ghhuang
* *: DMZ web interface modification & ratioQosCfgParam_t initial values modification
*
* Revision 1.313  2005/01/19 09:06:52  shliu
* *** empty log message ***
*
* Revision 1.312  2005/01/19 06:54:32  shliu
* *** empty log message ***
*
* Revision 1.311  2005/01/19 02:29:54  cfliu
* *** empty log message ***
*
* Revision 1.310  2005/01/09 08:55:11  cfliu
* +: 11a Web UI update
*
* Revision 1.309  2005/01/03 01:32:12  rupert
* +: IPSEC WEB access
*
* Revision 1.308  2004/12/28 09:50:48  rupert
* +: Add IPSEC Support
*
* Revision 1.307  2004/12/22 05:19:35  tony
* +: support new features: make ALG(FTP,SIP,NetMeeting) support MNQueue.
*
* Revision 1.306  2004/12/14 09:48:10  chenyl
* +: NAPT-Connection Control system
* *: add "NAPT-AddFail" error messages into ignore case.
*
* Revision 1.305  2004/12/06 10:51:09  ghhuang
* Multiple ACL entries can refer to one rate limit entry
*
* Revision 1.304  2004/12/02 03:08:37  yjlou
* +: support IPX/Netbios Passthru function
*
* Revision 1.303  2004/11/30 04:55:18  cfliu
* +: Update Wireless webpages.
*
* Revision 1.302  2004/11/29 13:11:53  chenyl
* *: check the subnet gotten from DHCP-client, if it overlaps the original subnet (ex.LAN)
* 	we don't set it to system and let DHCP-client send the renew message.
* 	- after testing, Point-to-Point protocols is OK unless the LAN host's IP is same as the Gateway's IP.
*
* Revision 1.301  2004/11/29 07:42:16  chenyl
* +: add Semaphore protection into tunekey when ip Up/Down events occur.
*
* Revision 1.300  2004/11/19 10:08:49  cfliu
* *** empty log message ***
*
* Revision 1.299  2004/11/18 14:26:16  chhuang
* *: bug fixed: ip unnumber + default session configuration
*
* Revision 1.298  2004/11/18 08:05:22  shliu
* *** empty log message ***
*
* Revision 1.297  2004/11/16 02:30:30  shliu
* *** empty log message ***
*
* Revision 1.296  2004/11/10 12:52:13  yjlou
* *: UART console can be selected by menuconfig.
*
* Revision 1.295  2004/11/10 11:29:59  chhuang
* *: bug fixed: initial flow control set to enable
*
* Revision 1.294  2004/11/10 05:32:01  cfliu
* +: modify WLAN UI and use 8185 MP calibration param in flash to set Txpower and rx/tx chargepump
* +: enable dual antenna and diversity ctrl
*
* Revision 1.293  2004/11/01 06:35:43  tony
* *: add new api rtl8651_addProtoStackServerPortRange
*
* Revision 1.292  2004/10/29 09:43:11  cfliu
* +add regulation domain field
*
* Revision 1.291  2004/10/28 11:09:31  chenyl
* +: pptp-client auto-retry
* *: pppd close-connect-notify process error
*
* Revision 1.290  2004/10/22 11:55:36  cfliu
* *: Fix initial VLAN setting bug that LAN's netmask is not correctly set.
*
* Revision 1.289  2004/10/21 11:47:57  chenyl
* +: web-based icmp/l4proto DMZ forward setting
*
* Revision 1.288  2004/10/13 13:35:44  chenyl
* +: domain setting of DHCP Server
* +: real-DNS-server setting of DHCP Server
*
* Revision 1.287  2004/10/11 04:50:48  yjlou
* +: add rtl8651_enableDropUnknownPppoePADT()
*
* Revision 1.286  2004/10/07 10:19:39  chenyl
* *: bug fix: variable assignment error
*
* Revision 1.285  2004/10/06 15:31:42  chenyl
* *: store lease info between dhcp server restart
*
* Revision 1.284  2004/10/06 14:08:03  chenyl
* +: dhcp-server wins setting and broadcast to client
*
* Revision 1.283  2004/10/06 12:48:35  orlando
* previous fix in acl_tblDrvAccess() is too strong, will make multiple-non-default-lanType-napt
* case not work. new condition will cover only multiple-non-default-lanType-unnumbered case
*
* Revision 1.282  2004/10/06 10:27:25  tony
* *: support dynamic gatedesc.xml for CDRouter UPNP test case.
*
* Revision 1.281  2004/10/05 09:20:42  chenyl
* +: web page to turn ON/OFF ip-multicast system
*
* Revision 1.280  2004/10/04 09:26:23  cfliu
* add wireless webpage update
*
* Revision 1.279  2004/10/04 09:00:22  orlando
* bug fix for multiple pppoe's unnumbered case
*
* Revision 1.278  2004/10/04 03:12:45  chenyl
* *: fwdEngine: modify rtl8651_doProtoStackAction(), if the Action type is found as PS_ACTION_DONT_TIMEOUT,
* 	this function must return "PS_ACTION_NONE"
*
* *: board.c: Because we add the protocol-stack-napt-flow cache and pptp/l2tp header-refill functions,
* 	board.c don't need to register protocol-stack-action as 'Client' anymore
*
* Revision 1.277  2004/10/01 07:52:55  yjlou
* +: add enable/disable PPPoE Passthru and IPv6 Passthru
*
* Revision 1.276  2004/09/30 09:42:50  jzchen
* *: Remove MII from default port
*
* Revision 1.275  2004/09/24 10:56:52  chhuang
* *: set arp_announce to 1
*
* Revision 1.274  2004/09/24 05:20:52  chenyl
* *: add secondary DNS server setting
*
* Revision 1.273  2004/09/22 13:41:27  chenyl
* *: add newline to /etc/resolv.conf
*
* Revision 1.272  2004/09/17 04:33:04  chenyl
* *: remove multicast SetUpStream's third parameter
*
* Revision 1.271  2004/09/16 13:30:12  tony
* *: add pptp softeare solution
*
* Revision 1.270  2004/09/16 05:43:33  chenyl
* *: multicast: remove/modify temporary APIs
* 		- rtl8651_multicastSetUpStream: remove 'port'
* 		- remove temp APIs add/del-ExternalMulticastPort();
* +: multicast: dynmaic upstream port selection
* 		- if upstream vlan (set by rtl8651_multicastSetUpStream) has multiple WAN port,
* 		  system will dynamically select one active port of it to forward.
*
* Revision 1.269  2004/09/16 04:29:18  cfliu
* Add RTL8185 D cut chip support
*
* Revision 1.268  2004/09/16 02:31:13  chenyl
* *: add 1 parameter when setUpStream
* *: add external port setting API(temporary)
*
* Revision 1.267  2004/09/14 13:49:15  chhuang
* *: allow mtu to be set to 1460 for PPTP
*
* Revision 1.266  2004/09/03 12:41:58  chenyl
* *: bug fix: dhcp single-DNS server setting bug
*
* Revision 1.265  2004/09/03 03:00:09  chhuang
* +: add new feature: pseudo VLAN
*
* Revision 1.264  2004/09/02 09:21:54  rupert
* *: mmap don't shift anymore
*
* Revision 1.263  2004/09/02 02:36:44  tony
* *: fix bug for dhcp client renew problem. (trap dst-port 68 to protostack)
*
* Revision 1.262  2004/08/20 12:12:47  cfliu
* +: Add Loose UDP ctrl item
* +: Rewrite WLAN WDS ctrl code
*
* Revision 1.261  2004/08/18 05:39:59  chenyl
* +: napt special option web-based setting
*
* Revision 1.260  2004/08/17 12:30:01  chenyl
* *: add port config to multicast default upstream setting API
*
* Revision 1.259  2004/08/17 09:25:54  tony
* *: add define CONFIG_RTL8185 to fix compiler warning.
*
* Revision 1.258  2004/08/13 06:00:18  cfliu
* +: Rewrite Wireless webpages for RTL8185 11a/b/g card
*
* Revision 1.257  2004/08/11 07:28:22  tony
* +: new features: support quickcam web camera.
*
* Revision 1.256  2004/08/04 14:48:56  yjlou
* *: merge rtl_bdinfo.h into flashdrv.h
*
* Revision 1.255  2004/07/29 11:46:05  chhuang
* *: bug fixed: use rtl8651_setNetMtu() instead of rtl8651_setPppoeMtu()
*
* Revision 1.254  2004/07/27 10:50:07  cfliu
* -: Remove RTL865x external loopback port related code for PPTP/L2TP/WLAN
*
* Revision 1.253  2004/07/27 07:23:52  chenyl
* +: DoS ignore type setting
*
* Revision 1.252  2004/07/26 05:46:11  chhuang
* *: Even if multiple session, only one MAC address is used in WAN
*
* Revision 1.251  2004/07/23 09:28:00  cfliu
* +: Add WLAN access ctrl code
*
* Revision 1.250  2004/07/15 11:16:39  tony
* +: add remote management DONT_TIMEOUT action in PPTP/L2TP mode.
*
* Revision 1.249  2004/07/14 13:55:59  chenyl
* +: web page for MN queue
*
* Revision 1.248  2004/07/13 10:23:30  tony
* *: fix bug when dhcpl2tp redial, dhcpc will call many times.
*
* Revision 1.247  2004/07/13 09:05:41  tony
* +: New Features: add new WAN type DHCPL2TP, support redial many times.
*
* Revision 1.246  2004/07/13 07:12:34  cfliu
* Add write kernel memory function
*
* Revision 1.245  2004/07/12 11:21:16  cfliu
* +: Update WLAN setting parameters
*
* Revision 1.244  2004/07/12 07:35:32  chhuang
* *: modify rate limit web page
*
* Revision 1.243  2004/07/12 07:25:16  tony
* *: make dhcp get gateway ip to be a l2tp server ip in dhcpl2tp mode.
*
* Revision 1.242  2004/07/12 07:03:47  tony
* +: add wan type dhcpl2tp.
*
* Revision 1.241  2004/07/12 06:12:05  cfliu
* no message
*
* Revision 1.240  2004/07/12 05:56:11  cfliu
* *: correct OFDM set error
*
* Revision 1.239  2004/07/12 04:25:36  chenyl
* *: extend existing port scan mechanism
*
* Revision 1.238  2004/07/08 10:51:41  tony
* *: change ipUp routine to new arch.
*
* Revision 1.237  2004/07/07 07:15:42  chenyl
* *: bug fix : bandwidth control sweep index fail
*
* Revision 1.236  2004/07/07 05:12:08  chhuang
* +: add a new WAN type. Not complete yet!!
*
* Revision 1.235  2004/07/07 05:04:45  tony
* *: disable pppd second parameter.
*
* Revision 1.234  2004/07/07 02:00:53  tony
* *: upnp_start will call upnp_stop to kill old upnp process.
*
* Revision 1.233  2004/07/06 06:19:09  chhuang
* +: add rate limit
*
* Revision 1.232  2004/07/05 11:58:44  tony
* *: modify UI control for UPNPD.
*
* Revision 1.231  2004/07/02 12:33:22  tony
* *: support for new IGD(UPNP).
*
* Revision 1.230  2004/06/30 05:16:11  tony
* *: support PPPoE/PPTP/L2TP for MMU mode.
*
* Revision 1.229  2004/06/29 16:16:06  cfliu
* +: define USERAPP_NOMMU only when MMU is not enabled
*
* Revision 1.228  2004/06/29 10:57:37  cfliu
* *: Update shared PCI mode check function using RTL865XBv2's SharedPCI bit
*
* Revision 1.227  2004/06/29 09:39:27  cfliu
* +:Add generic kernel memory read function based on /proc filesystem
*
* Revision 1.226  2004/06/29 07:35:42  chenyl
* +: igmp-proxy group filter
*
* Revision 1.225  2004/06/17 07:51:26  tony
* +: add call setNetMtu in PPTP/L2TP mode.
*
* Revision 1.224  2004/06/15 10:08:46  tony
* *: using share memory instead of direct access in syslog.
*
* Revision 1.223  2004/06/15 05:36:07  rupert
* *: fix do_exec
*
* Revision 1.222  2004/06/14 13:48:17  rupert
* +: Add work properly with MMU kernel
*
* Revision 1.221  2004/06/14 06:15:24  chenyl
* +: USERAPP_NOMMU for upnp application
* +: _UPNP_MM_ for upnp memory management
*
* Revision 1.220  2004/06/11 09:20:18  tony
* +: using share memory instead of direct access for pRomeCfgParam.
*
* Revision 1.219  2004/06/11 00:45:02  cfliu
* +: Add port ON/Off webpage
*
* Revision 1.218  2004/06/10 14:35:11  cfliu
* +: Add port config webpage
*
* Revision 1.217  2004/06/10 10:34:52  tony
* +: add PPTP dial status: disconnecting, make redial function correct.
*
* Revision 1.216  2004/06/09 12:32:16  tony
* +: add PPTP/L2TP UI page.(Dial and Hang_Up).
*
* Revision 1.215  2004/06/08 10:53:57  cfliu
* +: Add WLAN dual mode webpages. Not yet completed...
*
* Revision 1.214  2004/06/08 02:40:26  chenyl
* *: related modification for dns-proxy implementation change
*
* Revision 1.213  2004/06/07 08:01:00  tony
* *: fix dial-on-demand can't re-dial problem.
*
* Revision 1.212  2004/06/07 07:23:12  tony
* *** empty log message ***
*
* Revision 1.211  2004/06/04 08:08:30  chhuang
* ip unnumbered configuration: rtl8651_specifyNetworkIntfLinkLayerType() then
* rtl8651_addPppoeSession()
*
* Revision 1.210  2004/06/02 12:51:46  tony
* make PPPoE/L2TP is able to run multi-times in single process.
* and fix pppoe can't run dial-on-demand problem.
*
* Revision 1.209  2004/05/31 14:39:06  jzchen
* Change the counter setting to configured accompany with VLAN setting
*
* Revision 1.208  2004/05/28 09:49:16  yjlou
* +: support Protocol-Based NAT
*
* Revision 1.207  2004/05/27 05:17:59  cfliu
* Default set WLAN enable to 0
*
* Revision 1.206  2004/05/27 05:12:36  tony
* fix multiple pppoe dial problem.
*
* Revision 1.205  2004/05/27 05:07:45  chhuang
* change the order of rtl8651_specifyNetworkIntfLinkLayerType() and rtl8651_addPppoeSession()
*
* Revision 1.204  2004/05/26 10:11:55  tony
* make pppoe daemon always run at the same process.
*
* Revision 1.203  2004/05/22 03:21:57  chenyl
* * bug fix of web page setting/initial setting
*
* Revision 1.202  2004/05/21 12:08:50  chenyl
* *: TCP/UDP/ICMP spoof -> check for (sip) == (dip)
* *: modify DOS prevention webpage
*
* Revision 1.201  2004/05/20 09:57:00  tony
* fix bug: make l2tpd more stable.
*
* Revision 1.200  2004/05/20 08:43:55  chhuang
* add Web Page for QoS
*
* Revision 1.199  2004/05/20 07:10:11  tony
* fix bug: success for compiler in non pptp/l2tp mode.
*
* Revision 1.198  2004/05/20 03:21:37  tony
* New Features: add dial-on-demand and auto-reconnect for PPTP/L2TP.
*
* Revision 1.197  2004/05/19 08:38:54  orlando
* checkin diag led and init button and bi color led realted code
*
* Revision 1.196  2004/05/17 12:16:35  cfliu
* Add access concentrator's name for PPPoE.
*
* Revision 1.195  2004/05/17 07:22:16  tony
* fix pppoe silent timeout bug and make PPTP/L2TP support silent timeout.
*
* Revision 1.194  2004/05/12 08:09:56  chhuang
* +: dhcp static binding
*
* Revision 1.193  2004/05/12 07:20:15  chenyl
* +: source ip blocking
* *: modify dos mechanism
*
* Revision 1.192  2004/05/12 05:15:05  tony
* support PPTP/L2TP in RTL865XB.
*
* Revision 1.191  2004/05/10 05:49:20  chhuang
* add src ip blocking for url-filtering
*
* Revision 1.190  2004/05/05 09:39:37  tony
* open dns relay when pptp/l2tp mode
*
* Revision 1.189  2004/05/05 08:27:07  tony
* new features: add remote management spec
*
* Revision 1.188  2004/05/03 15:02:51  cfliu
* Add 8650B extension port support.
* Revise all WLAN/extport related code.
*
* Revision 1.187  2004/04/30 13:00:32  chenyl
* *: remove CONFIG_RTL865X_MULTICAST and always include multicast/igmp function
*
* Revision 1.186  2004/04/29 05:41:54  chhuang
* add new API rtl8651_addNaptMappingExt()
*
* Revision 1.185  2004/04/27 01:50:51  tony
* add l2tp length bit
*
* Revision 1.184  2004/04/19 13:45:18  tony
* add resetPptpProprity and resetL2tpProprity IOCTL.
*
* Revision 1.183  2004/04/16 07:34:49  cfliu
* Reorg loopback port setting code.
*
* Revision 1.182  2004/04/14 08:43:56  tony
* make L2TP support auto reconnect.
*
* Revision 1.181  2004/04/13 08:15:53  tony
* fix bug: make PPTP/L2TP run stably.
*
* Revision 1.180  2004/04/09 02:26:12  tony
* remove rtl8651_specifyNetworkIntfLinkLayerType_1 IOCTL.
*
* Revision 1.179  2004/04/08 13:18:12  tony
* add PPTP/L2TP routine for MII lookback port.
*
* Revision 1.178  2004/04/08 12:29:05  cfliu
* Add WDS support on extension port API
* Add some debug mesg
*
* Revision 1.177  2004/03/31 01:59:36  tony
* add L2TP wan type UI pages.
*
* Revision 1.176  2004/03/19 09:51:18  tony
* make the 'lan permit' acl is able to select by user.
*
* Revision 1.175  2004/03/17 03:04:36  tony
* fix bug: dhcp server started when dhcps is disable in UI.
*
* Revision 1.174  2004/03/12 08:31:56  tony
* when Server Port add failed, disable it in UI.
*
*
* Revision 1.172  2004/03/10 11:41:40  cfliu
* Move layer2 related functions and code to separate header file & src file.
*
* Revision 1.171  2004/03/09 08:58:02  cfliu
* add MII port as one of the default LAN port
*
* Revision 1.170  2004/03/05 12:26:14  tony
* fix bug: when in DMZ mode, trap port 23 to protocol stack.
*
* Revision 1.169  2004/03/04 08:51:38  tony
* fix bug: must asign dial seesion ID, when call rtl8651_addRoute in pppoe mode.
*
* Revision 1.168  2004/03/03 03:43:31  tony
* add static routing table in turnkey.
*
* Revision 1.167  2004/02/23 15:02:23  cfliu
* Add WLAN support
*
* Revision 1.166  2004/02/18 09:27:56  tony
* add telnetd on turnkey.
*
* Revision 1.165  2004/02/13 08:26:09  rupert
* Fix lanType parameter when PPPoE Down
*
* Revision 1.164  2004/02/11 06:24:21  tony
* let ACL can drop LAN users's packets which forward to Internet.
* but, all the LAN users's packets to gateway must pass through.
*
* Revision 1.163  2004/02/11 03:05:39  orlando
* add dial-on-demand support for multiple pppoe's unnumbered case
*
* Revision 1.162  2004/02/10 12:48:52  orlando
* check in multiple/unnumbered ip code
*
* Revision 1.161  2004/02/09 09:18:00  tony
* add function: user is able to add protocol stack Server used TCP ports by
* rtl8651_addProtoStackServerUsedTcpPort(incoming_src_port); and flush the
* table by rtl8651_flushProtoStackServerUsedTcpPort();
*
* Revision 1.160  2004/02/09 07:17:36  tony
* avoid setting gateway's IP address in ACL(rtl8651a_addAclRule).
*
* Revision 1.159  2004/02/05 12:06:21  tony
* fix acl bug: set flagMask to 0 when set type to IP.
*
* Revision 1.158  2004/02/05 07:11:16  tony
* add acl filter field: IP.
*
* Revision 1.157  2004/02/04 06:23:49  rupert
* Add UDP Block Support
*
* Revision 1.156  2004/02/03 08:14:34  tony
* add UDP Blocking web UI configuration.
*
* Revision 1.155  2004/02/03 07:31:45  orlando
* checkin bug fix regarding multiple pppoe/napt's patch CVS: ----------------------------------------------------------------------
*
* Revision 1.154  2004/01/30 12:03:05  tony
* make Special Application is able to support multiple session.
*
* Revision 1.153  2004/01/30 06:52:54  tony
* fix bug: serverpTableDriverAccessCalledFromBoot is not able to check correctly.
*
* Revision 1.152  2004/01/29 14:15:49  rupert
* fix dmz wan ip
*
* Revision 1.151  2004/01/29 12:17:08  rupert
* Add Multiple rtl8651a_setWanStatus() support
*
* Revision 1.150  2004/01/29 12:15:35  orlando
* for acl_tableDriverAccess()
*
* Revision 1.149  2004/01/29 11:42:07  rupert
* Add Multiple DMZ support
*
* Revision 1.148  2004/01/29 10:56:08  orlando
* turnon dos related settings
*
* Revision 1.147  2004/01/29 09:46:33  tony
* modify serverp_tableDriverAccess(), make it support multiple session.
* add protocol type in server port UI.
*
* Revision 1.146  2004/01/29 01:40:41  orlando
* checkin acl's dsid support, not the final version
*
* Revision 1.145  2004/01/27 08:34:13  tony
* fix bug: low NAPT throughput when special application type is BOTH.
*
* Revision 1.144  2004/01/16 12:16:46  tony
* modify ALG cfg params and web UI,
* rearrange rtl8651a_setAlgStatus() must called after rtl8651_addIpIntf()
*
* Revision 1.143  2004/01/15 13:46:30  tony
* move rtl8651a_setAlgStatus(), it must call after IP Up and rtl8651_addIpIntf().
*
* Revision 1.142  2004/01/14 03:37:18  tony
* Support single session in rtl8651_setAlgStatus (for old user)
*
* Revision 1.141  2004/01/14 02:42:46  hiwu
* add PPTP configuration
*
* Revision 1.140  2004/01/12 09:48:31  orlando
* add debug msg for rtl8651_setPppoeDefaultDialSessionId()
*
* Revision 1.139  2004/01/09 08:26:52  orlando
* checkin acl related api change
*
* Revision 1.138  2004/01/09 08:03:54  tony
* make the code architecture of ALG is able to support multiple dial session.
*
* Revision 1.137  2004/01/09 06:12:01  orlando
* checkin serverport api change
*
* Revision 1.136  2004/01/09 05:03:59  orlando
* checkin dmz api change
*
* Revision 1.135  2004/01/09 04:27:16  orlando
* tune module init sequence in sysInit()
*
* Revision 1.134  2004/01/08 13:24:59  orlando
* url/log/dos related change
*
* Revision 1.133  2004/01/08 12:13:44  tony
* add Port Range into Server Port.
* support Server Port for multiple session UI.
*
* Revision 1.132  2004/01/08 07:23:20  tony
* support multiple session UI for ACL, URL Filter, DoS log.
*
* Revision 1.131  2004/01/07 10:59:56  tony
* Support multiple session UI plugin for ACL.
*
* Revision 1.130  2004/01/07 09:10:04  tony
* add PPTP Client UI in Config Wizard.
*
* Revision 1.129  2004/01/07 07:36:36  tony
* Support multiple session UI plugin for ALG.
*
* Revision 1.128  2004/01/07 05:38:30  orlando
* logging feature sercomm phase2 spec 1st milestone checkin
*
* Revision 1.127  2004/01/07 03:43:53  orlando
* checkin sercomm phase2 spec 1st milestone api
*
* Revision 1.126  2004/01/06 13:50:25  tony
* Support multiple session UI plugin for the following functions:
* DMZ, URL Filter, Dos Prevention
*
* Revision 1.125  2004/01/02 01:15:55  orlando
* to support global ip before pppoe dial-up, add ip interface at wanlan_init(),
* and skip addIpIntf()/delIpIntf() at ipUpEvent/ipDownEvent.
*
* Revision 1.124  2003/12/31 05:53:00  orlando
* to support global ip subnet in lan before pppoe dial-up using
* "ifconfig eth1:1 <addr>", also call "rtl8651_addIpIntf()"
* in wanlan_init().
*
* Revision 1.123  2003/12/19 04:33:01  tony
* add Wireless Lan config pages: Basic Setting, Advance Setting, Security, Access Control, WDS
*
* Revision 1.122  2003/12/18 12:45:05  rupert
* fix demand route
*
* Revision 1.121  2003/12/17 11:50:06  rupert
* change policy route from ip net to ip range
*
* Revision 1.120  2003/12/17 08:29:08  tony
* add "parse_ipRange()" fucntion.
*
* Revision 1.119  2003/12/17 03:07:52  rupert
* fix idle timeout
*
* Revision 1.118  2003/12/12 10:44:14  orlando
* clear setPppoeMtu() code before ip-up events
*
* Revision 1.117  2003/12/12 02:43:03  tony
* add rtl8651_setMtu() function.
*
* Revision 1.116  2003/12/12 01:34:54  tony
* add NAPT toggle in Unnumbered PPPoE.
*
* Revision 1.115  2003/12/10 03:08:58  tony
* make logging function support time zone in kernel space.
*
* Revision 1.114  2003/12/09 13:44:34  tony
* add ACL,DoS,URL Filter logging function in kernel space.
*
* Revision 1.113  2003/12/09 03:05:44  tony
* add a param in rtl8651_setPppoeMtu function.
*
* Revision 1.112  2003/12/02 12:30:45  tony
* the common.h is replace by rtl8651_dos.h and rtl8651_alg_init.h
*
* Revision 1.111  2003/12/02 10:24:47  tony
* Add Routine: support DoS is able to set threshold by user(Webs GUI).
*
* Revision 1.110  2003/12/02 08:30:11  tony
* remove AOE2 from Special Application.(move to ALG: DirectX7)
*
* Revision 1.109  2003/12/01 12:35:52  tony
* make ALG is able to be configured by users(Web GUI).
*
* Revision 1.108  2003/11/28 07:27:53  tony
* modify AOE's trigger port type of default value to BOTH.
*
* Revision 1.107  2003/11/28 01:49:06  rupert
* FIX MULTIPLE HANGUP
*
* Revision 1.106  2003/11/27 12:15:54  tony
* remove mIRC from specail application default value.(use mIRC by ALG now)
*
* Revision 1.105  2003/11/27 03:26:57  tony
* fix bug:if default session is changed, old route table will can't delete correctly.
* must del old route before setting new default session.
*
* Revision 1.104  2003/11/24 02:21:01  rupert
* only multiple pppoe have defaultSession
*
* Revision 1.103  2003/11/21 03:29:23  tony
* fix bug: when pppoe default session not at first session, pppoe will don't have default route.
*
* Revision 1.102  2003/11/21 01:56:48  tony
* add function: user is able to add protocol stack used UDP ports by
* rtl8651_addProtoStackUsedUdpPort(incoming_src_port);
*
* Revision 1.101  2003/11/20 12:19:29  rupert
* Demand Route
*
* Revision 1.100  2003/11/19 03:52:09  tony
* modify unnumbered pppoe netmask gui.
*
* Revision 1.99  2003/11/19 02:40:15  rupert
* fix pppd_start_dial
*
* Revision 1.98  2003/11/18 13:25:39  rupert
* add dial demand
*
* Revision 1.97  2003/11/18 09:04:47  tony
* add routine: support mtu configure by user in pppoe.
*
* Revision 1.96  2003/11/14 09:13:36  tony
* modify multiple pppoe web page
*
* Revision 1.95  2003/11/13 12:52:06  tony
* add MTU and MRU field in pppoe.
*
* Revision 1.94  2003/11/13 12:31:28  tony
* small change
*
* Revision 1.93  2003/11/12 05:37:48  tony
* fix bug: 1.pppd can't be killed when connect failed.
* fix bug: 2.pppoe's service name can't use 'space' char.
*
* Revision 1.92  2003/11/10 13:49:36  tony
* fix multi-pppoe bugs:
* 1:dialState set to zero when boot.
* 2:disable Dial-on-Demand and Silent Timeout.
* 3:must hang up all the connection before save configuration.
* 4:only default session dial-on when boot.
*
* Revision 1.91  2003/11/10 11:40:58  orlando
* add pppd option "<local IP address>:<remote IP address>" for
* pppoe unnumbered case
*
* Revision 1.90  2003/11/10 07:43:34  rupert
* correct dport start end
*
* Revision 1.89  2003/11/07 11:05:59  rupert
* for multiple pppoe
*
* Revision 1.88  2003/11/07 09:16:26  rupert
* update multiple pppoe
*
* Revision 1.87  2003/11/07 06:31:22  tony
* add type PPPOECFGPARAM_DESTNETTYPE_NONE in MultiPPPoE dest network.
*
* Revision 1.86  2003/11/07 05:34:36  tony
* modify YMSG ALG, it'll not have to cooperate with trigger port.
*
* Revision 1.85  2003/11/06 02:25:08  tony
* add field in multi-pppoe cfg.
*
* Revision 1.84  2003/11/04 09:30:56  tony
* modfiy special-application list in board.c
*
* Revision 1.83  2003/11/04 01:56:34  orlando
* modify acl_tableDriverAccess() to set a aclCfgParam[i].port==0 ->
* tcpDst(Src)PortLB=0,tcpDst(Src)UB=0xffff. also modify ingress rule
* to set on 'eth1'(LAN) and egress rule to set on 'eth0'(WAN)
*
* Revision 1.82  2003/10/30 12:23:01  orlando
* set event log to be default "off"
*
* Revision 1.81  2003/10/29 10:20:41  tony
* modify acl policy list.
*
* Revision 1.80  2003/10/28 08:33:45  orlando
* rtl8651_setAsicNaptAutoAddDelete() obsoleted by rtl8651_enableNaptAutoAdd()
*
* Revision 1.79  2003/10/27 09:39:11  tony
* fix bug: clear acl rules with eth1
*
* Revision 1.78  2003/10/24 10:25:58  tony
* add DoS attack interactive webpage,
* FwdEngine is able to get WAN status by rtl8651_wanStatus(0:disconnect,1:connect)
*
* Revision 1.77  2003/10/21 08:07:02  tony
* add DoS attack log routine
*
* Revision 1.76  2003/10/17 07:17:54  tony
* *** empty log message ***
*
* Revision 1.75  2003/10/17 06:37:37  tony
* bug fix: factory_deafult() get error factory params.
*
* Revision 1.74  2003/10/17 03:41:47  tony
* add klogd to log_init
*
* Revision 1.73  2003/10/16 09:06:58  orlando
* add association between pppoe table entry (pppObjId) and pppx by
* parameter parsing argv[9]
*
* Revision 1.72  2003/10/16 03:11:32  orlando
* tune multiple pppoe association of hw table entry and ppp-x
*
* Revision 1.71  2003/10/15 12:12:08  orlando
* add pppoeCfgParam[].pppx to keep track of hw ppp obj id (0,1,2,3,...)
* in association with linux ppp dial up interface (ppp0,ppp1,ppp2,ppp3,...)
*
* Revision 1.70  2003/10/15 08:04:47  tony
* move Trigger Port range checking routine from FastAlias to NaptAlias
*
* Revision 1.69  2003/10/15 06:55:44  orlando
* add chap support
*
* Revision 1.68  2003/10/14 13:13:00  tony
* remove untested special application.
*
* Revision 1.67  2003/10/14 08:15:01  tony
* add user account management routine
*
* Revision 1.66  2003/10/14 02:28:30  tony
* add trigger port routine
*
* Revision 1.65  2003/10/09 13:23:44  tony
* TRIGGER_PORT: add function rtl8651_flushTriggerPortRules,rtl8651_addTriggerPortRule
*
* Revision 1.64  2003/10/07 06:18:17  rupert
* servie name
*
* Revision 1.63  2003/10/07 03:47:17  tony
* revise bug: multi pppoe start by pppoeCfgParam[].enable
*
* Revision 1.62  2003/10/07 03:45:36  tony
* revise bug: multi pppoe start by pppoeCfgParam[].enable
*
* Revision 1.61  2003/10/07 03:25:36  rupert
* change udhcpd server DNS options to gateway LAN Address
*
* Revision 1.60  2003/10/07 02:25:22  tony
* *** empty log message ***
*
* Revision 1.59  2003/10/06 13:17:38  rupert
* add user managment of webs interface
*
* Revision 1.58  2003/10/06 09:05:18  rupert
* Running the  dns proxy when  default session of multiple PPPoE starts
*
* Revision 1.57  2003/10/06 07:03:17  rupert
* remove sleep  when dhcps start
*
* Revision 1.56  2003/10/06 02:22:17  orlando
* add/delete a network route to linux protocol stack upon ip-up/down-event for
* unnumbered pppoe case (global network assigned by ISP in LAN)
*
* Revision 1.55  2003/10/03 12:27:35  tony
* add NTP time sync routine in management web page.
*
* Revision 1.54  2003/10/03 03:17:34  rupert
* fix dns null problem
*
* Revision 1.53  2003/10/03 01:26:42  tony
* add ServiceName field in pppoeCfgParam_t.
* add dynamic check in PPPoE/Unnumbered PPPoE/Multiple PPPoE web page.
*
* Revision 1.52  2003/10/02 10:50:17  orlando
* add manualHangup and whichPppObjId fields in pppoeCfgParam_t for auto
* reconnect implementation
*
* Revision 1.51  2003/10/02 07:53:13  orlando
* add pppoeManualHangupFlag[] for recording manual hangup events!!
*
* Revision 1.50  2003/10/02 06:34:40  orlando
* ppd_start() changed to add "defaultroute" or "nodefaultroute" in ppp option file, so linux routing table will have one default route only in multiple pppd case
*
* Revision 1.49  2003/10/02 04:58:29  rupert
* add dns proxy/cache relay
*
* Revision 1.48  2003/10/01 13:51:51  tony
* remove all unused variable.
*
* Revision 1.47  2003/10/01 13:40:39  tony
* solve all the compiler warnning message in tblDrv_mapping.c
*
* Revision 1.46  2003/10/01 13:25:13  tony
* change default connection type to static
*
* Revision 1.45  2003/10/01 12:27:20  orlando
* delete /var/run/pppd[id].pid file in board_ipDownEventTableDriverAccess(). asp_pppoe will check its existence, so as to decide if dial button is enabled.
*
* Revision 1.44  2003/10/01 10:51:38  rupert
* add dhcpc client status
*
* Revision 1.43  2003/10/01 10:31:47  tony
* solve all the compiler warnning messages in the board.c
*
* Revision 1.42  2003/10/01 09:41:32  orlando
* check in dial-on-demand and silent timeout related code
*
* Revision 1.41  2003/10/01 08:36:39  tony
* modify DHCPS start sequence.
*
* Revision 1.40  2003/10/01 07:43:17  tony
* kill upnp/ddns daemon before service start. in ddns_start(), upnp_start()
*
* Revision 1.39  2003/10/01 07:01:50  tony
* arrange boot start code
*
* Revision 1.38  2003/10/01 06:10:05  orlando
* sync changes
*
* Revision 1.37  2003/10/01 05:57:31  tony
* add URL Filter routine
*
* Revision 1.36  2003/10/01 05:43:24  orlando
* modify acl to act on "eth0" instead of "vl0"
*
* Revision 1.35  2003/10/01 05:17:09  orlando
* fine tune dmz_tableDriverAccess()/serverp_tableDriverAccess()/acl_tableDriverAcess() to choose the correct wan ip to config to rtl8651
*
* Revision 1.34  2003/10/01 03:03:10  orlando
* sync with cvs before changing multiple pppoe/default implementaiton
*
* Revision 1.33  2003/09/30 12:19:49  tony
* arrange board_ipUpEventTableDriverAccess(), let upnp,ddns,dmz be able to start after dhcpc/pppoe started.
*
* Revision 1.32  2003/09/30 09:46:38  tony
* add dmz_tableDriverAccess()
*
* Revision 1.31  2003/09/30 08:56:29  tony
* remove newServerpCfgParam[] from flash, rename ram PPPoeCfg to ramPppoeCfgParam
*
* Revision 1.30  2003/09/30 08:25:56  orlando
* rtl8651_setDefaultAcl(ifName,defAction) requires different parameter than before
*
* Revision 1.29  2003/09/30 08:00:49  orlando
* trim acl_tableDriverAccess(), and call acl_tableDriverAccess() in acl_init only in STATIC case
*
* Revision 1.28  2003/09/30 07:08:49  orlando
* clear ifCfgParam[0].ipAddr/ipMask/gwAddr/dnsPrimaryAddr/dnsSecondaryAddr to 0 for dhcp client wan config case, dhcp client will fill in correct values later
*
* Revision 1.27  2003/09/30 06:13:28  orlando
* check in after new table driver checkin
*
* Revision 1.26  2003/09/30 03:51:09  orlando
* sync changes
*
* Revision 1.25  2003/09/29 13:28:19  rupert
* add primary and secondary fields of ifCfgParam_s
*
* Revision 1.24  2003/09/29 12:58:34  tony
* add DDNS start/stop routine.
*
* Revision 1.23  2003/09/29 08:57:32  tony
* add routine: when pppoe config changed, the dial function will be disabled.
* add routine: dhcps is able to start/stop server on runtime.
*
* Revision 1.22  2003/09/29 07:20:37  orlando
* modify dmz_init() and add dmz related code in board_ipUpEventTableDriverAccess()
*
* Revision 1.21  2003/09/29 06:30:15  orlando
* kill -9 changed kill -15
*
* Revision 1.20  2003/09/29 05:07:22  orlando
* add board_ipUp/DownEventTableDriverAccess()
*
* Revision 1.19  2003/09/26 10:23:52  tony
* add PPPoE dial,hang-up routine
*
* Revision 1.18  2003/09/26 07:19:13  orlando
* set pppoeCfgParam[].dialState to ..._TRYING right before calling /bin/pppd
*
* Revision 1.17  2003/09/26 02:09:48  tony
* add/del UPnP default route in upnp_init() and asp_setUpnp()
*
* Revision 1.16  2003/09/26 01:53:40  orlando
* pppoeCfgParam adds more fields for control, tune code to adapt the changes
*
* Revision 1.15  2003/09/25 10:44:50  tony
* small change
*
* Revision 1.14  2003/09/25 10:14:50  tony
* modify pppoe webpage, support unnumbered IP, PPPoE, Multiple PPPoE.
*
* Revision 1.13  2003/09/25 06:41:40  rupert
* add routing function of kernel
*
* Revision 1.12  2003/09/25 03:37:36  orlando
* integration...
*
* Revision 1.11  2003/09/25 02:15:32  orlando
* Big Change
*
* Revision 1.8  2003/09/23 11:44:33  tony
* add UPNP daemon start/stop routine.
*
* Revision 1.7  2003/09/23 03:47:29  tony
* add ddnsCfgParam,ddnsDefaultFactory,ddns_init
*
* Revision 1.6  2003/09/22 08:01:45  tony
* add UPnP Web Configuration Function Routine
*
* Revision 1.5  2003/09/22 06:33:37  tony
* add syslogd process start/stop by CGI.
* add eventlog download/clear routine.
*
* Revision 1.4  2003/09/19 06:06:51  tony
* *** empty log message ***
*
* Revision 1.3  2003/09/19 01:43:50  tony
* add dmz routine
*
* Revision 1.2  2003/09/18 02:05:45  tony
* modify pppoeCfgParam to array
*
* Revision 1.1.1.1  2003/08/27 06:20:15  rupert
* uclinux initial
*
* Revision 1.1.1.1  2003/08/27 03:08:53  rupert
*  initial version 
*
* Revision 1.47  2003/07/04 10:02:26  orlando
* adjust rtl8651_addRoute() and rtl8651_addArp() sequence
* in if_init(). don't call them if l2 switching mode.
*
* Revision 1.46  2003/07/04 08:37:53  orlando
* adjust code layout.
*
* Revision 1.45  2003/07/04 08:32:45  orlando
* add debug compile switch for rtl8651_addRoute().
*
* Revision 1.44  2003/07/04 04:52:44  kckao
* Added for PPPoE HW acceleration
*
* Revision 1.43  2003/07/04 03:23:30  orlando
* add ASIC default route to wan's default gateway
* during if_init() is processing ifCfgParam[0].
*
* Revision 1.42  2003/07/03 12:15:59  tony
* fix some warning messages.
*
* Revision 1.41  2003/07/03 08:09:47  orlando
* if dhcp client clone mac is used, call rtl8651_assignVlanMacAddress()
* to change asic wan vlan mac, no matter if hw acceleration
* is used or not.
*
* Revision 1.40  2003/07/03 06:27:20  orlando
* serverp_tableDriverAccess() use inet_addr() to replace inet_aton().
*
* Revision 1.39  2003/07/03 05:59:46  tony
* add configChanged global param.
*
* Revision 1.38  2003/07/03 01:58:37  orlando
* acl table driver access should use "vl0" to set asic, even if pppoe is
* enabled.
*
* Revision 1.37  2003/07/02 10:26:25  orlando
* 1. arp has to be added after ip interface created.
* 2. assignVlanMac has to be done before network interface
*     created above the vlan. so clone mac has to be assigned
*     in vlan_init().
*
* Revision 1.36  2003/07/02 08:06:50  orlando
* call rtl8651_assignVlanMacAddress() to assign clone mac to wan
* interface if dhcp client is started on wan port and clone mac
* is enabled.
*
* Revision 1.35  2003/07/01 13:59:40  orlando
* modify mismatchDrop() logic to reflect correct default permit or drop.
*
* Revision 1.34  2003/07/01 12:58:48  orlando
* 1. replace rtlHwEnabled by natCfgParam.hwaccel.
* 2. call different table driver acl API depending on natCfgParam.hwaccel.
*
* Revision 1.33  2003/07/01 10:25:14  orlando
* call table driver server port and acl API in board.c
*
* Revision 1.32  2003/07/01 05:59:18  elvis
* remote L3_ACCELERATION and L4_ACCELERATION
*
* Revision 1.31  2003/07/01 03:09:06  tony
* add aclGlobalCfgParam structure.
* modify aclCfgParam and serverpCfgParam structure.
*
* Revision 1.30  2003/06/30 13:27:56  tony
* add a field in server_port table
*
* Revision 1.29  2003/06/30 07:46:12  tony
* add ACL and Server_Port structure
*
* Revision 1.28  2003/06/27 13:53:18  orlando
* remove dhcpcCfgParam.valid field, use ifCfgParam[0].connType field
* modify rtConfigHook() for cloneMac:
* use dhcpcCfgParam.cloneMac if ifCfgParam[0].connType is
* DHCPC and dhcpcCfgParam.cmacValid is 1 during boottime.
*
* Revision 1.27  2003/06/27 05:34:54  orlando
* modify pppoe_init() and dns_init().
*
* Revision 1.26  2003/06/26 03:22:29  tony
* remove some element in dhcpc data structure.
*
* Revision 1.25  2003/06/26 03:21:10  orlando
* modify dns_init().
*
* Revision 1.24  2003/06/25 08:59:53  orlando
* change default setting of static route to be "null".
*
* Revision 1.23  2003/06/25 07:08:40  orlando
* change factory default settings.
*
* Revision 1.22  2003/06/23 10:57:23  elvis
* change include path of  rtl_types.h
*
* Revision 1.21  2003/06/20 12:59:55  tony
* add dhcp client
*
* Revision 1.20  2003/06/17 10:50:00  elvis
* regular update
*
* Revision 1.19  2003/06/17 06:59:46  orlando
* trying to avoid word aligned load/store.
*
* Revision 1.18  2003/06/16 08:08:30  tony
* add dhcps & dns function
*
* Revision 1.17  2003/06/11 11:39:29  tony
* add WAN IP connection Type (static, PPPoE, DHCP)
*
* Revision 1.16  2003/06/06 12:23:13  orlando
* modify userDb default values.
*
* Revision 1.15  2003/06/06 11:56:57  orlando
* add pppoe cfg.
*
* Revision 1.14  2003/06/06 06:31:45  idayang
* add mgmt table in cfgmgr.
*
* Revision 1.13  2003/06/03 10:56:47  orlando
* add nat table in cfgmgr.
*
* Revision 1.12  2003/06/02 01:50:14  elvis
* regular update
*
* Revision 1.11  2003/05/19 09:40:08  elvis
* 1. bug-fix: parameters to rtl8651_addXXX
* 2. add show_curCfg()
*
* Revision 1.10  2003/05/19 07:35:22  orlando
* change factory default ip addresses.
*
* Revision 1.9  2003/05/16 06:18:16  elvis
* no message
*
* Revision 1.8  2003/05/12 10:55:46  orlando
* adjuct header file structure.
*
* Revision 1.7  2003/05/09 13:27:34  orlando
* tune output message.
*
* Revision 1.6  2003/05/09 12:24:08  kckao
* add rtConfigHook() and move upwan() and uplan() to this file
*
* Revision 1.5  2003/05/02 09:18:13  orlando
* no message
*
* Revision 1.4  2003/05/02 08:51:34  orlando
* merge cfgmgr with old board.c/board.h.
*
* Revision 1.3  2003/04/08 15:29:53  elvis
* add interface ,route and static arp configurations
*
* Revision 1.2  2003/04/04 02:31:17  elvis
* Define member ports by symbols
*
* Revision 1.1  2003/04/03 01:52:42  danwu
* init
*
* ---------------------------------------------------------------
*/
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <assert.h>

#define SIGHUP		 1	/* Hangup (POSIX).  */
#define SIGQUIT		 3	/* Quit (POSIX).  */
#define SIGKILL		 9	/* Kill, unblockable (POSIX).  */
#define SIGTERM		15	/* Termination (ANSI).  */
#define SIGUSR1		16	/* User-defined signal 1 (POSIX).  */
#define SIGUSR2		17	/* User-defined signal 2 (POSIX).  */
typedef void (*__sighandler_t)(int);
struct sigaction {
	unsigned int	sa_flags;
	__sighandler_t	sa_handler;
	sigset_t	sa_mask;
};

#include <unistd.h> /* for sleep */

#include <linux/sockios.h>
#include <netinet/in.h>
#include <linux/route.h>
#include <time.h>
#include <linux/types.h>
#include <netdb.h>
#include <stdlib.h>

#include <re865x.h>
/*#include <rt_stack/h/sys/porting.h> */
#include "board.h"
#include "flashdrv.h"

#include <rtl8651_dos.h> /* for DoS define */

#define  MCAST_FILTER_ACT_MIRROR                 0x01            /* mirror this packet to protocol stack */

#include <linux/config.h>

#include "rtl_cfgmgr.h"	/* For CFGMGR system access */
#include "rtl_board.h" /* exported function prototypes */
#include <rtl8651_tblDrv.h>
#include <rtl8651_alg_init.h>
#include <rtl8651_tblDrvFwd.h>

#ifndef __uClinux__
/*  mmap header */
#include <fcntl.h>
#include <stdio.h>
#include <sys/mman.h>
#endif

romeCfgParam_t *pRomeCfgParam = NULL;

/* ==============================================================
	Gateway Setting Related data:

		1. Rome driver setting declarations
		2. Default Values
     ============================================================== */

//romeCfgParam_t romeCfgParam;
//romeCfgParam_t * pRomeCfgParam = &romeCfgParam;
//extern romeCfgParam_t *pRomeCfgParam;
ifCfgParam_t			ramLanCfgParam;
ifCfgParam_t			ramWanCfgParam;
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
pptpCfgParam_t			ramPptpCfgParam;
l2tpCfgParam_t			ramL2tpCfgParam;
//dhcpL2tpCfgParam_t		ramDhcpL2tpCfgParam;
#endif
pppoeCfgParam_t			ramPppoeCfgParam[MAX_PPPOE_SESSION];
dhcpsCfgParam_t			ramDhcpsCfgParam;
dhcpcCfgParam_t			ramDhcpcCfgParam;
serverpCfgParam_t		ramServerpCfgParam[MAX_PPPOE_SESSION][MAX_SERVER_PORT];
urlfilterCfgParam_t		ramUrlfilterCfgParam[MAX_PPPOE_SESSION][MAX_URL_FILTER];
int totalWlanCards;
#ifdef CONFIG_RTL8185
	int8 cfgFilePath[]="/var/8185wpa.conf";
#endif

/* ============================================
	internal function declarations
     ============================================ */
extern int re865xIoctl(char *name,uint32 arg0, uint32 arg1, uint32 arg2, uint32 arg3);

// local function declare
int INET_setroute(int action, int options, char **args);
int setInterfaceIp(char *name,int ip, int netmask);
//uint32 getRomeCfgParamPtr(romeCfgParam_t ** ptr);
int do_exec(char *name, char *identity);
int do_kill(char *filename);
int upInterface(char *name);
void pppd_start(uint32 identity);
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
void pptp_start(uint32 identity);
void l2tp_start(uint32 identity);
#endif
void runDNSProxy();

uint32 configChanged = 0;
uint32 mgmt_udp_500=0;
static rtl8651_tblDrvAclRule_t tempAclRule;
static rtl8651_PS_Action_Entry_t tempPSAction;


/* local function prototype declaration */
int32 pppd_stop(uint32 pppObjId);


void LogDebugInfo(FILE *fp)
{
		
		printf("ifCfgParam[0].ipAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipAddr[0]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[1]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[2]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[3]);

		fprintf(fp,"ifCfgParam[0].ipAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipAddr[0]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[1]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[2]
			,pRomeCfgParam->ifCfgParam[0].ipAddr[3]);

		printf("ifCfgParam[0].ipMask: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipMask[0]
			,pRomeCfgParam->ifCfgParam[0].ipMask[1]
			,pRomeCfgParam->ifCfgParam[0].ipMask[2]
			,pRomeCfgParam->ifCfgParam[0].ipMask[3]);

		fprintf(fp,"ifCfgParam[0].ipMask: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].ipMask[0]
			,pRomeCfgParam->ifCfgParam[0].ipMask[1]
			,pRomeCfgParam->ifCfgParam[0].ipMask[2]
			,pRomeCfgParam->ifCfgParam[0].ipMask[3]);

		printf("ifCfgParam[0].gwAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].gwAddr[0]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[1]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[2]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[3]);

		fprintf(fp,"ifCfgParam[0].gwAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].gwAddr[0]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[1]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[2]
			,pRomeCfgParam->ifCfgParam[0].gwAddr[3]);

		printf("ifCfgParam[0].dnsPrimaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		fprintf(fp,"ifCfgParam[0].dnsPrimaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		printf("ifCfgParam[0].dnsSecondaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);

		fprintf(fp,"ifCfgParam[0].dnsSecondaryAddr: %u.%u.%u.%u\n"
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]
			,pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);

		{
			uint8 winsAddr[20];

			snprintf(winsAddr, sizeof(winsAddr), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x000000ff);
			
			printf("ifCfgParam[0].winsPrimaryAddr: %s\n", winsAddr);
			fprintf(fp, "ifCfgParam[0].winsPrimaryAddr: %s\n", winsAddr);

			snprintf(winsAddr, sizeof(winsAddr), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x000000ff);

			printf("ifCfgParam[0].winsSecondaryAddr: %s\n", winsAddr);
			fprintf(fp, "ifCfgParam[0].winsSecondaryAddr: %s\n", winsAddr);
		}
	}


/* ==============================================================
	CFGMGR control code:

		1. All CFGMGR procedures.
		2. Callback functions.
     ============================================================== */


/* ==============================================================
		Default value
     ============================================================== */
vlanCfgParam_t vlanCfgParamDefault[VLAN_LOAD_COUNT] = 
{
	/* WAN */{8,(PHY0),		  (PHY0),		1480,	1,{{0x00, 0x00, 0xda, 0x11, 0x22, 0x58}},{0,0}}, 
	/* LAN */{9,(PHY1|PHY2|PHY3|PHY4),(PHY1|PHY2|PHY3|PHY4),1480,	1,{{0x00, 0x00, 0xda, 0x11, 0x22, 0x68}},{0,0}}, 
		 {0,0x00,		  0x00,			0,	0,{{0,0,0,0,0,0}},			 {0,0}}
};

ifCfgParam_t ifCfgParamDefault[MAX_IP_INTERFACE] =
{
	{0, {172,20,1,254},	{0,0,0,0}, {0,0,0,0}, {255,255,255,0},	{255,255,255,0},	{255,255,255,0},	{172,20,1,250},	{168,95,1,1},	{168,95,1,1},	0, 0, 0, 0, 1,	IFCFGPARAM_CONNTYPE_DHCPC},
	{1, {192,168,1,254},	{0,0,0,0}, {0,0,0,0}, {255,255,255,0},	{255,255,255,0},	{255,255,255,0},	{192,168,1,254},	{168,95,1,1},	{168,95,1,1},	0, 0, 0, 0, 1,	0},
	{0, {0,0,0,0},			{0,0,0,0}, {0,0,0,0}, {0,0,0,0},			{0,0,0,0},		{0,0,0,0},		{0,0,0,0},		{0,0,0,0},	{0,0,0,0},	0, 0, 0, 0, 0,	0}
};

routeCfgParam_t routeCfgParamDefault[MAX_IP_INTERFACE] =
{
	{0, {0,0,0,0},     {0,0,0,0},       {0,0,0,0},       0}
};

arpCfgParam_t arpCfgParamDefault[MAX_STATIC_ARP] =
{
	/* Add static arp entrie for the hosts on the LAN interface, e.g. your PC */
	{0, {0,0,0,0},      0,         0,{{0,0,0,0,0,0}},                  {0,0}}
};


natCfgParam_t natCfgParamDefault[1] =
{
	{
		1, /* enable */
		1, /* hw accel */
		0, /* no ipsec passthru */
		0, /* no pptp passthru */
		0  /* no l2tp passthru */
	}
};

pppoeCfgParam_t pppoeCfgParamDefault[MAX_PPPOE_SESSION] =
{
	{
	1, /* disabled/enabled */
	1, /* default session or not */
	0, /* is pppoe unnumbered ? */
	1, /* auto reconnect */	
	1, /* dial on demand */	
	0, /* dial state */
	0, /* session id */
	0, /* silent time out */
	{172,21,1,254} ,{255,255,255,0},{172,21,1,250} ,{168,95,1,1},
	{192,168,1,1}, /* local host ip */
	"\0", /* user name */
	"\0", /* password */
	"\0", /* ac name */
	"\0", /* service name */
	{"\0","\0","\0","\0"}, /* destination network */
	{PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE},
	{0,0,0,0},  /* unnumbered ip */
	{255,255,255,254},   /* unnumbered network mask */
	{0,0,0,0,0,0}, /* server mac */
	0xff, /* pppx */
	1, /* Unnumbered PPPoE NAPT */
	0, /* whichPppObjId */
	0,  /* manualHangup */
	1492, /* MTU */
	PPPOECFGPARAM_LANTYPE_NAPT,
	PPPPARAM_AUTHTYPE_CHAP
	},

	{
	1, /* disabled/enabled */
	0, /* default session or not */
	0, /* is pppoe unnumbered ? */
	1, /* auto reconnect */
	1, /* dial on demand */	
	0, /* dial state */
	0, /* session id */
	0, /* silent time out */
	
	{172,22,1,254} ,{255,255,255,0},{172,22,1,250} ,{168,95,1,1},
	{192,168,1,1}, /* local host ip */
	"\0", /* user name */
	"\0", /* password */
	"\0", /* AC name */
	"\0", /* service name */
	{"\0","\0","\0","\0"}, /* destination network */
	{PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE,	PPPOECFGPARAM_DESTNETTYPE_NONE},
	{0,0,0,0},  /* unnumbered ip */
	{255,255,255,254},  /* unnumbered network mask */
	{0,0,0,0,0,0}, /* server mac */
	0xff, /* pppx */
	0, /* rsv1 */
	0, /* whichPppObjId */
	0,  /* manualHangup */
	1492, /* MTU */
	PPPOECFGPARAM_LANTYPE_NAPT,
	PPPPARAM_AUTHTYPE_CHAP	
	},



};

dhcpsCfgParam_t dhcpsCfgParamDefault[1] =
{
	{
		1, /* DHCP Server Status, 0:disable 1:enable */
		1, /* DHCP Server IP Pool Start IP */
		20, /* DHCP Server IP Pool End IP */
		0,
		0,	/* don't provide real DNS server to DHCP client */
		1,	/* forward domain got from upper-DHCP server */
		{0},	/* domain */
		{0, 0 },
		{ { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00} }
	}
};


dhcpcCfgParam_t dhcpcCfgParamDefault[1] =
{
	{
		0,		        /* cmac valid */	
		{0,0,0,0,0,0},	/* clone mac address */
	}
};

dnsCfgParam_t dnsCfgParamDefault[1] =
{
	{
		1, /* DNS Server Status, 0:disable 1:enable */
		{168,95,1,1},
		{0,0,0,0}
	}
};

mgmtCfgParam_t mgmtCfgParamDefault[MAX_MGMT_USER] =
{
	{"root", "\0","\0","\0","\0","\0",1,0,0xffffffff,8080,1}
};

aclGlobalCfgParam_t aclGlobalCfgParamDefault[1] =
{
	{
		ACLGLOBALCFGPARAM_ALLOWALLBUTACL,	// equivalent to "drop" rule
		1,  /* default for lan permit      */ 
		1,  /* default for layer2 permit */
		0
	}
};

aclCfgParam_t aclCfgParamDefault[MAX_PPPOE_SESSION][MAX_ACL] =
{
	{
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}}
	},

	{
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}},
	{{0,0,0,0},0,0,0,ACLCFGPARAM_PROTOCOL_TCP,0x7f,0,0,23,59,{0,0}}
	}
	
};

serverpCfgParam_t serverpCfgParamDefault[MAX_PPPOE_SESSION][MAX_SERVER_PORT] =
{
	{{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0}},

	{{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0},
	{{0,0,0,0},0,0,0,SERVERPCFGPARAM_PROTOCOL_TCP,0}}
	
};

specialapCfgParam_t specialapCfgParamDefault[MAX_PPPOE_SESSION][MAX_SPECIAL_AP] =
{
	{{"Quick Time 4",SPECIALACPCFGPARAM_PROTOCOL_UDP,"6970-6999",SPECIALACPCFGPARAM_PROTOCOL_TCP,554,554,0,{0,0,0}},
	{"MSN Gaming Zone",SPECIALACPCFGPARAM_PROTOCOL_TCP,"28800-29000",SPECIALACPCFGPARAM_PROTOCOL_TCP,6667,6667,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}}},

	{{"Quick Time 4",SPECIALACPCFGPARAM_PROTOCOL_UDP,"6970-6999",SPECIALACPCFGPARAM_PROTOCOL_TCP,554,554,0,{0,0,0}},
	{"MSN Gaming Zone",SPECIALACPCFGPARAM_PROTOCOL_TCP,"28800-29000",SPECIALACPCFGPARAM_PROTOCOL_TCP,6667,6667,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},			
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},				
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}},
	{"",SPECIALACPCFGPARAM_PROTOCOL_TCP,"",SPECIALACPCFGPARAM_PROTOCOL_TCP,0,0,0,{0,0,0}}},
	
//    {"ICUII v5.9",SPECIALACPCFGPARAM_PROTOCOL_BOTH,"2000-2003",SPECIALACPCFGPARAM_PROTOCOL_TCP,23562,23566,0,{0,0,0}},	
//    {"AOE II",SPECIALACPCFGPARAM_PROTOCOL_BOTH,"2300-2400",SPECIALACPCFGPARAM_PROTOCOL_BOTH,47624,47624,0,{0,0,0}},
//	{"ICQ 2000b~2003b",SPECIALACPCFGPARAM_PROTOCOL_TCP,"24500-24505",SPECIALACPCFGPARAM_PROTOCOL_TCP,5190,5190,0,{0,0,0}}, // do it with ALG
//	{"Yahoo MSG v5.6",SPECIALACPCFGPARAM_PROTOCOL_BOTH,"5000-5001,5055,5002",SPECIALACPCFGPARAM_PROTOCOL_TCP,5050,5050,0,{0,0,0}}, // do it with ALG
//	{"PPTP Server",SPECIALACPCFGPARAM_PROTOCOL_TCP,"1723",SPECIALACPCFGPARAM_PROTOCOL_TCP,1723,1723,0,{0,0,0}}, //do it with ALG
//	{"IPSEC",SPECIALACPCFGPARAM_PROTOCOL_UDP,"62514",SPECIALACPCFGPARAM_PROTOCOL_UDP,62514,62514,0,{0,0,0}}, // do it with ALG
//	{"mIRC v6.2",SPECIALACPCFGPARAM_PROTOCOL_TCP,"1024-5000",SPECIALACPCFGPARAM_PROTOCOL_TCP,6660,6669,0,{0,0,0}},
//	{"Dialpad",SPECIALACPCFGPARAM_PROTOCOL_UDP,"51200-51201",SPECIALACPCFGPARAM_PROTOCOL_UDP,51200,51201,0,{0,0,0}},
//	{"Paltalk",SPECIALACPCFGPARAM_PROTOCOL_UDP,"2090-2091",SPECIALACPCFGPARAM_PROTOCOL_UDP,2090,2091,0,{0,0,0}},
//	{"Starcraft",SPECIALACPCFGPARAM_PROTOCOL_UDP,"6112",SPECIALACPCFGPARAM_PROTOCOL_TCP,6112,6112,0,{0,0,0}},
};

gamingCfgParam_t gamingCfgParamDefault[MAX_PPPOE_SESSION][MAX_GAMING] =
{
	{{"",0,"","",0},
	{"",0,"","",0},			
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},		
	{"",0,"","",0}},

	{{"",0,"","",0},
	{"",0,"","",0},			
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},
	{"",0,"","",0},		
	{"",0,"","",0},		
	{"",0,"","",0}}
	
};

tbldrvCfgParam_t tbldrvCfgParamDefault[1] =
{
	{
		1,    // auto add on
		1,    // auto delete on
		60,   // icmp timeout
		300,  // udp timeout
		3600, // tcp long timeout
		900,  // tcp med timeout
		20    // tcp fast timeout
	}
};

dmzCfgParam_t dmzCfgParamDefault[MAX_PPPOE_SESSION] =
{
	//enable, ipaddress, don't forward various L4 protocol, don't forward icmp
	{0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0}
};

logCfgParam_t logCfgParamDefault[MAX_PPPOE_SESSION] =
{
	{0},	//disable all modules
	{0} 	//disable all modules
};

upnpCfgParam_t upnpCfgParamDefault[1] =
{
	{
		1,	// enable
	}
};

snmpCfgParam_t snmpCfgParamDefault[1] =
{
	{
		1,	// enable
	}
};


ddnsCfgParam_t ddnsCfgParamDefault[1] =
{
	{
		0,	// enable
		"\0",
		"\0",
		"\0",
		"\0",
		"\0",		
		"\0",				
	}
};

urlfilterCfgParam_t urlfilterCfgParamDefault[MAX_PPPOE_SESSION][MAX_URL_FILTER] =
{
	{{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 },{0,	"\0", 0, 0 }},
	{{0,	"\0", 0, 0 }, {0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" },{0,	"\0" }}	
};

urlfilterTrustedUserCfgParam_t urlfilterTrustedUserCfgParamDefault[URL_FILTER_MAX_TRUSTED_USERS]={{0,0},{0,0},{0,0},{0,0},{0,0}};


timeCfgParam_t timeCfgParamDefault[1] =
{
	{
		259,
		"-08:00",
		"clock.stdtime.gov.tw",
		"time-b.nist.gov",
		"time.nist.gov"
	}
};

naptCfgParam_t naptCfgParamDefault[1] =
{
	{
		/* disabled, disabled, disabled */
		0,
		0,
		0,
		0
	}
};

dosCfgParam_t dosCfgParamDefault[MAX_PPPOE_SESSION] =
{
	/* Disabled, Disabled, Don't ignore,TCP,UDP,TCPUDP,SRC_TCP,SRC_UDP,SRC_TCPUDP,SYN,FIN,UDP,ICMP,SRC_SYN,SRC_FIN,SRC_UDP,SRC_ICMP, SIPBLOCK_ENABLE, SIPBLOCK_PRISONTIME, portScan Level  */
	{0,0,0,2048,2048,4096,2048,2048,4096,50,50,50,50,30,30,30,30,0,120, 0},
	{0,0,0,2048,2048,4096,2048,2048,4096,50,50,50,50,30,30,30,30,0,120, 0}
};

algCfgParam_t algCfgParamDefault[MAX_PPPOE_SESSION] =
{
	{	0x7fffffff,	/* enable all ALG, disable PPTP software */
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}	/* ALG Server IP List */
	},

	{	0x7fffffff,	/* enable all ALG, disable PPTP software */
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}	/* ALG Server IP List */
	},

};


wlanCfgParam_t wlanCfgParamDefault[MAX_WLAN_CARDS] =
{{
	aliasName:		"WLAN1",
	ssid:				"Realtek AP1", 
	enable:			1,
	channel:			1,
	regDomain:		0,
	mode:			3,
    	dataRateMode:	WLAN_DATA_RATE_BG,
	dataRate:		WLAN_DATA_RATE_54M,
	frag:			2346,
	rts:				2347,
	beacon:			100,
	chipVer:			3,	/* default 8185 D cut */
	rxChargePump:	3,	/* 350mA */
	txChargePump:	6,	/* 500mA */
	protection:		1,
	preambleType:	WLAN_PREAMBLE_TYPE_LONG,
	broadcastSSID:	1,
	range:			3,
	dualAntenna:		1,

	cryptType:		CRYPT_NONE,
	cryptSubType:	{CRYPT_SUB_NONE},
	authType:		AUTH_NONE,

	authRadiusPort:	1812,
	authRadiusIp:		0,
	authRadiusPasswd:	"\0",

	acMacList:		{0},
	acComment:		{0},

	wdsMacList:		{0},

	acEnable:		0,
	wdsEnable:		0,
	wdsCount:		0,
	key:			"\0",
	adhoc: 			0,
},
{
	aliasName:		"WLAN2",
	ssid:				"Realtek AP2", 
	enable:			0,
	channel:			40,
	regDomain:		0,
	mode:			3,
    	dataRateMode:	WLAN_DATA_RATE_A,
	dataRate:		WLAN_DATA_RATE_54M,
	frag:			2346,
	rts:				2347,
	beacon:			100,
	chipVer:			3,	/* default 8185 D cut	 */
	rxChargePump:	3,	/*350mA */
	txChargePump:	6,	/* 500mA */
	protection:		1,
	preambleType:	WLAN_PREAMBLE_TYPE_LONG,
	broadcastSSID:	1,
	range:			3,
	dualAntenna:		1,

	cryptType:		CRYPT_NONE,
	cryptSubType:	{CRYPT_SUB_NONE},
	authType:		AUTH_NONE,

	authRadiusPort:	1812,
	authRadiusIp:		0,
	authRadiusPasswd:	"\0",

	acMacList:		{0},
	acComment:		{0},

	wdsMacList:		{0},

	acEnable:		0,
	wdsEnable:		0,
	wdsCount:		0,
	key:			"\0",
	adhoc:			0,
}};

pptpCfgParam_t pptpCfgParamDefault[1] =
{
	{
		{192,168,0,100},		//ip address
		{255,255,255,0},	//ipmask
		{192,168,0,2},		//pptp server ip address
		{0,0,0,0},		//pptp default gw ip address
		"\0",				//username
		"\0",				//password
		1460,			//mtu
		0,				// manualHangup
		0,				// autoReconnect
		0,				// demand
		PPTPCFGPARAM_DIALSTATE_OFF,				// dialState
		0,				// silentTimeout
		PPPPARAM_AUTHTYPE_CHAP
	}
};

l2tpCfgParam_t l2tpCfgParamDefault[1] =
{
	{
		{192,168,0,100},		//ip address
		{255,255,255,0},	//ipmask
		{192,168,0,2},		//l2tp server ip address
		{0,0,0,0},		//l2tp default gw ip address
		"\0",				//username
		"\0",				//password
		1452,			//mtu
		0,				// manualHangup
		0,				// autoReconnect
		0,				// demand
		L2TPCFGPARAM_DIALSTATE_OFF,				// dialState
		0,				// silentTimeout
		PPPPARAM_AUTHTYPE_CHAP
	}
};

pptpServerCfgParam_t pptpServerCfgParamDefault[1] =
{
	{"\0","\0",100,110,0,0}
};

 
udpblockCfgParam_t udpblockCfgParamDefault[MAX_PPPOE_SESSION] =
{
	//enable, size
		{0,30},
		{0,30}
};


routingCfgParam_t routingCfgParamDefault[MAX_ROUTING] =
{
	// route,mask,gateway,interface
		{0,0xffffffff,0,0},
		{0,0xffffffff,0,0},
		{0,0xffffffff,0,0},
		{0,0xffffffff,0,0},
		{0,0xffffffff,0,0},		
};


qosCfgParam_t qosCfgParamDefault[MAX_QOS] = 
{
	//Policy-Based QoS
	{ POLICY_BASED_QOS, 	{  23, FALSE } },
	{ POLICY_BASED_QOS, 	{  80, FALSE } },
	{ POLICY_BASED_QOS,	{  110, FALSE } },
	{ POLICY_BASED_QOS,	{  25, FALSE } },
	{ POLICY_BASED_QOS,	{    0,  FALSE } },
	{ POLICY_BASED_QOS,	{    0,  FALSE } },
	{ POLICY_BASED_QOS,	{    0,  FALSE } },

	//Port-Based QoS
	{ PORT_BASED_QOS,	{    0,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    1,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    2,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    3,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
	{ PORT_BASED_QOS,	{    4,  FALSE, FALSE, RTL8651_BC_FULL, RTL8651_BC_FULL } },
};


rateLimitCfgParam_t rateLimitCfgParamDefault[1] = 
{
	{
		0,
		{
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
			{ 0, 0, 0xffffff00, 0, 65535, 0, FALSE, 0, 0, 0, 0, FALSE, FALSE },
		}
	}
};

ratioQosCfgParam_t ratioQosCfgParamDefault[1] =
{
	{
		0,
		{	/* max Rate, Rate Unit, remaining Ratio */
			100, 0, 100, 100,0	/* total 100 Mbps, remaining 100%, 100% */
			,{{1000,0,5,0,0}  /* alg ftp queueId, ishigh, ratio , enable ,rsv */
			,{1001,1,30,0,0} /* sip ftp queueId, ishigh, ratio , enable ,rsv */
			,{1002,1,30,0,0}} /* h323 ftp queueId, ishigh, ratio , enable ,rsv */

		},
		{
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0},
			{ 0, 0, 0xffffffff, 0, 0, 0, 0, 0, 0, 0, 0, 0}
			/* MAX_RATIO_QOS is 10 */
			/* enable, queueID, isSrc, ip, ipMask, protoType, s_port, e_port, queue, ratio */
			/* { 0, 0, 0, 0, 0xffffffff, 0, 0, 0, 0, 0xffff, 0} */
		}
	}
};



pbnatCfgParam_t pbnatCfgParamDefault[MAX_PPPOE_SESSION][MAX_PBNAT] =
{
	/* Session 0 */
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },

	/* Session 1 */
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
	{ 0, 0, 0x00000000 },
};

modeCfgParam_t modeCfgParamDefault[1] =
{
	{
		4	/* Gateway mode */
	}
};

ripCfgParam_t ripCfgParamDefault[1] =
{
	{
		2, 2, 0, "realtek", "realtek", 2, 2, 0, 30, 180, 120
	}
};


pseudoVlanCfgParam_t pseudoVlanCfgParamDefault[1] = 
{
	{
		FALSE,
		{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }
	}
};

passthruCfgParam_t passthruCfgParamDefault[1] =
{
	{
		FALSE, /* PPPoE Passthru */
		FALSE, /* IPv6 Passthru */
	}
};

ipMulticastCfgParam_t ipMulticastCfgParamDefault[1] =
{
	{
		FALSE,	/* IP Multicast enable */
	}
};
ipsecGlobalCfgParam_t ipsecGlobalCfgParamDefault[]=
{
0,
};

ipsecConfigCfgParam_t ipsecConfigCfgParamDefault[MAX_IPSEC_SESSION]=
{
	{0x0,0,0,0,
	0xc0a80100,
	0,
	0,
	86400,
	86400,
	"\0",
	},
	{0,0,0,0,
	0xc0a80100,
	0,
	0,
	86400,
	86400,
	"\0",
	},
	{0,0,0,0,
	0xc0a80100,
	0,
	0,
	86400,
	86400,
	"\0",
	},
};

domainBlockCfgParam_t domainBlockCfgParamDefault[MAX_DOMAIN_BLOCKING] =
{
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
	{"\0", 0, 0, FALSE},
};

/***********************************************************************/



static _board_cfgmgr_ctrl_t _board_cfgmgr_ctrlTbl[CFGMGR_TABID_MAX+1] =
{
	{CFGMGR_TABID_NULL,			NULL,						0},
	{CFGMGR_TABID_VLAN,			vlanCfgParamDefault,		(sizeof(vlanCfgParamDefault))},
	{CFGMGR_TABID_IF,				ifCfgParamDefault,			(sizeof(ifCfgParamDefault))},
	{CFGMGR_TABID_ROUTE,			routeCfgParamDefault,		(sizeof(routeCfgParamDefault))},
	{CFGMGR_TABID_ARP,				arpCfgParamDefault,			(sizeof(arpCfgParamDefault))},
	{CFGMGR_TABID_NAT,				natCfgParamDefault,			(sizeof(natCfgParamDefault))},
	{CFGMGR_TABID_MGMT,			mgmtCfgParamDefault,		(sizeof(mgmtCfgParamDefault))},
	{CFGMGR_TABID_PPPOE,			pppoeCfgParamDefault,		(sizeof(pppoeCfgParamDefault))},
	{CFGMGR_TABID_DHCPS,			dhcpsCfgParamDefault,		(sizeof(dhcpsCfgParamDefault))},
	{CFGMGR_TABID_DHCPC,			dhcpcCfgParamDefault,		(sizeof(dhcpcCfgParamDefault))},
	{CFGMGR_TABID_DNS,				dnsCfgParamDefault,			(sizeof(dnsCfgParamDefault))},
	{CFGMGR_TABID_DMZ,				dmzCfgParamDefault,		(sizeof(dmzCfgParamDefault))},
	{CFGMGR_TABID_LOG,				logCfgParamDefault,			(sizeof(logCfgParamDefault))},
	{CFGMGR_TABID_UPNP,			upnpCfgParamDefault,		(sizeof(upnpCfgParamDefault))},
	{CFGMGR_TABID_SNMP,			snmpCfgParamDefault,		(sizeof(snmpCfgParamDefault))},
	{CFGMGR_TABID_DDNS,			ddnsCfgParamDefault,		(sizeof(ddnsCfgParamDefault))},
	{CFGMGR_TABID_ACL,				aclCfgParamDefault,			(sizeof(aclCfgParamDefault))},
	{CFGMGR_TABID_ACL_GLOBAL,		aclGlobalCfgParamDefault,	(sizeof(aclGlobalCfgParamDefault))},
	{CFGMGR_TABID_SERVERP,			serverpCfgParamDefault,		(sizeof(serverpCfgParamDefault))},
	{CFGMGR_TABID_SPECIALAP,		specialapCfgParamDefault,	(sizeof(specialapCfgParamDefault))},
	{CFGMGR_TABID_TBLDRV,			tbldrvCfgParamDefault,		(sizeof(tbldrvCfgParamDefault))},
	{CFGMGR_TABID_URLFILTER,		urlfilterCfgParamDefault,		(sizeof(urlfilterCfgParamDefault))},
	{CFGMGR_TABID_DOS,				dosCfgParamDefault,			(sizeof(dosCfgParamDefault))},
	{CFGMGR_TABID_ALG,				algCfgParamDefault,			(sizeof(algCfgParamDefault))},
	{CFGMGR_TABID_TIME,			timeCfgParamDefault,		(sizeof(timeCfgParamDefault))},
	{CFGMGR_TABID_WLAN,			wlanCfgParamDefault,		(sizeof(wlanCfgParamDefault))},
	{CFGMGR_TABID_UDPBLOCK,		udpblockCfgParamDefault,	(sizeof(udpblockCfgParamDefault))},
	{CFGMGR_TABID_ROUTING,			routingCfgParamDefault,		(sizeof(routingCfgParamDefault))},
	{CFGMGR_TABID_PPTP,			pptpCfgParamDefault,		(sizeof(pptpCfgParamDefault))},
	{CFGMGR_TABID_L2TP,				l2tpCfgParamDefault,			(sizeof(l2tpCfgParamDefault))},
	{CFGMGR_TABID_QOS,				qosCfgParamDefault,			(sizeof(qosCfgParamDefault))},
	{CFGMGR_TABID_PBNAT,			pbnatCfgParamDefault,		(sizeof(pbnatCfgParamDefault))},
	{CFGMGR_TABID_RATELIMIT,		rateLimitCfgParamDefault,	(sizeof(rateLimitCfgParamDefault))},
	{CFGMGR_TABID_RATIOQOS,		ratioQosCfgParamDefault,	(sizeof(ratioQosCfgParamDefault))},
	{CFGMGR_TABID_NAPT,			naptCfgParamDefault,		(sizeof(naptCfgParamDefault))},
	{CFGMGR_TABID_MODE,			modeCfgParamDefault,		(sizeof(modeCfgParamDefault))},
	{CFGMGR_TABID_RIP,				ripCfgParamDefault,			(sizeof(ripCfgParamDefault))},
	{CFGMGR_TABID_PSEUDOVLAN,		pseudoVlanCfgParamDefault,	(sizeof(pseudoVlanCfgParamDefault))},
	{CFGMGR_TABID_PASSTHRU,		passthruCfgParamDefault,	(sizeof(passthruCfgParamDefault))},
	{CFGMGR_TABID_IPMULTICAST,		ipMulticastCfgParamDefault,	(sizeof(ipMulticastCfgParamDefault))}, 
	{CFGMGR_TABID_IPSECCONFIG,		ipsecConfigCfgParamDefault,	(sizeof(ipsecConfigCfgParamDefault))},

	{CFGMGR_TABID_IPSECGLOBALCONFIG,		ipsecGlobalCfgParamDefault,	(sizeof(ipsecGlobalCfgParamDefault))},
	{CFGMGR_TABID_GAMING,			gamingCfgParamDefault,		(sizeof(gamingCfgParamDefault))},	
	{CFGMGR_TABID_DOMAINBLOCK,	domainBlockCfgParamDefault,	(sizeof(domainBlockCfgParamDefault))},	
	{CFGMGR_TABID_PPTPSERVER,		pptpServerCfgParamDefault,	(sizeof(pptpServerCfgParamDefault))},
	{CFGMGR_TABID_URLFILTERTRUSTEDUSER,		urlfilterTrustedUserCfgParamDefault,	sizeof(urlfilterTrustedUserCfgParamDefault)},
	{CFGMGR_TABID_MAX,				NULL,						0}
};


int32 board_cfgmgr_callBack(uint8 flag, uint8 argc, uint32 argv[]);
int32 _board_cfgmgr_callBack_integrityCheck(uint16 tableId, uint32 buffSize, uint8 *buff);
int32 _board_cfgmgr_callBack_factoryDefault(uint16 tableId, uint8 *origBuff, uint32 origBuffSize, uint8 *newBuff, uint32 *len_p);
int32 board_cfgmgr_init(uint8 syncAll);

int32 board_cfgmgr_callBack(uint8 flag, uint8 argc, uint32 *argv)
{
	uint16 tableId = 0;

	if (argc < 1)
	{
		printf("%s-%d-Error: argument count : %d\n", __FUNCTION__, __LINE__, argc);
		goto err;
	}

	tableId = (uint16)(*argv);

	if (tableId <= CFGMGR_TABID_NULL || tableId >= CFGMGR_TABID_MAX)
	{
		printf("%s-%d-Error: tableID : %d\n", __FUNCTION__, __LINE__, tableId);
		goto err;
	}


	switch (flag)
	{
		case CFGMGR_CALLBACK_CHECKINTEGRITY:
		{
			if (argc != 3)
			{
				printf("%s-%d-Error: argument count : %d for flag %d\n", __FUNCTION__, __LINE__, argc, flag);
				goto err;
			}
			/*
				Check integrity
			*/
			if (	_board_cfgmgr_callBack_integrityCheck(	tableId,
														(uint32)(argv[1]),	/* buffer size */
														(uint8*)(argv[2])	/* buffer pointer*/)	!= SUCCESS			)
			{
				goto err;
			}
			break;
		}
		case CFGMGR_CALLBACK_FACTORYDEFAULT:
		{
			if (argc != 5)
			{
				printf("%s-%d-Error: argument count : %d for flag %d\n", __FUNCTION__, __LINE__, argc, flag);
				goto err;
			}
			/*
				Set factory default for entry
			*/
			if (	_board_cfgmgr_callBack_factoryDefault(	tableId,
														(uint8*)(argv[1]),	/* original data */
														(uint32)(argv[2]),	/* original data size */
														(uint8*)(argv[3]),	/* buffer to write new data */
														(uint32*)(argv[4])	/* pointer for length */)	!= SUCCESS		)
			{
				goto err;
			}
			break;
		}
		default:
			printf("Unknown flag : %d\n", flag);
			goto err;
	}

	return SUCCESS;

err:
	printf("%s-%d-Call Back [%d] failed.\n", __FUNCTION__, __LINE__, flag);
	
	return FAILED;
}

static int32 _board_cfgmgr_callBack_integrityCheck(uint16 tableId, uint32 buffSize, uint8 *buff)
{
	if ((tableId <= CFGMGR_TABID_NULL) || (tableId >= CFGMGR_TABID_MAX))
	{
		return FAILED;
	}

	if (buffSize == _board_cfgmgr_ctrlTbl[tableId].defaultSize)
	{
		return SUCCESS;
	}

	return FAILED;		
}
static int32 _board_cfgmgr_callBack_factoryDefault(uint16 tableId, uint8 *origBuff, uint32 origBuffSize, uint8 *newBuff, uint32 *len_p)
{
	if ((tableId <= CFGMGR_TABID_NULL) || (tableId >= CFGMGR_TABID_MAX))
	{
		return FAILED;
	}
	if (newBuff == NULL || len_p == NULL)
	{
		return FAILED;
	}

	if (*len_p < _board_cfgmgr_ctrlTbl[tableId].defaultSize)
	{
		printf("MAX length of tmp buffer (%d) is smaller than ID (%d)'s configuration (%d)\n",
				*len_p,
				tableId,
				_board_cfgmgr_ctrlTbl[tableId].defaultSize);
		return FAILED;
	}
	
	memcpy(newBuff, _board_cfgmgr_ctrlTbl[tableId].dafaultPtr, _board_cfgmgr_ctrlTbl[tableId].defaultSize);
	*len_p = _board_cfgmgr_ctrlTbl[tableId].defaultSize;

	return SUCCESS;
}

/* procedures */
int32 board_cfgmgr_init(uint8 syncAll)
{
	cfgmgr_initParam_t param;
	cfgmgr_callBackFunction_t callBack;
	int32 idx;

	/* Init  phase */
#ifdef CONFIG_RTL865X_CUSTOM_CCFG_SIZE
	#define CFGMGR_SIZE CONFIG_RTL865X_CUSTOM_CCFG_SIZE /* menuconfig */
#else
	#define CFGMGR_SIZE (0x2000UL)   /* 8k */
#endif

	param.maxCfgSize = CFGMGR_SIZE;
	param.maxEntryCount = CFGMGR_TABID_MAX;
	callBack.pCallBackFunction = board_cfgmgr_callBack;
	if (cfgmgr_init(&param) != SUCCESS)
	{
		goto err;
	}

	/* register phase */

	for (idx = CFGMGR_TABID_NULL+1 ; idx < CFGMGR_TABID_MAX ; idx ++)
	{
		if (cfgmgr_registerEntry(	_board_cfgmgr_ctrlTbl[idx].tableId,
								callBack) != SUCCESS)
		{
			goto err;
		}
	}

	if (cfgmgr_registerOk() != SUCCESS)
	{
		goto err;
	}

	/* Sync CFGMGR */

	if (syncAll == TRUE)
	{
		if (cfgmgr_syncAll() != SUCCESS)
		{
			goto err;
		}
	}

	return SUCCESS;

err:
	return FAILED;
}



/***************************************************************************/
/***************************************************************************/
/***************************************************************************/


#ifdef CONFIG_RTL865X

int ReadPhysicalMemory32(unsigned int addr, unsigned int *value){
	char str[32];
	int ret=-1;
    sprintf(str,"0x%08x",addr);
	FILE *f=fopen("/proc/rtl865x/reg32","w+");
	if(f){
	    fputs(str,f);
		fgets(str,sizeof(str),f);
		*value=(unsigned) strtoul(str,NULL,0);
		fclose(f);
		ret=0;
	}
	return ret;
}

int WritePhysicalMemory32(unsigned int addr, unsigned int value){
	char str[32];
	int ret=-1;
    sprintf(str,"0x%08x",addr);
	FILE *f=fopen("/proc/rtl865x/reg32","w+");
	if(f){
	    fputs(str,f);
	    sprintf(str,"0x%08x",value);
	    fputs(str,f);
		fclose(f);
		ret=0;
	}
	return ret;
}

int _chip_is_shared_pci_mode(){

#ifdef CONFIG_RTL865X_UART_UART0
	return 0;
#elif defined(CONFIG_RTL865X_UART_UART1)
	return 1;
#else/*CONFIG_RTL865X_UART_AUTO*/
	unsigned int value;
	
	if(ReadPhysicalMemory32(0xbc805030,&value))
		printf("Can't read kernel memory via /proc filesystem. \n");
	if((value&0x80000000)==0){
		#ifdef CONFIG_PCI
			goto maybe8650B_208;
		#else
			return 0;
		#endif
	}
maybe8650B_208:	
	if(ReadPhysicalMemory32(0xbc805104,&value))
		printf("Can't read kernel memory via /proc filesystem. \n");
	value&=0x07f0ffff;
	if(0x05005788==value){
		//chip is 8650B 208 package with PCI bonding and PCI kernel option is enabled.
		return 1;
	}
	return 0;
#endif

}
#endif

/*
	memory dump utility
*/
void memDump (void *start, uint32 size, int8 * strHeader){
  int32 row, column, index, index2, max;
  uint8 *buf, ascii[17];
  int8 empty = ' ';

  if(!start ||(size==0))
  	return;
  buf = (uint8 *) start;

  /*
     16 bytes per line
   */
  if (strHeader)
    printf ("%s", strHeader);
  column = size % 16;
  row = (size / 16) + 1;
  for (index = 0; index < row; index++, buf += 16) {
      memset (ascii, 0, 17);
      printf ("\n%08x ", (memaddr) buf);

      max = (index == row - 1) ? column : 16;

      //Hex
      for (index2 = 0; index2 < max; index2++){
	  if (index2 == 8)
	    printf ("  ");
	  printf ("%02x ", (uint8) buf[index2]);
	  ascii[index2] = ((uint8) buf[index2] < 32) ? empty : buf[index2];
	}

      if (max != 16){
	  if (max < 8)
	    printf ("  ");
	  for (index2 = 16 - max; index2 > 0; index2--)
	    printf ("   ");
	}

      //ASCII
      printf ("  %s", ascii);
    }
  printf ("\n");
  return;
}

/* ============================================
	System interface control library in board.c
     ============================================ */
#define RTK_LINUX_PATH_PROCNET_DEV	"/proc/net/dev"

static char *rtk_linux_get_devName(char *name, char *p)
{
	while (isspace(*p))
	{
		p ++;
	}
	while (*p)
	{
		if (isspace(*p))
		{
			break;
		}

		if (*p == ':')
		{	/* could be an alias */
			char *dot = p, *dotname = name;

			*name++ = *p++;
			while (isdigit(*p))
			{
				*name++ = *p++;
			}

			if (*p != ':')
			{	/* it wasn't, backup */
				p = dot;
				name = dotname;
			}
			if (*p == '\0')
			{
				return NULL;
			}
			p ++;
			break;
		}
		*name++ = *p++;
	}
	*name++ = '\0';
	return p;
}

/*
	Realtek LINUX dependent functions:

	Turn UP/DOWN all interfaces whose name match "prefix".

		- Note that the interface "lo" would never been matched.
*/
int32 rtk_linux_intf_upDown(char *prefix, int32 isUp, char *arg)
{
	FILE *netDevFd;
	char buf[512];
	int32 retval = FAILED;
	int32 prefixLen = 0;

	if (prefix)
	{
		prefixLen = strlen(prefix);
	} else
	{
		/* No prefix, all characters wide-card */
		prefixLen = 0;
	}

	netDevFd = fopen(RTK_LINUX_PATH_PROCNET_DEV, "r");

	if (netDevFd)
	{
		/* don't process 1st / 2nd line, they are the item names. */
		if (fgets(buf, sizeof(buf), netDevFd) == 0) goto out;
		if (fgets(buf, sizeof(buf), netDevFd) == 0) goto out;

		while (fgets(buf, sizeof(buf), netDevFd))
		{
			char devName[64];
			int32 devNameLen;

			memset(devName, 0, sizeof(devName));
			rtk_linux_get_devName(devName, buf);

			if (	(devName) &&
				(strncmp(devName, "lo", sizeof("lo")) != 0 /* filter loopback "lo" interface */))
			{
				char cmdBuf[64];

				devNameLen = strlen(devName);

				if (	(devNameLen >= prefixLen) &&
					((prefixLen == 0) || (strncmp(devName, prefix, prefixLen) == 0)))
				{
					printf("Turn %s interface : [%s]\n", isUp?"UP":"DOWN", devName);
					sprintf(cmdBuf, "ifconfig %s %s %s", devName, isUp?"up":"down", arg?arg:"");
					printf("=> %s\n", cmdBuf);system(cmdBuf);
				}
			}
		}

		retval = SUCCESS;
	}

out:
	if (netDevFd)
	{
		fclose(netDevFd);
	}

	if (retval != SUCCESS)
	{
		printf("[%s]: failed, return %d\n", retval);
	}

	return retval;
}

/* ============================================
	Semaphore Control in board.c
     ============================================ */
uint32 rtl8651_sem_init(uint8 val)
{
	uint32 i;

	if (pRomeCfgParam == NULL) {
		printf("FAILED : pRomeCfgParam is NULL\n");
		return 1;
	}

	/* set default value to ALL semaphores */
	for ( i = 0 ; i < MAX_USER_SEMAPHORE ; i ++ ) {
		pRomeCfgParam->semaphore[i] = val;
	}

	return 0;
}

void rtl8651_sem_wait(uint32 sem_type)
{
	if (sem_type >= MAX_USER_SEMAPHORE)
		return;	/* type does not exist */

	while (pRomeCfgParam->semaphore[sem_type] == 0)
		usleep(200);
	pRomeCfgParam->semaphore[sem_type] --;
}

void rtl8651_sem_post(uint32 sem_type)
{
	if (sem_type >= MAX_USER_SEMAPHORE)
		return;	/* type does not exist */

	pRomeCfgParam->semaphore[sem_type] ++;
}

/*
 * Routine Name: vlan_init
 * Description: configure vlan and create interface
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 vlan_init()
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_VLAN,(void*)pRomeCfgParam->vlanCfgParam, sizeof(pRomeCfgParam->vlanCfgParam))!=0)
	{
		printf("vlan_init: call cfgmgr_read fail\n");		
		/* take proper actions */
		return 1;
	}
	return 0;
}

uint32 bridge_wanlan_init(void)
{
	uint32 MemberPorts = (1 << 0) | (1 << 1) | (1 << 2) | (1 << 3) | (1 << 4) | (1 << 6);
	unsigned char  macStr[17];
	int32 ret;	
	rtl8651_tblDrvAclRule_t aclRule;
	int32 trueFlag = FALSE;

	/*  If RTL865xB is operating as layer 2 bridge, we have to cancel this drop case.
            Otherwise, ARP pkts (before access to web server) cannot reach the protocol stack.   */
	ret = rtl8651_fwdEngineDropPktCase(FWDENG_ARP_OTHERS, &trueFlag);
	if (ret)
		printf("rtl8651_fwdEngineDropPktCase: ret %d", ret);

	/* ====== ROMEDRV config L1/L2: VLAN & Port attributes & Network intf ====== */
	re865xIoctl("eth0", ADD_IF, 0, 0, 0);
	bdinfo_getMac((macaddr_t *)macStr);
	re865xIoctl("eth0", ADD_VLAN, pRomeCfgParam->vlanCfgParam[0].vid, MemberPorts, (uint32)&macStr);
	rtl8651_cfgCounter(0x1, MemberPorts);	//Configure VLAN 8 member port using counter 1 to monitor
	rtl8651_setMtu(1500);
	re865xIoctl("eth0", SET_VLAN_TYPE, LL_VLAN, 0, 0);

	// protocol stack setting
	setInterfaceIp("lo", 0x7f000001, 0xff000000);
	setInterfaceIp("eth0", *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)), *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)));

	// ACL rule for trapping pkts of web server access.
	memset((void*) &aclRule, 0, sizeof(rtl8651_tblDrvAclRule_t));
	aclRule.ruleType_ = RTL8651_ACL_IP;
	aclRule.actionType_ = RTL8651_ACL_CPU;
	memcpy(&(aclRule.dstIpAddr_), pRomeCfgParam->ifCfgParam[1].ipAddr, 4);
	//memcpy(&(aclRule.dstIpAddrMask_), pRomeCfgParam->ifCfgParam[1].ipMask, 4);
	aclRule.dstIpAddrMask_= 0xffffffff;
	ret = rtl8651a_addAclRule(0, "eth0", 1, (rtl8651_tblDrvAclRule_t* )&aclRule);
	if (ret)
		printf("Bridge Mode: rtl8651a_addAclRule.\n");	

	return 0;
}

/* 
	Original wanlan_init() function configures RTL865xB in NAPT-mode.
	Now, we should support Router-Mode configuration.
	router_mode_wanlan_init() is to replace wanlan_init() when user chooses Router-Mode.

	Default Router-Mode will be configured as one LAN interface and one WAN interface.
	Packets won't be NAPT-ed/NAPTR-ed between WAN and LAN.
*/
uint32 router_wanlan_init(void)
{
	char *argv[8];
	unsigned char  macStr[17];
	uint32 wanMemberPorts = pRomeCfgParam->vlanCfgParam[0].memberPort;
	uint32 lanMemberPorts = pRomeCfgParam->vlanCfgParam[1].memberPort;
	int32 ret = FAILED;
	uint32 i = 0;
	
	/* ====== ROMEDRV config L1/L2: VLAN & Port attributes ====== */

	// for wan
	re865xIoctl("eth0", ADD_IF, 0, 0, 0);
	if (pRomeCfgParam->ifCfgParam[0].connType  == IFCFGPARAM_CONNTYPE_DHCPC && (pRomeCfgParam->dhcpcCfgParam.cmacValid == 1))
		memcpy((char *)&macStr, (char *)&(pRomeCfgParam->dhcpcCfgParam.cloneMac), 6);
	else
		bdinfo_getMac((macaddr_t *)macStr);
	re865xIoctl("eth0", ADD_VLAN, pRomeCfgParam->vlanCfgParam[0].vid, wanMemberPorts, (uint32)&macStr);
	rtl8651_cfgCounter(0x1, wanMemberPorts);	//Configure VLAN 8 member port using counter 1 to monitor

	// for lan
	sleep(1);
	bdinfo_getMac((macaddr_t *)macStr);
	macStr[5] = macStr[5] + 1;

#ifdef CONFIG_RTL865XB_EXP_WLAN
	lanMemberPorts|= 0x40; 	//add first extension port (used by WLAN) to LAN 
#endif

	re865xIoctl("eth1", ADD_VLAN, pRomeCfgParam->vlanCfgParam[1].vid, lanMemberPorts, (uint32)&macStr);
	rtl8651_cfgCounter(0x2, lanMemberPorts);	//Configure VLAN 9 member port using counter 2 to monitor

	/* ====== ROMEDRV config L2/L3: network/ip interface ====== */

	// for lan
	re865xIoctl("eth1", SET_VLAN_TYPE, LL_VLAN, 0, 0);
	re865xIoctl("eth1", SET_VLAN_IP, *(uint32 *)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)), *(uint32 *)(&(pRomeCfgParam->ifCfgParam[1].ipMask)), 0);

	// protocol stack setting
	setInterfaceIp("lo", 0x7f000001, 0xff000000);
	setInterfaceIp("eth1", *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)), *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)));

	// for wan
	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_STATIC) 
	{
		uint32 netmask = 0;
		rtl8651_setMtu(1500);
		netmask|= (pRomeCfgParam->ifCfgParam[0].ipMask[0]) << 24;
		netmask|= (pRomeCfgParam->ifCfgParam[0].ipMask[1]) << 16;
		netmask|= (pRomeCfgParam->ifCfgParam[0].ipMask[2]) << 8;
		netmask|= pRomeCfgParam->ifCfgParam[0].ipMask[3];
		
		re865xIoctl("eth0", SET_VLAN_TYPE, LL_VLAN, 0, 0);
		re865xIoctl("eth0", SET_VLAN_IP, *(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)), netmask, 0);
		
		#if defined(CONFIG_RTL865X_DIAG_LED)
		{
			ipaddr_t gwWanIp,gwWanIpmask;		
			ipaddr_t gwLanIp,gwLanIpmask;
			memcpy((void*)&gwWanIp, pRomeCfgParam->ifCfgParam[0].ipAddr, 4);
			memcpy((void*)&gwWanIpmask, pRomeCfgParam->ifCfgParam[0].ipMask, 4);			
			memcpy((void*)&gwLanIp, pRomeCfgParam->ifCfgParam[1].ipAddr, 4);
			memcpy((void*)&gwLanIpmask, pRomeCfgParam->ifCfgParam[1].ipMask, 4);
			if ((gwWanIp & gwWanIpmask) == (gwLanIp & gwLanIpmask))
				re865xIoctl("eth0", RTL8651_IOCTL_DIAG_LED, 5, 0, 0);
		}
		#endif /* CONFIG_RTL865X_DIAG_LED */
		
		re865xIoctl("eth0", ADD_GW,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].gwAddr)),netmask,0);
		
		// protocol stack setting
		setInterfaceIp("eth0",*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),netmask);

		argv[0]="default";
		
		sprintf(macStr,"%u.%u.%u.%u",
			pRomeCfgParam->ifCfgParam[0].gwAddr[0],
			pRomeCfgParam->ifCfgParam[0].gwAddr[1],
			pRomeCfgParam->ifCfgParam[0].gwAddr[2],
			pRomeCfgParam->ifCfgParam[0].gwAddr[3]);
		argv[1]="gw";
		argv[2]=(char*)&macStr;
		argv[3]=NULL;
		INET_setroute(RTACTION_ADD, 0, argv);
		runDNSProxy();
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC */	
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC)
	{
		rtl8651_setMtu(1500);		
		/* clear ifCfgParam[0].ipAddr[] etc, dhcp client will fill these values later */
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipAddr, 0, 4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipMask, 0, 4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].gwAddr, 0, 4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr, 0, 4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr, 0, 4);
		re865xIoctl("eth0", SET_VLAN_TYPE, LL_VLAN, 0, 0);
		// protocol stack setting
		setInterfaceIp("eth0", 0, 0);

		udhcpc_start();
	}
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE)
	{
		// protocol stack setting
		upInterface("eth0");
		
		ret = rtl8651_addNetworkIntf("eth0");
		if (ret)
			printf("rtl8651_addNetworkIntf: ret %d\n", ret);

		ret = rtl8651_specifyNetworkIntfLinkLayerType("eth0", RTL8651_LL_PPPOE, pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n", ret);

		ret = rtl8651_addPppoeSession(i,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_addPppoeSession: ret %d\n", ret);

		ret = rtl8651_addRoute((ipaddr_t)0, (ipaddr_t)0, (int8*)"eth0", 0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n",ret);

		pppd_start(0);
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE */
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
	{
		uint32 pppObjId = 0;

		// protocol stack setting
		upInterface("eth0");
				
		ret = rtl8651_addNetworkIntf("eth0");
		if (ret)
			printf("rtl8651_addNetworkIntf: ret %d\n", ret);
    	
    		ret = rtl8651_specifyNetworkIntfLinkLayerType("eth0", RTL8651_LL_PPPOE, pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n", ret);
			
	    	for (i = 0; i < MAX_PPPOE_SESSION; i++) {
			ret = rtl8651_addPppoeSession(i, pRomeCfgParam->vlanCfgParam[0].vid);
			if (ret)
				printf("session: %d -- rtl8651_addPppoeSession: ret %d\n", i, ret);

			if (pRomeCfgParam->pppoeCfgParam[i].defaultSession == 1){
				ret = rtl8651_setPppoeDefaultDialSessionId(i);
				if (ret)
					printf("rtl8651_setPppoeDefaultDialSessionId: ret %d\n", ret);
				else
					printf("rtl8651_setPppoeDefaultDialSessionId(%d): ret %d\n", i, ret);
			}
			if(pRomeCfgParam->pppoeCfgParam[i].lanType==PPPOECFGPARAM_LANTYPE_UNNUMBERED)
				pppObjId = i;
		}

		/* assign the pre-assigned global ip to gw */
		if(pRomeCfgParam->pppoeCfgParam[pppObjId].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED)
		{		
			ipaddr_t ipStub = 0x0b010101, ipMaskStub = 0xfffffffd;
			memcpy((void*)&ipStub, pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpAddr, 4);
			memcpy((void*)&ipMaskStub, pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpMask, 4);

			ret = rtl8651_addIpIntf("eth1", (ipaddr_t)ipStub, (ipaddr_t)ipMaskStub);
			if (ret)
				printf("rtl8651_addIpIntf: ret %d\n", ret);

			/* initialize user protocol stack: set inside
			 * global ip address to LAN
			 * uClinux "ifconfig" command:
			 *    add alias:ifconfig eth1:1 10.1.1.2 netmask 255.255.255.0
			 *    del alias:ifconfig eth1:1 0.0.0.0		 
			 */
			{
				int 	ipValue;
				char	*av[5];
				
				char	pname[] = "/bin/ifconfig";
				char	*ip_string;
				char	*ipmask_string;
				ip_string = malloc(MAX_IP_STRING_LEN);
				ipmask_string = malloc(MAX_IP_STRING_LEN);
				ipValue = (int) ipStub;
				sprintf(ip_string, "%u.%u.%u.%u", (ipValue >> 24) & 0xff, (ipValue >> 16) & 0xff, (ipValue >> 8) & 0xff, ipValue & 0xff);
				ipValue = (int) ipMaskStub;
				sprintf(ipmask_string, "%u.%u.%u.%u", (ipValue >> 24) & 0xff, (ipValue >> 16) & 0xff, (ipValue >> 8) & 0xff, ipValue & 0xff);
				
				av[0] = pname;
				av[1] = "eth1:1";
				av[2] = ip_string;
				av[3] = "netmask";
				av[4] = ipmask_string;
				av[5] = NULL;
				runProgram(pname,av);
				free(ip_string);
				free(ipmask_string);
			}			
		}

		ret = rtl8651_addRoute((ipaddr_t)0, (ipaddr_t)0, (int8*)"eth0", 0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n", ret);

		for (i = 0; i < MAX_PPPOE_SESSION; i++) {
			pRomeCfgParam->pppoeCfgParam[i].dialState = 0;			 
			if (pRomeCfgParam->pppoeCfgParam[i].defaultSession == 1)
				pppd_start(i); // start pppd on pppObjId x
		}
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE */
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED)
	{
		ipaddr_t ipStub;
		ipaddr_t ipMaskStub;

		// protocol stack setting
		upInterface("eth0");

		ret = rtl8651_addNetworkIntf("eth0");
		if (ret)
			printf("rtl8651_addNetworkIntf: ret %d\n", ret);

		ret = rtl8651_specifyNetworkIntfLinkLayerType("eth0", RTL8651_LL_PPPOE, pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n", ret);

		ret = rtl8651_addPppoeSession(i,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_addPppoeSession: ret %d\n", ret);

		memcpy((void*) &ipMaskStub, pRomeCfgParam->pppoeCfgParam[0].unnumberedIpMask, 4);
		ret = rtl8651_addIpUnnumbered("eth0", "eth1", (ipaddr_t)ipMaskStub);
		if (ret)
			printf("rtl8651_addIpUnnumbered: ret %d\n", ret);

		/* assign the pre-assigned global ip to gw */
		memcpy((void*)&ipStub, pRomeCfgParam->pppoeCfgParam[0].unnumberedIpAddr, 4);
		ret = rtl8651_addIpIntf("eth1", (ipaddr_t)ipStub, (ipaddr_t)ipMaskStub);
		if (ret)
			printf("rtl8651_addIpIntf: ret %d\n", ret);
		
		/* initialize user protocol stack: set inside
		 * global ip address to LAN
		 * uClinux "ifconfig" command:
		 *    add alias:ifconfig eth1:1 10.1.1.2 netmask 255.255.255.0
		 *    del alias:ifconfig eth1:1 0.0.0.0		 
		 */
		{
			int ipValue;
			char	*av[5];
			char	*ip_string;
			char	*ipmask_string;
			char	pname[]="/bin/ifconfig";

			ip_string = malloc(MAX_IP_STRING_LEN);
			ipmask_string = malloc(MAX_IP_STRING_LEN);
			ipValue = (int)ipStub;
			sprintf(ip_string, "%u.%u.%u.%u", (ipValue >> 24) & 0xff, (ipValue >> 16) & 0xff, (ipValue >> 8) & 0xff, ipValue & 0xff);
			ipValue = (int)ipMaskStub;
			sprintf(ipmask_string, "%u.%u.%u.%u", (ipValue >> 24) & 0xff, (ipValue >> 16) & 0xff, (ipValue >> 8) & 0xff, ipValue & 0xff);
			
			av[0] = pname;
			av[1] = "eth1:1";
			av[2] = ip_string;
			av[3] = "netmask";
			av[4] = ipmask_string;
			av[5] = NULL;
			runProgram(pname,av);
			free(ip_string);
			free(ipmask_string);
		}

		ret = rtl8651_addRoute((ipaddr_t)0, (ipaddr_t)0, (int8*)"eth0", 0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n", ret);
		
		pppd_start(0);
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED */
#if defined(CONFIG_RTL865X_PPTPL2TP) || defined(CONFIG_RTL865XB_PPTPL2TP)
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPTP)
	{
		uint32 netmask = 0;
		uint8 strBuffer[128];

		// protocol stack setting
		upInterface("eth0");
		
		netmask |= (pRomeCfgParam->pptpCfgParam.ipMask[0]) << 24;
		netmask |= (pRomeCfgParam->pptpCfgParam.ipMask[1]) << 16;
		netmask |= (pRomeCfgParam->pptpCfgParam.ipMask[2]) << 8;
		netmask |= pRomeCfgParam->pptpCfgParam.ipMask[3];

		ret = rtl8651_addNetworkIntf("eth0");
		if (ret)
			printf("rtl8651_addNetworkIntf: ret %d\n", ret);

		ret = rtl8651_specifyNetworkIntfLinkLayerType("eth0", LL_PPTP, pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n", ret);
		
		re865xIoctl("eth0", SET_VLAN_IP, *(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipAddr)), *(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipMask)),0);
	
		sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
			pRomeCfgParam->pptpCfgParam.ipAddr[0],
			pRomeCfgParam->pptpCfgParam.ipAddr[1],
			pRomeCfgParam->pptpCfgParam.ipAddr[2],
			pRomeCfgParam->pptpCfgParam.ipAddr[3],
			pRomeCfgParam->pptpCfgParam.ipMask[0],
			pRomeCfgParam->pptpCfgParam.ipMask[1],
			pRomeCfgParam->pptpCfgParam.ipMask[2],
			pRomeCfgParam->pptpCfgParam.ipMask[3]);

		system(strBuffer);

		ret = rtl8651_addSession(RTL8651_PPTP, 1, "eth0", pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_addSession: ret %d\n", ret);
		
		ret = rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n",ret);

		pptp_start(0);
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPTP */	
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_L2TP)
	{
		uint32 netmask = 0;
		uint8 strBuffer[128];

		// protocol stack setting
		upInterface("eth0");

		netmask |= (pRomeCfgParam->l2tpCfgParam.ipMask[0]) << 24;
		netmask |= (pRomeCfgParam->l2tpCfgParam.ipMask[1]) << 16;
		netmask |= (pRomeCfgParam->l2tpCfgParam.ipMask[2]) << 8;
		netmask |= pRomeCfgParam->l2tpCfgParam.ipMask[3];

		//l2tp by MII lookback path
		ret = rtl8651_addNetworkIntf("eth0");
		if (ret)
			printf("rtl8651_addNetworkIntf: ret %d\n", ret);
		
		ret = rtl8651_specifyNetworkIntfLinkLayerType("eth0", LL_L2TP, pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n", ret);

		re865xIoctl("eth0", SET_VLAN_IP, *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)), *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)), 0);

		sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
			pRomeCfgParam->l2tpCfgParam.ipAddr[0],
			pRomeCfgParam->l2tpCfgParam.ipAddr[1],
			pRomeCfgParam->l2tpCfgParam.ipAddr[2],
			pRomeCfgParam->l2tpCfgParam.ipAddr[3],			
			pRomeCfgParam->l2tpCfgParam.ipMask[0],
			pRomeCfgParam->l2tpCfgParam.ipMask[1],
			pRomeCfgParam->l2tpCfgParam.ipMask[2],
			pRomeCfgParam->l2tpCfgParam.ipMask[3]);
		
		system(strBuffer);

		ret = rtl8651_addSession(RTL8651_L2TP, 1, "eth0", pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_addSession: ret %d\n", ret);
		
		ret = rtl8651_addRoute((ipaddr_t)0, (ipaddr_t)0, (int8*)"eth0", 0);
		if (ret)
			printf("rtl8651_addRoute: ret %d\n", ret);
		
		l2tp_start(0);
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_L2TP */
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP) {

		// protocol stack setting
		setInterfaceIp("eth0", 0, 0);
		
		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;
		
		/* clear ifCfgParam[0].ipAddr[] etc, dhcp client will fill these values later */
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);

		udhcpc_start();
	}
	
#endif 		// defined(CONFIG_RTL865X_PPTPL2TP) || defined(CONFIG_RTL865XB_PPTPL2TP)

	rtl8651_multicastSetUpStream("eth0", 0);	// set default Upstream of IGMP system

	return 0;
}


/*
 * Routine Name: wanlan_int
 * Description: configure wan/lan interface
 * Input:
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 wanlan_init(void)
{
	char           *argv[8];
	unsigned char  macStr[17];
	//char           *cp;
	uint32         i=0;
	uint32	lanMemberPorts=pRomeCfgParam->vlanCfgParam[1].memberPort;
	uint32 	wanMemberPorts = pRomeCfgParam->vlanCfgParam[0].memberPort;
	int32          ret=FAILED;
	FILE *f;
	/* init wan part I */

	re865xIoctl("eth0",ADD_IF,0,0,0);

	if (pRomeCfgParam->ifCfgParam[0].connType  == IFCFGPARAM_CONNTYPE_DHCPC&& (pRomeCfgParam->dhcpcCfgParam.cmacValid == 1))
		memcpy((char*)&macStr,(char*)&(pRomeCfgParam->dhcpcCfgParam.cloneMac),6);
	else
		bdinfo_getMac((macaddr_t*)macStr);

#ifdef CONFIG_RTL865XB_3G
	 if ((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_USB_ETHERNET) 
		||(pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_3G))
		wanMemberPorts |= (1<<CONFIG_RTL865XB_3G_PORT);
	 
#endif	 

	re865xIoctl("eth0",ADD_VLAN,pRomeCfgParam->vlanCfgParam[0].vid,wanMemberPorts,(uint32)&macStr);

	rtl8651_cfgCounter(0x1, wanMemberPorts);//Configure VLAN 8 member port using counter 1 to monitor
	/* init lan */
	sleep(1);
	bdinfo_getMac((macaddr_t*)macStr);

#ifdef CONFIG_RTL865XB_3G
	{
		FILE *f;
		f=fopen("/var/bdinfo_mac.txt","w");
		fprintf(f,"%u\n%u\n%u\n%u\n%u\n%u\n",macStr[0],macStr[1],macStr[2],macStr[3],macStr[4],macStr[5]);
		fclose(f);
	}
#endif	

	//Reserve MAX_PPPOE_SESSION MACs...
	macStr[5] = macStr[5]+1; //MAX_PPPOE_SESSION; /* Even if multiple PPPoE session, only one MAC address is used in WAN */

#ifdef CONFIG_RTL865XB_EXP_WLAN
	//printf("WLAN: Adding extport 6 (0x40)\n");
	lanMemberPorts|= 0x40; //add first extension port(used by WLAN) to LAN 
#endif
	re865xIoctl("eth1",ADD_VLAN,pRomeCfgParam->vlanCfgParam[1].vid,lanMemberPorts,(uint32)&macStr);
	rtl8651_cfgCounter(0x2, lanMemberPorts);//Configure VLAN 9 member port using counter 2 to monitor
	
	setInterfaceIp("lo",0x7f000001,0xff000000);	
	re865xIoctl("eth1",SET_VLAN_TYPE,LL_VLAN,0,0);

	/* If wan type is unnumbered pppoe and "NAPT for LAN hosts" feature is turned off, we don't add private LAN ip interface. */
	if ( !(pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED && pRomeCfgParam->pppoeCfgParam[0].unnumberedNapt == 0))
	{
		re865xIoctl("eth1",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)),*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)),0);
	}
	re865xIoctl("eth1",SET_NET_PARA,0,0,0);
	setInterfaceIp("eth1",*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr)),*(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask)));

	/* turn off auto learn due to url filtering 'forward' logging needs */
	rtl8651_enableNaptAutoAdd(0);

	DEBUG_P("mac address %02X:%02X:%02X:%02X:%02X:%02X\n",macStr[0],macStr[1],macStr[2],macStr[3],macStr[4],macStr[5]);

	DEBUG_P("wan address %x netmask %x\n",*(uint32*)&(pRomeCfgParam->ifCfgParam[0].ipAddr),*(uint32*)&(pRomeCfgParam->ifCfgParam[0].ipMask));

	DEBUG_P("lan address %x netmask %x\n",*(uint32*)&(pRomeCfgParam->ifCfgParam[1].ipAddr),*(uint32*)&(pRomeCfgParam->ifCfgParam[1].ipMask));


	/* set protocol stack used udp ports in DMZ (software path) */
/*
	rtl8651_flushProtoStackUsedUdpPorts();	
	rtl8651_addProtoStackUsedUdpPort(53);
	rtl8651_flushProtoStackServerUsedTcpPorts();		
	rtl8651_addProtoStackServerUsedTcpPort(80);
*/
	//start telnetd
	#if 0
	system("/bin/telnetd &");
	rtl8651_addProtoStackServerUsedTcpPort(23);	
	#endif

	/* init wan part II */
#ifdef CONFIG_RTL865XB_3G
	 if ((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC) ||
		(pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_USB_ETHERNET))
#else
	 if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC) 
#endif	 	
	{	
		uint32 netmask=0;

#ifdef CONFIG_RTL865XB_3G
		if(pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_USB_ETHERNET)		
			system("ifconfig eth2 up promisc");
#endif		
		rtl8651_setMtu(1500);	
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[0])<<24;
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[1])<<16;
		netmask|=(pRomeCfgParam->ifCfgParam[0].ipMask[2])<<8;
		netmask|=pRomeCfgParam->ifCfgParam[0].ipMask[3];
		
		//printf("cfg wan to static ...\n");
		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),netmask,0);

		/* For multiple DMZ hosts spec -- setting alias ip. */
		uint32 netmask1 = 0, ipAddr1 = 0;
		netmask1|=(pRomeCfgParam->ifCfgParam[0].ipMask1[0])<<24;
		netmask1|=(pRomeCfgParam->ifCfgParam[0].ipMask1[1])<<16;
		netmask1|=(pRomeCfgParam->ifCfgParam[0].ipMask1[2])<<8;
		netmask1|=pRomeCfgParam->ifCfgParam[0].ipMask1[3];
		ipAddr1 |= (pRomeCfgParam->ifCfgParam[0].ipAddr1[0])<<24;
		ipAddr1 |= (pRomeCfgParam->ifCfgParam[0].ipAddr1[1])<<16;
		ipAddr1 |= (pRomeCfgParam->ifCfgParam[0].ipAddr1[2])<<8;
		ipAddr1 |= pRomeCfgParam->ifCfgParam[0].ipAddr1[3];
		if(ipAddr1 != 0)
			re865xIoctl("eth0", SET_VLAN_IP, *(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr1)), netmask1, 0);

		/* For multiple DMZ hosts spec -- setting alias ip. */
		uint32 netmask2 = 0, ipAddr2 = 0;
		netmask2|=(pRomeCfgParam->ifCfgParam[0].ipMask2[0])<<24;
		netmask2|=(pRomeCfgParam->ifCfgParam[0].ipMask2[1])<<16;
		netmask2|=(pRomeCfgParam->ifCfgParam[0].ipMask2[2])<<8;
		netmask2|=pRomeCfgParam->ifCfgParam[0].ipMask2[3];
		ipAddr2 |= (pRomeCfgParam->ifCfgParam[0].ipAddr2[0])<<24;
		ipAddr2 |= (pRomeCfgParam->ifCfgParam[0].ipAddr2[1])<<16;
		ipAddr2 |= (pRomeCfgParam->ifCfgParam[0].ipAddr2[2])<<8;
		ipAddr2 |= pRomeCfgParam->ifCfgParam[0].ipAddr2[0];
		if(ipAddr2 != 0)
			re865xIoctl("eth0", SET_VLAN_IP, *(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr2)), netmask2, 0);
		
		#if defined(CONFIG_RTL865X_DIAG_LED)
		{
			ipaddr_t gwWanIp,gwWanIpmask;		
			ipaddr_t gwLanIp,gwLanIpmask;
			memcpy((void*)&gwWanIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
			memcpy((void*)&gwWanIpmask,pRomeCfgParam->ifCfgParam[0].ipMask,4);			
			memcpy((void*)&gwLanIp,pRomeCfgParam->ifCfgParam[1].ipAddr,4);
			memcpy((void*)&gwLanIpmask,pRomeCfgParam->ifCfgParam[1].ipMask,4);
			if ((gwWanIp&gwWanIpmask)==(gwLanIp&gwLanIpmask))
				re865xIoctl("eth0",RTL8651_IOCTL_DIAG_LED,5,0,0);
		}
		#endif /* CONFIG_RTL865X_DIAG_LED */
		re865xIoctl("eth0",ADD_GW,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].gwAddr)),netmask,0);

		re865xIoctl("eth0",SET_EXT_INTERFACE,*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),0,0);

		/* For multiple DMZ hosts spec -- setting alias ip as a "NAPT IP". */
		if(pRomeCfgParam->ifCfgParam[0].ipAddr1 != 0)
			rtl8651_addNaptMappingExt(*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr1)));
		/* For multiple DMZ hosts spec -- setting alias ip as a "NAPT IP". */
		if(pRomeCfgParam->ifCfgParam[0].ipAddr2 != 0)
			rtl8651_addNaptMappingExt(*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr2)));

#if 0	// RTL865xB d-cut testing hash-1.
		{
			uint32 test_addr = 0;
			memcpy((void*)&test_addr,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr2),4);
			test_addr+=1;
			re865xIoctl("eth0", SET_VLAN_IP, test_addr, netmask1, 0);
			printf("==============================%u.%u.%u.%u\n", NIPQUAD(test_addr));
			ret = rtl8651_addNaptMappingExt(test_addr);
			printf("============================ add napt mapping ret: %d\n", ret);
		}
#endif

		setInterfaceIp("eth0",*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr)),netmask);

		/* For multiple DMZ-host spec. */
		if(pRomeCfgParam->ifCfgParam[0].ipAddr1 != 0) {
			char	*av[5];
			
			char	pname[]="/bin/ifconfig";
			//static char ip_string[MAX_IP_STRING_LEN];
			//static char ipmask_string[MAX_IP_STRING_LEN];
			char	*ip_string;
			char	*ipmask_string;
			ip_string     = malloc(MAX_IP_STRING_LEN);
			ipmask_string = malloc(MAX_IP_STRING_LEN);
			sprintf(ip_string,"%u.%u.%u.%u",pRomeCfgParam->ifCfgParam[0].ipAddr1[0], 
			           						pRomeCfgParam->ifCfgParam[0].ipAddr1[1], 
			           						pRomeCfgParam->ifCfgParam[0].ipAddr1[2], 
			           						pRomeCfgParam->ifCfgParam[0].ipAddr1[3]);
			sprintf(ipmask_string,"%u.%u.%u.%u",pRomeCfgParam->ifCfgParam[0].ipMask1[0],
											 pRomeCfgParam->ifCfgParam[0].ipMask1[1],
											 pRomeCfgParam->ifCfgParam[0].ipMask1[2],
											 pRomeCfgParam->ifCfgParam[0].ipMask1[3]);
			
			av[0]=pname;
			av[1]="eth0:1";
			av[2]=ip_string;
			av[3]="netmask";
			av[4]=ipmask_string;
			av[5]=NULL;
			runProgram(pname,av);


			
			free(ip_string);
			free(ipmask_string);
		}

		/* For multiple DMZ-host spec. */
		if(pRomeCfgParam->ifCfgParam[0].ipAddr2 != 0) {
			char	*av[5];
			
			char	pname[]="/bin/ifconfig";
			//static char ip_string[MAX_IP_STRING_LEN];
			//static char ipmask_string[MAX_IP_STRING_LEN];
			char	*ip_string;
			char	*ipmask_string;
			ip_string     = malloc(MAX_IP_STRING_LEN);
			ipmask_string = malloc(MAX_IP_STRING_LEN);
			sprintf(ip_string,"%u.%u.%u.%u",pRomeCfgParam->ifCfgParam[0].ipAddr2[0], 
			           						pRomeCfgParam->ifCfgParam[0].ipAddr2[1], 
			           						pRomeCfgParam->ifCfgParam[0].ipAddr2[2], 
			           						pRomeCfgParam->ifCfgParam[0].ipAddr2[3]);
			sprintf(ipmask_string,"%u.%u.%u.%u",pRomeCfgParam->ifCfgParam[0].ipMask2[0],
											 pRomeCfgParam->ifCfgParam[0].ipMask2[1],
											 pRomeCfgParam->ifCfgParam[0].ipMask2[2],
											 pRomeCfgParam->ifCfgParam[0].ipMask2[3]);
			
			av[0]=pname;
			av[1]="eth0:2";
			av[2]=ip_string;
			av[3]="netmask";
			av[4]=ipmask_string;
			av[5]=NULL;
			runProgram(pname,av);
			free(ip_string);
			free(ipmask_string);
		}
		
		argv[0]="default";
		
		sprintf(macStr,"%u.%u.%u.%u",
			pRomeCfgParam->ifCfgParam[0].gwAddr[0],
			pRomeCfgParam->ifCfgParam[0].gwAddr[1],
			pRomeCfgParam->ifCfgParam[0].gwAddr[2],
			pRomeCfgParam->ifCfgParam[0].gwAddr[3]);
		argv[1]="gw";
		argv[2]=(char*)&macStr;
		argv[3]=NULL;
		INET_setroute(RTACTION_ADD, 0, argv);
		
		 runDNSProxy();
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC */	
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPC)
	{
		printf("cfg wan to dhcp client ...\n");
		rtl8651_setMtu(1500);		
		/* clear ifCfgParam[0].ipAddr[] etc, dhcp client will fill these values later */
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);
		setInterfaceIp("eth0",0,0);		
		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);	
		rtl8651_addExtNetworkInterface((int8*)"eth0");

		udhcpc_start();
	}
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE)
	{
		//printf("cfg wan to single PPPoE ...\n");

		/* linux if up */
		upInterface("eth0");
				
		rtl8651_addNetworkIntf("eth0");
    	//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    	rtl8651_enableNaptAutoAdd(0);
    	/* note: for ip unnumbered case, reference  pppObjId=0 only
    	 *       ppp obj id equal to session number (0,1,2,3,...)
    	 */
	    	
		ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",RTL8651_LL_PPPOE,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
		//for (i=0;i<MAX_PPPOE_SESSION;i++)
	    	for (i=0;i<1;i++)
			rtl8651_addPppoeSession(i,pRomeCfgParam->vlanCfgParam[0].vid);

		/* make this network interface for napt */
		//rtl8651_addExtNetworkInterface(int8 * ifName);
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);

		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
		}		

		#if 1
		pppd_start(0); // start pppd on pppObjId 0
		#else
		for (i=0;i<1;i++)
		{
			char identity[4];
			char papStr[20];
			char pppOptionStr[20];

			#if 0
			/* pppoeCfgParam[].enable only used for multiple pppoe */
			if (pRomeCfgParam->pppoeCfgParam[i].enable==0)
			{
				printf("pppoe session #%u disabled ... \n", i);
				continue;
			}
			else
				printf("pppoe session #%u enabled ... \n",i);
			#endif
				
			tmp = malloc(160);
			f1 = fopen("/etc/ppp.options","r");
			
			sprintf(papStr,"/var/ppp/pap%u",i);
			f2 = fopen(papStr,"w+");
			sprintf(tmp,"%s * %s" ,pRomeCfgParam->pppoeCfgParam[i].username,pRomeCfgParam->pppoeCfgParam[i].password);
			fputs(tmp,f2);
			fclose(f2);
			
			sprintf(pppOptionStr,"/var/ppp/options%u",i);
			f2 = fopen(pppOptionStr,"w+");
			while (!feof(f1))
			{
				fgets(tmp,160,f1);
				if (!memcmp(tmp,"user",4))
					sprintf(tmp,"user %s\n",pRomeCfgParam->pppoeCfgParam[i].username);
				fputs(tmp,f2);
			}			
			fclose(f1);
			
			/* render idle option (auto disconnect) for pppd's reference */
			fprintf(f2,"idle %u\n",pRomeCfgParam->pppoeCfgParam[i].silentTimeout);			
			
			/* render dial-on-demand option for pppd's reference */
/*
			if (pRomeCfgParam->pppoeCfgParam[i].demand==1)
				fprintf(f2,"demand 1\n");
*/
			fclose(f2);
			free(tmp);
			pRomeCfgParam->pppoeCfgParam[i].dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;
			sprintf(identity,"%u",i);
			do_exec("/bin/pppd",identity);
		} /* end for i */
		#endif
		
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE */
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
	{
		uint32 pppObjId = 0;
		
		//printf("cfg wan to multiple PPPoE ...\n");

		/* linux if up */
		upInterface("eth0");
				
		rtl8651_addNetworkIntf("eth0");
    	//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    	rtl8651_enableNaptAutoAdd(0);

    		ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",RTL8651_LL_PPPOE,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
			
	    	/* note: for ip unnumbered case, reference  pppObjId=0 only
	    	 *       ppp obj id equal to session number (0,1,2,3,...)
	    	 */
	    	for (i=0;i<MAX_PPPOE_SESSION;i++){
			rtl8651_addPppoeSession(i,pRomeCfgParam->vlanCfgParam[0].vid);
			if (pRomeCfgParam->pppoeCfgParam[i].defaultSession==1){
				ret=rtl8651_setPppoeDefaultDialSessionId(i);
				if (ret)
					printf("rtl8651_setPppoeDefaultDialSessionId: ret %d\n",ret);
				else
					printf("rtl8651_setPppoeDefaultDialSessionId(%d): ret %d\n",i,ret);
			}
			if(pRomeCfgParam->pppoeCfgParam[i].lanType==PPPOECFGPARAM_LANTYPE_UNNUMBERED)
				pppObjId=i;
		}

		/*make this network interface  for NAPT*/
		//rtl8651_addExtNetworkInterface(int8 * ifName);
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);

		/* assign the pre-assigned global ip to gw */
		#if 1
		if(pRomeCfgParam->pppoeCfgParam[pppObjId].lanType==PPPOECFGPARAM_LANTYPE_UNNUMBERED)
		{		
			ipaddr_t ipStub=0x0b010101,ipMaskStub=0xfffffffd;
			//memcpy(pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpAddr,&ipStub,4);
			//memcpy(pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpMask,&ipMaskStub,4);
			memcpy((void*)&ipStub,pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpAddr,4);
			memcpy((void*)&ipMaskStub,pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpMask,4);
			//printf("rtl8651_addIpIntf(eth1): ip(0x%x) ipMask(0x%0x)\n",ipStub,ipMaskStub);
			ret=rtl8651_addIpIntf("eth1",(ipaddr_t)ipStub,(ipaddr_t)ipMaskStub);
			if (ret)
			{
				printf("rtl8651_addIpIntf: ret %d\n",ret);
			}
			/* initialize user protocol stack: set inside
			 * global ip address to LAN
			 * uClinux "ifconfig" command:
			 *    add alias:ifconfig eth1:1 10.1.1.2 netmask 255.255.255.0
			 *    del alias:ifconfig eth1:1 0.0.0.0		 
			 */
			{
				int 	ipValue;
				char	*av[5];
				
				char	pname[]="/bin/ifconfig";
				//static char ip_string[MAX_IP_STRING_LEN];
				//static char ipmask_string[MAX_IP_STRING_LEN];
				char	*ip_string;
				char	*ipmask_string;
				ip_string     = malloc(MAX_IP_STRING_LEN);
				ipmask_string = malloc(MAX_IP_STRING_LEN);
				ipValue=(int)ipStub;
				sprintf(ip_string,"%u.%u.%u.%u",(ipValue>>24)&0xff, (ipValue>>16)&0xff, (ipValue>>8)&0xff, ipValue&0xff);
				ipValue=(int)ipMaskStub;
				sprintf(ipmask_string,"%u.%u.%u.%u",(ipValue>>24)&0xff, (ipValue>>16)&0xff, (ipValue>>8)&0xff, ipValue&0xff);
				
				av[0]=pname;
				av[1]="eth1:1";
				av[2]=ip_string;
				av[3]="netmask";
				av[4]=ipmask_string;
				av[5]=NULL;
				runProgram(pname,av);
				free(ip_string);
				free(ipmask_string);
			}			
		}		
		#endif


		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
		}		

		for (i=0;i<MAX_PPPOE_SESSION;i++)
		{
			/* orlando remark 2003/10/16:
			 * only dial default session upon boot
			 * user has to manual dial additional sessions
			 */
			pRomeCfgParam->pppoeCfgParam[i].dialState=0;			 
			if (pRomeCfgParam->pppoeCfgParam[i].defaultSession == 1)
			{
				pppd_start(i); // start pppd on pppObjId x
			}
		}		
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE */
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED)
	{
		ipaddr_t ipStub;
		ipaddr_t ipMaskStub;
		//printf("cfg wan to unnumbered PPPoE ...\n");

		/* linux if up */
		upInterface("eth0");

		rtl8651_addNetworkIntf("eth0");
    	//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    	rtl8651_enableNaptAutoAdd(0);

		ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",RTL8651_LL_PPPOE,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
		
	    	/* note: for ip unnumbered case, reference  pppObjId=0 only
	    	 *       ppp obj id equal to session number (0,1,2,3,...)
	    	 */
	    	for (i=0;i<1;i++)
			rtl8651_addPppoeSession(i,pRomeCfgParam->vlanCfgParam[0].vid);
		
		

		/* make this network interface for napt */
		//rtl8651_addExtNetworkInterface(int8 * ifName);
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);

		/* assumption: ifCfgParam[0] is for wan interface */
		memcpy((void*)&ipMaskStub,pRomeCfgParam->pppoeCfgParam[0].unnumberedIpMask,4);
		ret=rtl8651_addIpUnnumbered("eth0","eth1", (ipaddr_t)ipMaskStub);
		if (ret)
			printf("rtl8651_addIpUnnumbered: ret %d\n",ret);		

		/* assign the pre-assigned global ip to gw */
		#if 1
		memcpy((void*)&ipStub,pRomeCfgParam->pppoeCfgParam[0].unnumberedIpAddr,4);
		//printf("rtl8651_addIpIntf(eth1): ip(0x%x) ipMask(0x%0x)\n",ipStub,ipMaskStub);
		ret=rtl8651_addIpIntf("eth1",(ipaddr_t)ipStub,(ipaddr_t)ipMaskStub);
		if (ret)
		{
			printf("rtl8651_addIpIntf: ret %d\n",ret);
		}
		#endif
		
		/* initialize user protocol stack: set inside
		 * global ip address to LAN
		 * uClinux "ifconfig" command:
		 *    add alias:ifconfig eth1:1 10.1.1.2 netmask 255.255.255.0
		 *    del alias:ifconfig eth1:1 0.0.0.0		 
		 */
		{
			int 	ipValue;
			char	*av[5];
			char	*ip_string;
			char	*ipmask_string;
			char	pname[]="/bin/ifconfig";

			ip_string     = malloc(MAX_IP_STRING_LEN);
			ipmask_string = malloc(MAX_IP_STRING_LEN);
			ipValue=(int)ipStub;
			sprintf(ip_string,"%u.%u.%u.%u",(ipValue>>24)&0xff, (ipValue>>16)&0xff, (ipValue>>8)&0xff, ipValue&0xff);
			ipValue=(int)ipMaskStub;
			sprintf(ipmask_string,"%u.%u.%u.%u",(ipValue>>24)&0xff, (ipValue>>16)&0xff, (ipValue>>8)&0xff, ipValue&0xff);
			
			av[0]=pname;
			av[1]="eth1:1";
			av[2]=ip_string;
			av[3]="netmask";
			av[4]=ipmask_string;
			av[5]=NULL;
			runProgram(pname,av);
			free(ip_string);
			free(ipmask_string);
		}


		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
		}
		
		#if 1
		pppd_start(0); // start pppd on pppObjId x
		#else
		for (i=0;i<MAX_PPPOE_SESSION;i++)
		//for (i=0;i<1;i++)
		{
			char identity[4];
			char papStr[20];
			char pppOptionStr[20];

			#if 0
			/* pppoeCfgParam[].enable only used for multiple pppoe */
			if (pRomeCfgParam->pppoeCfgParam[i].enable==0)
			{
				printf("pppoe session #%u disabled ... \n", i);
				continue;
			}
			else
				printf("pppoe session #%u enabled ... \n",i);
			#endif
						
			tmp = malloc(160);
			f1 = fopen("/etc/ppp.options","r");
			
			sprintf(papStr,"/var/ppp/pap%u",i);
			f2 = fopen(papStr,"w+");
			sprintf(tmp,"%s * %s" ,pRomeCfgParam->pppoeCfgParam[i].username,pRomeCfgParam->pppoeCfgParam[i].password);
			fputs(tmp,f2);
			fclose(f2);

			sprintf(pppOptionStr,"/var/ppp/options%u",i);
			f2 = fopen(pppOptionStr,"w+");
			while (!feof(f1))
			{
				fgets(tmp,160,f1);
				if (!memcmp(tmp,"user",4))
					sprintf(tmp,"user %s\n",pRomeCfgParam->pppoeCfgParam[i].username);
				fputs(tmp,f2);
			}
			
			/* put requested ip in the option file
			 * option format: <local IP address>:<remote IP address>
			 */
			fprintf(f2,"%u.%u.%u.%u:0.0.0.0\n",
				pRomeCfgParam->pppoeCfgParam[i].unnumberedIpAddr[0],
				pRomeCfgParam->pppoeCfgParam[i].unnumberedIpAddr[1],
				pRomeCfgParam->pppoeCfgParam[i].unnumberedIpAddr[2],
				pRomeCfgParam->pppoeCfgParam[i].unnumberedIpAddr[3]);
			
			fclose(f1);
			fclose(f2);
			free(tmp);
			pRomeCfgParam->pppoeCfgParam[i].dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;
			sprintf(identity,"%u",i);
			//do_exec("/bin/pppd",identity);
		} /* end for i */
		#endif
	} /* ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED */


#ifdef CONFIG_RTL865XB_3G
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_3G) 
	{
		re865xIoctl("ppp0",ADD_IF,0,0,0);
		rtl8651_setMtu(1500);	
		
		upInterface("eth0");
		ret=rtl8651_addNetworkIntf("eth0");
		if (ret)	printf("rtl8651_addNetworkIntf: ret %d\n",ret);		
		ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_VLAN,CONFIG_RTL865XB_3G_VLAN);
		if (ret)	printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
		rtl8651_enableNaptAutoAdd(0);
		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)	printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);
		
		system("/bin/pppd-3g call gprs &");
	}


#endif
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPTP) 
	{
		uint32 netmask=0, def_gw_ipAddr = 0;		
		uint8 strBuffer[128];
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[0])<<24;
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[1])<<16;
		netmask|=(pRomeCfgParam->pptpCfgParam.ipMask[2])<<8;
		netmask|=pRomeCfgParam->pptpCfgParam.ipMask[3];
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[3]);
		
		//printf("cfg wan to pptp ...\n");	

		//specifyNetworkIntfLinkLayerType
		//re865xIoctl("eth0",SET_VLAN_TYPE,LL_PPTP,0,0); //for PPPoE only
		rtl8651_addNetworkIntf("eth0");	
		//rtl8651_setNetMtu("eth0",pRomeCfgParam->pptpCfgParam.mtu);	//must call after addNetworkIntf ,2004/6/17
		rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_PPTP, pRomeCfgParam->vlanCfgParam[0].vid);

		/* linux if up */
		upInterface("eth0");
			
    	//rtl8651_setAsicNaptAutoAddDelete(FALSE, 1);
    	rtl8651_enableNaptAutoAdd(0);

		//add ip interface
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->pptpCfgParam.ipMask)),0);		
		#if 0 
		ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",RTL8651_LL_PPTP,pRomeCfgParam->vlanCfgParam[0].vid);
		if (ret)
			printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
		#endif

		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);
	
		sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
			pRomeCfgParam->pptpCfgParam.ipAddr[0],
			pRomeCfgParam->pptpCfgParam.ipAddr[1],
			pRomeCfgParam->pptpCfgParam.ipAddr[2],
			pRomeCfgParam->pptpCfgParam.ipAddr[3],
			pRomeCfgParam->pptpCfgParam.ipMask[0],
			pRomeCfgParam->pptpCfgParam.ipMask[1],
			pRomeCfgParam->pptpCfgParam.ipMask[2],
			pRomeCfgParam->pptpCfgParam.ipMask[3]);

		system(strBuffer);

		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->pptpCfgParam.gwAddr[0],
				pRomeCfgParam->pptpCfgParam.gwAddr[1],
				pRomeCfgParam->pptpCfgParam.gwAddr[2],
				pRomeCfgParam->pptpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_ADD, 0, argv);
		}
		/* ====================================== */

		ret=rtl8651_addSession(RTL8651_PPTP, 1, "eth0", pRomeCfgParam->vlanCfgParam[0].vid); 
		if (ret)
		{
			printf("rtl8651_addSession: ret %d\n",ret);
		}
		
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
		}

		pptp_start(0);				
		
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPTP */	
	
else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_L2TP) 
	{
		uint32 netmask=0, def_gw_ipAddr = 0;		
		uint8 strBuffer[128];

		netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[0])<<24;
		netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[1])<<16;
		netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[2])<<8;
		netmask|=pRomeCfgParam->l2tpCfgParam.ipMask[3];
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[3]);
		
		//printf("cfg wan to l2tp ...\n");

#if 1 //l2tp by MII lookback path
		rtl8651_addNetworkIntf("eth0");	
		//rtl8651_setNetMtu("eth0",pRomeCfgParam->l2tpCfgParam.mtu);	//must call after addNetworkIntf ,2004/6/17
		rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_L2TP, pRomeCfgParam->vlanCfgParam[0].vid);

		//rtl8651_addIpIntf
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)),0);
#else // pure software path	
		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);
		re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),netmask,0);
		setInterfaceIp("eth0",*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),netmask);
#endif		

		/* linux if up */
		upInterface("eth0");
				
    	rtl8651_enableNaptAutoAdd(0);

		ret=rtl8651_addExtNetworkInterface((int8*)"eth0");
		if (ret)
			printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);    	

		sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
			pRomeCfgParam->l2tpCfgParam.ipAddr[0],
			pRomeCfgParam->l2tpCfgParam.ipAddr[1],
			pRomeCfgParam->l2tpCfgParam.ipAddr[2],
			pRomeCfgParam->l2tpCfgParam.ipAddr[3],			
			pRomeCfgParam->l2tpCfgParam.ipMask[0],
			pRomeCfgParam->l2tpCfgParam.ipMask[1],
			pRomeCfgParam->l2tpCfgParam.ipMask[2],
			pRomeCfgParam->l2tpCfgParam.ipMask[3]);
		
		system(strBuffer);

		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->l2tpCfgParam.gwAddr[0],
				pRomeCfgParam->l2tpCfgParam.gwAddr[1],
				pRomeCfgParam->l2tpCfgParam.gwAddr[2],
				pRomeCfgParam->l2tpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_ADD, 0, argv);
		}
		/* ====================================== */

		ret=rtl8651_addSession(RTL8651_L2TP, 1, "eth0", pRomeCfgParam->vlanCfgParam[0].vid); 
		if (ret)
		{
			printf("rtl8651_addSession: ret %d\n",ret);
		}
		
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
		}
		
		l2tp_start(0);
		
	} /* end ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_L2TP */
	else if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPL2TP) {

		printf("cfg: DHCP+L2TP Wan Type ...\n");
		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;


				
		/* clear ifCfgParam[0].ipAddr[] etc, dhcp client will fill these values later */
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].ipMask,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].gwAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,0,4);
		memset((void*)pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,0,4);

		setInterfaceIp("eth0",0,0);		
//		re865xIoctl("eth0",SET_VLAN_TYPE,LL_VLAN,0,0);	
//		rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_L2TP, pRomeCfgParam->vlanCfgParam[0].vid);
			
   		rtl8651_enableNaptAutoAdd(0);    		
		
		udhcpc_start();
	}
	
#endif // CONFIG_RTL865X(B)_PPTPL2TP

	// set default Upstream of IGMP system
	rtl8651_multicastSetUpStream("eth0", 0);

	/* try to update relative interfaces */
	rtk_linux_intf_upDown("rtl", TRUE, "promisc");

	return 0;
} /* end wanlan_init */


/*
 * Routine Name: staticroute_init
 * Description: configure route
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 staticroute_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ROUTE,(void*)pRomeCfgParam->routeCfgParam, sizeof(pRomeCfgParam->routeCfgParam))!=0)
	{
		printf("route_init: call cfgmgr_read fail\n");		
		/* take proper actions */
		return NOT_OK;
	}

	/* configure interface address and route */
	{
		routeCfgParam_t *pRouteCfg;
		int8 ifName[RTL8651_IPINTF_NAME_LEN];
		uint32 i=0;

		i=0;

		for(pRouteCfg=&(pRomeCfgParam->routeCfgParam[i]); (pRouteCfg->valid == 1)&&(i<MAX_ROUTE); )
		{
			char gateway_str[18]={0};
			char route_str[18]={0};
			
			sprintf(ifName, "vl%d", pRouteCfg->if_unit);
			{
				sprintf(gateway_str,"%u.%u.%u.%u",pRouteCfg->ipGateway[0],pRouteCfg->ipGateway[1],pRouteCfg->ipGateway[2],pRouteCfg->ipGateway[3]);
				sprintf(route_str,"%u.%u.%u.%u",pRouteCfg->ipAddr[0] & pRouteCfg->ipMask[0],
												pRouteCfg->ipAddr[1] & pRouteCfg->ipMask[1],
												pRouteCfg->ipAddr[2] & pRouteCfg->ipMask[2],
												pRouteCfg->ipAddr[3] & pRouteCfg->ipMask[3]);
			}
			if (pRomeCfgParam->natCfgParam.hwaccel) {
				#if 0
				ret=rtl8651_addRoute(*((ipaddr_t *)(pRouteCfg->ipAddr)), *((ipaddr_t *)(pRouteCfg->ipMask)), ifName, *((ipaddr_t *)(pRouteCfg->ipGateway)));
				if(ret!=SUCCESS)
					printf("staticroute_init: rtl8651_addRoute failed ret:%d\n",ret);
				else
					printf("staticroute_init: rtl8651_addRoute(%s) ok\n",route_str);
				#endif
			}
			i++;
			pRouteCfg = &pRomeCfgParam->routeCfgParam[i];
		} /* end for */
	}
	return OK;
} /* end staticroute_init */

/*
 * Routine Name: arp_init
 * Description: configure static arp entries
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 arp_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ARP,(void*)pRomeCfgParam->arpCfgParam, sizeof(pRomeCfgParam->arpCfgParam))!=0)
	{
		printf("arp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if (pRomeCfgParam->natCfgParam.hwaccel)	/* configure static arp entries */
	{
		struct arpCfgParam_s *pArpCfg;
		int8 ifName[RTL8651_IPINTF_NAME_LEN];
		uint32 i=0;
		
		for(pArpCfg = &(pRomeCfgParam->arpCfgParam[i]); (pArpCfg->valid==1)&&(i<MAX_STATIC_ARP); ){
			sprintf(ifName, "vl%d", pArpCfg->if_unit);			
			//rtl8651_addArp(inet_addr(pArpCfg->ipAddr), &(pArpCfg->mac), ifName, pArpCfg->port);
			//rtl8651_addArp(*(ipaddr_t*)pArpCfg->ipAddr, &(pArpCfg->mac), ifName, pArpCfg->port);
			i++;
			pArpCfg = &(pRomeCfgParam->arpCfgParam[i]);
		}
	}

	return 0;	
} /* end arp_init */

/*
 * Routine Name: nat_init
 * Description: configure nat cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 nat_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_NAT,(void*)&(pRomeCfgParam->natCfgParam), sizeof(pRomeCfgParam->natCfgParam))!=0)
	{
		printf("nat_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;	
} /* end nat_init */
/* userDb_init()
*/

uint32 userDb_init(void)
{
	if (cfgmgr_read(CFGMGR_TABID_MGMT,(void*)&(pRomeCfgParam->mgmtCfgParam), sizeof(struct mgmtCfgParam_s)*MAX_MGMT_USER)!=0)
	{
		printf("userDb_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;	


}

/*
 * Routine Name: pppoe_init
 * Description: configure pppoe cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
#if 0
/* obsolete by wan flat init in sysInit 2003/09/24 */
uint32 pppoe_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam, sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION)!=0)
	{
		printf("pppoe_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	memcpy((void*)ramPppoeCfgParam,(void*)pRomeCfgParam->pppoeCfgParam,sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION));
	
	
	return 0;	
} /* end pppoe_init */
#endif

void dhcps_start(void)
{
	FILE *f1,*f2;
	unsigned char tmp[240];
	int32 i;

	if (pRomeCfgParam->dhcpsCfgParam.enable == 0)
	{
		do_kill("/var/run/udhcpd.pid");
		return;
	}

	/* Don't need sleep because running dns proxy/cache */
	f1 = fopen("/etc/udhcpd.conf","r");
	if (!f1)
	{
		printf("fopen /etc/udhcpd.conf failed\n");
		while(1);
	}

	f2 = fopen("/var/udhcpd.conf","w+");
	if (!f2)
	{
		printf("fopen /var/udhcpd.conf failed\n");
		while(1);
	}
	
	while (!feof(f1))
	{
		fgets(tmp,240,f1);
		if (!memcmp(tmp,"startip",7))
			sprintf(tmp,"start	%u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[1].ipAddr[0],
				pRomeCfgParam->ifCfgParam[1].ipAddr[1],
				pRomeCfgParam->ifCfgParam[1].ipAddr[2],
				pRomeCfgParam->dhcpsCfgParam.startIp);
					
		if (!memcmp(tmp,"endip",5))
			sprintf(tmp,"end	%u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[1].ipAddr[0],
				pRomeCfgParam->ifCfgParam[1].ipAddr[1],
				pRomeCfgParam->ifCfgParam[1].ipAddr[2],
				pRomeCfgParam->dhcpsCfgParam.endIp);
					
		if (!memcmp(tmp,"dnsip",5))
		{
			if (pRomeCfgParam->dhcpsCfgParam.realDNSenable)
			{	/* provide real DNS server */
				ipaddr_t dnsServer[2] = {0};
				dnsServer[0] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]) << 24) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]) << 16) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]) << 8) +
								(uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

				dnsServer[1] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]) << 24) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]) << 16) +
								((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]) << 8) +
								(uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);

				if ((dnsServer[0] == 0) && (dnsServer[1] == 0))
				{	/* no DNS server assigned, use gateway as the default DNS server */
					goto GWIsDNS;
				}
				if (dnsServer[0] && dnsServer[1])
				{	/* both primary and secondary DNS servers are OK */
					sprintf(tmp, "opt dns %u.%u.%u.%u\nopt dns %u.%u.%u.%u\n",
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);
				} else if (dnsServer[0])
				{	/* only primary DNS server is OK */
					sprintf(tmp, "opt dns %u.%u.%u.%u\n",
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);
				} else
				{	/* only secondary DNS server is OK */
					sprintf(tmp, "opt dns %u.%u.%u.%u\n",
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2],
						pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);
				}

			}else
			{	/* provide gateway as the default DNS server */
	GWIsDNS:
				sprintf(tmp,"opt dns  %u.%u.%u.%u\n",
					pRomeCfgParam->ifCfgParam[1].ipAddr[0],
					pRomeCfgParam->ifCfgParam[1].ipAddr[1],
					pRomeCfgParam->ifCfgParam[1].ipAddr[2],
					pRomeCfgParam->ifCfgParam[1].ipAddr[3]);
			}
		}

		if (!memcmp(tmp,"routerip",8))
			sprintf(tmp,"opt router  %u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[1].ipAddr[0],
				pRomeCfgParam->ifCfgParam[1].ipAddr[1],
				pRomeCfgParam->ifCfgParam[1].ipAddr[2],
				pRomeCfgParam->ifCfgParam[1].ipAddr[3]);

		if (!memcmp(tmp, "domain", 6))
		{
			tmp[0] = '\0';
			if (pRomeCfgParam->dhcpsCfgParam.domain[0] != '\0')
			{
				snprintf(tmp, sizeof(tmp), "opt domain %s\n", pRomeCfgParam->dhcpsCfgParam.domain);
			}
		}

		if (!memcmp(tmp, "winsip", 6))
		{
			uint8 winsAddr[20];
			uint8 winsAddr2[20];

			snprintf(winsAddr, sizeof(winsAddr), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)&0x000000ff);

			snprintf(winsAddr2, sizeof(winsAddr2), "%u.%u.%u.%u",
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr) >> 24,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x00ff0000) >> 16,
				((pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x0000ff00) >> 8,
				(pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)&0x000000ff);
	
			tmp[0] = '\0';
			if (pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr && pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)
			{
				sprintf(tmp, "opt wins %s\nopt wins %s\n", winsAddr, winsAddr2);
			}else if (pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)
			{
				sprintf(tmp, "opt wins %s\n", winsAddr);
			}else if (pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)
			{
				sprintf(tmp, "opt wins %s\n", winsAddr2);
			}
		}
		fputs(tmp,f2);
	}

	for(i=0; i<2; i++) {
		sprintf(tmp, "\nmanual %02X:%02X:%02X:%02X:%02X:%02X  %u.%u.%u.%u\n", 
				pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][0], pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][1],
				pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][2], pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][3],
				pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][4], pRomeCfgParam->dhcpsCfgParam.hardwareAddr[i][5],
				pRomeCfgParam->dhcpsCfgParam.manualIp[i]>>24, (pRomeCfgParam->dhcpsCfgParam.manualIp[i]&0x00ff0000)>>16,
				(pRomeCfgParam->dhcpsCfgParam.manualIp[i]&0x0000ff00)>>8, pRomeCfgParam->dhcpsCfgParam.manualIp[i]&0xff);
		fputs(tmp,f2);
	}
#if 0
	f1 = fopen("/var/resolv.conf","r");
	if (f1)
	{
		while ((!feof(f1))) 
		{
			memset(tmp,0,160);
			fgets(tmp,160,f1);
			/*for (i=0;i<160;i++)
			{
				if (memcmp(*tmp," ",1))
					tmp++;
				if (*tmp==0)break;
			}*/
			cp = strchr(tmp,' ');
			if (cp)
			fprintf(f2,"opt dns %s\n",cp);
		}
	}
#endif
	fclose(f2);

	/* kill old udhcpd if it exists */
	/* backup lease info */
	send_signal("/var/run/udhcpd.pid", SIGUSR1);
	sleep(1);
	do_kill("/var/run/udhcpd.pid");
	do_exec("/bin/udhcpd", NULL);
	sleep(1);
}

/*
 * Routine Name: dhcps_init
 * Description: configure dhcps cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dhcps_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DHCPS,(void*)&(pRomeCfgParam->dhcpsCfgParam), sizeof(dhcpsCfgParam_t))!=0)
	{
		printf("dhcps_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	memcpy((void*)&ramDhcpsCfgParam,&(pRomeCfgParam->dhcpsCfgParam),sizeof(dhcpsCfgParam_t));

	if (!((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) ||
		(pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)))
	{	/* other wan type except DHCP: don't forward domain */
		pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd = 0;
	}

	return 0;	
} /* end dhcps_init */

/*
 * Routine Name: dhcpc_init
 * Description: configure dhcpc cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
#if 0
/* obsoleted by flat wan init in sysInit 2003/09/24 orlando */
uint32 dhcpc_init(void)
{	
	/* read cfg from cfgmgr
	 */
	if (cfgmgr_read(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam), sizeof(dhcpcCfgParam_t))!=0)
	{
		printf("dhcpc_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
	memcpy((void*)&(ramDhcpcCfgParam),(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(dhcpcCfgParam_t));
	
	return 0;	
} /* end dhcpc_init */
#endif

/*
 * Routine Name: dns_init
 * Description: create /var/resolv.conf based on xxxCfgParam[].dnsPrimaryAddr
 *              this file is to be referenced by nameserver
 *              note that dhcpc and pppd will overwrite this file upon ip-up.
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dns_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DNS,(void*)&(pRomeCfgParam->dnsCfgParam), sizeof(pRomeCfgParam->dnsCfgParam))!=0)
	{
		printf("dns_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
	/* PPPoE has to have a callback mechanism when ppp state reaches "NETWORK"
	   reflect the new dns given by pppoe service provider
	   current implementation try to init it during bootup to wan's static dns.
	   it's easier for demonstraton purpose. but need to change it when
	   the callback mechanism is ready!! orlando 2003/06/26
	 */
	if ( (pRomeCfgParam->dnsCfgParam.enable == 1)
	     && 
	     (   pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_STATIC
	      || pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE
	      || pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE
	      || pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED	      
	      || pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC
	     )
	   )
	{
		char primary[16]={0};
		FILE *f;
		sprintf(primary,"%d.%d.%d.%d",pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
									  pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3] );
		//printf("dns_init: starting dns proxy at %s ...\n",primary);
		
		// set resolv.conf
		f=fopen("/var/resolv.conf","w+");
		fprintf(f,"nameserver %s\n",primary);
		fclose(f);
	}

	return 0;	
} /* end dns_init */

void acl_tableDriverSingleHandle(int action,int j,int i)	
{
	// j: dial session , i: index of acl rule
	int8 ifStr[20];
	int8 ifWanStr[20];
	int8 ifLanStr[20];
	int ret;

	memset(ifStr,0,20);	
	sprintf(ifStr,"eth0");
	memset(ifWanStr,0,20);	
	sprintf(ifWanStr,"eth0");
	memset(ifLanStr,0,20);	
	sprintf(ifLanStr,"eth1");		
	
	memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));

	/* prepare acl rule data structure */
	if (   (pRomeCfgParam->aclCfgParam[j][i].direction == ACLCFGPARAM_DIRECTION_INGRESS_DEST)
	    || (pRomeCfgParam->aclCfgParam[j][i].direction == ACLCFGPARAM_DIRECTION_EGRESS_DEST )
	   )
	{			
		memcpy(&(tempAclRule.dstIpAddr_),pRomeCfgParam->aclCfgParam[j][i].ip,4);
		if (   pRomeCfgParam->aclCfgParam[j][i].ip[0]==0
	    	&& pRomeCfgParam->aclCfgParam[j][i].ip[1]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[2]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[3]==0)
			tempAclRule.dstIpAddrMask_=0;
		else
			tempAclRule.dstIpAddrMask_=0xffffffff;
	}
	else
	{
		memcpy(&(tempAclRule.srcIpAddr_),pRomeCfgParam->aclCfgParam[j][i].ip,4);
		if (   pRomeCfgParam->aclCfgParam[j][i].ip[0]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[1]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[2]==0
		    && pRomeCfgParam->aclCfgParam[j][i].ip[3]==0)
			tempAclRule.srcIpAddrMask_=0;
		else
			tempAclRule.srcIpAddrMask_=0xffffffff;
	}
	
	tempAclRule.tos_=0;
	tempAclRule.tosMask_=0;

	tempAclRule.ipFlag_=0;
	tempAclRule.ipMF_=0;
	tempAclRule.ipDF_=0;
	//tempAclRule.ipRSV_=0;
		
	if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_TCP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_TCP;
		tempAclRule.tcpFlagMask_=0;
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.tcpDstPortLB_=0;
				tempAclRule.tcpDstPortUB_=0xffff;
			}else{
				tempAclRule.tcpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.tcpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;
		}
		else
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.tcpSrcPortLB_=0;
				tempAclRule.tcpSrcPortUB_=0xffff;
			}else{
				tempAclRule.tcpSrcPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.tcpSrcPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.tcpDstPortLB_=0;
			tempAclRule.tcpDstPortUB_=0xffff;
		}
		tempAclRule.tcpFlag_=0;
		tempAclRule.tcpURG_=0;
		tempAclRule.tcpACK_=0;
		tempAclRule.tcpPSH_=0;
		tempAclRule.tcpRST_=0;
		tempAclRule.tcpSYN_=0;
		tempAclRule.tcpFIN_=0;
	}
	else if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_UDP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.udpDstPortLB_=0;
				tempAclRule.udpDstPortUB_=0xffff;
			}else{
				tempAclRule.udpDstPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpDstPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.udpSrcPortLB_=0;
			tempAclRule.udpSrcPortUB_=0xffff;
		}
		else
		{
			if (pRomeCfgParam->aclCfgParam[j][i].port==0){
				tempAclRule.udpSrcPortLB_=0;
				tempAclRule.udpSrcPortUB_=0xffff;
			}else{
				tempAclRule.udpSrcPortLB_=pRomeCfgParam->aclCfgParam[j][i].port;
				tempAclRule.udpSrcPortUB_=pRomeCfgParam->aclCfgParam[j][i].port;
			}
			tempAclRule.udpDstPortLB_=0;
			tempAclRule.udpDstPortUB_=0xffff;
		}
	}
	else if (pRomeCfgParam->aclCfgParam[j][i].type == ACLCFGPARAM_PROTOCOL_IP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_IP;
		tempAclRule.tcpFlagMask_=0;
#if 0				
		if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		    ||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_EGRESS_DEST )
		   )
		{
		
			tempAclRule.tcpDstPortLB_=0;
			tempAclRule.tcpDstPortUB_=0xffff;				
			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;
		}
		else
		{				
			tempAclRule.tcpSrcPortLB_=0;
			tempAclRule.tcpSrcPortUB_=0xffff;				
			tempAclRule.tcpDstPortLB_=0;
			tempAclRule.tcpDstPortUB_=0xffff;
		}
#endif
		tempAclRule.ipFlag_=0;
		tempAclRule.ipFlagMask_=0;
	}			
			
	if (pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_ALLOWALLBUTACL)
		tempAclRule.actionType_=RTL8651_ACL_DROP;
	else if (pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_DENYALLBUTACL)
		tempAclRule.actionType_=RTL8651_ACL_PERMIT;
	else if(pRomeCfgParam->aclGlobalCfgParam.policy == ACLGLOBALCFGPARAM_ALLOWALLBUTACL_LOG)
		tempAclRule.actionType_=RTL8651_ACL_DROP_LOG;			

	if (  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
		||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC )
	   )
		sprintf(ifStr,ifLanStr);
	else
		sprintf(ifStr,ifWanStr);
	
	if (pRomeCfgParam->natCfgParam.hwaccel==1)
	{

		if(action==ACL_SINGLE_HANDLE_ADD)
		{
			ret = rtl8651a_addAclRule(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			if (ret!=SUCCESS)
			{
				printf("acl_tableDriverAcess: rtl8651a_addAclRule() ret:%d\n",ret);
				pRomeCfgParam->aclCfgParam[j][i].enable=0;
				return NOT_OK;
			}
			else
				printf("acl_tableDriverAcess: rtl8651a_addAclRule(if:%s) ret:%d\n",ifStr,ret);
		}
		else if(action==ACL_SINGLE_HANDLE_DEL)
		{
			ret = rtl8651a_delAclRule(j, ifStr,
								  (pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_DEST)
								||(pRomeCfgParam->aclCfgParam[j][i].direction==ACLCFGPARAM_DIRECTION_INGRESS_SRC ),
								(rtl8651_tblDrvAclRule_t *)&tempAclRule);
			if (ret!=SUCCESS)
			{
				printf("acl_tableDriverAcess: rtl8651a_delAclRule() ret:%d\n",ret);
				pRomeCfgParam->aclCfgParam[j][i].enable=0;
				return NOT_OK;
			}
			else
				printf("acl_tableDriverAcess: rtl8651a_delAclRule(if:%s) ret:%d\n",ifStr,ret);
		}
	}	

}


void parse_and_add_triggerPort(int dsid,int parseLen,char *inRange,uint8 inType,uint8 outType,uint16 outStart,uint16 outFinish,ipaddr_t localIp)
{
	int j;
	char tempStr1[10]={0},tempStr2[10]={0};
	int idx=0,shift=0;

	printf("Range=%s\n",inRange);

	// add trigger port entry to fwdEngine
	for(j=0;j<parseLen;j++)
	{
		if(((inRange[j]>='0')&&(inRange[j]<='9')))
		{
			if(shift>=9) continue;
			if(idx==0)
				tempStr1[shift++]=inRange[j];
			else
				tempStr2[shift++]=inRange[j];
			
		}
		else if((inRange[j]==',')||
				(inRange[j]=='-')||
				(inRange[j]==0))
		{
			if(idx==0)
				tempStr1[shift]=0;
			else
				tempStr2[shift]=0;
		
			shift=0;
			if((inRange[j]==',')||
				(inRange[j]==0))
			{
				uint16 inStart,inFinish;
				inStart=atoi(tempStr1);
				if(idx==0)
					inFinish=inStart;
				else
					inFinish=atoi(tempStr2);
				idx=0;
			
				//make inFinish always bigger than inStart
				if(inStart>inFinish)
				{
					uint16 temp;
					temp=inFinish;
					inFinish=inStart;
					inStart=temp;
				}
				
				if(!((inStart==0)||(inFinish==0)))
				{
					rtl8651a_addTriggerPortRule(
					dsid, //dsid
					inType,inStart,inFinish,
					outType,
					outStart,
					outFinish,localIp);
//					printf("inRange=%d-%d\n inType=%d\n",inStart,inFinish,inType);
				}
			}
			else
			{
				idx++;	
			}
			if(inRange[j]==0)
				break;
		}				
	}
#if 0 //disable trap to cpu , when turn auto-learn off.
	memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
	//trap all IP address
	tempAclRule.dstIpAddrMask_=0;

	if (pRomeCfgParam->specialapCfgParam[i].outType == ACLCFGPARAM_PROTOCOL_TCP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_TCP;

		tempAclRule.tcpDstPortLB_=pRomeCfgParam->specialapCfgParam[i].outStart;
		tempAclRule.tcpDstPortUB_=pRomeCfgParam->specialapCfgParam[i].outFinish;
		tempAclRule.tcpSrcPortLB_=0;
		tempAclRule.tcpSrcPortUB_=0xffff;
		
		tempAclRule.tcpFlagMask_=0;
		tempAclRule.tcpFlag_=0;
		tempAclRule.tcpURG_=0;
		tempAclRule.tcpACK_=0;
		tempAclRule.tcpPSH_=0;
		tempAclRule.tcpRST_=0;
		tempAclRule.tcpSYN_=1;
		tempAclRule.tcpFIN_=0;
	}
	else if (pRomeCfgParam->specialapCfgParam[i].outType == ACLCFGPARAM_PROTOCOL_UDP)
	{
		tempAclRule.ruleType_=RTL8651_ACL_UDP;
		tempAclRule.udpDstPortLB_=pRomeCfgParam->specialapCfgParam[i].outStart;
		tempAclRule.udpDstPortUB_=pRomeCfgParam->specialapCfgParam[i].outFinish;
		tempAclRule.udpSrcPortLB_=0;
		tempAclRule.udpSrcPortUB_=0xffff;	
	}
			
	//trap packets to CPU 
	tempAclRule.actionType_=RTL8651_ACL_CPU;

	if (pRomeCfgParam->natCfgParam.hwaccel==1)
	{
		//add egress rule
		ret = rtl8651a_addAclRule(i,"eth1",TRUE,(rtl8651_tblDrvAclRule_t *)&tempAclRule);
		if (ret!=SUCCESS)
		{
			printf("acl_tableDriverAcess Trigger_Port: rtl8651_addAclRule() ret:%d\n",ret);
			return NOT_OK;
		}
		else
			printf("acl_tableDriverAcess Trigger_Port: rtl8651_addAclRule(if:eth1) ret:%d\n",ret);
	}			
#endif
}



/*
 * Routine Name: acl_tableDriverAccess
 * Description: access table driver acl APIs
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 acl_tableDriverAccess(void)
{
	int32 ret;
	
	int8 ifWanStr[20];
	int8 ifLanStr[20];
	uint32 i,j,k,l;
	uint32 loopUpperBound=0;
	uint32 defActionSet[2] = {0};
	FILE *f;

	memset(ifWanStr,0,20);	
	sprintf(ifWanStr,"eth0");
	memset(ifLanStr,0,20);	
	sprintf(ifLanStr,"eth1");

	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
		loopUpperBound = MAX_PPPOE_SESSION;
	else
		loopUpperBound = 1;
	
	/* flush all wan interface's egress/ingress rule */
	for(i=0;i<loopUpperBound;i++){
		if (pRomeCfgParam->natCfgParam.hwaccel==1)
		{
			ret = rtl8651a_flushAclRule(i,ifWanStr,0);
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifWanStr,ret);
				return NOT_OK;		
			}
		
			ret = rtl8651a_flushAclRule(i,ifWanStr,1);		
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifWanStr,ret);
				return NOT_OK;		
			}

			ret = rtl8651a_flushAclRule(i,ifLanStr,0);
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifLanStr,ret);
				return NOT_OK;		
			}
		
			ret = rtl8651a_flushAclRule(i,ifLanStr,1);		
			if (ret)
			{
				printf("acl_tableDriverAccess: rtl8651_flushAclRule(if:%s) ret:%d\n",ifLanStr,ret);
				return NOT_OK;		
			}
		}
	}
	
	if(pRomeCfgParam->aclGlobalCfgParam.lanPermit==1)
	{
		memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));	
		{
			uint32 tempip,mask;

			memcpy(&tempip,pRomeCfgParam->ifCfgParam[1].ipAddr,4);		
			memcpy(&mask,pRomeCfgParam->ifCfgParam[1].ipMask,4);
			tempip&=mask;
			memcpy(&(tempAclRule.dstIpAddr_),&tempip,4);
			memcpy(&(tempAclRule.dstIpAddrMask_),pRomeCfgParam->ifCfgParam[1].ipMask,4);
		}
		tempAclRule.ruleType_=RTL8651_ACL_IP;
		tempAclRule.actionType_=RTL8651_ACL_PERMIT;
		ret = rtl8651a_addAclRule(0,ifLanStr,1,(rtl8651_tblDrvAclRule_t* )&tempAclRule);		
	}
	
       /*add for Permit Layer2 ACL rule */
	if(pRomeCfgParam->aclGlobalCfgParam.layer2Permit==1)
	{
	   memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));	
	   tempAclRule.ruleType_=RTL8651_ACL_MAC;
	   tempAclRule.actionType_=RTL8651_ACL_PERMIT;
	   tempAclRule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
	   ret = rtl8651a_addAclRule(0,ifLanStr,1,(rtl8651_tblDrvAclRule_t* )&tempAclRule);		
	}
	
	for(i=0;i<loopUpperBound;i++){
		#if 0
		if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS &&
		(!pRomeCfgParam->pppoeCfgParam[i].defaultSession) && pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED)
		#else
		/* bug fix for multiple pppoe's unnumbered case 2004/10/04 */
		if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS &&
		(!pRomeCfgParam->pppoeCfgParam[i].defaultSession)
  		 && (   pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED
		      ||((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
		          &&(pRomeCfgParam->pppoeCfgParam[i].lanType==PPPOECFGPARAM_LANTYPE_UNNUMBERED)))
		)
		#endif
		{
			if(pRomeCfgParam->pppoeCfgParam[i].lanType==PPPOECFGPARAM_LANTYPE_NAPT)
			{
				memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
				tempAclRule.dstIpAddrMask_=0xffffffff;
				memcpy(&(tempAclRule.dstIpAddr_),pRomeCfgParam->pppoeCfgParam[i].ipAddr,4);
				tempAclRule.ruleType_=RTL8651_ACL_IP;
				tempAclRule.actionType_=RTL8651_ACL_CPU;
			}else{
				ipaddr_t mySubnet;
				memset((void*)&tempAclRule,0,sizeof(rtl8651_tblDrvAclRule_t));
				memcpy(&(tempAclRule.dstIpAddrMask_),pRomeCfgParam->pppoeCfgParam[i].unnumberedIpMask,4);
				memcpy(&(tempAclRule.dstIpAddr_),pRomeCfgParam->pppoeCfgParam[i].unnumberedIpAddr,4);
				mySubnet = (tempAclRule.dstIpAddr_ & tempAclRule.dstIpAddrMask_);
				tempAclRule.dstIpAddr_ = mySubnet;
				tempAclRule.ruleType_=RTL8651_ACL_IP;
				tempAclRule.actionType_=RTL8651_ACL_CPU;
			}
			ret = rtl8651a_addAclRule(i,"eth0",1,(rtl8651_tblDrvAclRule_t* )&tempAclRule);
			if (ret !=SUCCESS)
			{
				printf("rtl8651a_addAclRule() ret:%d\n",ret);				
			}
		}
	}


	// flush all trigger port entry in fwdEngine
	rtl8651_flushTriggerPortRules();
			
	// add trigger port	
	for(k=0;k<loopUpperBound;k++)
	{	
		for(i=0;i<MAX_SPECIAL_AP;i++)
		{		
			if((pRomeCfgParam->specialapCfgParam[k][i].outStart!=0)&&(pRomeCfgParam->specialapCfgParam[k][i].enable==1))
			{
				parse_and_add_triggerPort(k,SPECIAL_AP_MAX_IN_RANGE,pRomeCfgParam->specialapCfgParam[k][i].inRange
					,pRomeCfgParam->specialapCfgParam[k][i].inType
					,pRomeCfgParam->specialapCfgParam[k][i].outType
					,pRomeCfgParam->specialapCfgParam[k][i].outStart
					,pRomeCfgParam->specialapCfgParam[k][i].outFinish,0);
			}			
		} //end special_application

		
		// add gaming port 
		for(i=0;i<MAX_GAMING;i++)
		{		
			if((pRomeCfgParam->gamingCfgParam[k][i].ip!=0)&&(pRomeCfgParam->gamingCfgParam[k][i].enable==1))
			{
				if(strlen(pRomeCfgParam->gamingCfgParam[k][i].tcpRange)!=0)
				{
					parse_and_add_triggerPort(k,GAMING_MAX_RANGE,pRomeCfgParam->gamingCfgParam[k][i].tcpRange					
						,0
						,0
						,0
						,0
						,pRomeCfgParam->gamingCfgParam[k][i].ip);
				}

				if(strlen(pRomeCfgParam->gamingCfgParam[k][i].udpRange)!=0)
				{
					parse_and_add_triggerPort(k,GAMING_MAX_RANGE,pRomeCfgParam->gamingCfgParam[k][i].udpRange
						,1
						,0
						,0
						,0
						,pRomeCfgParam->gamingCfgParam[k][i].ip);
				}				
			}			
		} //end special_application
		
	}
	


	/* set default permit rule
	 * the next loop ensures that rtl8651_setDefaultAcl() is called
	 * once and only once.
	 */

	for ( i = 0 ; i < loopUpperBound; i ++ )
	{
		if (pRomeCfgParam->natCfgParam.hwaccel == 1)
		{
			int8 defAction;

			switch (pRomeCfgParam->aclGlobalCfgParam.policy)
			{
				case ACLGLOBALCFGPARAM_DENYALLBUTACL:
					defAction = RTL8651_ACL_DROP;
					break;
				case ACLGLOBALCFGPARAM_L34_DENYALLBUTACL:	/* default-deny all L34 packet, bu L2 is permitted */
					defAction = RTL8651_ACL_L34_DROP;
					break;
				case ACLGLOBALCFGPARAM_ALLOWALLBUTACL:
					defAction = RTL8651_ACL_PERMIT;
					break;
				case ACLGLOBALCFGPARAM_ALLOWALLBUTACL_LOG:
					defAction = RTL8651_ACL_PERMIT;
					break;
				default:
					printf("[%s] Unknown default policy: %d, set default permit\n", __FUNCTION__, pRomeCfgParam->aclGlobalCfgParam.policy);
					defAction = RTL8651_ACL_PERMIT;
			}

			{
				char* intf[2] = {"eth0", "eth1"};
				const int intfCnt = 2;

				for ( j = 0 ; j < intfCnt ; j ++ )
				{
					if (defActionSet[j] == 1)
					{	/* default ACL action of this interface has been set */
						continue;
					}
					ret = rtl8651a_setDefaultAcl(i , intf[j], defAction);
					if ( ret == 0 )	/* 0: SUCCESS */
					{
						defActionSet[j] = 1;
					} else
					{
						printf("%s: set default ACL(%s) to the action [%d] FAILED, return value: %d\n", __FUNCTION__, intf[j], defAction, ret);
					}
				}
			}
		}
	}
	
	/* scan aclCfgParam[] to set rule to asic one by one */
	f=fopen("/var/acl.cron","w");	
	
	for (j=0;j<loopUpperBound;j++){
		for (i=0; i<MAX_ACL; i++){	
			clock_t t;
			struct tm *gm;
			time(&t);	
			
			if (pRomeCfgParam->aclCfgParam[j][i].enable != 1)
				continue;
			
			gm=localtime(&t);
			//printf("gm->tm_wday=%d hour=%d min=%d\n",gm->tm_wday,gm->tm_hour,gm->tm_min);

			//create acl crontab file
			if(pRomeCfgParam->aclCfgParam[j][i].day!=0)			
			{
				int first=1;
				fprintf(f,"%d %d * * ",pRomeCfgParam->aclCfgParam[j][i].start_minute,pRomeCfgParam->aclCfgParam[j][i].start_hour);
				for(l=0,k=1;l<7;l++,k<<=1)
				{					
					if(pRomeCfgParam->aclCfgParam[j][i].day&k) 
					{
						if(first!=1) fprintf(f,",");
						fprintf(f,"%d",l);
						first=0;
					}
				}
				fprintf(f," /bin/boa addacl %d %d\n",j,i);

				first=1;
				fprintf(f,"%d %d * * ",pRomeCfgParam->aclCfgParam[j][i].end_minute,pRomeCfgParam->aclCfgParam[j][i].end_hour);
				for(l=0,k=1;l<7;l++,k<<=1)
				{
					if(pRomeCfgParam->aclCfgParam[j][i].day&k) 
					{
						if(first!=1) fprintf(f,",");					
						fprintf(f,"%d",l);
						first=0;
					}
				}
				
				fprintf(f," /bin/boa delacl %d %d\n",j,i);
				
			}

			//check day
			if(((pRomeCfgParam->aclCfgParam[j][i].day)&(1<<(gm->tm_wday)))==0) continue; // not today

			//check time
			if(
				((gm->tm_hour*60+gm->tm_min)<
				((uint32)(pRomeCfgParam->aclCfgParam[j][i].start_hour)*60+pRomeCfgParam->aclCfgParam[j][i].start_minute)) ||
				((gm->tm_hour*60+gm->tm_min)>
				((uint32)(pRomeCfgParam->aclCfgParam[j][i].end_hour)*60+pRomeCfgParam->aclCfgParam[j][i].end_minute))
			  ) continue;  // time not in the schedule
		
			acl_tableDriverSingleHandle(ACL_SINGLE_HANDLE_ADD,j,i);
		
		} /* end for i */
	} /* end for j */
	fclose(f);

	//run the crond
	{
		char tempStr[32];		
		sprintf(tempStr,"/bin/crontab /var/acl.cron");
		system(tempStr);
		f=fopen("/var/run/crond.pid","r");
		if(f==NULL)		
		{
			sprintf(tempStr,"/bin/crond -f &");
			system(tempStr);
			printf("run crond\n");
		}
		else
		{
			fclose(f);
			send_signal("/var/run/crond.pid",SIGHUP);
		}
	}
	
	return OK;
} /* end acl_tableDriverAccess */


/*
 * Routine Name: acl_init
 * Description: configure acl cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 acl_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_ACL_GLOBAL,(void*)&(pRomeCfgParam->aclGlobalCfgParam), sizeof(pRomeCfgParam->aclGlobalCfgParam))!=0)
	{
		printf("acl_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ACL,(void*)pRomeCfgParam->aclCfgParam, sizeof(struct aclCfgParam_s)*MAX_ACL*MAX_PPPOE_SESSION)!=0)
	{
		printf("acl_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
		
	return OK;	
} /* end acl_init */

#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)

uint32 pptp_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_PPTP,(void*)&(pRomeCfgParam->pptpCfgParam), sizeof(struct pptpCfgParam_s))!=0)
	{
		printf("pptp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	
	return OK;	
} /* end pptp_init */

uint32 l2tp_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_L2TP,(void*)&(pRomeCfgParam->l2tpCfgParam), sizeof(struct l2tpCfgParam_s))!=0)
	{
		printf("l2tp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}	
	return OK;	
} /* end l2tp_init */

uint32 pptpserver_init(void)
{	
	if (cfgmgr_read(CFGMGR_TABID_PPTPSERVER,(void*)&(pRomeCfgParam->pptpServerCfgParam), sizeof(struct pptpServerCfgParam_s))!=0)
	{
		printf("pptpserver_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
#ifdef CONFIG_RTL865XB_PPTPSERVER
	pptpServer_start();
#endif
	
	return OK;	
} /* end pptp_init */

#endif //CONFIG_RTL865X(B)_PPTPL2TP

uint32 domainBlock_init(void)
{
	int idx;

	if (cfgmgr_read(	CFGMGR_TABID_DOMAINBLOCK,
					(void*)&(pRomeCfgParam->domainBlockCfgParam),
					sizeof(domainBlockCfgParam_t) * MAX_DOMAIN_BLOCKING) != 0 )
	{
		printf("domainBlock_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}

	rtl8651_flushDomainBlockingEntry();

	for ( idx = 0 ; idx < MAX_DOMAIN_BLOCKING ; idx ++ )
	{
		if (pRomeCfgParam->domainBlockCfgParam[idx].enable == TRUE)
		{
			if (rtl8651_addDomainBlockingEntry(	pRomeCfgParam->domainBlockCfgParam[idx].domain,
												pRomeCfgParam->domainBlockCfgParam[idx].sip,
												pRomeCfgParam->domainBlockCfgParam[idx].smask) != SUCCESS)
			{
				printf("Enable Add failed\n");
				pRomeCfgParam->domainBlockCfgParam[idx].enable = FALSE;
			}
		}
	}

	return OK;
}

/*
 * Routine Name: serverp_tableDriverAccess
 * Description: access table driver server port APIs
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 serverp_tableDriverAccess(uint32 dsid)
{
	int32 ret;
	ipaddr_t wanIp;
	ipaddr_t tempIpAddr;
	int i;

	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
	{
		memcpy((void*)&wanIp,pRomeCfgParam->pppoeCfgParam[dsid].ipAddr,4);			
	}
	else
	{
		memcpy((void*)&wanIp,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr),4);		
	}

	if(wanIp==0)
	{
		printf("serverp_tableDriverAccess: no valid wan ip!\n");
		return NOT_OK;
	}

				
		/* for loop to delete all "enabled" entry in serverpCfgParam[] */	
		for (i=0;i<MAX_SERVER_PORT;i++)
		{	
			if (ramServerpCfgParam[dsid][i].enable == 0)
				continue;

			memcpy((void*)&tempIpAddr,(void*)(ramServerpCfgParam[dsid][i].ip),4);

			if(ramServerpCfgParam[dsid][i].wanPortStart==ramServerpCfgParam[dsid][i].wanPortFinish)
			{			
				ret = rtl8651a_delNaptServerPortMapping(
					dsid,
					(ramServerpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,                     /* current wan ip */
					(uint16)   ramServerpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   ramServerpCfgParam[dsid][i].portStart);

				if (ret != SUCCESS)
				{					
					printf("serverp_tableDriverAccess: rtl8651_delNaptServerPortMapping() ret:%d\n",ret);
					//return NOT_OK;
				}				
			}
			else
			{
				ret = rtl8651a_delNaptServerPortRange(
					dsid,
					(ramServerpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t)wanIp,                     /* current wan ip */
					(uint16)ramServerpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t)tempIpAddr,
					(uint16)ramServerpCfgParam[dsid][i].portStart,
					(uint16)ramServerpCfgParam[dsid][i].wanPortFinish-ramServerpCfgParam[dsid][i].wanPortStart+1);

				if (ret != SUCCESS)
				{
					printf("serverp_tableDriverAccess: rtl8651_delNaptServerPortRange() ret:%d\n",ret);
					//return NOT_OK;
				}				
				
			}
			
			
		} /* end for */
	
	
	/* for loop to add all "enabled" entry in newServerpCfgParam[] */
	for (i=0;i<MAX_SERVER_PORT;i++)
	{	
		
		if (pRomeCfgParam->serverpCfgParam[dsid][i].enable == 0)
			continue;
			
		/* enable/create some serverp entry */
		if ( (    (pRomeCfgParam->serverpCfgParam[dsid][i].ip[0] == 0)
			   && (pRomeCfgParam->serverpCfgParam[dsid][i].ip[1] == 0)
			   && (pRomeCfgParam->serverpCfgParam[dsid][i].ip[2] == 0)
			   && (pRomeCfgParam->serverpCfgParam[dsid][i].ip[3] == 0)
			  )
			 || (pRomeCfgParam->serverpCfgParam[dsid][i].portStart == 0)
			 || (pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart == 0)
			)
		{
			/* clear this invalid rule */
			memset(&(pRomeCfgParam->serverpCfgParam[dsid][i]),0,sizeof(serverpCfgParam_t));
		}
		else
		{
			memcpy((void*)&tempIpAddr,(void*)(pRomeCfgParam->serverpCfgParam[dsid][i].ip),4);

			
			
			if(pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart==pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish)
			{	
				
				ret = rtl8651a_addNaptServerPortMapping(
					dsid,
					(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].portStart);

				if (ret != SUCCESS)
				{
					ramServerpCfgParam[dsid][i].enable = 0;
					pRomeCfgParam->serverpCfgParam[dsid][i].enable=0;				
					printf("serverp_tableDriverAccess: rtl8651_addNaptServerPortMapping(wanip:%0x,wanport:%u,localip:%0x,localport:%u) ret:%d\n",wanIp,pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,tempIpAddr,pRomeCfgParam->serverpCfgParam[dsid][i].portStart,ret);
					return NOT_OK;
				}				
			}
			else
			{
				ret = rtl8651a_addNaptServerPortRange(
					dsid,
					(pRomeCfgParam->serverpCfgParam[dsid][i].protocol==SERVERPCFGPARAM_PROTOCOL_TCP),
					(ipaddr_t) wanIp,               /* current wan ip */
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,
					(ipaddr_t) tempIpAddr,
					(uint16)   pRomeCfgParam->serverpCfgParam[dsid][i].portStart, 
					(uint16) pRomeCfgParam->serverpCfgParam[dsid][i].wanPortFinish-pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart+1);		

				if (ret != SUCCESS)
				{
					ramServerpCfgParam[dsid][i].enable = 0;
					pRomeCfgParam->serverpCfgParam[dsid][i].enable=0;				
					printf("serverp_tableDriverAccess: rtl8651_addNaptServerPortRange(wanip:%0x,wanport:%u,localip:%0x,localport:%u) ret:%d\n",wanIp,pRomeCfgParam->serverpCfgParam[dsid][i].wanPortStart,tempIpAddr,pRomeCfgParam->serverpCfgParam[dsid][i].portStart,ret);
					return NOT_OK;
				}				
				
			}
			
			
		} /* end if */
	} /* end for */

	return OK;
} /* end serverp_tableDriverAccess */

/*
 * Routine Name: serverp_init
 * Description: configure serverp cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 serverp_init(void)
{	


	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_SERVERP,(void*)pRomeCfgParam->serverpCfgParam, sizeof(serverpCfgParam_t)*MAX_SERVER_PORT*MAX_PPPOE_SESSION)!=0)
	{
		printf("serverp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}		

	/* skip all delete when boot from scratch, since asic are all EMPTY */
	memcpy(ramServerpCfgParam,pRomeCfgParam->serverpCfgParam,sizeof(serverpCfgParam_t)*MAX_SERVER_PORT*MAX_PPPOE_SESSION);

	return 0;	
} /* end serverp_init */


/*
 * Routine Name: dmz_tableDriverAccess
 * Description: access table driver dmz APIs
 * Input:  char *ip , pointer to a ip address(char[4]).
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dmz_tableDriverAccess(int pppObjId)
{
	/* config DMZ host*/
	int32    ret;
	ipaddr_t wanIp=0, wanIp2=0, wanIp3=0;
	
		
	if (pRomeCfgParam->dmzCfgParam[pppObjId].enable==0)
		return OK; // do nothing and return success if not dmz host not enabled

	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
	{
		memcpy((void*)&wanIp,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr,4);		
	}
	else
	{
		memcpy((void*)&wanIp,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr),4);
		memcpy((void*)&wanIp2,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr1),4);
		memcpy((void*)&wanIp3,(void*)(pRomeCfgParam->ifCfgParam[0].ipAddr2),4);
	}
	/* access table driver now */
	//ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp);
	if (wanIp)
	{
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
	}
	if (wanIp2)
	{
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp2, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp2);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
	}
	if (wanIp3)
	{
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp3, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp3);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
	}

#if 0	// RTL865xB d-cut testing hash-1.
		ret=rtl8651a_addDmzHost(pppObjId,(ipaddr_t)wanIp3 + 1, (ipaddr_t)pRomeCfgParam->dmzCfgParam[pppObjId].dmzIp3 + 1);
		if(ret)
		{
			printf("dmz_tableDriverAccess: rtl8651_addDmzHost() ret:%d\n",ret);
		}
#endif	

	return OK;
} /* dmz_tableDriverAccess */



uint32 udp_tableDriverAccess(int pppObjId)
{
	/* config DMZ host*/
	int32    ret;
	uint32  len;

	if (pRomeCfgParam->udpblockCfgParam[pppObjId].enable)
		len=	pRomeCfgParam->udpblockCfgParam[pppObjId].size*1000;
	else
		len=0xffff;
		
	/* access table driver now */
	rtl8651a_setUdpSizeThreshValue(pppObjId,len);
#if 0
	ret=rtl8651a_setUdpSizeThreshValue(pppObjId,len);
	if(ret)
	{
		printf(" ret:udp_tableDriverAccess() : rtl8651a_setUdpSizeThreshValue %d\n",ret);
		return NOT_OK;
	}
#endif

	return OK;
} /* udp_tableDriverAccess */

void addRMPsaForUnnumberCase(ipaddr_t privateLanIp, ipaddr_t privateLanMask, ipaddr_t publicLanIp, ipaddr_t publicLanMask, ipaddr_t wanIp, uint16 RMport)
{
	int32 ret;
	FILE *fp;
	ipaddr_t ipRange1_LB, ipRange1_UB, ipRange2_LB, ipRange2_UB, temp_ip;
	
	if (privateLanIp < publicLanIp) {
		ipRange1_LB = (privateLanIp & privateLanMask) + 1;
		ipRange1_UB = (privateLanIp & privateLanMask) + (~privateLanMask) - 1;
		ipRange2_LB = (publicLanIp & publicLanMask) + 1;
		ipRange2_UB = (publicLanIp & publicLanMask) + (~publicLanMask) - 1;
	}
	else {
		ipRange1_LB = (publicLanIp & publicLanMask) + 1;
		ipRange1_UB = (publicLanIp & publicLanMask) + (~publicLanMask) - 1;
		ipRange2_LB = (privateLanIp & privateLanMask) + 1;
		ipRange2_UB = (privateLanIp & privateLanMask) + (~privateLanMask) - 1;
	}
	/* add a proto stack action for ip range 1. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = 0;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = ipRange1_LB - 1;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForUnnumberCase (1) ret: %d\n", ret);

	/* add a proto stack action for ip range 2. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = ipRange1_UB + 1;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = ipRange2_LB - 1;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForUnnumberCase (2) ret: %d\n", ret);

	/* add a proto stack action for ip range 3. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = ipRange2_UB + 1;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = 0xffffffff;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForUnnumberCase (3) ret: %d\n", ret);
}

void addRMPsaForNaptCase(ipaddr_t privateLanIp, ipaddr_t privateLanMask, ipaddr_t wanIp, uint16 RMport)
{
	int32 ret;
	ipaddr_t temp_ip;

	/* add a proto stack action for ip range 1. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = 0;
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = privateLanIp & privateLanMask;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForNaptCase (1) ret: %d\n", ret);

	/* add a proto stack action for ip range 2. */
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&tempPSAction.dstIp, &wanIp, sizeof(ipaddr_t));
	temp_ip = (privateLanIp & privateLanMask) + (~privateLanMask);
	memcpy(&tempPSAction.lowerIp, &temp_ip, sizeof(ipaddr_t));
	temp_ip = 0xffffffff;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	tempPSAction.orgPort = RMport;
	tempPSAction.orgPortEnd = RMport;
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf(" addGenericProtoStackActions in addPsaForNaptCase (2) ret: %d\n", ret);
	
}
/* 
	IpUnWAport: unnumbered subnet web access port
	S1WAport: private lan web access port on session 1
	S2WAport: private lan web access port on session 2
	lanType: private lan / unnumbered subnet (public lan)
*/
void addProtoStackActions(ipaddr_t wanIp, ipaddr_t ipAddr, ipaddr_t ipMask, int sessionNo, uint16 IpUnWAport, uint16 S0WAport, uint16 S1WAPort, uint32 lanType)
{
	int32 ret;
	ipaddr_t temp_ip;
	
	memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
	memcpy(&(tempPSAction.dstIp), &wanIp, sizeof(ipaddr_t));
	temp_ip = (ipAddr & ipMask) + 1;
	memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
	temp_ip = (ipAddr & ipMask) + (~ipMask) - 1;
	memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
	/* 
		(1) sessionNo is unnumbered session and lanType is unnumbered subnet => use IpUnWAport 
		(2) sessionNo is unnumbered session and lanType is private lan => sessionNo == 0, use S0WAport; sessionNo = 1, use S1WAport
		(3) sessionNo is NAPT session and lanType is unnumbered subnet => the same as (2)
		(4) sessionNo is NAPT session and lanType is private lan => the same as (2)
	*/
	if (pRomeCfgParam->pppoeCfgParam[sessionNo].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED && lanType == RTL865XB_MULTIPLE_PPPOE_UNNUMBER_LAN) {
		tempPSAction.orgPort = IpUnWAport;
		tempPSAction.orgPortEnd = IpUnWAport;
	}
	else {
		tempPSAction.orgPort = (sessionNo == 0)? S0WAport: S1WAPort;
		tempPSAction.orgPortEnd = (sessionNo == 0)? S0WAport: S1WAPort;
	}
#if 0	
	tempPSAction.orgPort = (pRomeCfgParam->pppoeCfgParam[sessionNo].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED) ? IpUnRMport: NaptRMport;
	tempPSAction.orgPortEnd = (pRomeCfgParam->pppoeCfgParam[sessionNo].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED) ? IpUnRMport: NaptRMport;
#endif
	tempPSAction.fwdPort = 80;
	tempPSAction.protocol = IPPROTO_TCP;
	tempPSAction.action = PS_ACTION_TO_PS;
	tempPSAction.role = PS_ACTION_SERVER;
	ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
	if (ret)
		printf("addGenericProtoStackActions failed (wanIp: %u.%u.%u.%u): %d\n", NIPQUAD(wanIp), ret);
}

void addProtoStackActionsForIcmpDisable(ipaddr_t wanIp, ipaddr_t ipAddr, ipaddr_t ipMask)
{
	int32 ret;
	ipaddr_t temp_ip;

	if(!pRomeCfgParam->mgmtCfgParam[0].remoteIcmpEnable)
	{
		memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
		memcpy(&(tempPSAction.dstIp), &wanIp, sizeof(ipaddr_t));
		temp_ip = (ipAddr & ipMask) + 1;
		memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
		temp_ip = (ipAddr & ipMask) + (~ipMask) - 1;
		memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
		tempPSAction.protocol = IPPROTO_ICMP;
		tempPSAction.action = PS_ACTION_TO_PS;
		ret = rtl8651_addGenericProtoStackActions(&tempPSAction);
		if (ret)
			printf("addGenericProtoStackActions failed (wanIp: %u.%u.%u.%u): %d\n", NIPQUAD(wanIp), ret);
	}

}

uint32 remoteMgmt_tableDriverAccess(void)
{
	uint32 ret;
	/* 
	      	-1: no unnumbered pppoe session exists in multiple pppoe
		0: session 0 is unnumbered pppoe session
		1: session 1 is unnumbered pppoe session
	*/
	int8 IpUnSession = -1;

	rtl8651_flushProtoStackActions();

	/* ========= Add protocol stack actions for (1) LAN pkt to web server on protocol stack (2) ping from LAN to PS =============== */
	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE) {
		
		int i;
		ipaddr_t ipAddr, ipMask, wanIp, temp_ip;

		/* check whether unnumbered session setting exists or not */
		for (i = 0; i < MAX_PPPOE_SESSION; i++)
			if (pRomeCfgParam->pppoeCfgParam[i].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED)
				IpUnSession = i;

		/* add proto stack actions */
		for (i = 0; i < MAX_PPPOE_SESSION; i++) {
			if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS) {

				wanIp = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[i].ipAddr));

				/* There exists an unnumbered pppoe session */
				if (IpUnSession != -1) {
					/* add a proto stack action for public lan */
					ipAddr = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[IpUnSession].unnumberedIpAddr));
					ipMask = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[IpUnSession].unnumberedIpMask));

					#if 1	/* session 1 and session 2 use the same remote management port */
					addProtoStackActions(wanIp, ipAddr, ipMask, i, 80, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, RTL865XB_MULTIPLE_PPPOE_UNNUMBER_LAN);
					#else	/* example: session 1 and session 2 use different remote management port */
					addProtoStackActions(wanIp, ipAddr, ipMask, i, 80, 8080, 9090, RTL865XB_MULTIPLE_PPPOE_UNNUMBER_LAN);
					#endif

					/* Ping from LAN to PS */
					addProtoStackActionsForIcmpDisable( wanIp, ipAddr, ipMask );

					/* add a proto stack action for private lan */
					ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
					ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));

					#if 1	/* session 1 and session 2 use the same remote management port */
					addProtoStackActions(wanIp, ipAddr, ipMask, i, 80, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, RTL865XB_MULTIPLE_PPPOE_PRIVATE_LAN);
					#else	/* example: session 1 and session 2 use different remote management port */
					addProtoStackActions(wanIp, ipAddr, ipMask, i, 80, 8080, 9090, RTL865XB_MULTIPLE_PPPOE_PRIVATE_LAN);
					#endif

					/* Ping from LAN to PS */
					addProtoStackActionsForIcmpDisable( wanIp, ipAddr, ipMask );
				}
				else {
					/* add a proto stack action for private lan */
					ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
					ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));

					#if 1	/* session 1 and session 2 use the same remote management port */
					addProtoStackActions(wanIp, ipAddr, ipMask, i, 80, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, RTL865XB_MULTIPLE_PPPOE_PRIVATE_LAN);
					#else	/* example: session 1 and session 2 use different remote management port */
					addProtoStackActions(wanIp, ipAddr, ipMask, i, 80, 8080, 9090, RTL865XB_MULTIPLE_PPPOE_PRIVATE_LAN);
					#endif

					/* Ping from LAN to PS */
					addProtoStackActionsForIcmpDisable( wanIp, ipAddr, ipMask );
				}
			}
		}
	}
	else {
		ipaddr_t ipAddr, ipMask;
		ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
		ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));
		ret = rtl8651_addProtoStackActions((ipAddr & ipMask) + 1, (ipAddr & ipMask) + (~ipMask) - 1,
										   PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_TCP,
										   pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort, 80);
		if (ret)
			printf(" addProtoStackActions :LAN pkt to web server failed: %d\n", ret);

		/* Ping from LAN to PS */
		addProtoStackActionsForIcmpDisable( 0, ipAddr, ipMask );


		if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED) {
			ipAddr = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[0].unnumberedIpAddr));
			ipMask = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[0].unnumberedIpMask));
			ret = rtl8651_addProtoStackActions((ipAddr & ipMask) + 1,
											   (ipAddr & ipMask) + (~ipMask) - 1,
											   PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_TCP,
											   /*pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort*/80, 80);
			if (ret)
				printf(" addProtoStackActions :LAN pkt to web server for public LAN failed: %d\n", ret);

			/* Ping from LAN to PS */
			addProtoStackActionsForIcmpDisable( 0, ipAddr, ipMask );
		}
	}
	/* ============================================================================ */

	/* ========================= Remote Management Setting ================================ */

	/* when remote ip range setting is default, we partition it into several ip ranges */
	if (pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp == 0 && pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask == 0xffffffff) {
		if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE) {
			int i;
			ipaddr_t ipAddr, ipMask, wanIp, temp_ip;

			for (i = 0; i < MAX_PPPOE_SESSION; i++) {
				if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS) {

					wanIp = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[i].ipAddr));

					/* There exists an unnumbered pppoe session */
					if (IpUnSession != -1) {
						ipaddr_t unnumberIpAddr, unnumberIpMask;
						
						ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
						ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));
						unnumberIpAddr = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[IpUnSession].unnumberedIpAddr));
						unnumberIpMask = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[IpUnSession].unnumberedIpMask));

						#if 1	/* session 1 and session 2 use the same remote management port */
						addRMPsaForUnnumberCase(ipAddr, ipMask, unnumberIpAddr, unnumberIpMask, wanIp, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort);
						#else	/* example: session 1 and session 2 use different remote management port */
						if (pRomeCfgParam->pppoeCfgParam[i].defaultSession == 1)
							addRMPsaForUnnumberCase(ipAddr, ipMask, unnumberIpAddr, unnumberIpMask, wanIp, 8080);
						else
							addRMPsaForUnnumberCase(ipAddr, ipMask, unnumberIpAddr, unnumberIpMask, wanIp, 9090);
						#endif
					}
					else {
						ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
						ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));

						#if 1	/* session 1 and session 2 use the same remote management port */
						addRMPsaForNaptCase(ipAddr, ipMask, wanIp, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort);
						#else	/* example: session 1 and session 2 use different remote management port */
						if (pRomeCfgParam->pppoeCfgParam[i].defaultSession == 1)
							addRMPsaForNaptCase(ipAddr, ipMask, wanIp, 8080);
						else
							addRMPsaForNaptCase(ipAddr, ipMask, wanIp, 9090);
						#endif
					}
				}
			}
		}
		else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED) {
			/* add three range of remote management*/
			ipaddr_t ipAddr, ipMask, unnumberIpAddr, unnumberIpMask;
			ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
			ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));
			unnumberIpAddr = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[0].unnumberedIpAddr));
			unnumberIpMask = *(uint32*)(&(pRomeCfgParam->pppoeCfgParam[0].unnumberedIpMask));

			addRMPsaForUnnumberCase(ipAddr, ipMask, unnumberIpAddr, unnumberIpMask, 0, pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort);
		}
		else {
			ipaddr_t ipAddr, ipMask;
			ipAddr = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipAddr));
			ipMask = *(uint32*)(&(pRomeCfgParam->ifCfgParam[1].ipMask));

			/* add two range of remote management: {0.0.0.0~255.255.555.255} - {LAN subnet} */		
			ret = rtl8651_addProtoStackActions(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp,
											ipAddr & ipMask,
											PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,
											pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort,80);
			if(ret)
				printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions %d\n",ret);

			ret = rtl8651_addProtoStackActions((ipAddr & ipMask) + (~ipMask), pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask,
											PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,
											pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort,80);
			if(ret)
				printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions %d\n",ret);
		}
	}
	/* user setting of remote ip range */
	else {
		ret = rtl8651_addProtoStackActions(pRomeCfgParam->mgmtCfgParam[0].remoteMgmtIp,
										pRomeCfgParam->mgmtCfgParam[0].remoteMgmtMask,
										PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,
										pRomeCfgParam->mgmtCfgParam[0].remoteMgmtPort,80);
		if(ret)
			printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions %d\n",ret);
	}

	/* ================================================================================== */


	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,23,23);	
	ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP,8888,8888); //for Home Monitor
	if (ret)
		printf(" addProtoStackActions for Home Monitor failed: %d\n", ret);

	//rtl8651_addProtoStackServerPortRange(0,0,IPPROTO_TCP,23,23); //for telnetd
	
	/* chenyl : these settings are not be used after napt-flow-cache is applied */
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_CLIENT,IPPROTO_TCP,53,53);
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_CLIENT,IPPROTO_UDP,53,53);
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_CLIENT,IPPROTO_UDP,67,67);
	//rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_UDP,68,68);
	if (mgmt_udp_500) {
		ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_UDP,500,500);
		if (ret)
			printf(" addProtoStackActions for mgmt_udp_500 failed: %d\n", ret);
	}
	//disable L2TP,PPTP idle timeout
	ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DONT_TIMEOUT,PS_ACTION_CLIENT,IPPROTO_UDP,1701,1701);
	if (ret)
		printf(" addProtoStackActions to disable L2TP idle timeout failed: %d\n", ret);
	
	ret = rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DONT_TIMEOUT,PS_ACTION_CLIENT,IPPROTO_TCP,1723,1723);	
	if (ret)
		printf(" addProtoStackActions to disable PPTP idle timeout failed: %d\n", ret);

#if 0
	if(ret)
	{
		printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions %d\n",ret);
		return NOT_OK;
	}
#endif
	
	if(pRomeCfgParam->mgmtCfgParam[0].remoteIcmpEnable)
		ret=rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_TO_PS,0,IPPROTO_ICMP,0,0);
	if(ret)
		printf(" ret:remoteMgmt_tableDriverAccess() : rtl8651_addProtoStackActions for icmp %d\n",ret);
		
	return OK;
} /* remoteMgmt_tableDriverAccess */


/*
 * Routine Name: dmz_init
 * Description: configure dmz cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dmz_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DMZ,(void*)(pRomeCfgParam->dmzCfgParam), sizeof(struct dmzCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("dmz_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	/* for each PPPoE session, l4fwd and icmpfwd are the same */
	rtl8651_setDmzL4Fwd(pRomeCfgParam->dmzCfgParam[0].l4fwd);
	rtl8651_setDmzIcmpFwd(pRomeCfgParam->dmzCfgParam[0].icmpfwd);

	return 0;	
} /* end dmz_init */


/*
 * Routine Name: udpblock_init
 * Description: configure udpblock cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 udpblock_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_UDPBLOCK,(void*)(pRomeCfgParam->udpblockCfgParam), sizeof(struct udpblockCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("udpblock_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;	
} /* end udpblock_init */

/*
 * Routine Name: routing_init
 * Description: configure routing cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 routing_init(void)
{	
	int i,ret;
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ROUTING,(void*)(pRomeCfgParam->routingCfgParam), sizeof(struct routingCfgParam_s)*MAX_ROUTING)!=0)
	{
		printf("routing_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	for(i=0;i<MAX_ROUTING;i++)
	{
		if(pRomeCfgParam->routingCfgParam[i].interface!=ROUTING_INTERFACE_NONE)
		{
			char interface[8]={0};
			if(pRomeCfgParam->routingCfgParam[i].interface==ROUTING_INTERFACE_WAN) sprintf(interface,"eth0");
			if(pRomeCfgParam->routingCfgParam[i].interface==ROUTING_INTERFACE_LAN) sprintf(interface,"eth1");
			ret=rtl8651_addRoute((ipaddr_t)pRomeCfgParam->routingCfgParam[i].route,
								  (ipaddr_t)pRomeCfgParam->routingCfgParam[i].mask,
								  (int8*)interface,(ipaddr_t)pRomeCfgParam->routingCfgParam[i].gateway);
			if (ret)
			{
				pRomeCfgParam->routingCfgParam[i].interface=ROUTING_INTERFACE_NONE;			
				printf("rtl8651_addRoute %x: ret %d\n",pRomeCfgParam->routingCfgParam[i].route,ret);				
			}
		}	
	}
	return 0;	
} /* end routing_init */

/*
 * Routine Name: log_init
 * Description: configure log cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 log_init(void)
{	
	int i;
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_LOG,(void*)(pRomeCfgParam->logCfgParam), sizeof(struct logCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("log_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	system("touch /var/syslog");
	
	for(i=0;i<MAX_PPPOE_SESSION;i++)
	{
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_DOS)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_DOS,1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_ACL)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_ACL, 1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_URL)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_URL, 1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_NEWFLOW)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_NEWFLOW, 1);
	}

	for(i=0;i<MAX_PPPOE_SESSION;i++)
	{
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_DOS)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_DOS,1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_ACL)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_ACL, 1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_URL)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_URL, 1);
		if(pRomeCfgParam->logCfgParam[i].module&RTL8651_LOGMODULE_NEWFLOW)
			rtl8651a_enableLogging(i,RTL8651_LOGMODULE_NEWFLOW, 1);
	}

	return 0;	
} /* end log_init */

#ifdef __uClinux__
#define USERAPP_NOMMU
#endif


#if 0 //for PSEUDO_ICSD
#ifdef USERAPP_NOMMU
uint32 upnp_start(void)
{
	if(pRomeCfgParam->upnpCfgParam.enable == 1)
	{
		// start upnp service
		char temp[2][30] = {0};
		char *argv[6] = {0};
		char interface[10] = {0};
		int pid = 0;
		FILE *f = NULL;
		FILE *f_arg = NULL;

		// Route related setting		
		argv[0]="-net";
		argv[1]="239.0.0.0";
		argv[2]="netmask";
		argv[3]="255.0.0.0";
		argv[4]="eth1";
		argv[5]=NULL;

		// upnp daemon related setting

		/*
			Current argument for UPnP daemon
		*/
		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
			case IFCFGPARAM_CONNTYPE_DHCPC:
				sprintf(interface,"eth0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE:
			case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
				sprintf(interface,"ppp0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:					
				sprintf(interface,"ppp%d",pRomeCfgParam->pppoeCfgParam[pRomeCfgParam->pppoeCfgParam[0].whichPppObjId].pppx);
				break;
		}
		sprintf(&temp[0][0], "eth1 %s", interface);

		f_arg = fopen("/var/run/pseudoicsd.arg", "r");
		if (f_arg)
		{
			char ptr[20];
			char* cp;

			bzero(ptr, sizeof(ptr));
			cp = &temp[1][0];
			while (fscanf(f_arg, "%s", ptr) != EOF)
			{
				if (cp == &temp[1][0])
				{	// first argument
					cp += sprintf(cp, "%s", ptr);
				}else
				{
					cp += sprintf(cp, " %s", ptr);
				}
			}

			if (strncmp(&temp[0][0], &temp[1][0], strlen(&temp[0][0])) == 0)
			{	// we don't change configuration file
				fclose(f_arg);
				goto start_upnp;
			}
			// configuration change: modify configuration file
			fclose(f_arg);
		}
		// re-open argument file to write
		f_arg = fopen("/var/run/pseudoicsd.arg", "w");
		if (!f_arg)
		{
			printf("Error: cannot set argument of uPnP daemon!\n");
			goto errout;
		}
		fprintf(f_arg, "%s\n", &temp[0][0]);
		fclose(f_arg);

start_upnp:

		f = fopen("/var/run/pseudoicsd.pid", "r");
		if (f)
		{
			fscanf(f, "%d", &pid);
			if (kill(pid, SIGHUP))
			{	// file not exist
				fclose(f);
				unlink("/var/run/pseudoicsd.pid");
				goto create_upnp;
			}
			fclose(f);	// reset successful: return
			goto out;
		}
create_upnp:
		{
			char command[20] = {0};
			sprintf(command, "/bin/upnp &");
			system(command);
		}

out:
		// create route for upnp
		INET_setroute(RTACTION_ADD, 0, argv);
		// set multicast filter to upnp
		rtl8651_multicastAddFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		return 0;
errout:
		// remove route for upnp
		INET_setroute(RTACTION_DEL, 0, argv);
		rtl8651_multicastDelFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		return 1;
	}
	return 1;
}
#else /* USERAPP_NOMMU */
uint32 upnp_start(void)
{
	if(pRomeCfgParam->upnpCfgParam.enable==1)
	{
		// start upnp service
		char temp[30];
		char *argv[6];
		char interface[10]={0};
		int pid=0;
		FILE *f;
		
		argv[0]="-net";
		argv[1]="239.0.0.0";
		argv[2]="netmask";
		argv[3]="255.0.0.0";
		argv[4]="eth1";
		argv[5]=NULL;
		
		//kill old process		
		f=fopen("/var/run/pseudoicsd.pid","r");
		if(f!=NULL)
		{
			// del upnp route
			INET_setroute(RTACTION_DEL, 0, argv);			
			fscanf(f,"%d",&pid);
			kill(pid,SIGTERM);
			remove("/var/run/pseudoicsd.pid");
			fclose(f);
		}
		
		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
			case IFCFGPARAM_CONNTYPE_DHCPC:
				sprintf(interface,"eth0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE:
			case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
				sprintf(interface,"ppp0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:					
				sprintf(interface,"ppp%d",pRomeCfgParam->pppoeCfgParam[pRomeCfgParam->pppoeCfgParam[0].whichPppObjId].pppx);
				break;
		}
				
		INET_setroute(RTACTION_ADD, 0, argv);
		rtl8651_multicastAddFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		sprintf(temp,"/bin/upnp eth1 %s &",interface);		
		system(temp);
	}
	else
	{
		rtl8651_multicastDelFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		return 1;
	}
	return 0;		
}
void upnp_stop(void)
{
		char *argv[6];
		argv[0]="-net";
		argv[1]="239.0.0.0";
		argv[2]="netmask";
		argv[3]="255.0.0.0";
		argv[4]="eth1";
		argv[5]=NULL;
		
		//kill old process		
		send_signal("/var/run/pseudoicsd.pid",SIGTERM);
		unlink("/var/run/pseudoicsd.pid");
		// del upnp route
		INET_setroute(RTACTION_DEL, 0, argv);		
}


#endif /* USERAPP_NOMMU */

#else // for LINUX-IGD
void upnp_stop(void)
{
		char *argv[6];
		argv[0]="-net";
		argv[1]="239.0.0.0";
		argv[2]="netmask";
		argv[3]="255.0.0.0";
		argv[4]="eth1";
		argv[5]=NULL;
		
		//kill old process		
		send_signal("/var/run/linuxigd.pid",SIGTERM);
		unlink("/var/run/linuxigd.pid");
		// del upnp route
		INET_setroute(RTACTION_DEL, 0, argv);
		sleep(1);
}

uint32 upnp_start(void)
{
	if(pRomeCfgParam->upnpCfgParam.enable==1)
	{
		//close old upnp daemon.
		upnp_stop();
	
		// start upnp service
		char temp[30];
		char *argv[6];
		char interface[10]={0};
		int pid=0;
		FILE *f,*f2;
		
		argv[0]="-net";
		argv[1]="239.0.0.0";
		argv[2]="netmask";
		argv[3]="255.0.0.0";
		argv[4]="eth1";
		argv[5]=NULL;

		f=fopen("/var/gatedesc.xml","w");
		f2=fopen("/etc/linuxigd/gatedesc.xml.org","r");		
		if(f2!=NULL)
		{
			char tempStr[160]={0};

			while(1)
			{
				fgets(tempStr,160,f2);
				if(feof(f2)) break;
				if(strstr(tempStr,"<URLBase>")!=NULL)
				{
					fprintf(f,"<URLBase>http://%d.%d.%d.%d:49152</URLBase>\n"
					,pRomeCfgParam->ifCfgParam[1].ipAddr[0]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[1]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[2]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[3]);
				}
				else if(strstr(tempStr,"<presentationURL>")!=NULL)
				{
					fprintf(f,"<presentationURL>http://%d.%d.%d.%d</presentationURL>\n"
					,pRomeCfgParam->ifCfgParam[1].ipAddr[0]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[1]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[2]
					,pRomeCfgParam->ifCfgParam[1].ipAddr[3]);
				}
				else
					fputs(tempStr,f);			
				
			}				
			fclose(f2);			
		}
		fclose(f);
		
	
		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
			case IFCFGPARAM_CONNTYPE_DHCPC:
				sprintf(interface,"eth0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE:
			case IFCFGPARAM_CONNTYPE_PPTP:
			case IFCFGPARAM_CONNTYPE_L2TP:				
			case IFCFGPARAM_CONNTYPE_DHCPL2TP:								
			case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
				sprintf(interface,"ppp0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:					
				sprintf(interface,"ppp%d",pRomeCfgParam->pppoeCfgParam[pRomeCfgParam->pppoeCfgParam[0].whichPppObjId].pppx);
				break;
		}
				
		INET_setroute(RTACTION_ADD, 0, argv);
		rtl8651_multicastAddFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		sprintf(temp,"/bin/upnpd %s eth1 &",interface);		
		system(temp);
	}
	else
	{
		rtl8651_multicastDelFilter(ntohl(inet_addr("239.255.255.250")), MCAST_FILTER_ACT_MIRROR);
		return 1;
	}
	return 0;		
}
#endif

void snmp_start(void)
{
	send_signal("/var/run/snmpd.pid",9);
	do_exec("/bin/snmpd",NULL);
}


void snmp_stop(void)
{
	FILE *f;
	f=fopen("/var/run/snmpd.pid","r");
	if(f!=NULL)
	{
		send_signal("/var/run/snmpd.pid",9);
		unlink("/var/run/snmpd.pid");
		fclose(f);
	}

}


void udhcpc_start(void)
{
	send_signal("/var/run/udhcpc.pid",9);
	do_exec("/bin/udhcpc",NULL);
}

void udhcpc_renew(void)
{
	FILE *f;

	f = fopen("/var/run/udhcpc.pid", "r");
	if (f)
		send_signal("/var/run/udhcpc.pid", SIGUSR1);
	else
		udhcpc_start();
}

void udhcpc_release(void)
{
       FILE *f;

	f = fopen("/var/run/udhcpc.pid", "r");
	if (f)
	{
       	send_signal("/var/run/udhcpc.pid", SIGUSR2);
	}
       else
       {
            printf("Wan side dhcp client has NOT run, it need not release !\n");
       }
}

/*
 * Routine Name: upnp_init
 * Description: configure upnp cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 upnp_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_UPNP,(void*)&(pRomeCfgParam->upnpCfgParam), sizeof(struct upnpCfgParam_s))!=0)
	{
		printf("upnp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;	
} /* end upnp_init */

/*
 * Routine Name: upnp_init
 * Description: configure upnp cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 snmp_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_SNMP,(void*)&(pRomeCfgParam->snmpCfgParam), sizeof(struct snmpCfgParam_s))!=0)
	{
		printf("snmp_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;	
} /* end snmp_init */


/*
 * Routine Name: urlfilter_init
 * Description: configure urlfilter cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 urlfilter_init(void)
{		
	int i;
#if 0	/* Sample code for "rtl8651_setUrlForwardLogging" */
	{
		int32 ret;
		ret = rtl8651_setUrlForwardLogging(0, FALSE);
		if (ret)
			printf("rtl8651_setUrlForwardLogging: %d\n", ret);
	}
#endif
#if 0	/* Sample code for actionType field of urlFilter */
	{
		int32 ret;
		rtl8651_tblDrv_urlFilter_t urlFilter;

		rtl8651_setUrlDefaultAction(0, RTL8651_URL_DROP);

		bzero(&urlFilter, sizeof(rtl8651_tblDrv_urlFilter_t));
		urlFilter.urlFilterString = (int8 *)malloc(32);
		strncpy(urlFilter.urlFilterString, "google", 6);
		urlFilter.urlFilterStrLen = 6;
		urlFilter.actionType = RTL8651_URL_PERMIT;
		ret = rtl8651_addGenericURLFilterRule(&urlFilter, NULL);
		if (ret)
			printf("= rtl8651_addGenericURLFilterRule failed: %d =\n", ret);
	}
#endif
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_URLFILTER,(void*)(pRomeCfgParam->urlfilterCfgParam), sizeof(struct urlfilterCfgParam_s)*MAX_PPPOE_SESSION*MAX_URL_FILTER)!=0)
	{
		printf("urlfilter_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	
	for(i=0;i<MAX_URL_FILTER;i++)
	{
		if(pRomeCfgParam->urlfilterCfgParam[0][i].enable==1)
		{
			rtl8651_addURLFilterRule(0,pRomeCfgParam->urlfilterCfgParam[0][i].string, strlen(pRomeCfgParam->urlfilterCfgParam[0][i].string), pRomeCfgParam->urlfilterCfgParam[0][i].ip_start, pRomeCfgParam->urlfilterCfgParam[0][i].ip_end);
		}
	}
#if 0	/* Sample code for rtl8651_flushUrlFilterRule( ) */
	{
		int32 retval;
		retval = rtl8651_flushUrlFilterRule(0);
		if (retval)
			printf("rtl8651_flushUrlFilterRule failed: %d\n", retval);
	}
#endif
	return 0;	
} /* end urlfilter_init */

/*
 * Routine Name: urlfilterTrustedUser_init
 * Description: configure urlfilter trusted user cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 urlfilterTrustedUser_init(void)
{		
	int i;
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_URLFILTERTRUSTEDUSER,(void*)(pRomeCfgParam->urlfilterTrustedUserCfgParam), sizeof(struct urlfilterTrustedUserCfgParam_s)*URL_FILTER_MAX_TRUSTED_USERS)!=0)
	{
		printf("urlfilterTrustedUser_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}


	rtl8651_flushUrlFilterTrustedUser();

	for(i=0;i<URL_FILTER_MAX_TRUSTED_USERS;i++)
	{
		if((pRomeCfgParam->urlfilterTrustedUserCfgParam[i].trustedIP!=0) && (pRomeCfgParam->urlfilterTrustedUserCfgParam[i].enable==1))
			rtl8651_addUrlFilterTrustedUser(pRomeCfgParam->urlfilterTrustedUserCfgParam[i].trustedIP);
	}

	return 0;	
} /* end urlfilter_init */

uint32 zone_init(void)
{
	char tmp[16];
	FILE *f;
	int32 timezone_diff;

	sprintf(tmp,"EST%s",pRomeCfgParam->timeCfgParam.timeZone);
	if(tmp[3]==' ') tmp[3]='+';
	
	setenv("TZ",tmp, 1);
	timezone_diff=(tmp[4]-'0')*36000+(tmp[5]-'0')*3600+(tmp[7]-'0')*600+(tmp[8]-'0')*60;
	if(tmp[3]=='+') timezone_diff*=-1;
	rtl8651_setTimeZone(timezone_diff);
	
	f=fopen("/var/TZ","w");
	fprintf(f,"%s\n",tmp);
	fclose(f);
	f=fopen("/proc/sys/net/ipv4/conf/all/arp_announce","w");
	fprintf(f,"1");
	fclose(f);
	f=fopen("/proc/sys/net/ipv4/conf/default/arp_announce","w");
	fprintf(f,"1");
	fclose(f);

}

uint32 time_start(void)
{
	char tempStr[56];
	sprintf(tempStr,"/bin/rdate -s %s &",pRomeCfgParam->timeCfgParam.ntpServer1);
	system(tempStr);
	sprintf(tempStr,"/bin/rdate -s %s &",pRomeCfgParam->timeCfgParam.ntpServer2);
	system(tempStr);
	sprintf(tempStr,"/bin/rdate -s %s &",pRomeCfgParam->timeCfgParam.ntpServer3);
	system(tempStr);
}

/*
 * Routine Name: time_init
 * Description: configure time cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 time_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_TIME,(void*)&pRomeCfgParam->timeCfgParam, sizeof(struct timeCfgParam_s))!=0)
	{
		printf("time_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;	
} /* end time_init */

/*
 * Routine Name: napt_init
 * Description: configure napt cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 napt_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_NAPT, (void*)(&pRomeCfgParam->naptCfgParam), sizeof(struct naptCfgParam_s)) != 0)
	{
		printf("napt_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	/* initial parameters */
	rtl8651_WeakNaptCtrl(pRomeCfgParam->naptCfgParam.weakNaptEnable);
	rtl8651_looseUdpCtrl(pRomeCfgParam->naptCfgParam.looseUdpEnable);
	rtl8651_TcpNaptStaticPortMappingCtrl(pRomeCfgParam->naptCfgParam.tcpStaticPortMappingEnable);
	rtl8651_UdpNaptStaticPortMappingCtrl(pRomeCfgParam->naptCfgParam.udpStaticPortMappingEnable);

	return 0;
}	/* end napt_init */

/*
 * Routine Name: dos_init
 * Description: configure dos cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 dos_init(void)
{
	uint32 i;
	uint32 pScanThreshold;
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DOS,(void*)(pRomeCfgParam->dosCfgParam), sizeof(struct dosCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("dos_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	for(i=0;i<MAX_PPPOE_SESSION;i++){

		/* flooding */
		rtl8651a_setDosThreshold(i,RTL8651_DOS_SYN_THRESHOLD,pRomeCfgParam->dosCfgParam[i].syn);
		rtl8651a_setDosThreshold(i,RTL8651_DOS_FIN_THRESHOLD,pRomeCfgParam->dosCfgParam[i].fin);
		rtl8651a_setDosThreshold(i,RTL8651_DOS_UDP_THRESHOLD,pRomeCfgParam->dosCfgParam[i].udp);
		rtl8651a_setDosThreshold(i,RTL8651_DOS_ICMP_THRESHOLD,pRomeCfgParam->dosCfgParam[i].icmp);

		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_SYN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_syn);
		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_FIN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_fin);
		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_UDP_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_udp);
		rtl8651a_setPerSrcDosThreshold(i, RTL8651_DOS_ICMP_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_icmp);

		/* connection count control */
		rtl8651a_setDosThreshold(0, RTL8651_DOS_TCPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].tcpc);
		rtl8651a_setDosThreshold(0, RTL8651_DOS_UDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].udpc);
		rtl8651a_setDosThreshold(0, RTL8651_DOS_TCPUDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].tcpudpc);

		rtl8651a_setPerSrcDosThreshold(0, RTL8651_DOS_TCPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_tcpc);
		rtl8651a_setPerSrcDosThreshold(0, RTL8651_DOS_UDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_udpc);
		rtl8651a_setPerSrcDosThreshold(0, RTL8651_DOS_TCPUDPCONN_THRESHOLD, pRomeCfgParam->dosCfgParam[i].perSrc_tcpudpc);

		/* scan */
		switch (pRomeCfgParam->dosCfgParam[i].portScan_level)
		{
			case 0:	/* Low */
				pScanThreshold = DOS_PORTSCAN_LOW_VAL;
				break;
			case 1:	/* high */
				pScanThreshold = DOS_PORTSCAN_HIGH_VAL;
				break;
			default:
				pScanThreshold = DOS_PORTSCAN_LOW_VAL;
		}
		rtl8651_dosScanTrackingSetPara(i, RTL8651_DOS_SCAN_MOINTOR_WIN_DEFAULT, pScanThreshold);

		if (pRomeCfgParam->dosCfgParam[i].ignoreLanSideCheck)
		{
			rtl8651_addDosIgnoreType(RTL8651_DOS_IGNORETYPE_FROM_LAN);
		}else
		{
			rtl8651_delDosIgnoreType(RTL8651_DOS_IGNORETYPE_FROM_LAN);
		}

		rtl8651_dosProc_blockSip_setPrisonTime(pRomeCfgParam->dosCfgParam[i].sipblock_PrisonTime);
		rtl8651_dosProc_blockSip_enable(i, pRomeCfgParam->dosCfgParam[i].sipblock_enable);
	}

	return 0;	
} /* end dos_init */

/*
 * Routine Name: alg_init
 * Description: configure alg cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 alg_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_ALG,(void*)(pRomeCfgParam->algCfgParam), sizeof(struct algCfgParam_s)*MAX_PPPOE_SESSION)!=0)
	{
		printf("alg_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;	
} /* end alg_init */

/*
 * Routine Name: passthru_init
 * Description: configure passthru cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 passthru_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_PASSTHRU,(void*)(&pRomeCfgParam->passthruCfgParam), sizeof(struct passthruCfgParam_s))!=0)
	{
		printf("passthru_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	rtl8651_EnablePppoePassthru( pRomeCfgParam->passthruCfgParam.enabledPppoe );
	rtl8651_enableDropUnknownPppoePADT( pRomeCfgParam->passthruCfgParam.enabledDropUnknownPppoePADT );
	rtl8651_EnableIpv6Passthru( pRomeCfgParam->passthruCfgParam.enabledIpv6 );
	rtl8651_EnableIpxPassthru( pRomeCfgParam->passthruCfgParam.enabledIpx );
	rtl8651_EnableNetbiosPassthru( pRomeCfgParam->passthruCfgParam.enabledNetbios );

	return 0;	
} /* end passthru_init */

/*
 * Routine Name: ipMulticast_init
 * Description: configure passthru cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 ipMulticast_init(void)
{		
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_IPMULTICAST,(void*)(&pRomeCfgParam->ipMulticastCfgParam), sizeof(struct ipMulticastCfgParam_s))!=0)
	{
		printf("ipMulticast_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	rtl8651_EnablIpMulticast( pRomeCfgParam->ipMulticastCfgParam.enabledIpMulticast );

	return 0;	
} /* end ipMulticast_init */

uint32 opMode_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_MODE, (void*)&(pRomeCfgParam->modeCfgParam), sizeof(struct modeCfgParam_s)) != 0)
	{
		printf("opMode_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}
	return 0;
}

uint32 CreateStunnelCfgFile(void)
{
	FILE *fp;

	fp = fopen("/var/stunnel.conf", "w");
	if (fp) {
		fprintf(fp, "cert = /etc/stunnel/stunnel.pem\n");
		fprintf(fp, "pid = /var/run/stunnel.pid\n");
//		fprintf(fp, "setuid = 0\n");
//		fprintf(fp, "setgid = 0\n");
		fprintf(fp, "foreground = yes\n");
		fprintf(fp, "output = /var/stunnel.log\n");
		fprintf(fp, "debug = 7\n");
		fprintf(fp, "[boa]\n");
//		fprintf(fp, "accept = %u.%u.%u.%u:443\n", NIPQUAD(*(uint32*)(&(pRomeCfgParam->ifCfgParam[0].ipAddr))));
//		fprintf(fp, "connect = 127.0.0.1:80\n");
		fprintf(fp, "accept = 443\n");
		fprintf(fp, "connect = 80\n");
		fprintf(fp, "delay = no\n");
		fprintf(fp, "TIMEOUTclose = 0\n");
//		fprintf(fp, "exec = /bin/boa\n");
//		fprintf(fp, "execargs = boa -c /etc\n");
		fclose(fp);
	}
	else {
		printf("create stunnel.conf fail\n");
		return 1;
	}
	return 0;
}

uint32 CreateRipCfgFile(void)
{
	FILE *f1, *f2;
	
	/* Create zebra configuration files: zebra.conf */
	f1 = fopen("/var/zebra.conf", "w");
	f2 = fopen("/var/ripd.conf", "w");

	/* Basic command in zebra.conf */
	if(f1)
	{
		fprintf(f1, "hostname Router\n");

		// No need to transmit RIP messages to eth0(WAN).
		// For Layer4 configuration, LAN routes cannot be distributed to WAN.
		// Therefore, I comment the following two lines.

		fprintf(f1, "interface eth0\n");
		fprintf(f1, "multicast\n");

		
		fprintf(f1, "interface eth1\n");
		fprintf(f1, "multicast\n");
		fclose(f1);
	}
	else
	{
		printf("create zebra.conf fail\n");
		return 1;
	}

	/* Read configurations in FLASH, and map them to the ripd command. */
	if(f2)
	{
		fprintf(f2, "hostname ripd\n");

		// RIP authentication testing
/*		
		fprintf(f2, "key chain test\n");
		fprintf(f2, "key 1\n");
		fprintf(f2, "key-string test\n");
*/
		// Per-interface setting: eth0

		fprintf(f2, "interface eth0\n");
		if(pRomeCfgParam->ripCfgParam.send_eth0 == 0)
			fprintf(f2, "ip rip send version 1 2\n");
		else
			fprintf(f2, "ip rip send version %d\n", pRomeCfgParam->ripCfgParam.send_eth0);
		if(pRomeCfgParam->ripCfgParam.rcv_eth0 == 0)
			fprintf(f2, "ip rip receive version 1 2\n");
		else
			fprintf(f2, "ip rip receive version %d\n", pRomeCfgParam->ripCfgParam.rcv_eth0);

		if(pRomeCfgParam->ripCfgParam.auth_eth0 == 1)
		{
			fprintf(f2, "ip rip authentication mode text\n");
			fprintf(f2, "ip rip authentication string %s\n", pRomeCfgParam->ripCfgParam.pass_eth0);
		}


		// Per-interface setting: eth1
		fprintf(f2, "interface eth1\n");
		if(pRomeCfgParam->ripCfgParam.send_eth1 == 0)
			fprintf(f2, "ip rip send version 1 2\n");
		else
			fprintf(f2, "ip rip send version %d\n", pRomeCfgParam->ripCfgParam.send_eth1);
		if(pRomeCfgParam->ripCfgParam.rcv_eth1 == 0)
			fprintf(f2, "ip rip receive version 1 2\n");
		else
			fprintf(f2, "ip rip receive version %d\n", pRomeCfgParam->ripCfgParam.rcv_eth1);

		if(pRomeCfgParam->ripCfgParam.auth_eth1 == 1)
		{
			fprintf(f2, "ip rip authentication mode text\n");
			fprintf(f2, "ip rip authentication string %s\n", pRomeCfgParam->ripCfgParam.pass_eth1);
		}
/*
		fprintf(f2, "ip rip authentication mode md5\n");
		fprintf(f2, "ip rip authentication key-chain test\n");
*/

		// RIP setting
		fprintf(f2, "router rip\n");
//		fprintf(f2, "route 0.0.0.0/0\n");
		fprintf(f2, "timers basic %d %d %d\n", pRomeCfgParam->ripCfgParam.update_tr, pRomeCfgParam->ripCfgParam.timeout_tr, pRomeCfgParam->ripCfgParam.garbage_tr);

		fprintf(f2, "network eth0\n");
		// If we configure RTL865xB in gateway mode, we don't distribute routing information to WAN.
		if (pRomeCfgParam->modeCfgParam.Mode == RTL865XB_L4GATEWAYMODE)
			fprintf(f2, "passive-interface eth0\n");
		else
			fprintf(f2, "no passive-interface eth0\n");

		fprintf(f2, "network eth1\n");
		fprintf(f2, "no passive-interface eth1\n");
		fclose(f2);
	}
	else
	{
		printf("create ripd.conf fail\n");
		return 1;
	}

	return 0;
}


uint32 stunnel_init(void)
{
	//Create "/var/stunnel.conf".
	if(CreateStunnelCfgFile())
	{
		printf("stunnel_init: create stunnel cfg file fail\n");
		return 1;
	}

	do_exec("/bin/stunnel", NULL);
	return 0;
}

/*
 * Routine Name: rip_init
 * Description: configure rip cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 rip_init(void)
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_RIP,(void*)&(pRomeCfgParam->ripCfgParam), sizeof(struct ripCfgParam_s))!=0)
	{
		printf("rip_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	//Create "/var/zebra.conf" & "/var/ripd.conf".
	if(CreateRipCfgFile())
	{
		printf("rip_init: create rip cfg file fail\n");
		return 1;
	}

	//When multicast feature of the gateway is turned on, the packet destined to "224.0.0.9" should be mirrored to CPU.
	rtl8651_multicastAddFilter(ntohl(inet_addr("224.0.0.9")), MCAST_FILTER_ACT_MIRROR);
	//Invoke the zebra and ripd.
	do_exec("/bin/zebra", NULL);
	do_exec("/bin/ripd", NULL);
	
	return 0;	
}


#define WLAN_SUPPORT_FUNCs

/*
	ReArrange WLAN interfaces for init / reinit.

	isInit == TRUE	-- init (called when system reboot)
	isInit == FALSE	-- reinit
*/
static void wlan_reArrange(int isInit)
{
	/* ===================================================
				Information collection
	     =================================================== */

	totalWlanCards = 0;			/* total WLAN card count in whole system */
	#ifdef CONFIG_RTL8185
	totalWlanCards += wlan_rtl8185_getInterfaceCount();
	#endif /* CONFIG_RTL8185 */

	/* ===================================================
				System initialize
	     =================================================== */

	if (isInit == TRUE)
	{
		#ifdef CONFIG_RTL8185
		wlan_setup(1);
		#endif /* CONFIG_RTL8185 */
	} else
	{
		#ifdef CONFIG_RTL8185
		wlan_setup(0);
		#endif /* CONFIG_RTL8185 */
	}
}

/*
	Init function of WLAN
*/
uint32 wlan_init (void)
{		
	wlan_reArrange(TRUE);
	return 0;
} /* end wlan_init */

/*
	Reinit function of WLAN
*/
uint32 wlan_reinit(void)
{
	wlan_reArrange(FALSE);
	return 0;
}

/*
	Check WEP/WPA key's correctness
*/

int32 wlan_chkKey(int8 *key, int32 cryptType, uint8 *cryptSubType)
{
	int i;
	int keylen = strlen(key);
	int legalLen;

	switch ( cryptType )
	{
		case CRYPT_WPA:
		case CRYPT_WPA2:
		case CRYPT_WPAMIX:
		{
			/* check length */
			if (keylen > 64 || keylen < 8)
			{
				return -1;
			}
			
			if (keylen == 64)
			{	/* No pass-phrase needed, so all of them must be HEX-digit */
				for ( i = 0 ; i < keylen ; i ++ )
				{
					if (isxdigit(key[i]))
					{
						continue;
					} else
					{
						return -1;
					}
				}
			} else
			{
				/* need be pass-phrased, so no any constraint */
			}
			break;
		}
		case CRYPT_WEP:
		{
			/*
				Due to WEP types have no any MIX mode, so we just simply get the first
				subtype of cryptSubType to decide if it's WEP64 or WEP128.
			*/
			switch (*cryptSubType)
			{
				case CRYPT_SUB_WEP_64:
					/*
						For WEP64, legal key is 10 hex digit
					*/
					legalLen = 10;

					break;
				case CRYPT_SUB_WEP_128:
					/*
						For WEP128, legal key is 26 hex digit
					*/
					legalLen = 26;

					break;
				default:
					assert(0);
					return -1;
			}
			/*
				start to check key:

					For WEP key, no passphrase can be used and length must fix.
					Besides, all chars of key must be hex digit.
			*/
			if ( keylen != legalLen )
			{
				return -1;
			}
			for ( i = 0 ; i < legalLen ; i ++ )
			{
				if (isxdigit(key[i]))
				{
					continue;
				} else
				{
					return -1;
				}
			}
			break;
		}
	}

	/* correctness check OK, accept */
	return keylen;
}

#ifdef CONFIG_RTL8185

/* <---- debug message ----> */
#define WLAN_DEBUG
#define WLAN_MSG_MASK			0xffffffff	/* Tune ON all debug messages */
#define WLAN_MSG_INFO			(1<<0)
#define WLAN_MSG_WARN			(1<<1)
#define WLAN_MSG_ERR			(1<<2)

#ifdef WLAN_DEBUG

#define WLAN_INFO(fmt, args...) \
	if (WLAN_MSG_MASK&WLAN_MSG_INFO) \
		do {printf("[%s-%d]-info-: " fmt "\n", __FUNCTION__, __LINE__, ## args); fflush(stdout);} while (0);
#define WLAN_WARN(fmt, args...) \
	if (WLAN_MSG_MASK&WLAN_MSG_WARN) \
		do {printf("[%s-%d]-warning-: " fmt "\n", __FUNCTION__, __LINE__, ## args); fflush(stdout);} while (0);
#define WLAN_ERR(fmt, args...) \
	if (WLAN_MSG_MASK&WLAN_MSG_ERR) \
		do {printf("[%s-%d]-error-: " fmt "\n", __FUNCTION__, __LINE__, ## args); fflush(stdout);} while (0);

#else	/* WLAN_DEBUG */

#define WLAN_INFO(fmt, args...)
#define WLAN_WARN(fmt, args...)
#define WLAN_ERR(fmt, args...)

#endif	/* WLAN_DEBUG */

#define SLEEP(t)	\
		do { \
			int i; \
			for (i=0;i<t;i++) \
			{ \
				sleep(1);\
			} \
		} while (0);

int32 wds_intf_updown(int w, int wds, int up)
{
	char cmdBuf[64];
	printf("Turn %s WDS interface : wlan%d-wds%d\n", up?"ON":"OFF", w, wds);

	sprintf(cmdBuf, "ifconfig wlan%d-wds%d %s", w, wds, up?"up":"down");
	printf("==> %s\n", cmdBuf);
	system(cmdBuf);
	return SUCCESS;
}

int32 wlan_intf_updown(int w, int wds, int up)
{
	char cmdBuf[64];

	if (wds < 0)
	{
		printf("Turn %s WLAN interface : wlan%d\n", up?"ON":"OFF", w);
		sprintf(cmdBuf, "ifconfig wlan%d %s", w, up?"up":"down");
	} else
	{
		printf("Turn %s WDS interface : wlan%d-wds%d\n", up?"ON":"OFF", w, wds);
		sprintf(cmdBuf, "ifconfig wlan%d-wds%d %s", w, wds, up?"up":"down");
	}

	printf("==> %s\n", cmdBuf);
	system(cmdBuf);
	return SUCCESS;	
}

/* rearrange WDS interfaces to check redundant link */
void wds_rearrange(void)
{
	int card, wds;
	char zero[6] = {0};
	int wdsCnt[MAX_WLAN_CARDS];		/* per-Card wds count */

	printf("\nRe-Arrange ALL WDS Links:\n");
	printf("=============================================================\n");

	for (card=0;card<MAX_WLAN_CARDS;card++)
	{
		/* init WDS count of the specific interface */
		wdsCnt[card] = 0;

		for(wds=0;wds<MAX_WLAN_WDS;wds++)
		{
			/* Per-interface process															*/
			/********************************************************************************/

		
			/* check for redundancy */
			if(memcmp(pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds], zero, sizeof(ether_addr_t)) != 0)
			{
				int card_cmp, wds_cmp;

				for (card_cmp=0;card_cmp<MAX_WLAN_CARDS;card_cmp++)
				for (wds_cmp=0;wds_cmp<MAX_WLAN_WDS;wds_cmp++)
				{
					if (card_cmp<card)
						continue;
					if (card_cmp==card&&wds_cmp<=wds)
						continue;
					if (memcmp(	pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds],
								pRomeCfgParam->wlanCfgParam[card_cmp].wdsMacList[wds_cmp],
								sizeof(ether_addr_t)) == 0)
					{
						/*
							redundant WDS peer found : remove it.
						*/
						printf("[%s] Duplicate WDS peer: %02X:%02X:%02X:%02X:%02X:%02X at (wlan%d-wds%d) and (wlan%d-wds%d)\n",
							__FUNCTION__,
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][0],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][1],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][2],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][3],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][4],
							pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][5],
							card, wds,
							card_cmp, wds_cmp
							);

						printf("\t==> Remove (wlan%d-wds%d)\n",
							card_cmp, wds_cmp);
						/* remove the redundant interface same as current one */
						memset(pRomeCfgParam->wlanCfgParam[card_cmp].wdsMacList[wds_cmp], 0, sizeof(ether_addr_t));
					}
				}

				printf("[%s] WDS peer: %02X:%02X:%02X:%02X:%02X:%02X at (wlan%d-wds%d)\n",
					__FUNCTION__,
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][0],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][1],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][2],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][3],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][4],
					pRomeCfgParam->wlanCfgParam[card].wdsMacList[wds][5],
					card, wds
				);

				/* current entry is counted */
				wdsCnt[card] ++;
			}

			/********************************************************************************/
		}
		printf("[%s] Total WDS count of (wlan%d) : %d\n",
			__FUNCTION__,
			card,
			wdsCnt[card]);
	}

	/* fill WDS count of each CARD */
	for (card=0;card<MAX_WLAN_CARDS;card++)
	{
		pRomeCfgParam->wlanCfgParam[card].wdsCount = wdsCnt[card];
	}

	printf("=============================================================\n\n");
}

int32 wlan_down(int w)
{
	int32 i;
	char cmdBuf[64];
	printf("Turn OFF WLAN (WDS) interfaces ...\n");

	if (w < 0)
	{
		for (i = 0 ; i < MAX_WLAN_CARDS ; i ++)
		{
			printf("Turn OFF WLAN (WDS) interfaces for WLAN-CARD %d\n", i);
			wlan_intf_updown(i, -1 /* WLAN interface it-self */, 0);
			wds_down(i);
		}
	} else
	{
		printf("Turn OFF WLAN (WDS) interfaces for WLAN-CARD %d\n", w);
		wlan_intf_updown(w, -1 /* WLAN interface it-self */, 0);
		wds_down(w);
	}
}

int32 wds_down(int w)
{
	int32 i;
	char cmdBuf[64];
	printf("Turn OFF WDS interfaces ....\n");
	/*
		When turning OFF WDS interfaces, we MUST ALWAYS try to turn ALL interfaces OFF.
		It is due to some of these interfaces are turned off by web-setting before.
		The corresponding interfaces would be turned on in wds_up()
	*/
	for ( i = 0 ; i < MAX_WLAN_WDS ; i++ )
	{
		wds_intf_updown(w, i, 0);
	}
}

int32 wds_up(int w)
{
	int32 i;
	char cmdBuf[64];

	if (	(pRomeCfgParam->wlanCfgParam[w].enable) &&
		(pRomeCfgParam->wlanCfgParam[w].mode>1) &&
		(pRomeCfgParam->wlanCfgParam[w].wdsEnable))
	{
		/* Bring up WDS interfaces. */
		WLAN_INFO("total %d WDS links\n",pRomeCfgParam->wlanCfgParam[w].wdsCount);

		for(i=0;i<(pRomeCfgParam->wlanCfgParam[w].wdsCount);i++)
		{
			wds_intf_updown(w, i, 1);
		}
	}
}

static int32 wlandrv_setup(int w, FILE *wpaCfgFile)
{
	uint8 wepkeyid=1;
	char temp[6]={0};	
	char mask[6]={0xff,0xff,0xff,0xff,0xff,0xff};	
	char cmdBuf[64]={0};
	int i=0,value;

	int8 KEY[65];
	int32 keylen;

	int16 authType[CRYPT_MAX/*encryption selection*/][AUTH_MAX/*auth selection*/] = {
		/*No encrypt*/	{	AUTH_NONE	,AUTH_8021x	,-1			,-1			},
		/*WEP64*/		{	AUTH_NONE	,AUTH_KEY	,AUTH_AUTO	,AUTH_8021x	},
		/*WEP128*/		{	AUTH_NONE	,AUTH_KEY	,AUTH_AUTO	,AUTH_8021x	},
		/*WPA-TKIP*/	{	AUTH_KEY	,AUTH_8021x	,-1			,-1			},
		/*WPA-AES*/	{	AUTH_KEY	,AUTH_8021x	,-1			,-1			}
	};

	if (cfgmgr_read(	CFGMGR_TABID_WLAN,
					(void*)pRomeCfgParam->wlanCfgParam,
					sizeof(struct wlanCfgParam_s)*MAX_WLAN_CARDS) !=0 )
	{
		printf("wlan_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return -1;
	}
	
	if (pRomeCfgParam->wlanCfgParam[w].enable == 0)
	{
		printf("wlan_init: wlan%d not enabled\n",w);
		return -1;
	}

	/* set the random seed */
	srandom(time(NULL));

	/****************************************************************************
		Set mib to drvier
	*****************************************************************************/
	#define IWPRIV(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "busybox iwpriv wlan%d " fmt, wlanIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETMIB(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "busybox iwpriv wlan%d set_mib " fmt, wlanIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETIFCFG(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "ifconfig wlan%d " fmt, wlanIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETIFCFG_WDS(wlanIdx, wdsIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, "ifconfig wlan%d-wds%d " fmt, wlanIdx, wdsIdx, ## args); \
			printf("@ WLAN -%d- [%s]\n", wlanIdx, cmdBuf); \
			system(cmdBuf); \
		} while (0);

	#define SETCFGFILE(wlanIdx, fmt, args...) \
		do { \
			sprintf(cmdBuf, fmt, ## args); \
			printf("@ WLAN -%d- File (%s) [%s]\n", wlanIdx, cfgFilePath, cmdBuf); \
			fprintf(wpaCfgFile, "%s\n", cmdBuf); \
		} while (0);

wlan_start_setting:

	/* =======================================================================
		Set Chip Version

		8:	8185B,	Zebra A
		9:	8185C,	Zebra A
		10:	8185C,	Zebra B
		11:	8185D,	Zebra C
		23:	8185D,	OMC A
	    ======================================================================= */
#ifdef CONFIG_RTL865X_CLE
	IWPRIV( w, "mp_cfg rfchip=%d",
			(pRomeCfgParam->wlanCfgParam[w].chipVer == 4)?10/* OMC */:9/* Zebra */);
#endif
	SETMIB(	w, "chipVersion=%d",
			(pRomeCfgParam->wlanCfgParam[w].chipVer == 4)
				?23	/* OMC */
				:(8+pRomeCfgParam->wlanCfgParam[w].chipVer)	/* Zebra */);

	/* =======================================================================
		RFChip Version

		RFChipID:
			7	- Zebra RTL8225
			8	- OMC RTL8255
	    ======================================================================= */
	if (pRomeCfgParam->wlanCfgParam[w].chipVer != 4)
	{
		SETMIB(w, "RFChipID=7");	/* use Realtek's own 11g RF chip (RTL8225) */
	}else
	{
		SETMIB(w, "RFChipID=8");	/* use Realtek's own 11abg RF chip (RTL8255) */
	}


	/* =======================================================================

		Wifi test specific setting

		For compatible issues (B+G AP mode's accessibility for 11B client),
		we need turn the mib 'wifi_specific' OFF.
		However, turn this off would cause some effects and let WIFI-reverse-test being FAILED.

		In RTL865XB platform, we think the compatibility issue is more important than WIFI test issues now.
		So we ALWAYS turn the mib item OFF here.

													- 2005/05/31
	    ======================================================================= */

	SETMIB(w, "wifi_specific=0");

	/* =======================================================================
		Regulation Domain
	    ======================================================================= */

	SETMIB(w, "regdomain=%d", (pRomeCfgParam->wlanCfgParam[w].regDomain+1));

	/* =======================================================================
		MAC address
	    ======================================================================= */
	{
		macaddr_t macStr;
		uint8 *p = (unsigned char *)&macStr;

		if (bdinfo_getWlanMac((macaddr_t*)&macStr, w) != 0)
		{
			WLAN_ERR("Can not get MAC Address.");
			goto err;
		} else
		{
			/* get MAC successfully */
			uint8 invalid[6]={0xff,0xff,0xff,0xff,0xff,0xff};

			/*
				MAC is FF:FF:FF:FF:FF:FF	:
					It's invlalid and might be the default value of storage (ex. NOR Flash),
					so we must call reset function.
			*/
			if (memcmp(&invalid, p, 6) == 0)
			{
				goto flashDefault;
			}

			SETIFCFG(w, "hw ether %02X:%02X:%02X:%02X:%02X:%02X",	p[0],
																	p[1],
																	p[2],
																	p[3],
																	p[4],
																	p[5]);
		}

	}

	/* =======================================================================
		Charge pump
	    ======================================================================= */
	{
		int rxChargePump, txChargePump;

		if (bdinfo_get8185ChargePumpSetting(&rxChargePump,&txChargePump, w) != 0)
		{
			WLAN_ERR("Can not get ChargePump.");
			goto err;
		} else
		{
			/*
				Charge Pump is 0xff
					It's invlalid and might be the default value of storage (ex. NOR Flash),
					so we must call reset function.
			*/
			if (rxChargePump==0xff || txChargePump==0xff)
			{
				goto flashDefault;
			}

			/* charge pump is useful only for RTL8225 2.4G RF chip, it is meaningless for RTL8255 2.4/5G RF. */
			if (rxChargePump == 0)
			{
				rxChargePump = 3; /* Default Rx charge pump on Realtek's mini-PCI demo board */
			}
			if (txChargePump == 0)
			{
				txChargePump = 6; /* Default Tx charge pump on Realtek's mini-PCI demo board */
			}

			SETMIB(w, "rxChargePump=%d", rxChargePump);
			SETMIB(w, "txChargePump=%d", txChargePump);
		}
	}

	/* =======================================================================
		Protection mode
	     ======================================================================= */

	SETMIB(w, "disable_protection=%d", pRomeCfgParam->wlanCfgParam[w].protection?0:1);
	SETMIB(w, "cts2self=%d", pRomeCfgParam->wlanCfgParam[w].protection?1:0);	/* use CTS to self for protection mode */

	/* =======================================================================
		CCK Preamble
			0:	long preamble
			1:	short preamble
	     ======================================================================= */
	SETMIB(w, "preamble=%d", pRomeCfgParam->wlanCfgParam[w].preambleType);

	/* =======================================================================
		Operation mode

		opmode:
			16	- AP
			8	- Infrastructure client
			32	- Ad-hoc client
	    ======================================================================= */

	switch (pRomeCfgParam->wlanCfgParam[w].mode)
	{
		case 0:	/* AP */

			SETMIB(w, "opmode=16");		/* AP mode */
			break;

		case 1:	/* Client mode */

			if (pRomeCfgParam->wlanCfgParam[w].adhoc==0)
			{
				/* set as infrastructure client */
				SETMIB(w, "opmode=8");		/* Infrastructure client */
			} else
			{
				/* set as Ad-hoc client */
				SETMIB(w, "opmode=32");		/* Ad-hoc client */
			}
			break;

		case 2:	/* Pure WDS */

			SETMIB(w, "opmode=16");		/* AP mode */
			SETMIB(w, "wds_pure=1");		/* pure wds */
			break;

		case 3:	/* AP+WDS */

			SETMIB(w, "opmode=16");		/* AP mode */
			SETMIB(w, "wds_pure=0");		/* not pure wds */
			break;

		default:
			WLAN_ERR("Unknown mode [%d].", pRomeCfgParam->wlanCfgParam[w].mode);
			goto err;
	}

	/* =======================================================================
		Hidden AP
	     ======================================================================= */

	SETMIB(w,	"hiddenAP=%d",
				(pRomeCfgParam->wlanCfgParam[w].broadcastSSID == 1)	?0/* Broadcast SSID */
																	:1/* Dont broadcast SSID and Hide AP */);

	/* =======================================================================
		Dual Antenna
			- Diversity
			- DIG
			- High Pwoer Check
			- Antenna Diversity
			- Default Antenna
	    ======================================================================= */
	{
		int dualAntenna = 0;
		int isDipoleAntenna = TRUE;	/* Di-pole Antenna : TRUE, Printed Antenna : FALSE */

		if (pRomeCfgParam->wlanCfgParam[w].dualAntenna)
		{
			dualAntenna = 1;
		} else
		{
			dualAntenna = 0;
		}

		SETMIB(w, "Diversity=%d",			dualAntenna);	/* used by 8180/8181, HW supported diversity, not used in 8185/8186 */
		SETMIB(w, "DIG_enable=%d",		dualAntenna);
		SETMIB(w, "HighPowerChk=%d",	dualAntenna);
		if (isDipoleAntenna)
		{
			SETMIB(w, "ExtAntDvry=%d",		dualAntenna);	/* SW supported, for dipole antenna : use antenna with better signal strength */
		} else
		{
			SETMIB(w, "AntDvrsty=%d",		dualAntenna);	/* SW supported, for dead angle of printed antenna with high RX quality */
		}
		SETMIB(w, "DefaultAnt=0");
	}

	switch (pRomeCfgParam->wlanCfgParam[w].range)
	{
		case 3:
			WLAN_INFO("Wireless coverage: Minimum.");
			break;
		case 2:
			WLAN_INFO("Wireless coverage: Limited.");
			break;
		case 1:
			WLAN_INFO("Wireless coverage: Normal.");
			break;
		case 0:
			WLAN_INFO("Wireless coverage: Max range.");
			break;
		default:
			WLAN_INFO("Wireless coverage: Unknown(%d).", pRomeCfgParam->wlanCfgParam[w].range);
			goto err;
	}

	/* =======================================================================
			Get TxPower and set channels
	    ======================================================================= */
	switch (pRomeCfgParam->wlanCfgParam[w].dataRateMode)
	{
		case WLAN_DATA_RATE_A:		/* 11a mode */
		{
			uint32 ofdmPower = 0;
			uint32 channel;
			uint32 chanlist[BDINFO_5GRF_CHANNELS+1/* 0 */]={0,36,40,44,48,52,56,60,64};

			for ( i=0 ; i < BDINFO_5GRF_CHANNELS ; i++)
			{
				/* RTL8255 supports only 8 11a channels: 36~64 */
				channel=36+i*4;

				/* Get OFDM TxPower */
				if (	bdinfo_get8185OfdmTxPower(	&ofdmPower,
													channel,
													pRomeCfgParam->wlanCfgParam[w].range, w) != 0 )
				{
					WLAN_ERR("Get OFDM TxPower error.");
					goto err;
				}

				/*		Invalid TxPower: '0xff' means the default value of storage (ex. NOR type FLASH),
						so we try to set it to default value and refetch TxPower again.						*/
				if ( ofdmPower == 0xff )
				{
					goto flashDefault;
				}
				/*
					Important Note:
						When we set  TxPower of channels,
						we must set the channel number as (channel - 1) to fix 8185 driver's constraint.
				*/
				SETMIB(w, "TxPowerOFDM=%d,%d", (channel - 1), ofdmPower);
			}

			/* Set Working Channel */
			channel = chanlist[pRomeCfgParam->wlanCfgParam[w].channel];
	 
			/* check the correctness of channel */
			{
				int idx;

				for (idx = 0 ; idx < (BDINFO_5GRF_CHANNELS+1) ; idx ++)
				{
					if (channel == chanlist[idx])
					{
						break;
					}
				}
				if (idx >= (BDINFO_5GRF_CHANNELS+1))
				{
					uint32 defChan = chanlist[0];
					WLAN_INFO("=> Unknown channel : %d, use the default channel [%d].", channel, defChan);
					channel = defChan;
				}
			}

			SETMIB(w, "channel=%d", channel);
		}
			break;
		case WLAN_DATA_RATE_B:
		case WLAN_DATA_RATE_G:
		case WLAN_DATA_RATE_BG:
		{
			int channel;

			for ( i = 0 ; i < 14 ; i++ )
			{
				uint32 ofdmPower = 0, cckPower = 0;
				channel = i+1;

				/* ============================================================
						OFDM
				    ============================================================ */

				if (bdinfo_get8185OfdmTxPower(	&ofdmPower,
												channel,
												pRomeCfgParam->wlanCfgParam[w].range,
												w))
				{
					WLAN_ERR("Get OFDM TxPower error.");
					goto err;
				}

				/*		Invalid TxPower: '0xff' means the default value of storage (ex. NOR type FLASH),
						so we try to set it to default value and refetch TxPower again.						*/
				if ( ofdmPower == 0xff )
				{
					goto flashDefault;
				}
				/*
					Important Note:
						When we set  TxPower of channels,
						we must set the channel number as (channel - 1) to fix 8185 driver's constraint.

						==> i = (channel - 1)
				*/
				SETMIB(w, "TxPowerOFDM=%d,%d", i, ofdmPower);

				/* ============================================================
						CCK
				    ============================================================ */
	 
				bdinfo_get8185CckTxPower(&cckPower,channel, pRomeCfgParam->wlanCfgParam[w].range, w);

				/*
					Important Note:
						When we set  TxPower of channels,
						we must set the channel number as (channel - 1) to fix 8185 driver's constraint.

						==> i = (channel - 1)
				*/
				SETMIB(w, "TxPowerCCK=%d,%d", i, cckPower);

			}

			{
				/* start to set working channel number */
				if (pRomeCfgParam->wlanCfgParam[w].channel == 0)
				{
					channel = 0;
				} else
				{
				  	int first, last;;

					#define WLAN_REGDOMAIN_FCC			0
					#define WLAN_REGDOMAIN_CANADA		1
					#define WLAN_REGDOMAIN_EUROPE		2
					#define WLAN_REGDOMAIN_SPAIN			3
					#define WLAN_REGDOMAIN_FRANCE		4
					#define WLAN_REGDOMAIN_JAPAN			5
					#define WLAN_REGDOMAIN_ISRAEL		6
					

					switch (pRomeCfgParam->wlanCfgParam[w].regDomain)
					{
						case WLAN_REGDOMAIN_FCC:
							first = 1;
							last = 11;
							break;
						case WLAN_REGDOMAIN_CANADA:
							first = 1;
							last = 11;
							break;
						case WLAN_REGDOMAIN_EUROPE:
							first = 1;
							last = 13;
							break;
						case WLAN_REGDOMAIN_SPAIN:
							first = 10;
							last = 11;
							break;
						case WLAN_REGDOMAIN_FRANCE:
							first = 10;
							last = 13;
							break;
						case WLAN_REGDOMAIN_JAPAN:
							first = 1;
							last = 14;
							break;
						case WLAN_REGDOMAIN_ISRAEL:
							first = 3;
							last = 13;
							break;
						default:
							printf("[WARNING] Unknown regulation domain: %d\n");
							first = 0;
							last = 0;
					}

					if (pRomeCfgParam->wlanCfgParam[w].channel > (last-first+1))
					{	/* Unknown channel setting */
						WLAN_WARN("[WARNING] Unknown channel index: %d, reset to AUTO\n", pRomeCfgParam->wlanCfgParam[w].channel);
						pRomeCfgParam->wlanCfgParam[w].channel = 0;
						channel = 0;
					} else
					{
						channel = first + pRomeCfgParam->wlanCfgParam[w].channel - 1;
					}

				}
			}
			/* set channel */
			SETMIB(w, "channel=%d", channel);
		}
			break;
		default:
		{
			WLAN_ERR("Unknown data rate mode (%d).", pRomeCfgParam->wlanCfgParam[w].dataRateMode);
			goto err;
		}
	}

	/* =======================================================================
			SSID
	    ======================================================================= */

	if (strlen(pRomeCfgParam->wlanCfgParam[w].ssid) > 32)
	{
		WLAN_ERR("string length of SSID (%d) is too large.\n", strlen(pRomeCfgParam->wlanCfgParam[w].ssid));
		goto err;
	}

	SETMIB(w, "ssid=\"%s\"", pRomeCfgParam->wlanCfgParam[w].ssid);	/* SSID */
	SETMIB(w, "defssid=\"%s\"", pRomeCfgParam->wlanCfgParam[w].ssid);	/* default SSID : for IBSS mode */

	/* =======================================================================
			Band selection
				1		11b
				2		11g
				3		11b+g
				4		11a
	    ======================================================================= */
	{
		uint16 band[4] = {1/*b only*/, 2 /*g only*/,3/*b+g*/,4/*a only */};

		if (	(pRomeCfgParam->wlanCfgParam[w].dataRateMode >= 0	/* (b only) = 0 */) &&
			(pRomeCfgParam->wlanCfgParam[w].dataRateMode < 4	/* (a only) = 3 */))
		{
			SETMIB(w, "band=%d", band[pRomeCfgParam->wlanCfgParam[w].dataRateMode]);	/* Band selection */
		}
	}

	/* =======================================================================
			Rate setting

			Basic Rate :
				For the compatible issue with Centrino, basic rate need to be provided in different modes.

	    ======================================================================= */

	{
		uint32 basicRate = 0xfff;

		/* Rate support/BitMask mapping */
		#define R_1M			(1<<0)
		#define R_2M			(1<<1)
		#define R_5_5M		(1<<2)
		#define R_11M		(1<<3)
		#define R_6M			(1<<4)
		#define R_9M			(1<<5)
		#define R_12M		(1<<6)
		#define R_18M		(1<<7)
		#define R_24M		(1<<8)
		#define R_36M		(1<<9)
		#define R_48M		(1<<10)
		#define R_54M		(1<<11)

		/* oprate rate */
		if ( pRomeCfgParam->wlanCfgParam[w].dataRate > 0 )
		{
			uint16 opRateSet[13] = {	0		/* Auto*/				,
									0xfff	/* All rate <= 54M */		,
									0x7ff	/* All rate <= 48M */		,
									0x3ff	/* All rate <= 36M */		,
									0x1ff	/* All rate <= 24M */		,
									0x0ff	/* All rate <= 18M */		,
									0x07f	/* All rate <= 12M */		,
									0x03f	/* All rate <= 9M */		,
									0x01f	/* All rate <= 6M */		,
									0x00f	/* All rate <= 11M */		,
									0x007	/* All rate <= 5.5M */		,
									0x003	/* All rate <= 2M */		,
									0x001	/* All rate <= 1M */			};

			if (pRomeCfgParam->wlanCfgParam[w].dataRate < 13)
			{
				uint16 oprate = opRateSet[pRomeCfgParam->wlanCfgParam[w].dataRate];

				switch (pRomeCfgParam->wlanCfgParam[w].dataRateMode)
				{
					case WLAN_DATA_RATE_B:
						/* b mode only can use 1/2/5.5/11 M */
						oprate &= (R_1M | R_2M | R_5_5M | R_11M);
						break;
					default:
						/* all data rates are ok to use, we don't need to mask anyone. */
						break;
				}
				SETMIB(w, "oprates=%d", opRateSet[pRomeCfgParam->wlanCfgParam[w].dataRate]);
			} else
			{
				WLAN_WARN("Unknown data Rate item [%d], set to auto.", pRomeCfgParam->wlanCfgParam[w].dataRate);
				pRomeCfgParam->wlanCfgParam[w].dataRate = WLAN_DATA_RATE_AUTO;
			}
		}

		/* basic rate */
		switch (pRomeCfgParam->wlanCfgParam[w].dataRateMode)
		{
			case WLAN_DATA_RATE_B:
			case WLAN_DATA_RATE_BG:
			{
				basicRate = (R_1M | R_2M | R_5_5M | R_11M);
			}
				break;
			case WLAN_DATA_RATE_G:
			case WLAN_DATA_RATE_A:
			{
				basicRate = (R_6M | R_9M | R_12M | R_18M);
			}
				break;
			default:
			{
				WLAN_ERR("Unknown data rate mode (%d).", pRomeCfgParam->wlanCfgParam[w].dataRateMode);
				goto err;
			}
		}

		SETMIB(w, "basicrates=%d", basicRate);

		/* auto rate */
		SETMIB(w, "autorate=1");									/* we always turn ON auto rate */

		/* fix rate */
		SETMIB(w, "fixrate=%d", R_1M);								/* we never use fix rate */

	}

	/* =======================================================================
			Threshold / time related parameters
				- DTIM period
				- client inactivity time
				- Long/short retry limit
				- fragmentation threshold
				- RTS threshold
				- beacon interval
	    ======================================================================= */
	SETMIB(w, "dtimperiod=1");										/* DTIM period : 1 (because patent issue) */
	SETMIB(w, "expired_time=3000");									/* Client inactivity time in 10 ms */
	SETMIB(w, "longretry=6");											/* Long Retry Limit : 6 (default value in 8185 driver) */
	SETMIB(w, "shortretry=6");											/* Short Retry Limit : 6 (default value in 8185 driver) */
	SETMIB(w, "fragthres=%d", pRomeCfgParam->wlanCfgParam[w].frag);	/* fragmentation threshold */
	SETMIB(w, "rtsthres=%d", pRomeCfgParam->wlanCfgParam[w].rts);		/* RTS threshold */
	SETMIB(w, "bcnint=%d", pRomeCfgParam->wlanCfgParam[w].beacon);	/* beacon interval */
	SETMIB(w, "DRSA_disable=1");										/* We disable DRSA auto-adjustment now because it would hurt performacne in 865xB platform */
	/* =======================================================================
			MISC setting
				- DONT block associated clients' relay
				- DONT deny 'any'
				- DONT disable TX shortcut
				- DONT disable RX shortcut
				- Always enable NAT2.5
				- Always add broadcast flag into DHCP request
	    ======================================================================= */
	SETMIB(w, "block_relay=0");							/* For packet relaying between associated client: 0 - relay, 1 - block and drop 2 - block and indicate to bridge */
	SETMIB(w, "deny_any=0");								/* don't deny the association SSID of 'any' */
	SETMIB(w, "disable_txsc=0");							/* don't disable TX shortcut */
	SETMIB(w, "disable_rxsc=0");							/* don't disable RX shortcut */
	SETMIB(w, "nat25_disable=0");							/* always enable NAT 2.5 */
	SETMIB(w, "dhcp_bcst_disable=0");						/* always enable bcast for DHCP */

	/* set DMZ MAC address as gateway's LAN interface MAC for NAT2.5 mapping */
	if (0)	/* not enable yet */
	{
		uint8 macStr[6];

		bdinfo_getMac((macaddr_t*)macStr);
		SETMIB(w, "nat25_dmzMac=%02x%02x%02x%02x%02x%02x",
							macStr[0],
							macStr[1],
							macStr[2],
							macStr[3],
							macStr[4],
							macStr[5] + 1	/* refer wan lan initiaion function: LAN's MAC address is bdInfo's mac + 1 */);
	}

	/* =======================================================================
		Security

			- WEP/WPA/WPA2
			- configuration file setting
			- key setting
	    ======================================================================= */
	{
		/* Set WPA configuration file */
		if (wpaCfgFile)
		{
			SETCFGFILE(w, "ssid = \"%s\"", pRomeCfgParam->wlanCfgParam[w].ssid);
		}

		/* ====================================
				Encryption mode
		     ==================================== */
		{
			int32 encmode = 0;

			switch (pRomeCfgParam->wlanCfgParam[w].cryptType)
			{
				case CRYPT_NONE:
					encmode = 0;			/* disabled */
					break;
				case CRYPT_WEP:
				{
					switch (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0])
					{
						case CRYPT_SUB_WEP_64:
							encmode = 1;		/* WEP64 */
							break;
						case CRYPT_SUB_WEP_128:
							encmode = 5;		/* WEP128 */
							break;
						default:
							WLAN_ERR("Unknown encryption sub-type [%d] (encryption type : %d).",
								pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
								pRomeCfgParam->wlanCfgParam[w].cryptType);
							goto err;
					}
					break;
				}
				case CRYPT_WPA:
				case CRYPT_WPA2:
				{
					switch (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0])
					{
						case CRYPT_SUB_WPA_TKIPAES:	/* BOTH TKIP / AES are supported */
						/*
							8185 driver team:
								After test, if the encription supports both AES/TKIP, the AES/TKIP encryption type for each client
								is decided by 'auth' daemon and tell 8185 driver by iwcontrol. Therefore, the encmode could be
								set to one of TKIP or AES and these two setting are OK.
							
						*/
						case CRYPT_SUB_WPA_TKIP:
							encmode = 2;		/* TKIP */
							break;
						case CRYPT_SUB_WPA_AES:
							encmode = 4;		/* AES(CCMP) */
							break;
						default:
							WLAN_ERR("Unknown encryption sub-type [%d] (encryption type : %d).",
								pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
								pRomeCfgParam->wlanCfgParam[w].cryptType);
							goto err;
					}
					break;
				}
				case CRYPT_WPAMIX:
					/*
						8185 driver team:
							When cryption type set to WPA Mix mode, the AES/TKIP encryption type for each client is decided by 'auth' daemon
							and tell 8185 driver by iwcontrol. Therefore, the encmode could be set to one of TKIP or AES and these two setting are OK.
						
					*/
					encmode = 2;	/* TKIP */
					break;
				default:
					WLAN_ERR("Unknown ecryption type [%d].", pRomeCfgParam->wlanCfgParam[w].cryptType);
					goto err;
			}

			SETMIB(w, "encmode=%d", encmode);
		}

		/* ====================================
				WEP / WPA detail setting
		     ==================================== */
		{
			int32 key_idx;

			switch (pRomeCfgParam->wlanCfgParam[w].cryptType)
			{
				/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
										WEP
				    =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
				case CRYPT_WEP:
					/* -----------------------------------
							WEP encryption related setting
					     ----------------------------------- */

					/*
						Set Key inforamtion to 8185 driver:

							In 8185 driver, there are 4 different keys can set.
							However, in fact, we only allow user to set only 1 key in system now.
							Therefore, we set 4 key-entries with same key set by user,
							and always tell 8185 driver to use the key 1 to process encryption.
					*/
					for ( key_idx = 0 ; key_idx < 4 ; key_idx ++ )
					{
						/*
							The key set by user might be fail:

							In order to prevent MIB setting error, we would want to 
						*/
						if (wlan_chkKey(	pRomeCfgParam->wlanCfgParam[w].key,
										pRomeCfgParam->wlanCfgParam[w].cryptType,
										&(pRomeCfgParam->wlanCfgParam[w].cryptSubType))< 0)
						{
							int i;

							if (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0] == CRYPT_SUB_WEP_64)
							{
								uint8 key64[11] = {0};

								for ( i = 0 ; i < 10 ; i ++ )
								{
									uint8 ran, asci;

									ran = (rand() & 0x0f);
									asci = (ran >= 10)?(ran-10+'a'):(ran+'0');
									key64[i] = asci;
								}

								SETMIB(w, "wepkey%d=%s", (key_idx + 1), key64);
							} else
							{
								uint8 key128[27] = {0};

								assert(pRomeCfgParam->wlanCfgParam[w].cryptSubType[0] == CRYPT_SUB_WEP_128);

								for (i = 0 ; i < 26 ; i ++)
								{
									uint8 ran, asci;

									ran = (rand() & 0x0f);
									asci = (ran >= 10)?(ran-10+'a'):(ran+'0');
									key128[i] = asci;
								}

								SETMIB(w, "wepkey%d=%s", (key_idx + 1), key128);
							}
							
						} else
						{
							SETMIB(w, "wepkey%d=%s", (key_idx + 1), pRomeCfgParam->wlanCfgParam[w].key);
						}
					}

					SETMIB(w, "wepdkeyid=0");	/* always use the first key */

					/*
						Set WEP inforamtion to configuration file for AUTH:

							In 8185 driver, there are 4 different keys can set.
							However, in fact, we only allow user to set only 1 key in system now.
							Therefore, we set 4 key-entries with same key set by user,
							and always tell 8185 driver to use the key 1 to process encryption.
					*/

					if (wpaCfgFile)
					{
						/* Encryption setting */
						SETCFGFILE(w, "encryption = 1");

						/* WEP type */
						if (pRomeCfgParam->wlanCfgParam[w].cryptSubType[0] == CRYPT_SUB_WEP_64)
						{	/* WEP 64 */
							SETCFGFILE(w, "wepKey = 1");	/* WEP64 */
						} else
						{	/* WEP 128 */
							SETCFGFILE(w, "wepKey = 2");	/* WEP128 */
						}
					} else
					{
						WLAN_ERR("WPA configuration is not provided.");
					}

				/* continue to set AUTHENTICATION */
				case CRYPT_NONE:	/* Don't do encryption, we check authentication only */
					/* ---------------------------------------------------------------------
						WEP authentication related setting

						Now, for WEP, 865x platform provide 4 kinds of AUTH methods to
						be used:
							1. Open system (none)
							2. Pre-shared key
							3. auto (both Open system and Pre-shared key are ok)
							3. 802.1x radius
					     --------------------------------------------------------------------- */
					switch (pRomeCfgParam->wlanCfgParam[w].authType)
					{
						case AUTH_NONE:		/* Open system */
							SETMIB(w, "802_1x=0");			/* not 802.1x */
							SETMIB(w, "authtype=0");			/* 0: open system */
							break;

						case AUTH_KEY:		/* Pre-shared key */
							SETMIB(w, "802_1x=0");			/* not 802.1x */
							SETMIB(w, "authtype=1");			/* 1: shared key */
							break;

						case AUTH_AUTO:		/* Open system + Pre-shared key */
							SETMIB(w, "802_1x=0");			/* not 802.1x */
							SETMIB(w, "authtype=2");			/* 2: auto */
							break;

						case AUTH_8021x:	/* 802.1x */
							SETMIB(w, "802_1x=1");			/* 802.1x */
							/*
								chenyl (2005/09/14):

									Jimmy said, in (WEP + 802.1x) mode, we can allow user to set its authentication
									type (Open System / Shared Key / Auto).

									Due to our UI don't support independent setting of authentication type & 802.1x radius ON/OFF,
									we just simply set the authType to Auto mode when 802.1x is enabled.
							*/
							SETMIB(w, "authtype=2");			/* 2: auto */

							/* Set configuration file */
							if (wpaCfgFile)
							{
								/* enable 1x */
								SETCFGFILE(w, "enable1x = 1");
								/* authentication == 2: pre-shared key for WEP 802.1x authentication, referenced from 8186's setting (chenyl, 2005/9/16) */
								SETCFGFILE(w, "authentication = 2");
								/* Set the UDP Port number of radius server (normally, 1812 is used) */
								SETCFGFILE(w, "rsPort = %d", pRomeCfgParam->wlanCfgParam[w].authRadiusPort);
								/* IP Address of radius server */
								SETCFGFILE(w, "rsIP = %u.%u.%u.%u", NIPQUAD(pRomeCfgParam->wlanCfgParam[w].authRadiusIp));
								/* password of radius server (31 chars in max) */
								SETCFGFILE(w, "rsPassword = \"%s\"", pRomeCfgParam->wlanCfgParam[w].authRadiusPasswd);
								/* Max retry number of request packet with radius server (3 is the default value) */
								SETCFGFILE(w, "rsMaxReq = 3");
								/* Timeout (in sec.) of waiting RSP packet of radius server (5 is the default value) */
								SETCFGFILE(w, "rsAWhile = 5");
							} else
							{
								WLAN_ERR("WPA configuration is not provided.");
							}
							break;
						default:
							WLAN_ERR("Unknown authentication type [%d].", pRomeCfgParam->wlanCfgParam[w].authType);
							goto err;
					}
					
					break;
				/* ===================================================================== */

				/* =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
										WPA
				    =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= */
				case CRYPT_WPA:
				case CRYPT_WPA2:
				case CRYPT_WPAMIX:
				{
					int32 unicastCipher = -1, wpa2UnicastCipher = -1;
					int32 wpaCipher[CRYPT_SUB_MAX] = {
						-1	/* CRYPT_SUB_NONE , non-exist in WPA */,
						-1	/* CRYPT_SUB_WEP_64 , non-exist in WPA */,
						-1	/* CRYPT_SUB_WEP_128 , non-exist in WPA */,
						1	/* CRYPT_SUB_WPA_TKIP , WPA auth configuration is set to 1 */,
						2	/* CRYPT_SUB_WPA_AES , WPA auth configuration is set to 2 */,
						3	/* CRYPT_SUB_WPA_TKIPAES , WPA auth configuration is set to 3 (bit-width OR of TKIP and AES) */
					};
					/*
						For WPA settings, AUTH is always needed.
					*/
					if (wpaCfgFile == NULL)
					{
						WLAN_ERR("WPA configuration is not provided.");
						break;
					}

					/* -----------------------------------
							WPA encryption related setting
					     ----------------------------------- */

					/*
						Set Key inforamtion to 8185 driver.

						chenyl (2005/09/14):
							Jimmy said, in (WPA + 802.1x) mode, no matter its WPA, WPA2 or WPA mixed mode,
							the authentication type MUST be set to Open System !
					*/

					SETMIB(w, "authtype=0");	/* 0: open system */
					/*
						Set WEP inforamtion to configuration file for AUTH:
					*/

					/* disable MAC authentication */
					SETCFGFILE(w, "enableMacAuth = 0");
					/* disable non-WPA client support (not supported now) */
					SETCFGFILE(w, "supportNonWpaClient = 0");
					/* Group key re-key time (No use yet) */
					SETCFGFILE(w, "groupRekeyTime = 86400");

					/* For WPA/WPA2/WPA-Mix mode, the only w differences between them are Cipher function / encryption setting */

					switch (pRomeCfgParam->wlanCfgParam[w].cryptType)
					{
						case CRYPT_WPA:

							SETCFGFILE(w, "encryption = 2");

							unicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[0]];
							if (unicastCipher < 0)
							{
								WLAN_ERR("Invalid cryptSubType %d (crypt type: %d)",
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
									pRomeCfgParam->wlanCfgParam[w].cryptType);
								goto err;
							}
							break;
						case CRYPT_WPA2:

							SETCFGFILE(w, "encryption = 4");

							wpa2UnicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[0]];
							if (wpa2UnicastCipher < 0)
							{
								WLAN_ERR("Invalid cryptSubType %d (crypt type: %d)",
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
									pRomeCfgParam->wlanCfgParam[w].cryptType);
								goto err;
							}
							break;
						case CRYPT_WPAMIX:

							SETCFGFILE(w, "encryption = 6");

							unicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[0]];
							wpa2UnicastCipher = wpaCipher[pRomeCfgParam->wlanCfgParam[w].cryptSubType[1]];
							if (	(unicastCipher < 0) ||
								(wpa2UnicastCipher < 0) )
							{
								WLAN_ERR("Invalid cryptSubType %d, %d (crypt type: %d)",
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[0],
									pRomeCfgParam->wlanCfgParam[w].cryptSubType[1],
									pRomeCfgParam->wlanCfgParam[w].cryptType);
								goto err;
							}
							break;
					}

					if (unicastCipher >= 0)
					{
						SETCFGFILE(w, "unicastCipher = %d", unicastCipher);
					}

					if (wpa2UnicastCipher >= 0)
					{
						SETCFGFILE(w, "wpa2UnicastCipher = %d", wpa2UnicastCipher);
					}

					/* ---------------------------------------------------------------------
						WPA authentication related setting

						Now, for WPA, 865x platform provide 2 kinds of AUTH methods to
						be used:
							1. Pre-shared key
							2. 802.1x radius
					     --------------------------------------------------------------------- */
					switch(pRomeCfgParam->wlanCfgParam[w].authType)
					{
						case AUTH_8021x:	/* WPA radius */

							/* enable 1x */
							SETMIB(w, "802_1x=1"); 
							SETCFGFILE(w, "enable1x = 1");
							/* authentication == 1: radius */
							SETCFGFILE(w, "authentication = 1");
							/* Set the UDP Port number of radius server (normally, 1812 is used) */
							SETCFGFILE(w, "rsPort = %d", pRomeCfgParam->wlanCfgParam[w].authRadiusPort);
							/* IP Address of radius server */
							SETCFGFILE(w, "rsIP = %u.%u.%u.%u", NIPQUAD(pRomeCfgParam->wlanCfgParam[w].authRadiusIp));
							/* password of radius server (31 chars in max) */
							SETCFGFILE(w, "rsPassword = \"%s\"", pRomeCfgParam->wlanCfgParam[w].authRadiusPasswd);
							/* Max retry number of request packet with radius server (3 is the default value) */
							SETCFGFILE(w, "rsMaxReq = 3");
							/* Timeout (in sec.) of waiting RSP packet of radius server (5 is the default value) */
							SETCFGFILE(w, "rsAWhile = 5");
							break;

						case AUTH_KEY: /* WPA-PSK */

							/* disable 1x */
							SETMIB(w, "802_1x=0"); 
							SETCFGFILE(w, "enable1x = 0");
							/* authentication == 2: pre-shared key */
							SETCFGFILE(w, "authentication = 2");
							/* key process */
							keylen = strlen(pRomeCfgParam->wlanCfgParam[w].key);
							if (keylen != 64)	/* legal pre-shared key's length is 64 */
							{
								/* 1: use passphrase algorithm to convert Pre-shared Key value */
								SETCFGFILE(w, "usePassphrase = 1");
							}else
							{
								/* 0: use key as raw data */
								SETCFGFILE(w, "usePassphrase = 0");
							}

							/* pre-shared key: if (usePassphrase == 0), it's is 64 hex digits. if (usePassphrase == 1), this string length is (>=8) && (<=64) */
							SETCFGFILE(w, "psk = \"%s\"", pRomeCfgParam->wlanCfgParam[w].key);

							break;

						default:
							SETMIB(w, "802_1x=0"); 
							WLAN_ERR("Unknown authentication type [%d].", pRomeCfgParam->wlanCfgParam[w].authType);
							goto err;
					}
					break;
				}
				/* ===================================================================== */

				default:
					WLAN_ERR("Unknown encryption type [%d].", pRomeCfgParam->wlanCfgParam[w].cryptType);
					goto err;
			}
		}
	}

	/* =======================================================================
		Access control

			- ACL
	    ======================================================================= */

	if (pRomeCfgParam->wlanCfgParam[w].acEnable)	/* accept or deny */
	{
		int i;

		/* 0: disable 1: accept 2: deny */
		SETMIB(w, "aclmode=%d", pRomeCfgParam->wlanCfgParam[w].acEnable);

		/* init acl rule number */
		SETMIB(w, "aclnum=0");

		for ( i = 0 ; i < MAX_WLAN_AC ; i++ )
		{
			/* If acl rule is set, we set it to driver */
			if ( memcmp(pRomeCfgParam->wlanCfgParam[w].acMacList[i], temp, 6) != 0 )
			{
				SETMIB(w, "acladdr=%02x%02x%02x%02x%02x%02x",
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][0],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][1],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][2],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][3],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][4],
						pRomeCfgParam->wlanCfgParam[w].acMacList[i][5]
				);
			}
		}
	}else
	{
		/* init acl rule number */
		SETMIB(w, "aclnum=0");
	}

	/* =======================================================================
		WDS
	    ======================================================================= */

	/* we don't give WDS packets higher priority */
	SETMIB(w, "wds_priority=0");
	
	if (	(pRomeCfgParam->wlanCfgParam[w].mode > 1 /* It's 2 (WDS) or 3 (AP+WDS) */) &&
		(pRomeCfgParam->wlanCfgParam[w].wdsEnable))
	{
		char macAddr[16];
		macaddr_t macStr;
		uint8 *p = (unsigned char *)&macStr;
		int count = 0;
		uint8 invalid[6]={0xff,0xff,0xff,0xff,0xff,0xff};

		if (bdinfo_getWlanMac((macaddr_t*)&macStr, w) != 0)
		{
			WLAN_ERR("Can not get MAC Address.");
			goto err;
		}
		/* get MAC successfully */

		/*
			MAC is FF:FF:FF:FF:FF:FF	:
				It's invlalid and might be the default value of storage (ex. NOR Flash),
				so we must call reset function.
		*/
		if (memcmp(&invalid, p, 6) == 0)
		{
			goto flashDefault;
		}

		/* enable WDS */
		SETMIB(w, "wds_enable=1");

		/* init WDS number */
		SETMIB(w, "wds_num=0");

		/* before setting WDS interfaces, we must rearrange it */
		wds_rearrange();

		count = 0;
		for ( i = 0 ; i < MAX_WLAN_WDS ; i++)
		{
			/* Turn ON WDS interfaces */
			if (memcmp(pRomeCfgParam->wlanCfgParam[w].wdsMacList[i], temp, 6) != 0)
			{
				sprintf(macAddr, "%02x%02x%02x%02x%02x%02x",
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][0],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][1],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][2],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][3],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][4],
							pRomeCfgParam->wlanCfgParam[w].wdsMacList[i][5]	
				);

				SETMIB(w, "wds_add=%s", macAddr);

				SETIFCFG_WDS(w, count, "hw ether %02X:%02X:%02X:%02X:%02X:%02X", p[0], p[1], p[2], p[3], p[4], p[5]);
				count++;

				/* ==========================================
					Default don't use any encryption over WDS links.

					If user wants to support encryption on WDS, please
					refers to RTL8185's iwpriv document.
				    ========================================== */
			}
		}
	}else
	{
		/* Disable WDS */
		SETMIB(w, "wds_enable=0");
		/* init WDS number */
		SETMIB(w, "wds_num=0");

	}

	return 0;	/* SUCCESS */

flashDefault:
	{
		int cnt;
		WLAN_WARN("== Reset MP-CFG parameters for WLAN [%d] ==", w);
		IWPRIV(w, "mp_cfg default");
		WLAN_WARN("== Done, re-start setting ==");
		SLEEP(3);
	}
	goto wlan_start_setting;	/* restart setting */

err:
	return -1;	/* FAILED */
}


void wlan_setup (int32 flag)
{
	int32 w;
	char cmdBuf[128];
	int8 cfgFilePathFmt[]="/var/8185auth%d.conf";
	int8 cfgFilePath[64];
	int32 restart;
	int8 daemonInUsed = FALSE;	/* indicate if IAPP or 802.1x daemon are used or not */

do_again:

	restart = 0;

	/* =========================================================================== 
			Stop Interfaces and services
	    =========================================================================== */
	for ( w = 0 ; w < totalWlanCards ; w++ )
	{
		/* stop wlan interface */
		WLAN_INFO("==> Stop wlan%d", w);
		sprintf(cmdBuf, "ifconfig wlan%d down", w);
		printf("%s\n", cmdBuf);system(cmdBuf);;

		/* stop wds interfaces if any */
		WLAN_INFO("==> Stop WDS for wlan%d", w);
		wds_down(w);

		/* shutdown Daemon: AUTH */
		{
			int pid = 0;
			FILE *f;

			sprintf(cmdBuf, "/var/run/auth-wlan%d.pid", w);
			
			f = fopen(cmdBuf, "r");
			if ( f )
			{
				fscanf(f, "%d", &pid);
				fclose(f);

				if ( pid != 0 )
				{
					WLAN_INFO("@ Try to Kill process %s (%d)", cmdBuf, pid);
					kill(pid, SIGTERM);
					WLAN_INFO("\t=> Done");
				}
				f = fopen (cmdBuf, "r");
				if (f)
				{
					fclose(f);
					remove (cmdBuf);
				}
			}

			/* remove configuration file */
			sprintf(cmdBuf, cfgFilePathFmt, w);
			f = fopen(cmdBuf, "r");
			if ( f )
			{
				fclose(f);
				remove (cmdBuf);
			}
		}
	}

	for ( w=0 ; w < totalWlanCards ; w++ )
	{
		FILE *wpaCfgFile;

		/* setup driver via iwpriv */
		sprintf(cfgFilePath, cfgFilePathFmt, w);
		wpaCfgFile = fopen(cfgFilePath,"w+");		/* erase old file and create new one. */

		if (wlandrv_setup(w, wpaCfgFile))
		{
			WLAN_ERR("wlan%d setup failed!!!\n", w);
			continue;
		}
		if (wpaCfgFile)
		{
			fclose(wpaCfgFile);
		}

		/* now bring up wlan interface */
		WLAN_INFO("==> Turn ON wlan%d", w);
		sprintf(cmdBuf, "ifconfig wlan%d up",w);
		printf("%s\n", cmdBuf);system(cmdBuf);	

		/* now bring up wds interfaces if any */
		WLAN_INFO("==> Turn ON WDS for wlan%d", w);
		wds_up(w);

		/*
			start user level auth daemon if WPA enabled or Radius enable:

				802.1x Daemon Configuration:
					Need start daemon when:
						- WPA/WPA2 is used
						- WEP + 802.1x (authentication with radius server)
						- No encryption + 802.1x (authentication with radius server)
		*/
		if (	(pRomeCfgParam->wlanCfgParam[w].cryptType==CRYPT_WPA)||
			(pRomeCfgParam->wlanCfgParam[w].cryptType==CRYPT_WPA2)||
			(pRomeCfgParam->wlanCfgParam[w].cryptType==CRYPT_WPAMIX) ||
			(pRomeCfgParam->wlanCfgParam[w].authType==AUTH_8021x))
		{
			daemonInUsed = TRUE;

 			if (wpaCfgFile == NULL)
			{
				WLAN_ERR("Must run auth daemon but no cfg file exist\n");
				return;
			}

			SLEEP(3);

			WLAN_INFO("==> auth start");
			if (pRomeCfgParam->wlanCfgParam[w].mode != 1)
			{	/* is AP mode */
				sprintf(cmdBuf, "auth wlan%d eth1 auth %s &", w,cfgFilePath);
			}else
			{
				/* is client mode */
				if (pRomeCfgParam->wlanCfgParam[w].adhoc == 1)
				{
					sprintf(cmdBuf, "auth wlan%d eth1 client-adhoc %s &", w,cfgFilePath);
				}else
				{
					sprintf(cmdBuf, "auth wlan%d eth1 client-infra %s &", w,cfgFilePath);
				}
			}
			printf("%s\n", cmdBuf); system(cmdBuf);
		}
	}

	/* delay before runing iwcontrol is needed */
	SLEEP(3);

	/* start user level iwcontrol daemon to recv driver->auth messages */
	if (daemonInUsed == TRUE)
	{
		/*
			iwcontrol Daemon Configuration
				Need start daemon when:
					- 802.1x daemon is used
					- IAPP daemon is used
					==> Note: iwcontrol daemon should be started AFTER 802.1x or IAPP daemon is running.
		*/
		WLAN_INFO("==> iwcontrol start");
		{
			sprintf(cmdBuf, "iwcontrol ");
			for ( w = 0 ; w < totalWlanCards ; w++ )
			{
				sprintf(cmdBuf, "%s wlan%d", cmdBuf, w);
			}
			printf("%s\n", cmdBuf);system(cmdBuf);
		}
	}

	/* if in client mode, join to AP */
	for ( w=0 ; w<totalWlanCards ; w++ )
	{
		if (pRomeCfgParam->wlanCfgParam[w].mode == 1)
		{
			if ( 1==apClientJoin(w, flag) )
			{
				restart ++;
			}
		}
	}

	if (restart)
	{
		flag = 0;
		goto do_again;
	}
}

/* ====================================
		RTL8185 informations
    ==================================== */
int wlan_rtl8185_getInterfaceCount (void)
{
	int32 idx;
	char intfMib[32];
	FILE *fd;
	int intfCnt = 0;

	for ( idx = 0 ; idx < MAX_WLAN_CARDS ; idx ++ )
	{
		memset(intfMib, 0, sizeof(intfMib));
		sprintf(intfMib,"/proc/wlan%d/mib_all", idx);

		fd = fopen(intfMib, "r");
		if (fd == NULL)
		{
			break;
		}
		fclose(fd);

		intfCnt ++;
	}

	return intfCnt;
}

#endif	/* CONFIG_RTL8185 */

void ddns_start (void)
{
	char str[160]={0};
	char interface[10]={0};
	int cnt=0;
	FILE *f,*f2;
		
	if(pRomeCfgParam->ddnsCfgParam.enable==1)
	{
		//del old process
		remove("/var/run/no-ip2.conf");
		do_kill("/var/run/no-ip2.pid");	
	
		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
			case IFCFGPARAM_CONNTYPE_DHCPC:
				sprintf(interface,"eth0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE:
			case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
				sprintf(interface,"ppp0");
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
				sprintf(interface,"ppp%d",pRomeCfgParam->pppoeCfgParam[pRomeCfgParam->pppoeCfgParam[0].whichPppObjId].pppx);
				break;
		}
		
		f2=fopen("/var/run/no-ip2.pid","r");
		if(f2!=NULL) { fclose(f2); return; } // process is running...
	
		remove("/var/run/no-ip2.conf");
		sprintf(str,"noip2 -C -U 30 -u \"%s\" -p \"%s\" -I %s &",pRomeCfgParam->ddnsCfgParam.username,pRomeCfgParam->ddnsCfgParam.password,interface);
		system(str);	
		while(1)
		{
			sleep(1);
			f=fopen("/var/run/no-ip2.conf","r");
			if(f!=NULL) break;
			cnt++;
			if(cnt>5) break;
		}
		if(f!=NULL) fclose(f);
		if(cnt>5) return; // configure file can't be created.		
		system("/bin/noip2 &");	
	}


	//ez-ipupdate
	if(strlen(pRomeCfgParam->ddnsCfgParam.service)!=0) //not be disabled
	{
		int r;
		r=send_signal("/var/run/ez-ipupdate.pid",9);
		if(r==0) 	sleep(1);

		sprintf(str,"/bin/ez-ipupdate -d --pid-file /var/run/ez-ipupdate.pid --service-type %s --user %s:%s --host %s",pRomeCfgParam->ddnsCfgParam.service,
			pRomeCfgParam->ddnsCfgParam.username2,
			pRomeCfgParam->ddnsCfgParam.password2,
			pRomeCfgParam->ddnsCfgParam.hostname
		);


		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
			case IFCFGPARAM_CONNTYPE_DHCPC:
				strcat(str," --interface eth0");
				break;
			case IFCFGPARAM_CONNTYPE_PPTP:
			case IFCFGPARAM_CONNTYPE_L2TP:
			case IFCFGPARAM_CONNTYPE_PPPOE:
			case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
			case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
				strcat(str," --interface ppp0");
				break;					
		}

		strcat(str," &");
		printf("run:[%s]\n",str);
		system(str);
	}
	
}
#ifdef CONFIG_KU_KLIPS
void vpnIpsec_Init()
{
	if (cfgmgr_read(CFGMGR_TABID_IPSECCONFIG,(void*)(&pRomeCfgParam->ipsecConfigCfgParam), sizeof(struct ipsecConfigCfgParam_s)*MAX_IPSEC_SESSION)!=0)
	{
		printf("ipsecConfig_init: call cfgmgr_read fail\n");
		/* take proper actions */
	}

}
int  vpnIpsec_start(int wanType)
{
	int i,start;
	FILE *fp;
	

	start=0;
	mgmt_udp_500=0;
	system("/etc/rc.d/init.d/ipsec stop");
	fp=fopen("/var/ipsec.conf","w+");
	fprintf(fp,"version	2.0	# conforms to second version of ipsec.conf specification\n");;
	fprintf(fp,"# basic configuration\n");
	fprintf(fp,"config setup\n");
	if (wanType==IFCFGPARAM_CONNTYPE_STATIC||wanType==IFCFGPARAM_CONNTYPE_DHCPC)
		fprintf(fp,"\tinterfaces=\"ipsec0=eth0\"\n\tklipsdebug=none\n\tplutodebug=none\n");
	else
		fprintf(fp,"\tinterfaces=\"ipsec0=ppp0\"\n\tklipsdebug=none\n\tplutodebug=none\n");
		
	if (cfgmgr_read(CFGMGR_TABID_IPSECGLOBALCONFIG,(void*)(&pRomeCfgParam->ipsecGlobalCfgParam), sizeof(struct ipsecGlobalCfgParam_s))!=0)
	{
		printf("ipsecGlobalConfig_init: call cfgmgr_read fail\n");
	}
	if (pRomeCfgParam->ipsecGlobalCfgParam.enableNatTraversal)
		fprintf(fp,"\tnat_traversal=yes\n");

	fprintf(fp,"\tplutostderrlog=/tmp/pluto.log\n");
	fclose(fp);


	fp=fopen("/var/ipsec.secrets","w+");
	fprintf(fp,"\n");
	fclose(fp);
	if (cfgmgr_read(CFGMGR_TABID_IPSECCONFIG,(void*)(&pRomeCfgParam->ipsecConfigCfgParam), sizeof(struct ipsecConfigCfgParam_s)*MAX_IPSEC_SESSION)!=0)
	{
		printf("ipsecConfig_init: call cfgmgr_read fail\n");
		/* take proper actions */
		remoteMgmt_tableDriverAccess();
		return 1;
	}
	for (i=0;i<MAX_IPSEC_SESSION;i++)
	{
		if (pRomeCfgParam->ipsecConfigCfgParam[i].enable)
		{
			start=1;
			mgmt_udp_500=1;
			fp=fopen("/var/ipsec.conf","a+");
			fprintf(fp,"conn Tunnel%c\n",(char)'A'+i);
			fprintf(fp,"\ttype=tunnel\n",i);
			fprintf(fp,"\tleft=%u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[0].ipAddr[0],
				pRomeCfgParam->ifCfgParam[0].ipAddr[1],
				pRomeCfgParam->ifCfgParam[0].ipAddr[2],
				pRomeCfgParam->ifCfgParam[0].ipAddr[3]);
			fprintf(fp,"\tleftnexthop=%u.%u.%u.%u\n",
				pRomeCfgParam->ifCfgParam[0].gwAddr[0],
				pRomeCfgParam->ifCfgParam[0].gwAddr[1],
				pRomeCfgParam->ifCfgParam[0].gwAddr[2],
				pRomeCfgParam->ifCfgParam[0].gwAddr[3]);


			fprintf(fp,"\tleftsubnet=%u.%u.%u.%u/24\n",
				(pRomeCfgParam->ipsecConfigCfgParam[i].localnet>>24)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].localnet>>16)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].localnet>>8)&0xff,
				pRomeCfgParam->ipsecConfigCfgParam[i].localnet&0xff);
			fprintf(fp,"\trightsubnet=%u.%u.%u.%u/24\n",
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotenet>>24)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotenet>>16)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotenet>>8)&0xff,
				pRomeCfgParam->ipsecConfigCfgParam[i].remotenet&0xff);
			fprintf(fp,"\tright=%u.%u.%u.%u\n",
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotegw>>24)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotegw>>16)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotegw>>8)&0xff,
				pRomeCfgParam->ipsecConfigCfgParam[i].remotegw&0xff);

			fprintf(fp,"\tkeyexchange=ike\n");
			if (pRomeCfgParam->ipsecConfigCfgParam[i].encryption==1)
			{
				if (pRomeCfgParam->ipsecConfigCfgParam[i].authentication==1)
					fprintf(fp,"\tesp=3des-md5-96\n");
				else
					fprintf(fp,"\tesp=3des-sha1-96\n");
			}
			else
			{
					fprintf(fp,"\tesp=aes256-sha1\n");
			}
			fprintf(fp,"\tauto=start\n");
			fprintf(fp,"\tkeyingtries=3\n");
			if ((pRomeCfgParam->ipsecConfigCfgParam[i].ipsec_keylife<1200)|| (pRomeCfgParam->ipsecConfigCfgParam[i].isakmp_keylife<1200))
			fprintf(fp,"\trekeymargin=%d\n",(pRomeCfgParam->ipsecConfigCfgParam[i].ipsec_keylife>>1)-1);

			if (pRomeCfgParam->ipsecConfigCfgParam[i].ipsec_keylife>2)
			{
							fprintf(fp,"\tkeylife=%ds\n",pRomeCfgParam->ipsecConfigCfgParam[i].ipsec_keylife);
			}
			if (pRomeCfgParam->ipsecConfigCfgParam[i].isakmp_keylife)
				fprintf(fp,"\tikelifetime=%ds\n",pRomeCfgParam->ipsecConfigCfgParam[i].isakmp_keylife);
			fprintf(fp,"\tauthby=secret\n");

			if (pRomeCfgParam->ipsecConfigCfgParam[i].pfs)
				fprintf(fp,"\tpfs=yes\n");
			else
				fprintf(fp,"\tpfs=no\n");

			fprintf(fp,"\n\n\n#Diable OE\n");
			fprintf(fp,"conn block\n");
			fprintf(fp,"\tauto=ignore\n");
			fprintf(fp,"conn private\n");
			fprintf(fp,"\tauto=ignore\n");
			fprintf(fp,"conn private-or-clear\n");
			fprintf(fp,"\tauto=ignore\n");
			fprintf(fp,"conn clear-or-private\n");
			fprintf(fp,"\tauto=ignore\n");
			fprintf(fp,"conn clear\n");
			fprintf(fp,"\tauto=ignore\n");
			fprintf(fp,"conn packetdefault\n");
			fprintf(fp,"\tauto=ignore\n");
			fprintf(fp,"\n");
			fclose(fp);

			fp=fopen("/var/ipsec.secrets","a+");
			fprintf(fp,"%u.%u.%u.%u  %u.%u.%u.%u : PSK  \"%s\"\n",
				pRomeCfgParam->ifCfgParam[0].ipAddr[0],
				pRomeCfgParam->ifCfgParam[0].ipAddr[1],
				pRomeCfgParam->ifCfgParam[0].ipAddr[2],
				pRomeCfgParam->ifCfgParam[0].ipAddr[3],
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotegw>>24)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotegw>>16)&0xff,
				(pRomeCfgParam->ipsecConfigCfgParam[i].remotegw>>8)&0xff,
				pRomeCfgParam->ipsecConfigCfgParam[i].remotegw&0xff,
				pRomeCfgParam->ipsecConfigCfgParam[i].secrets);
			
			fclose(fp);


				
		}
	}

	remoteMgmt_tableDriverAccess();
	if (start) system("/etc/rc.d/init.d/ipsec restart");
	return 0;	

}
#endif
/*
 * Routine Name: ddns_init
 * Description: configure ddns cfg param entry
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 ddns_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_DDNS,(void*)&(pRomeCfgParam->ddnsCfgParam), sizeof(struct ddnsCfgParam_s))!=0)
	{
		printf("ddns_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	return 0;	
} /* end ddns_init */


uint32 rateLimit_init(void)
{
	int32 retval;
	uint32 entry;
	uint8 *ifname[] = { "eth1", "eth0" };
	rtl8651_tblDrvAclRule_t rule;
	
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_RATELIMIT,(void*)&(pRomeCfgParam->rateLimitCfgParam), sizeof(struct rateLimitCfgParam_s))!=0) 	{
		printf("rateLimit_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	for(entry=0; entry<16; entry++) {
		if (pRomeCfgParam->rateLimitCfgParam.entry[entry].enable == FALSE) {
			bzero(&pRomeCfgParam->rateLimitCfgParam.entry[entry], sizeof(rateLimitEntry_t));
			pRomeCfgParam->rateLimitCfgParam.entry[entry].ipMask = 0xffffffff;
			continue;
		}
		if (pRomeCfgParam->rateLimitCfgParam.enable == FALSE)
			continue;
		asp_addRateLimitRule(&pRomeCfgParam->rateLimitCfgParam.entry[entry], entry);
	}

	return 0;
}

uint32 ratioQos_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_RATIOQOS,(void*)&(pRomeCfgParam->ratioQosCfgParam), sizeof(struct ratioQosCfgParam_s))!=0)
	{
		printf("ratioQos_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if(pRomeCfgParam->ratioQosCfgParam.enable)
	{
		int i;
		for(i=0;i<ALG_QOS_TYPES;i++)
		{
			uint32 queueId;
			uint32 isHigh,enable,ratio;

			enable=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].enable;
			isHigh=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].isHigh;
			ratio=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].ratio;			

			if(enable==1)
			{
				queueId=pRomeCfgParam->ratioQosCfgParam.upInfo.algQosEntry[i].queueID;
/* Following configuration is invalid due to NULL rule return SUCCESS directly */
				if(isHigh==1)
				{
					rtl8651_addFlowToUnlimitedQueue("eth0",NULL,ratio,queueId);
				}
				else
				{
					rtl8651_addFlowToLimitedQueue("eth0",NULL,ratio,queueId);
				}
			}
			else queueId=0;
			
			switch(i)
			{
				case 0: //ftp
					rtl8651_setAlgQosQueueId(RTL8651_ALG_FTP_IDX,queueId,isHigh, ratio);
					break;
				case 1://sip
					rtl8651_setAlgQosQueueId(RTL8651_ALG_SIP_IDX,queueId,isHigh, ratio);
					break;
				case 2://netmeeting
					rtl8651_setAlgQosQueueId(RTL8651_ALG_NETMEETING_IDX,queueId,isHigh, ratio);
					break;
			}
				
		}
	}

	
	rearrange_Ratio_Qos(FALSE);
	return 0;
}


uint32 pseudoVlan_init(void)
{
	uint32 port, portMask[6] = { 0 }, i;
	uint32 startVid;
	
	
	if (cfgmgr_read(CFGMGR_TABID_PSEUDOVLAN,(void*)&(pRomeCfgParam->pseudoVlanCfgParam), sizeof(struct pseudoVlanCfgParam_s))!=0)
	{
		printf("pseudoVlan_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if (pRomeCfgParam->vlanCfgParam[0].vid > pRomeCfgParam->vlanCfgParam[1].vid)
		startVid = pRomeCfgParam->vlanCfgParam[0].vid+1;
	else startVid = pRomeCfgParam->vlanCfgParam[1].vid+1;

	if (pRomeCfgParam->pseudoVlanCfgParam.enable == TRUE) {
		for(port=0; port<RTL8651_PORT_NUMBER; port++) {
			if (pRomeCfgParam->pseudoVlanCfgParam.portVid[port] == 0)
				continue;
			portMask[pRomeCfgParam->pseudoVlanCfgParam.portVid[port]-startVid] |= (1<<port);
		}
		for(i=0; i<6; i++) {
			if (portMask[i] > 0)
				rtl8651_addSubVlan(pRomeCfgParam->vlanCfgParam[1].vid, i+startVid, portMask[i]);
		}
	}
	return 0;
}



/*
 *  This function will return the external IP address of the specific session
 *    no matter the WAN type is static or not, and no matter the WAN type is PPPoE or not.
 */
ipaddr_t board_getExternalIp( int32 ms )
{
	ipaddr_t msIp;

	msIp = NULL;

	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_STATIC:/* fall through */
		case IFCFGPARAM_CONNTYPE_DHCPC: /* fall through */
		case IFCFGPARAM_CONNTYPE_PPTP:  /* fall through */
		case IFCFGPARAM_CONNTYPE_L2TP:  /* fall through */
		case IFCFGPARAM_CONNTYPE_PPPOE: /* fall through */
		case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
			msIp = pRomeCfgParam->ifCfgParam[0].ipAddr[0] << 24 |
		           pRomeCfgParam->ifCfgParam[0].ipAddr[1] << 16 |
		           pRomeCfgParam->ifCfgParam[0].ipAddr[2] << 8 |
		           pRomeCfgParam->ifCfgParam[0].ipAddr[3];
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
			if ( pRomeCfgParam->pppoeCfgParam[ms].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS )
			{
				msIp = pRomeCfgParam->pppoeCfgParam[ms].ipAddr[0] << 24 |
			           pRomeCfgParam->pppoeCfgParam[ms].ipAddr[1] << 16 |
			           pRomeCfgParam->pppoeCfgParam[ms].ipAddr[2] << 8 |
			           pRomeCfgParam->pppoeCfgParam[ms].ipAddr[3];
			}
			break;
		default:
			break;
	}

	return msIp;
}


/*
 *	Protocol-Based NAT
 */

int32 pbnat_ipup( int32 ms, ipaddr_t MyIp )
{
	int j, ret, count = 0;

	if ( MyIp == NULL ) return SUCCESS; /* This session does NOT holds an IP address */
	
	for( j = 0; j < MAX_PBNAT; j++ )
	{
		if ( pRomeCfgParam->pbnatCfgParam[ms][j].enabled )
		{
			ret = rtl8651_addProtocolBasedNAT( pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
			                                   MyIp,
		                                       pRomeCfgParam->pbnatCfgParam[ms][j].IntIp );
			if ( ret != SUCCESS )
			{
				printf( "rtl8651_addProtocolBasedNAT(protocol:%d,ExtIp:%08x,IntIp:%08x) error: %d, but never mind.\n",
					pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
					MyIp,
		    		pRomeCfgParam->pbnatCfgParam[ms][j].IntIp,
		    		ret );
			}

			count++;
		}
	}

	if ( count > 0 )
		rtl8651_EnableProtocolBasedNAT( TRUE );

	return SUCCESS;
}


int32 pbnat_ipdown( int32 ms, ipaddr_t MyIp )
{
	int j, ret;

	if ( MyIp == NULL ) return SUCCESS; /* This session does NOT holds an IP address */
	
	for( j = 0; j < MAX_PBNAT; j++ )
	{
		if ( pRomeCfgParam->pbnatCfgParam[ms][j].enabled ) // no matter enabled or not, delete anyway.
		{
			ret = rtl8651_delProtocolBasedNAT( pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
			                                   MyIp,
		                                       pRomeCfgParam->pbnatCfgParam[ms][j].IntIp );
			if ( ret != SUCCESS )
			{
				printf( "rtl8651_delProtocolBasedNAT(protocol:%d,ExtIp:%08x,IntIp:%08x) error: %d, but never mind.\n",
					pRomeCfgParam->pbnatCfgParam[ms][j].protocol,
					MyIp,
		    		pRomeCfgParam->pbnatCfgParam[ms][j].IntIp,
		    		ret );
			}
		}
	}

	/* Since all entries are deleted, disable this function. */
	rtl8651_EnableProtocolBasedNAT( FALSE );
	
	return SUCCESS;
}


uint32 pbnat_init()
{
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_PBNAT,(void*)&(pRomeCfgParam->pbnatCfgParam), sizeof(struct pbnatCfgParam_s)*MAX_PBNAT*MAX_PPPOE_SESSION)!=0)
	{
		printf("pbnat_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if ( pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_STATIC )
	{
		pbnat_ipup( 0, pRomeCfgParam->ifCfgParam[0].ipAddr[0] << 24 |
		               pRomeCfgParam->ifCfgParam[0].ipAddr[1] << 16 |
		               pRomeCfgParam->ifCfgParam[0].ipAddr[2] << 8 |
		               pRomeCfgParam->ifCfgParam[0].ipAddr[3] );
	}

	return 0;
}


uint32 qos_init(void)
{	
	rtl8651_tblDrvPolicy_t policy;
	int32 index;
	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_QOS,(void*)&(pRomeCfgParam->qosCfgParam), sizeof(struct qosCfgParam_s)*MAX_QOS)!=0)
	{
		printf("qos_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return 1;
	}

	if (pRomeCfgParam->qosCfgParam[0].qosType & ENABLE_QOS) {
		for (index=0; index<7; index++) {
			if (pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber != 0) {
				bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
				policy.proto = RTL8651_POLICY_TCP;
				//Server is in the WAN
				policy.dport_start = 0; policy.dport_end = 65535;
				policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				//Server is in the LAN
				policy.sport_start = 0; policy.sport_end = 65535;
				policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);

				bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
				policy.proto = RTL8651_POLICY_TCP;
				//Server is in the WAN
				policy.sport_start = 0; policy.sport_end = 65535;
				policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				//Server is in the LAN
				policy.dport_start = 0; policy.dport_end = 65535;
				policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
				rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);

				if (index > 3) {
					bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
					policy.proto = RTL8651_POLICY_UDP;
					//Server is in the WAN
					policy.dport_start = 0; policy.dport_end = 65535;
					policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					//Server is in the LAN
					policy.sport_start = 0; policy.sport_end = 65535;
					policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth0", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);

					bzero(&policy, sizeof(rtl8651_tblDrvPolicy_t));
					policy.proto = RTL8651_POLICY_UDP;
					//Server is in the WAN
					policy.sport_start = 0; policy.sport_end = 65535;
					policy.dport_start = policy.dport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
					//Server is in the LAN
					policy.dport_start = 0; policy.dport_end = 65535;
					policy.sport_start = policy.sport_end = pRomeCfgParam->qosCfgParam[index].un.policy_based.portNumber;
					rtl8651_addPolicyBasedQoS("eth1", &policy, pRomeCfgParam->qosCfgParam[index].un.policy_based.isHigh);
				}
				
			}

		}
	}

	
	if (pRomeCfgParam->qosCfgParam[7].qosType & ENABLE_QOS) {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			rtl8651_setFlowControl(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.enableFlowCtrl);
			rtl8651_setPortPriorityQueue(index, pRomeCfgParam->qosCfgParam[index+7].un.port_based.isHigh);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.inRL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, pRomeCfgParam->qosCfgParam[index+7].un.port_based.outRL);
		}
	}
	else {
		for(index=0; index<RTL8651_PORT_NUMBER; index++) {
			rtl8651_setFlowControl(index, TRUE);
			rtl8651_setPortPriorityQueue(index, FALSE);
			rtl8651_setEthernetPortBandwidthControl(index, TRUE, RTL8651_BC_FULL);
			rtl8651_setEthernetPortBandwidthControl(index, FALSE, RTL8651_BC_FULL);
		}
	}
	
	return 0;	
} 

/* ==========================================================================================
						Board-info access
     ========================================================================================== */
#define BDINFO_ACCESS_FUNCs

int32 bdinfo_read(bdinfo_t *bdInfo_p)
{
	if (bdInfo_p == NULL)
	{
		return FAILED;
	}

	flashdrv_read(	(void*)bdInfo_p,
					(void*)FLASH_MAP_BOARD_INFO_ADDR,
					sizeof(bdinfo_t));

	return SUCCESS;
}

int32 bdinfo_getMac(macaddr_t *mac_p)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		memcpy(	(void*)mac_p,
					(void*)&(bdinfo.mac),
					sizeof(macaddr_t));
	}

	return 0;
} /* end bdinfo_getMac */

int32 bdinfo_getWlanMac(macaddr_t *mac_p, int index)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		memcpy(mac_p, bdinfo.wlan[index].mac, sizeof(macaddr_t));
		return 0;
	}
	return -1;
} 

int32 bdinfo_get8185CckTxPower(int *txPower, unsigned int channel, unsigned int level, unsigned int index)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		*txPower = (int)(bdinfo.wlan[index].cckTxPower[channel - 1][level]);
		return 0;
	}
	return -1;
}

int32 bdinfo_get8185OfdmTxPower(int *txPower, unsigned int channel, unsigned int level, unsigned int index)
{
	bdinfo_t bdinfo;

	if (channel > 14)
	{
		channel = 14 + ((channel-36)/4) + 1;
	}

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		*txPower = (int)(bdinfo.wlan[index].txPower[channel-1][level]);
		return 0;
	}
	return -1;
}

int32 bdinfo_get8185ChargePumpSetting(unsigned int *rx,unsigned int *tx, unsigned int index)
{
	bdinfo_t bdinfo;

	if (bdinfo_read(&bdinfo) == SUCCESS)
	{
		*rx = bdinfo.wlan[index].rxChargePump;
		*tx = bdinfo.wlan[index].txChargePump;
		return 0;
	}
	return -1;
}

/* ========================================================================================== */


/*
 * Routine Name: specialap_init
 * Description: configure specialap cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 specialap_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_SPECIALAP,(void*)pRomeCfgParam->specialapCfgParam, sizeof(struct specialapCfgParam_s)*MAX_SPECIAL_AP*MAX_PPPOE_SESSION)!=0)
	{
		printf("specialap_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	return OK;
} /* end specialap_init */

/*
 * Routine Name: gaming_init
 * Description: configure gaming cfg param entry
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 gaming_init(void)
{	
	/* read cfg from cfgmgr */
	if (cfgmgr_read(CFGMGR_TABID_GAMING,(void*)pRomeCfgParam->gamingCfgParam, sizeof(struct gamingCfgParam_s)*MAX_GAMING*MAX_PPPOE_SESSION)!=0)
	{
		printf("gaming_init: call cfgmgr_read fail\n");
		/* take proper actions */
		return NOT_OK;
	}
	return OK;
} /* end gaming_init */


/*
 * rtl8651 demo system configuration initialization entry point
 * called by main.c of go-ahead web server	
 */
#define SIGNAL(s, handler)	do { \
	sa.sa_handler = handler; \
	sigaction(s, &sa, NULL);  \
    } while (0)



struct circ_buf {
	int size;			
	int head;			
	int tail;			
	char data[1];		
};


void log_event(int sig)
{
	int idx=sig-60;
	FILE *f;
	int exit=FALSE;
	struct circ_buf *buf;
	uint32 index=0;
	int i=-1;
	int head,size,tail;
	int show=0;
	int moduleId=1<<(idx);
	char tempstr[160]={0},tempstr2[160]={0};	
	struct sockaddr_in address;
	struct hostent *host; 
	int sockfd;
	int ret;
	void* circBuff = NULL;

	f=fopen("/var/mail_content.txt","w");

	if (f == NULL)
	{
		printf("open /var/mail_content.txt FAILED\n");
		return;
	}
	fprintf(f,"Mail Alert: ");	
	switch(idx)
	{
		case 1:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_ACL)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_ACL)==0)) exit=TRUE;
			fprintf(f,"ACL");
			break;
		case 2:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_DOS)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_DOS)==0)) exit=TRUE;
			fprintf(f,"DoS");
			break;
		case 3:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_URL)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_URL)==0)) exit=TRUE;
			fprintf(f,"URL Filter");
			break;
		case 4:
			if(((pRomeCfgParam->logCfgParam[0].module&RTL8651_MAILALERT_NEWFLOW)==0) &&
				((pRomeCfgParam->logCfgParam[0].module&RTL8651_REMOTELOG_NEWFLOW)==0)) exit=TRUE;		
			fprintf(f,"New Connection");
			break;
	}

	if(exit==TRUE)
	{
		fclose(f);
		return;
	}


	if((pRomeCfgParam->logCfgParam[0].module & RTL8651_REMOTELOG_MASK )!=0) 
	{
		sockfd=socket(AF_INET,SOCK_DGRAM,0);
		host=gethostbyname(pRomeCfgParam->mgmtCfgParam[0].logserver);	
		if(host==NULL) {  printf("gethostbyname error\n");  return -1;	} 	
		memset(&address,0,sizeof(address));	address.sin_family=PF_INET;
		address.sin_addr=*((struct in_addr *)host->h_addr); 	
		address.sin_port=htons(514);  //RFC 3164
		ret=connect(sockfd,(struct sockaddr *)&address,sizeof(address));		
		if(ret==-1) {	printf("error\n"); close(sockfd); return -1; }
		sprintf(tempstr,"<%d>",(16+idx)*8+6);		
	}

	fprintf(f,"\r\n");

	if ( moduleId == RTL8651_LOGMODULE_SYS)
	{
		buf = getCircBufPtrByModuleId(moduleId);
	} else
	{
		circBuff = malloc(sizeof(struct circ_buf)+16000);
		if ( circBuff )
		{
			memset(circBuff, 0, (sizeof(struct circ_buf)+16000));
			if (rtl8651_getLogFromKernel(circBuff, moduleId, (sizeof(struct circ_buf)+16000)) == SUCCESS)
			{
				buf = (struct circ_buf *)circBuff;
			} else
			{
				buf = NULL;
			}
		} else
		{
			buf = NULL;
		}
	}
	
	if (	(buf == -1) ||
		(buf == NULL))
	{
		fclose(f);
		return 0;
	}

	head=buf->head;
	size=buf->size;
	tail=buf->tail;
		
	if(head>tail) tail+=size;

	/*
		determine show message or not according to the "prefix" of each message:
			show message only when this message is not dsid related ('x') or the dsid is same as the dsid(it's "ms") we select now.
	*/
	if((buf->data[head]=='0') || buf->data[head] == 'x')
		show = 1;
	else
		show = 0;
	
	for( i = tail-3; i >=head ; i--)
	{
		idx = i;
		while (idx >= size)
			idx -= size;
		
		if(buf->data[idx] == 0) 
		{
			break;
		}			

		if(buf->data[idx] == 10) 
		{	/* LF: Line Feed, we add new line in html form */
			break;
		}

		if (buf->data[idx] == 13)
		{	/* CR: Carriage Return, we ignore it */ 
			break;
		}	

	}

	if(show == 1)
	{
		char t[2]={0};		
		for(i=idx+1;i<tail;i++)
		{

			t[0]=buf->data[i];
			if(i==idx+1) if(t[0]=='0') continue;
			strcat(tempstr2,t);
		}	
		fprintf(f,"%s",tempstr2);
	}

	if((pRomeCfgParam->logCfgParam[0].module & RTL8651_REMOTELOG_MASK )!=0) 
	{
		strcat(tempstr,tempstr2);	
		write(sockfd,tempstr,strlen(tempstr));
		close(sockfd);
		printf("RemoteLog...\n");					
	}

	fclose(f);	

	if((pRomeCfgParam->logCfgParam[0].module & RTL8651_MAILALERT_MASK )!=0) 
	{
		printf("MailAlert...\n");
		sprintf(tempstr,"/bin/sendmail %s %s %s",pRomeCfgParam->mgmtCfgParam[0].smtpserver,pRomeCfgParam->mgmtCfgParam[0].mailfrom,pRomeCfgParam->mgmtCfgParam[0].rcptto);
		system(tempstr);			
	}

	if (circBuff)
	{
		free(circBuff);
	}

}

void pppd_start_dial(int sig)
{
	char idStr[4];
	int identity;
	char tmp[20];
	FILE *f2;
	identity=sig-40;
	sprintf(idStr,"%u",identity);
	fprintf(stderr,"receive signal %d identity %d\n",sig,identity);
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)	
	if(identity==4) // PPTP
	{	
		char tmp[32];
		rtl8651_setNetMtu("eth0",pRomeCfgParam->pptpCfgParam.mtu);
		sprintf(tmp,"/var/run/pptp.pid");		

#ifdef __uClinux__ 
#else //MMU
		send_signal(tmp,9);
		unlink(tmp);
		unlink("/var/run/pppd0.pid");
#endif

#ifdef __uClinux__ //non-MMU
		f2=fopen(tmp,"r");
		if(f2)
		{		
			fclose(f2);
			send_signal("/var/run/pptp.pid",SIGUSR2);
		}		
		else
#endif			
		{
			sprintf(tmp,"/bin/pptp %u.%u.%u.%u &"
			,pRomeCfgParam->pptpCfgParam.svAddr[0]
			,pRomeCfgParam->pptpCfgParam.svAddr[1]
			,pRomeCfgParam->pptpCfgParam.svAddr[2]
			,pRomeCfgParam->pptpCfgParam.svAddr[3]);
			system(tmp);
		}

	}
	else if(identity==5)
	{
		char tempStr[32];
		rtl8651_setNetMtu("eth0",pRomeCfgParam->l2tpCfgParam.mtu);
		sprintf(tempStr,"/var/run/l2tpd.pid");		
#ifdef __uClinux__ 
#else // MMU
		send_signal(tempStr,9);
		unlink(tempStr);
		unlink("/var/run/pppd0.pid");
#endif

#ifdef __uClinux__ // non-MMU
		f2=fopen(tempStr,"r");
		if(f2)
		{
			fclose(f2);
			send_signal("/var/run/l2tpd.pid",SIGUSR2);		
		}
		else
#endif			
		{		
			sprintf(tempStr,"/bin/l2tpd &");
			system(tempStr);
		}
	}
	else
	{
#endif
		sprintf(tmp,"/var/run/pppd%u.pid",identity);

#ifdef __uClinux__ 
#else//MMU
		send_signal(tmp,9);
		unlink(tmp);
#endif

#ifdef __uClinux__
		f2=fopen(tmp,"r");
		if(f2)
		{
			fclose(f2);
			send_signal(tmp,16); //restart pppd
		}
		else // run first time	
#endif		
		{
#ifdef CONFIG_PPP_MPPE_MPPC
			run_pppoe(identity);
#else
			do_exec("/bin/pppd",idStr);
#endif
		}
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)	
	}
#endif

}


#if defined(CONFIG_RTL865X_INIT_BUTTON)
void call_factory_default(int sig)
{
	cfgmgr_factoryDefault(1);
} /* end call_factory_ default */
#endif /* CONFIG_RTL865X_INIT_BUTTON */

/*   Parameter: wan type before system reinit. 
  *   Need this information to reset "protocol stack-related" configuration. */
void sysReinit(uint32 past_wanType)
{
	int32 ret;
	char	*av[3], *av1[4], argv[2];
	char	pname[] = "/bin/ifconfig";
	char	zero_string[] = "0.0.0.0";

	/* === Reset CFGMGR === */
	cfgmgr_reinit(FALSE);

	/* === Flush arp cache in linux kernel === */
	FILE *fp;
	int sockfd = 0;
	struct arpreq {
		struct sockaddr arp_pa;   /* protocol address */
		struct sockaddr arp_ha;   /* hardware address */
         	int arp_flags;            /* flags */
		struct sockaddr arp_netmask; 
		char arp_dev[16];
	} req;
	struct sockaddr_in *sin;
	struct in_addr ina;
	unsigned char *hw_addr;
	char line[200], ip[100], hwa[100], mask[100], dev[100];
	int num, type, flags, idx;
			
	if ((fp = fopen("/proc/net/arp", "r")) == NULL)
		printf("Open /proc/net/arp error!\n");
	if (fgets(line, sizeof(line), fp) != (char *) NULL) {
		for (; fgets(line, sizeof(line), fp);) {
			num = sscanf(line, "%s 0x%x 0x%x %100s %100s %100s\n", ip, &type, &flags, hwa, mask, dev);
		    	if (num < 4)
				break;
			sockfd = socket(AF_INET, SOCK_DGRAM, 0);
			if (sockfd < 0)
		    		printf("socket() error\n");
			sin = (struct sockaddr_in *) &req.arp_pa;
			memset(&req, 0, sizeof(req));
			sin->sin_family = AF_INET;
			ina.s_addr = inet_addr(ip);
			memcpy(&sin->sin_addr, (char *)&ina, sizeof(struct in_addr));
			strncpy(req.arp_dev, dev, 4);
			req.arp_ha.sa_family = AF_UNSPEC;
			ret = ioctl(sockfd, SIOCDARP, &req);
			if (ret < 0)
				printf("ioctl(arp) not successful, ret: %d\n", ret);
		}
	}

#if 0
	char *av1[4];
	char pname1[] = "/bin/ip";
	av1[0] = pname1;
	av1[1] = "neigh";
	av1[2] = "flush";
	av1[3] = "all";

	runProgram(pname1, av1);
#endif

	/* == Remove linux default route == */
	{
		int32 ret;
		int sockfd = 0;
		struct sockaddr_in *dst, *gw, *mask;
		struct rtentry route;

		sockfd = socket(AF_INET, SOCK_DGRAM, 0);
		memset(&route, 0, sizeof(struct rtentry));

		dst = (struct sockaddr_in *)(&(route.rt_dst));
		gw = (struct sockaddr_in *)(&(route.rt_gateway));
		mask = (struct sockaddr_in *)(&(route.rt_genmask));

		/* Make sure we're talking about IP here */
		dst->sin_family = AF_INET;
		gw->sin_family = AF_INET;
		mask->sin_family = AF_INET;

		/* Set up the data for removing the default route */
		dst->sin_addr.s_addr = 0;
		gw->sin_addr.s_addr = 0;
		mask->sin_addr.s_addr = 0;
		route.rt_flags = RTF_UP | RTF_GATEWAY;
		    
		/* Remove the default route */
		ret = ioctl(sockfd, SIOCDELRT, &route);
		if (ret < 0)
			printf("ioctl(route) not successful ret: %d\n", ret);
	}
	// linux kernel setting
	av1[0] = pname;
	av1[1] = "eth0";
	av1[2] = zero_string;
	av1[3] = NULL;
	runProgram(pname, av1);

	av[1] = "eth1";
	runProgram(pname, av1);

	/*
		turn OFF all interfaces.
	*/
	rtk_linux_intf_upDown(NULL /* wide-card match : all interfaces */, FALSE, NULL);

	if (past_wanType == IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED || past_wanType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE) {
		av[1] = "eth1:1";
		runProgram(pname, av);
		
	}

	av[1] = "eth1";
	runProgram(pname,av);

	av[1] = "lo";
	runProgram(pname,av);

	switch(past_wanType) {
		case IFCFGPARAM_CONNTYPE_STATIC:
			#if 0
			argv[0] = "default";
			argv[1] = NULL;
			INET_setroute(RTACTION_DEL, 0, argv);
			#endif
			break;
		case IFCFGPARAM_CONNTYPE_DHCPC:
			do_kill("/var/run/udhcpc.pid");
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
		case IFCFGPARAM_CONNTYPE_PPPOE:
			{
				int pid = 0;
				FILE *f;
				f = fopen("/var/run/pppd0.pid","r");
				if(f != NULL)
				{
					fscanf(f, "%d", &pid);
					kill(pid,SIGKILL);
					fclose(f);			
				}
			}
			remove("/var/run/pppd0");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:
			do_kill("/var/run/l2tpd.pid");
			do_kill("/var/run/pppd0.pid");
			remove("/var/l2tpd.conf");
			remove("/var/l2tpd-pppd.conf");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
			do_kill("/var/run/l2tpd.pid");
			do_kill("/var/run/pppd0.pid");
			do_kill("/var/run/udhcpc.pid");
			remove("/var/l2tpd.conf");
			remove("/var/l2tpd-pppd.conf");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
		case IFCFGPARAM_CONNTYPE_PPTP:
			do_kill("/var/run/pptp.pid");
			do_kill("/var/run/pppd0.pid");
			remove("/var/run/pptp_redial");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
			{
				int pid = 0;
				FILE *f;
				f = fopen("/var/run/pppd0.pid","r");
				if(f != NULL)
				{
					fscanf(f, "%d", &pid);
					kill(pid,SIGKILL);
					fclose(f);			
				}
			}
			remove("/var/run/pppd0");
			remove("/var/ppp/chap0");
			remove("/var/ppp/pap0");
			remove("/var/ppp/options0");

			av1[0] = pname;
			av1[1] = "ppp0";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp0";
			runProgram(pname,av);

			{
				int pid = 0;
				FILE *f;
				f = fopen("/var/run/pppd1.pid","r");
				if(f != NULL)
				{
					fscanf(f, "%d", &pid);
					kill(pid,SIGKILL);
					fclose(f);			
				}
			}
			remove("/var/run/pppd1");
			remove("/var/ppp/chap1");
			remove("/var/ppp/pap1");
			remove("/var/ppp/options1");

			av1[0] = pname;
			av1[1] = "ppp1";
			av1[2] = zero_string;
			av1[3] = NULL;
			runProgram(pname, av1);

			av[1] = "ppp1";
			runProgram(pname,av);
			break;
		default:
			break;
	}

	ret = rtl8651_tblDrvReinit();
	if (ret)
		printf("rtl8651_tblDrvReinit: ret %d\n", ret);

	ret = rtl8651_fwdEngineReinit();
	if (ret)
		printf("rtl8651_fwdEngineReinit: ret %d\n", ret);

	ret = rtl8651_reProbe();
	if (ret)
		printf("rtl8651_reProbe: ret %d\n", ret);

	sysInit();
}


uint32 sysInit(void)
{
	FILE *f1;
    struct sigaction sa;
    sigset_t mask;
	int i;

	printf("System initializing...\n");
	fflush(0);

	/* ===================================
		0. Init cfgmgr structure
	=================================== */
	if (pRomeCfgParam)
	{
		memset(pRomeCfgParam, 0, sizeof(romeCfgParam_t));
	}

	/* ===================================
		1. Init cfgmgr modules
	=================================== */

	/* code has removed to websAspInit() in asp_page.c, init cfgmgr before all procedures */
	
	/* ===================================
		2. Init timezone
	=================================== */
	time_init();
	zone_init();
	/* ===================================
		3. Init variables for NAT
	=================================== */
	nat_init();
	/* ===================================
		4. Init signals
	=================================== */
    	sigemptyset(&mask);
    	sigaddset(&mask, 40);
    	sigaddset(&mask, 41);
    	sigaddset(&mask, 42);
    	sigaddset(&mask, 43);

    	sigaddset(&mask, 44); //for pptp
    	sigaddset(&mask, 45); //for l2tp
	#if defined(CONFIG_RTL865X_INIT_BUTTON)
	sigaddset(&mask, 50);
	#endif /* CONFIG_RTL865X_INIT_BUTTON */

	sigaddset(&mask, 61); //for mail alert and remote log:ACL
	sigaddset(&mask, 62); //for mail alert and remote log:DoS
	sigaddset(&mask, 63); //for mail alert and remote log:URL Filter
	sigaddset(&mask, 64); //for mail alert and remote log:NAPT log

	sa.sa_mask = mask;
	sa.sa_flags = 0;
	re865xIoctl("eth0",ADD_SIGNAL_RECEIVE_PROCESS,getpid(),0,0);
    	SIGNAL(40, pppd_start_dial);	
    	SIGNAL(41, pppd_start_dial);	
    	SIGNAL(42, pppd_start_dial);	
    	SIGNAL(43, pppd_start_dial);
    	SIGNAL(44, pppd_start_dial);
    	SIGNAL(45, pppd_start_dial); 

	SIGNAL(61, log_event);   
	SIGNAL(62, log_event);   
	SIGNAL(63, log_event);   
	SIGNAL(64, log_event);   	

	#if defined(CONFIG_RTL865X_INIT_BUTTON)
	SIGNAL(50, call_factory_default);
	#endif /* CONFIG_RTL865X_INIT_BUTTON */

	/* ===================================
		5. Init variables for VLAN
	=================================== */
	vlan_init();

	/* call cfgmgr to read xxxCfgParam structures from nv-ram
	 * wan interface's init is flat in this sysInit()
	 */
	
	/* ===================================
		6. Init variables for Interface
	=================================== */
	if (cfgmgr_read(CFGMGR_TABID_IF,(void*)pRomeCfgParam->ifCfgParam, sizeof(pRomeCfgParam->ifCfgParam))!=0)
	{
		printf("sysInit: cfgmgr read ifCfgParam fail\n");
		/* take proper actions */
		return 1;
	}
	memcpy((void*)&ramWanCfgParam, &(pRomeCfgParam->ifCfgParam[0]),sizeof(ifCfgParam_t));
	memcpy((void*)&ramLanCfgParam, &(pRomeCfgParam->ifCfgParam[1]),sizeof(ifCfgParam_t));
	
	/* ===================================
		7. Init variables for DHCP-Client
	=================================== */
	if (cfgmgr_read(CFGMGR_TABID_DHCPC,(void*)&(pRomeCfgParam->dhcpcCfgParam), sizeof(dhcpcCfgParam_t))!=0)
	{
		printf("sysInit: cfgmgr read dhcpcCfgParam fail\n");
		/* take proper actions */
		return 1;
	}
	
	memcpy((void*)&(ramDhcpcCfgParam),(void*)&(pRomeCfgParam->dhcpcCfgParam),sizeof(dhcpcCfgParam_t));
	
	/* check if dhcp client uses clone mac */
	#if 0
	/* rupert used another method to check if clone mac is used in wanlan_init() */
	for(i=0; i<VLAN_LOAD_COUNT; i++)
	{
		if(pRomeCfgParam->vlanCfgParam[i].valid)
		{
			if (   i==0 /* vlanCfgParam[0] is for external vlan(wan) */
			    && (pRomeCfgParam->ifCfgParam[i].connType  == IFCFGPARAM_CONNTYPE_DHCPC)
			    && (pRomeCfgParam->dhcpcCfgParam.cmacValid == 1)
			   )
			{				
				if (    pRomeCfgParam->dhcpcCfgParam.cloneMac[0]==0
				     && pRomeCfgParam->dhcpcCfgParam.cloneMac[1]==0
				     && pRomeCfgParam->dhcpcCfgParam.cloneMac[2]==0
				     && pRomeCfgParam->dhcpcCfgParam.cloneMac[3]==0
				     && pRomeCfgParam->dhcpcCfgParam.cloneMac[4]==0
				     && pRomeCfgParam->dhcpcCfgParam.cloneMac[5]==0 )
				{
					/* error-protection: in case err cfg cannot boot */
					pRomeCfgParam->dhcpcCfgParam.cloneMac[0]=0x00;
					pRomeCfgParam->dhcpcCfgParam.cloneMac[1]=0x00;
					pRomeCfgParam->dhcpcCfgParam.cloneMac[2]=0xdd;
					pRomeCfgParam->dhcpcCfgParam.cloneMac[3]=0xee;
					pRomeCfgParam->dhcpcCfgParam.cloneMac[4]=0xff;
					pRomeCfgParam->dhcpcCfgParam.cloneMac[5]=0x10;
				}				
				
				memcpy(mac,pRomeCfgParam->dhcpcCfgParam.cloneMac,6);
			}
			else
			{
				bdinfo_getMac((macaddr_t*)mac);
				mac[5]+=i;
			}			
			memcpy(&(pRomeCfgParam->vlanCfgParam[i].gmac), mac, 6);		
		} /* end if */		
	} /* end for i */	
	memcpy(&(pRomeCfgParam->vlanCfgParam[i].gmac), mac, 6);
	#endif

	/* ===================================
		8. Init variables for PPPoE
	=================================== */
	if (cfgmgr_read(CFGMGR_TABID_PPPOE,(void*)pRomeCfgParam->pppoeCfgParam, sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION)!=0)
	{
		printf("sysInit: cfgmgr read ppoeCfgParam fail\n");
		/* take proper actions */
		return 1;
	}

	/* ===================================
		9. Init PPTP/L2TP services
	=================================== */
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	pptp_init();// read pptp configuration
	//printf("l2tp, ");	
	l2tp_init();// read l2tp configuration
	pRomeCfgParam->pptpCfgParam.dialState=PPTPCFGPARAM_DIALSTATE_OFF;	
	pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;
#endif //CONFIG_RTL865X(B)_PPTPL2TP
	// clear dialState when boot
	for(i=0;i<MAX_PPPOE_SESSION;i++)
		pRomeCfgParam->pppoeCfgParam[i].dialState=PPPOECFGPARAM_DIALSTATE_OFF;	
	
	
	memcpy((void*)ramPppoeCfgParam,(void*)pRomeCfgParam->pppoeCfgParam,sizeof(pppoeCfgParam_t)*MAX_PPPOE_SESSION);

	/* ===================================
		10. Init WAN/LAN settings and configurations
	=================================== */
	opMode_init();	// Read the operation mode (Gateway/Router/Bridge) which is configured in FLASH.
	
	if (pRomeCfgParam->modeCfgParam.Mode == RTL865XB_L2BRIDGEMODE)
		bridge_wanlan_init();
	else	 if (pRomeCfgParam->modeCfgParam.Mode == RTL865XB_L3ROUTERMODE)
		router_wanlan_init();
	else
		wanlan_init(); //NOTICE: rome driver access is okay after this line

	/* ===================================
		11. Init RomeDriver Services
	=================================== */
	log_init();	
	userDb_init();
	/* read from flash, these components are wan-independent */
	urlfilter_init(); // read flash and setTableDriver
	urlfilterTrustedUser_init(); // read flash and setTableDriver
	dns_init();
	dos_init();
	alg_init();
	dhcps_init();	

	/* read from flash, these components are wan-dependent */
	specialap_init(); //must before acl_tableDriverAccess()
	gaming_init(); //must before acl_tableDriverAccess()
	acl_init();  //must before acl_tableDriverAccess()
	serverp_init();		
	dmz_init();
	udpblock_init();
	upnp_init();	
	snmp_init();		
	ddns_init();
	routing_init();
	stunnel_init();
	rip_init();
	qos_init();
	pbnat_init();
	rateLimit_init();
	ratioQos_init();
	napt_init();
	pseudoVlan_init();
	passthru_init();
	ipMulticast_init();
#ifdef CONFIG_KU_KLIPS
	vpnIpsec_Init();
#endif
#ifdef CONFIG_RTL865XB_PPTPSERVER
	pptpserver_init();
#endif

	domainBlock_init();

	/* ===================================
		12. Init Wireless LAN

		NOTE:
			(tony: wlan must put here, else other init will have problem.)
	=================================== */
	wlan_init();
	
	/* ===================================
		13.	Init configurations and related services
			if WAN-side is the STATIC IP Mode
	=================================== */
	if((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_STATIC)
		||(pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_USB_ETHERNET))
	{
		/* for wan cfg other than STATIC, network interface will be created
		 * after wan ip is assigned, so acl rule can only be created by that
		 * time
		 */
		time_start();		
		acl_tableDriverAccess();
		serverp_tableDriverAccess(0);
		dmz_tableDriverAccess(0);
		udp_tableDriverAccess(0);
		upnp_start();
		snmp_start();		
		syslogd_start();
		ddns_start(); //must after dns_init();
#ifdef CONFIG_KU_KLIPS
		vpnIpsec_start(pRomeCfgParam->ifCfgParam[0].connType);
#endif
		rtl8651a_setWanStatus(0,TRUE);
		rtl8651a_setDosStatus(0, ((pRomeCfgParam->dosCfgParam[0].enable)?(pRomeCfgParam->dosCfgParam[0].enableItem):0));
		rtl8651a_setAlgStatus(0,pRomeCfgParam->algCfgParam[0].algList,pRomeCfgParam->algCfgParam[0].localIp);
	}

	/* ===================================
		14.	Init DHCP Server
	=================================== */
	if(pRomeCfgParam->dhcpsCfgParam.enable==1) dhcps_start();

	/* ===================================
		15.	Init Remote-management functions
	=================================== */
	remoteMgmt_tableDriverAccess();	

	/* ===================================
		16.	Init semaphores
	=================================== */
	rtl8651_sem_init(1);	/* default : no counting semaphore */

	return 0;
} /* end sysInit */

/*
 * re865x Ioctl (to call kernel functions including rtl8651 table driver APIs
 */
int re865xIoctl(char *name,uint32 arg0, uint32 arg1, uint32 arg2, uint32 arg3)
{
	uint32 args[4];
	struct ifreq ifr;
	int sockfd;

	args[0] = arg0;
	args[1] = arg1;
	args[2] = arg2;
	args[3] = arg3;

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		DEBUG_P("fatal error socket\n");
		return -3;
	}
	strcpy((char*)&ifr.ifr_name, name);
	((uint32 *)(&ifr.ifr_data))[0] = (uint32)args;
	if (ioctl(sockfd, SIOCDEVPRIVATE, &ifr)<0)
	{
		perror("device ioctl:");
		close(sockfd);
		return -1;
	}
	close(sockfd);
	return 0;
} /* end re865xIoctl */


/*
		run command with argument
 
*/
int runProgram(char *name,char *argv[])
{
	int pid;
	char *env[2];	
	pid =vfork();
	if (pid==0)
	{
		pid=vfork();
		if (pid>0) _exit(0); // second parent; grandparent still alive 
		env[0]="PATH=/bin:/sbin";
		env[1]=NULL;
		execve(name,argv,env);
		_exit(0);
	}
	else
		waitpid(pid,NULL,0);
	return 0;

}
int do_exec(char *name, char *identity)
{
	int pid,pid1;
	
	pid =vfork();
	if (pid==0)
	{
		char *av[3];
		char timezone[20];
		char *env[3];
		char tempStr[20]={0};
		FILE *f;
		f=fopen("/etc/TZ","r");
		if(f!=NULL)
		{
			fgets(tempStr,20,f);
			fclose(f);
		}

		pid1=vfork();
		if (pid1>0) _exit(0); // second parent; grandparent still alive 
		
		env[0]="PATH=/bin:/sbin";
		#if 0	/* should not fix TZ environment variable */
		strcpy(timezone,"TZ=std+00:00:00"); 
		#endif
		snprintf(timezone, strlen(tempStr) + 3, "TZ=%s", tempStr);
		env[1]=timezone;
		env[2]=NULL;
		//memcpy(env[1],tempStr,12);
		av[0]=name;
		av[1]=identity;
		//sprintf(tempStr,"%x",(uint32)pRomeCfgParam);
		av[2]=NULL;
		//av[3]=NULL;
		setsid();
		execve(name,av,env);
		_exit(0);
	}
	else
		waitpid(pid,NULL,0);
		
	//st = WEXITSTATUS(stat);
	return 0;
} /* end do_exec */


int run_pppoe(int session)
{
	char tempStr[256];
	sprintf(tempStr,"/bin/pppd  %u pty '/bin/pppoe -i %u -p /var/run/pppoe%u -I eth0 -T 80 -U -m %u %s %s' user %s &",
		session,session,session
		,pRomeCfgParam->pppoeCfgParam[session].mtu-40
		,(pRomeCfgParam->pppoeCfgParam[session].serviceName[0]==0)?"":"-S"
		,pRomeCfgParam->pppoeCfgParam[session].serviceName
		,pRomeCfgParam->pppoeCfgParam[session].username);

	system(tempStr);
	return 0;
} /* end do_exec */

int do_kill(char *filename)
{
	int pid=0;
	FILE *f;
	f=fopen(filename,"r");
	if(f!=NULL)
	{
		fscanf(f,"%d",&pid);

		kill(pid,SIGTERM);
		kill(pid,SIGQUIT);
		sleep(1);
		kill(pid,SIGKILL);
		fclose(f);
		remove(filename);
		return 0;
	}
	return -1;	
}



#define IFREQ_OFFSETOF(x)  offsetof(struct ifreq, x)
int setInterfaceIp(char *name,int ip, int netmask)
{
	struct ifreq ifr;
	unsigned char Str[20];
	struct sockaddr_in sai;
	unsigned char	*v=(char*)&ip;
	int net_fd;

	if ((net_fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		DEBUG_P("fatal error socket\n");
	}
	strcpy((char*)&ifr.ifr_name, name);
	sprintf(Str,"%u.%u.%u.%u",v[0],v[1],v[2],v[3]);
	sai.sin_family = AF_INET;
	sai.sin_addr.s_addr = INADDR_ANY;
	sai.sin_port = 0;
	if(inet_aton(Str, &sai.sin_addr) == 0) 
	{
		DEBUG_P("not dotted\n");
	}
	memcpy((char*)&ifr+IFREQ_OFFSETOF(ifr_addr),(char*)&sai,
		       sizeof(struct sockaddr));
	if (ioctl(net_fd, SIOCSIFADDR, &ifr) < 0) 
		DEBUG_P("error ioctl\n");

	v=(char*)&netmask;
	sprintf(Str,"%u.%u.%u.%u",v[0],v[1],v[2],v[3]);
	if(inet_aton(Str, &sai.sin_addr) == 0) 
	{
		DEBUG_P("not dotted\n");
	}
	memcpy((char*)&ifr+IFREQ_OFFSETOF(ifr_netmask),(char*)&sai,
		       sizeof(struct sockaddr));
	if (ioctl(net_fd, SIOCSIFNETMASK, &ifr) < 0) 
		DEBUG_P("error2 ioctl\n");


	if (ioctl(net_fd, SIOCGIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCGIFFLAGS"); 
	ifr.ifr_flags=IFF_UP|IFF_RUNNING|IFF_MULTICAST;
	if (ioctl(net_fd, SIOCSIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCSIFFLAGS"); 
	close(net_fd);
	return 0;
}	
int upInterface(char *name)
{
	struct ifreq ifr;
	//struct sockaddr_in sai;
	int net_fd;
	if ((net_fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		DEBUG_P("fatal error socket\n");
	}
	strcpy((char*)&ifr.ifr_name, name);
	if (ioctl(net_fd, SIOCGIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCGIFFLAGS"); 
	ifr.ifr_flags=IFF_UP|IFF_RUNNING|IFF_MULTICAST;
	if (ioctl(net_fd, SIOCSIFFLAGS, &ifr) < 0) 
		DEBUG_P("SIOCSIFFLAGS"); 
	close(net_fd);
	return 0;
}	

uint32 board_checkSubnetOverlapping(ipaddr_t ipAddr, ipaddr_t ipMask)
{
	#define WAN_INTERFACE_NUM  0
	
	int i;
	uint8 gipAddr[4], gnetMask[4];

	printf("=> Check subnet (%u.%u.%u.%u/%u.%u.%u.%u) overlapping .... ", NIPQUAD(ipAddr), NIPQUAD(ipMask));

	gipAddr[0] = (uint8)((uint32)ipAddr >> 24);
	gipAddr[1] = (uint8)(((uint32)ipAddr & 0x00ff0000) >> 16);
	gipAddr[2] = (uint8)(((uint32)ipAddr & 0x0000ff00) >> 8);
	gipAddr[3] = (uint8)(((uint32)ipAddr & 0x000000ff));

	gnetMask[0] = (uint8)((uint32)ipMask >> 24);
	gnetMask[1] = (uint8)(((uint32)ipMask & 0x00ff0000) >> 16);
	gnetMask[2] = (uint8)(((uint32)ipMask & 0x0000ff00) >> 8);
	gnetMask[3] = (uint8)((uint32)ipMask & 0x000000ff);

 
	for ( i = 0 ; i < MAX_IP_INTERFACE ; i ++ )
	{
		int arrIdx, j;
		uint8 bmask;
		if ( i == WAN_INTERFACE_NUM )	/* same as WAN */
			continue;
		if ( pRomeCfgParam->ifCfgParam[i].valid )
		{
			for (arrIdx = 0; arrIdx < 4 ; arrIdx ++)
			{
				for (j = 0 ; j < 8 ; j ++)
				{
					uint8 ip[2], msk[2];

					bmask = 1<<j;	/* bitmask in current Array entry */

					ip[0] = pRomeCfgParam->ifCfgParam[i].ipAddr[arrIdx] & bmask;
					msk[0] = pRomeCfgParam->ifCfgParam[i].ipMask[arrIdx] & bmask;
					ip[1] = gipAddr[arrIdx] & bmask;
					msk[1] = gnetMask[arrIdx] & bmask;

					if (msk[0] && msk[1] && (ip[0] != ip[1]))
					{
						goto check_next;	/* Subnet is different ! : legal subnet */
					}
				}
			}
			printf("=> confilct with (%u.%u.%u.%u/%u.%u.%u.%u)  "	, pRomeCfgParam->ifCfgParam[i].ipAddr[0]
																, pRomeCfgParam->ifCfgParam[i].ipAddr[1]
																, pRomeCfgParam->ifCfgParam[i].ipAddr[2]
																, pRomeCfgParam->ifCfgParam[i].ipAddr[3]
																, pRomeCfgParam->ifCfgParam[i].ipMask[0]
																, pRomeCfgParam->ifCfgParam[i].ipMask[1]
																, pRomeCfgParam->ifCfgParam[i].ipMask[2]
																, pRomeCfgParam->ifCfgParam[i].ipMask[3]
																);
			/* subset overlap ! : subnet is illegal ! */
			printf("OverLap! FAIL!\n");
			return 1;	/* overlap found */
		}
check_next:
		continue;
	}
	printf("No Overlap!\n");
	return 0; /* no overlap */
}

void dhcpcDeconfig()
{
	printf("dhcpc client deconfig\n");
	board_ipDownEventTableDriverAccess();
	setInterfaceIp("eth0",0,0);
}

/*
	DHCP Client RENEW
*/
int dhcpcIPRenew()
{
	int restartDHCP;

	restartDHCP = FALSE;

	/* DNS Server */
	{
		FILE *fp;
		char *dns_environment_str,*dns_token;
		int i, dns_idx;
		ipaddr_t ramDNSAddr[2] = {0};
		ipaddr_t oldDNSAddr[2] = {0};


		fp = fopen("/var/resolv.conf","w+");
		dns_environment_str = getenv("dns");
		dns_token = malloc(MAX_IP_STRING_LEN);
		dns_idx = 0;
		if (dns_environment_str)
		while(*(char*)dns_environment_str)
		{
			i = 0;
			while (*(char*)dns_environment_str )
			{
				dns_token[i] = *(char*)dns_environment_str;
				i ++;
				dns_environment_str ++;
				if (*(char*)dns_environment_str == ' ')
				{
					dns_environment_str ++;
					break;
				}
			}
			dns_token[i]='\0';
			if (dns_idx>=2)
				break;
			ramDNSAddr[dns_idx++] = inet_addr(dns_token);
			fprintf(fp,"nameserver %s\n",dns_token);
		}

		oldDNSAddr[0] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		oldDNSAddr[1] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);


		if (((oldDNSAddr[0] == ramDNSAddr[0]) && (oldDNSAddr[1] == ramDNSAddr[1])) ||
			((oldDNSAddr[1] == ramDNSAddr[0]) && (oldDNSAddr[0] == ramDNSAddr[1])))
		{	/* DNS server is not be changed */
		} else
		{	/* DNS server is changed */
			if (ramDNSAddr[0])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,(void*)&ramDNSAddr[0],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr, 0, sizeof(ipaddr_t));
			if (ramDNSAddr[1])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,(void*)&ramDNSAddr[1],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr, 0, sizeof(ipaddr_t));

			if (pRomeCfgParam->dhcpsCfgParam.realDNSenable == 1)
			{
				restartDHCP = TRUE;
			}

			/* restart DNS proxy */
			runDNSProxy();
		}
	}
	/* WINS Server */
	if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
	{
		int i, wins_idx;
		char	*wins_environment_str, *wins_token;
		ipaddr_t ramWinsAddr[2] = {0};

		memset(ramWinsAddr, 0, sizeof(ramWinsAddr));

		wins_environment_str = getenv("wins");
		wins_token = malloc(MAX_IP_STRING_LEN);
		wins_idx = 0;
		if (wins_environment_str)
		{
			while(*(char*)wins_environment_str)
			{
				i = 0;
				wins_token[0] = '\0';
				while (*(char*)wins_environment_str)
				{
					wins_token[i] = *(char*)wins_environment_str;
					i ++;
					wins_environment_str ++;
					if (*(char*)wins_environment_str == ' ')
					{
						wins_environment_str ++;
						break;
					}
				}

				wins_token[i] = '\0';
				if (wins_idx >= 2)
					break;
				ramWinsAddr[wins_idx++] = inet_addr(wins_token);
			}
		}
		free(wins_token);
		/* check if wins server is changed or not */
		{
			if (((ramWinsAddr[0] == pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr) &&
				(ramWinsAddr[1] == pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr)) ||
				((ramWinsAddr[0] == pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr) &&
				(ramWinsAddr[1] == pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr)))
			{	/* wins server is not be changed */
			} else
			{	/* wins server is changed */
				restartDHCP = TRUE;
				pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = ramWinsAddr[0];
				pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = ramWinsAddr[1];
			}
		}
	}
	/* domain  */
	if (pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd == 1)
	{
		char	*domain_environment_str;
		char domain[128];
		int minstr;

		memset(domain, 0, sizeof(domain));
		domain_environment_str = getenv("domain");
		if (domain_environment_str)
		{
			strncpy(domain, domain_environment_str, sizeof(domain));
		}
		minstr = (sizeof(pRomeCfgParam->dhcpsCfgParam.domain) > sizeof(domain))?(sizeof(domain)):(sizeof(pRomeCfgParam->dhcpsCfgParam.domain));

		if (strncmp(pRomeCfgParam->dhcpsCfgParam.domain, domain, minstr))
		{	/* domain is changed */
			restartDHCP = TRUE;
			memset(pRomeCfgParam->dhcpsCfgParam.domain, 0 , sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
			strncpy(pRomeCfgParam->dhcpsCfgParam.domain, domain, sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
		}
	}

	if (restartDHCP == TRUE)
	{
		dhcps_start();
	}

	return 0;
}

int dhcpcIPBound()
{
	FILE *fp;
	int i,dns_idx, wins_idx;
	char	*dns_environment_str,*dns_token,*router_string, *wins_environment_str, *wins_token, *domain_environment_str;
	int 	ipAddr=0,netMask=0,gwAddr=0;
	int ramDNSAddr[2] = {0};
	ipaddr_t ramWinsAddr[2] = {0};
	char *args[6];
	int restartDHCP;

	/* get ip and subnet first: to check the correctness of then */
	if (getenv("ip"))
	{
		printf("ip  %s\n",getenv("ip"));
		ipAddr=inet_addr(getenv("ip"));
	}
	if (getenv("subnet"))
	{
		printf("subnet %s\n",getenv("subnet"));
		netMask=inet_addr(getenv("subnet"));
	}
	/*************************************************************************************************/
	/******************************** Check the correctness of IP and Subnet ********************************/
	if (board_checkSubnetOverlapping(ipAddr, netMask) > 0)
		goto errout;
 	/*************************************************************************************************/

	/* Check OK: init variables and call ip-down */
	restartDHCP = FALSE;

	board_ipDownEventTableDriverAccess();

	/* IP and Subnet is legal: set Interface IP */
	setInterfaceIp("eth0",ipAddr, netMask);

	/* get and set default gateway's information */
	if (getenv("router"))
	{
		printf("router %s\n",getenv("router"));
		gwAddr=inet_addr(getenv("router"));
	}
	args[0]="default";
	args[1]="gw";
	router_string=malloc(MAX_IP_STRING_LEN);
	sprintf(router_string,"%u.%u.%u.%u",(gwAddr>>24)&0xff,
					(gwAddr>>16)&0xff,
					(gwAddr>>8)&0xff,
					(gwAddr)&0xff);
	args[2]=router_string;
	args[3]=NULL;
	INET_setroute(RTACTION_ADD, 0, args);
	free(router_string);

	/* save them to gateway's setting */
	memcpy((void*)&pRomeCfgParam->ifCfgParam[0].ipAddr,(void*)&ipAddr,sizeof(ipAddr));
	memcpy((void*)&pRomeCfgParam->ifCfgParam[0].gwAddr,(void*)&gwAddr,sizeof(gwAddr));
	memcpy((void*)&pRomeCfgParam->ifCfgParam[0].ipMask,(void*)&netMask,sizeof(netMask));

	/* get DNS informations */
	fp = fopen("/var/resolv.conf","w+");
	dns_environment_str=getenv("dns");
	dns_token=malloc(MAX_IP_STRING_LEN);
	dns_idx=0;
	if (dns_environment_str)
	while(*(char*)dns_environment_str)
	{
		i=0;
		while (*(char*)dns_environment_str )
		{
			dns_token[i]=*(char*)dns_environment_str;
			i++;
			dns_environment_str++;
			if (*(char*)dns_environment_str==' ')
			{
				dns_environment_str++;
				break;
			}
		}
		
		dns_token[i]='\0';
		if (dns_idx>=2)
			break;
		ramDNSAddr[dns_idx++]=inet_addr(dns_token);
		fprintf(fp,"nameserver %s\n",dns_token);
	}
	free(dns_token);
	fprintf(fp,"\n");
	fclose(fp);

	{
		ipaddr_t oldDNSAddr[2] = {0};
		
		oldDNSAddr[0] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);

		oldDNSAddr[1] = ((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]) << 24) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]) << 16) +
						((uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]) << 8) +
						(uint32)(pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);


		if (((oldDNSAddr[0] == ramDNSAddr[0]) && (oldDNSAddr[1] == ramDNSAddr[1])) ||
			((oldDNSAddr[1] == ramDNSAddr[0]) && (oldDNSAddr[0] == ramDNSAddr[1])))
		{	/* DNS server is not be changed */
		} else
		{	/* DNS server is changed */
			if (ramDNSAddr[0])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,(void*)&ramDNSAddr[0],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr, 0, sizeof(ipaddr_t));
			if (ramDNSAddr[1])
				memcpy((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,(void*)&ramDNSAddr[1],sizeof(int));
			else
				memset((void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr, 0, sizeof(ipaddr_t));

			if (pRomeCfgParam->dhcpsCfgParam.realDNSenable == 1)
			{
				restartDHCP = TRUE;
			}

			/* restart DNS proxy */
			runDNSProxy();
		}
	}
	
	/* domain */
	if (pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd == 1)
	{
		domain_environment_str = getenv("domain");
		if (domain_environment_str)
		{
			memset(pRomeCfgParam->dhcpsCfgParam.domain, 0 , sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
			strncpy(pRomeCfgParam->dhcpsCfgParam.domain, domain_environment_str, sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
			restartDHCP = TRUE;
		}
	}

	/* wins server */
	if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
	{
		memset(ramWinsAddr, 0, sizeof(ramWinsAddr));

		wins_environment_str = getenv("wins");
		wins_token = malloc(MAX_IP_STRING_LEN);
		wins_idx = 0;
		if (wins_environment_str)
		{
			while(*(char*)wins_environment_str)
			{
				i = 0;
				wins_token[0] = '\0';
				while (*(char*)wins_environment_str)
				{
					wins_token[i] = *(char*)wins_environment_str;
					i ++;
					wins_environment_str ++;
					if (*(char*)wins_environment_str == ' ')
					{
						wins_environment_str ++;
						break;
					}
				}

				wins_token[i] = '\0';
				if (wins_idx >= 2)
					break;
				ramWinsAddr[wins_idx++] = inet_addr(wins_token);
			}
		}
		free(wins_token);
		pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = ramWinsAddr[0];
		pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = ramWinsAddr[1];
		restartDHCP = TRUE;
	}

	if (restartDHCP == TRUE)
	{
		dhcps_start();
	}
	board_ipUpEventTableDriverAccess();

	return 0;

errout:
	udhcpc_renew();	
	return 0;
} /* end dhcpIpBound */

/* member to Port number*/
uint32 memberToPortNum(uint32 portmask)
{
	uint32  i;
	for (i=0;i<10;i++)
	{
		if (portmask==1)
			return i;
		portmask = portmask >>1;
	}
	return 0;
}




/* 
 * set add route for linux kernel function
 */
static int INET_resolve(char *name, struct sockaddr *sa)
{
	struct sockaddr_in *s_in = (struct sockaddr_in *)sa;

	s_in->sin_family = AF_INET;
	s_in->sin_port = 0;

	/* Default is special, meaning 0.0.0.0. */
	if (strcmp(name, "default")==0) {
		s_in->sin_addr.s_addr = INADDR_ANY;
		return 1;
	}
	/* Look to see if it's a dotted quad. */
	if (inet_aton(name, &s_in->sin_addr)) {
		return 0;
	}
	/* guess not.. */
	return -1;
}


int INET_setroute(int action, int options, char **args)
{
	struct rtentry rt;
	char target[64], gateway[64] = "NONE", netmask[64] = "default";
	int xflag, isnet;
	int skfd;

	xflag = 0;

	if (strcmp(*args, "-net")==0) {
		xflag = 1;
		args++;
	} else if (strcmp(*args, "-host")==0) {
		xflag = 2;
		args++;
	}
	strncpy(target, *args++, (sizeof target));
	fprintf(stderr,"target %s\n",target);
	/* Clean out the RTREQ structure. */
	memset((char *) &rt, 0, sizeof(struct rtentry));


	if ((isnet = INET_resolve(target, &rt.rt_dst)) < 0) {
		printf("can't resolve %s", target);
		return -1;   /* XXX change to E_something */
	}

	switch (xflag) {
		case 1:
			isnet = 1;
			break;

		case 2:
			isnet = 0;
			break;

		default:
			break;
	}

	/* Fill in the other fields. */
	rt.rt_flags = (RTF_UP | RTF_HOST);
	if (isnet)
		rt.rt_flags &= ~RTF_HOST;

	while (*args) {
		if (strcmp(*args, "metric")==0) {
			int metric;

			args++;
			metric = atoi(*args);
#if HAVE_NEW_ADDRT
			rt.rt_metric = metric + 1;
#else
			ENOSUPP("inet_setroute", "NEW_ADDRT (metric)");  /* XXX Fixme */
#endif
			args++;
			continue;
		}

		if (strcmp(*args, "netmask")==0) {
			struct sockaddr mask;

			args++;
			strncpy(netmask, *args, (sizeof netmask));
			if ((isnet = INET_resolve(netmask, &mask)) < 0) {
				error_msg(_("can't resolve netmask %s"), netmask);
				return E_LOOKUP;
			}
			rt.rt_genmask = full_mask(mask);
			args++;
			continue;
		}

		if (strcmp(*args, "gw")==0 || strcmp(*args, "gateway")==0) {
			args++;
			strncpy(gateway, *args, (sizeof gateway));
			if ((isnet = INET_resolve(gateway, &rt.rt_gateway)) < 0) {
				error_msg(_("can't resolve gw %s"), gateway);
				return E_LOOKUP;
			}
			if (isnet) {
				error_msg(
					_("%s: cannot use a NETWORK as gateway!"),
					gateway);
				return E_OPTERR;
			}
			rt.rt_flags |= RTF_GATEWAY;
			args++;
			continue;
		}

		if (strcmp(*args, "mss")==0) {
			args++;
			rt.rt_flags |= RTF_MSS;
			rt.rt_mss = atoi(*args);
			args++;
			if (rt.rt_mss < 64 || rt.rt_mss > 32768) {
				error_msg(_("Invalid MSS."));
				return E_OPTERR;
			}
			continue;
		}

		if (strcmp(*args, "window")==0) {
			args++;
			rt.rt_flags |= RTF_WINDOW;
			rt.rt_window = atoi(*args);
			args++;
			if (rt.rt_window < 128) {
				error_msg(_("Invalid window."));
				return E_OPTERR;
			}
			continue;
		}

		if (strcmp(*args, "irtt")==0) {
			args++;
			args++;
#if HAVE_RTF_IRTT
			rt.rt_flags |= RTF_IRTT;
			rt.rt_irtt = atoi(*(args - 1));
			rt.rt_irtt *= (HZ / 100);       /* FIXME */
#if 0                           /* FIXME: do we need to check anything of this? */
			if (rt.rt_irtt < 1 || rt.rt_irtt > (120 * HZ)) {
				error_msg(_("Invalid initial rtt."));
				return E_OPTERR;
			}
#endif
#else
			ENOSUPP("inet_setroute", "RTF_IRTT"); /* XXX Fixme */
#endif
			continue;
		}

		if (strcmp(*args, "reject")==0) {
			args++;
#if HAVE_RTF_REJECT
			rt.rt_flags |= RTF_REJECT;
#else
			ENOSUPP("inet_setroute", "RTF_REJECT"); /* XXX Fixme */
#endif
			continue;
		}
		if (strcmp(*args, "mod")==0) {
			args++;
			rt.rt_flags |= RTF_MODIFIED;
			continue;
		}
		if (strcmp(*args, "dyn")==0) {
			args++;
			rt.rt_flags |= RTF_DYNAMIC;
			continue;
		}
		if (strcmp(*args, "reinstate")==0) {
			args++;
			rt.rt_flags |= RTF_REINSTATE;
			continue;
		}
		if (strcmp(*args, "device")==0 || strcmp(*args, "dev")==0) {
			args++;
			rt.rt_dev = *args++;
			continue;
		}
		/* nothing matches */
		if (!rt.rt_dev) {
			rt.rt_dev = *args++;
		} else {
		}
	}

#if HAVE_RTF_REJECT
	if ((rt.rt_flags & RTF_REJECT) && !rt.rt_dev)
		rt.rt_dev = "lo";
#endif

	/* sanity checks.. */
	if (mask_in_addr(rt)) {
		unsigned long mask = mask_in_addr(rt);
		mask = ~ntohl(mask);
		if ((rt.rt_flags & RTF_HOST) && mask != 0xffffffff) {
			error_msg(
				_("netmask %.8x doesn't make sense with host route"),
				(unsigned int)mask);
			return E_OPTERR;
		}
		if (mask & (mask + 1)) {
			error_msg(_("bogus netmask %s"), netmask);
			return E_OPTERR;
		}
		mask = ((struct sockaddr_in *) &rt.rt_dst)->sin_addr.s_addr;
		if (mask & ~mask_in_addr(rt)) {
			error_msg(_("netmask doesn't match route address"));
			return E_OPTERR;
		}
	}
	/* Fill out netmask if still unset */
	if ((action == RTACTION_ADD) && rt.rt_flags & RTF_HOST)
		mask_in_addr(rt) = 0xffffffff;

	/* Create a socket to the INET kernel. */
	if ((skfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror("socket");
		return E_SOCK;
	}
	/* Tell the kernel to accept this route. */
	if (action == RTACTION_DEL) {
		if (ioctl(skfd, SIOCDELRT, &rt) < 0) {
			perror("SIOCDELRT");
			close(skfd);
			return E_SOCK;
		}
	} else {
		if (ioctl(skfd, SIOCADDRT, &rt) < 0) {
			perror("SIOCADDRT");
			close(skfd);
			return E_SOCK;
		}
	}

	/* Close the socket. */
	(void) close(skfd);
	return SUCCESS;
}




void board_ipUp_dhcp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int32  ret;
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);

		if (*myIp == *myGw) {	/* This is a special application. Both wan ip and default gateway ip is the same. */
			ret = rtl8651_addIpIntf("eth0", (ipaddr_t)*myIp, 0);
			if (ret)
			{
				printf("rtl8651_addIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);				
			}
		}
		else {
			ret = rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
			if (ret)
			{
				printf("rtl8651_addIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
			}
		}

		/* set default gateway ip */
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",(ipaddr_t)*myGw);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
			fprintf(fp,"rtl8651_addRoute(default): ret %d\n",ret);
		}
	
		/* how to determine who is napt? who is nat? */
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_addNaptMapping: ret %d\n",ret);
		}	

}

void board_ipUp_pppoe(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int32  ret;
		uint16 mySessionId;
		ether_addr_t myMac;
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);
		memcpy((void*)&myMac,pRomeCfgParam->pppoeCfgParam[0].svrMac,6);

		mySessionId = (uint16)pRomeCfgParam->pppoeCfgParam[0].sessionId;
		pRomeCfgParam->pppoeCfgParam[0].manualHangup=0; /* clear manual hangup flag */
		
		rtl8651_flushDemandRoute(0);
		ret=rtl8651_setPppoeSessionProperty((uint32)0,(uint16)mySessionId,(ether_addr_t*)&myMac,memberToPortNum(pRomeCfgParam->vlanCfgParam[0].memberPort));
		if (ret)
		{
			printf("rtl8651_setPppoeSessionProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_setPppoeSessionProperty: ret %d\n",ret);
		}

		ret=rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)0xffffffff);
		if (ret)
		{
			printf("rtl8651_addIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
		}

		ret=rtl8651_bindPppoeSession((ipaddr_t)*myIp,0); /* single pppoe always uses pppObjId=0 */
		if (ret)
		{
			printf("rtl8651_bindPppoeSession: ret %d\n",ret);
			fprintf(fp,"rtl8651_bindPppoeSession: ret %d\n",ret);
		}

		/* how to determine who is napt? who is nat? */
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_addNaptMapping: ret %d\n",ret);
		}

		/* set time out option */
		if (pRomeCfgParam->pppoeCfgParam[0].silentTimeout>0)
		{
			uint32 sec = pRomeCfgParam->pppoeCfgParam[0].silentTimeout;
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,TRUE,sec);
			if (ret)
			{
				printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
			}
		}
		
		/* sync what i have got back to romeCfgParam
		 * for single pppoe, the assigned ip/ipMask/gw/dns is saved in ifCfgParam[0].ipAddr/ipMask/gwAddr/dnsAddr
		 */
		pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS;

		//rtl8651_setPppoeMtu(0,pRomeCfgParam->pppoeCfgParam[0].mtu);
		rtl8651_setNetMtu("eth0", pRomeCfgParam->pppoeCfgParam[0].mtu);


}

void board_ipUp_multiplePppoe(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns,uint32 *pppObjId)
{
		int32 i,ret;
		uint16 mySessionId;
		uint32 myLanType=0;
		pppoeCfg_t	*pppoeCfgPtr;
		int32 ip_start,ip_end;
		uint16 port_start,port_end;
		rtl8651_tblDrvPolicyRoute_t tmpRt;
		ether_addr_t myMac;

	
		if(pRomeCfgParam->pppoeCfgParam[*pppObjId].lanType==PPPOECFGPARAM_LANTYPE_NAPT){
			memcpy((void*)myIp,pRomeCfgParam->pppoeCfgParam[*pppObjId].ipAddr,4);
			memcpy((void*)myIpMask,pRomeCfgParam->pppoeCfgParam[*pppObjId].ipMask,4);
			memcpy((void*)myGw,pRomeCfgParam->pppoeCfgParam[*pppObjId].gwAddr,4);
			memcpy((void*)myDns,pRomeCfgParam->pppoeCfgParam[*pppObjId].dnsAddr,4);
			memcpy((void*)&myMac,pRomeCfgParam->pppoeCfgParam[*pppObjId].svrMac,6);
			memcpy((void*)&myLanType,&(pRomeCfgParam->pppoeCfgParam[*pppObjId].lanType),4);
			
			mySessionId = (uint16)pRomeCfgParam->pppoeCfgParam[*pppObjId].sessionId;		
			pRomeCfgParam->pppoeCfgParam[*pppObjId].manualHangup=0; /* clear manual hangup flag */
			pppoeCfgPtr=malloc(sizeof(*pppoeCfgPtr));
			pppoeCfgPtr->defaultSession=pRomeCfgParam->pppoeCfgParam[*pppObjId].defaultSession;
			pppoeCfgPtr->sessionId=mySessionId;
			memcpy(pppoeCfgPtr->svrMac,(void*)&myMac,6);
			memcpy(pppoeCfgPtr->ipAddr,(void*)myIp,4);
			memcpy(pppoeCfgPtr->ipMask,(void*)myIpMask,4);
			memcpy(pppoeCfgPtr->gwAddr,(void*)myGw,4);
			memcpy(&(pppoeCfgPtr->lanType),(void*)&myLanType,4);
			
			re865xIoctl("eth0",PPPOEUP_CFG,(uint32)pppoeCfgPtr,*pppObjId,memberToPortNum(pRomeCfgParam->vlanCfgParam[0].memberPort));
			free(pppoeCfgPtr);

			/* how to determine who is napt? who is nat? */
			if (pRomeCfgParam->pppoeCfgParam[*pppObjId].defaultSession != 1)
			{
				ret=rtl8651_addRoute((ipaddr_t)*myIp,(ipaddr_t)0xffffffff,
					(int8*)"eth0",(ipaddr_t)*pppObjId);
				if (ret)
				{
					printf("rtl8651_addRoute %x: ret %d\n",*myIp,ret);
					fprintf(fp,"rtl8651_addRoute %x: ret %d\n",*myIp,ret);
				}
				//chhuang:
				rtl8651_addDriverNaptMapping(*myIp);
				memset(&tmpRt, 0, sizeof(tmpRt));
				tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_DSTIP;
				tmpRt.ip_alias=*myIp;
				tmpRt.ip_start=*myGw;
				tmpRt.ip_end=*myGw;
				rtl8651_addPolicyRoute(&tmpRt);
				for (i=0;i<4;i++)
				{
					if (pRomeCfgParam->pppoeCfgParam[*pppObjId].destnetType[i] == PPPOECFGPARAM_DESTNETTYPE_IP)
					{
						if (!pRomeCfgParam->pppoeCfgParam[*pppObjId].destnet[i]) continue;

						parse_ipRange(pRomeCfgParam->pppoeCfgParam[*pppObjId].destnet[i],&ip_start,&ip_end);
						memset(&tmpRt, 0, sizeof(tmpRt));
						tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_DSTIP;
						tmpRt.ip_alias=*myIp;
						tmpRt.ip_start=ip_start;
						tmpRt.ip_end=ip_end;
						rtl8651_addPolicyRoute(&tmpRt);
					}
					else if (pRomeCfgParam->pppoeCfgParam[*pppObjId].destnetType[i] ==
						 PPPOECFGPARAM_DESTNETTYPE_TCPPORT)
					{
						parse_portRange( pRomeCfgParam->pppoeCfgParam[*pppObjId].destnet[i],
							&port_start ,&port_end);
						memset(&tmpRt, 0, sizeof(tmpRt));
						tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_DSTTCPPORT;
						tmpRt.ip_alias=*myIp;
						tmpRt.trigger.dport.start=port_start;
						tmpRt.trigger.dport.end=port_end;
						rtl8651_addPolicyRoute(&tmpRt);
					}
					else if (pRomeCfgParam->pppoeCfgParam[*pppObjId].destnetType[i] ==
						 PPPOECFGPARAM_DESTNETTYPE_UDPPORT)
					{
						parse_portRange( pRomeCfgParam->pppoeCfgParam[*pppObjId].destnet[i],
							&port_start ,&port_end);
						memset(&tmpRt, 0, sizeof(tmpRt));
						tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_DSTUDPPORT;
						tmpRt.ip_alias=*myIp;
						tmpRt.trigger.dport.start=port_start;
						tmpRt.trigger.dport.end=port_end;
						rtl8651_addPolicyRoute(&tmpRt);
					}
				}
				
				pRomeCfgParam->pppoeCfgParam[*pppObjId].dialState = PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS;
				//acl_tableDriverAccess(); /* set acl, if any */

				#if 0
				/* multiple pppoe = single napt + multiple nat solution */
				ipaddr_t localHostIp;
				memcpy((void*)&localHostIp,pRomeCfgParam->pppoeCfgParam[pppObjId].localHostIp,4);
				ret=rtl8651_addNatMapping((ipaddr_t)*myIp,(ipaddr_t)localHostIp);
				if (ret)
				{
					printf("rtl8651_addNatMapping: ret %d\n",ret);
					fprintf(fp,"rtl8651_addNatMapping: ret %d\n",ret);
				}
				#else
				/* multiple pppoe = multiple napt solution */
				#endif
			}
			
			rtl8651_flushDemandRoute(*pppObjId);
			if (pRomeCfgParam->pppoeCfgParam[*pppObjId].silentTimeout>0)
			{
				uint32 sec = pRomeCfgParam->pppoeCfgParam[*pppObjId].silentTimeout;
				if (pRomeCfgParam->pppoeCfgParam[*pppObjId].defaultSession)
					ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,*pppObjId,TRUE,sec);
				else
					ret=re865xIoctl("eth0",SET_SOFTPPPD_IDLE_TIME,*pppObjId,sec,0);
				if (ret)
				{
					printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
					fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				}
			}

			pRomeCfgParam->pppoeCfgParam[*pppObjId].dialState = PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS;

			rtl8651_setPppoeMtu(*pppObjId,pRomeCfgParam->pppoeCfgParam[*pppObjId].mtu);
			
		}else {
			/* pRomeCfgParam->pppoeCfgParam[pppObjId].lanType==PPPOECFGPARAM_LANTYPE_UNNUMBERED */
			
			memcpy((void*)myIp,pRomeCfgParam->pppoeCfgParam[*pppObjId].unnumberedIpAddr,4);
			memcpy((void*)myIpMask,pRomeCfgParam->pppoeCfgParam[*pppObjId].unnumberedIpMask,4);
			memcpy((void*)myGw,pRomeCfgParam->pppoeCfgParam[*pppObjId].gwAddr,4);
			memcpy((void*)myDns,pRomeCfgParam->pppoeCfgParam[*pppObjId].dnsAddr,4);
			memcpy((void*)&myMac,pRomeCfgParam->pppoeCfgParam[*pppObjId].svrMac,6);
			memcpy((void*)&myLanType,&(pRomeCfgParam->pppoeCfgParam[*pppObjId].lanType),4);
			mySessionId = (uint16)pRomeCfgParam->pppoeCfgParam[*pppObjId].sessionId;		
			pRomeCfgParam->pppoeCfgParam[*pppObjId].manualHangup=0; /* clear manual hangup flag */
			pppoeCfgPtr=malloc(sizeof(*pppoeCfgPtr));
			pppoeCfgPtr->defaultSession=pRomeCfgParam->pppoeCfgParam[*pppObjId].defaultSession;
			pppoeCfgPtr->sessionId=mySessionId;
			memcpy(pppoeCfgPtr->svrMac,(void*)&myMac,6);
			memcpy(pppoeCfgPtr->ipAddr,(void*)myIp,4);
			memcpy(pppoeCfgPtr->ipMask,(void*)myIpMask,4);
			memcpy(pppoeCfgPtr->gwAddr,(void*)myGw,4);
			memcpy(&(pppoeCfgPtr->lanType),(void*)&myLanType,4);

			re865xIoctl("eth0",PPPOEUP_CFG,(uint32)pppoeCfgPtr,(uint32)*pppObjId,memberToPortNum(pRomeCfgParam->vlanCfgParam[0].memberPort));
			free(pppoeCfgPtr);

		
			/* how to determine who is napt? who is nat? */
			if (pRomeCfgParam->pppoeCfgParam[*pppObjId].defaultSession == 0){
				ipaddr_t srcSubnet;
				uint32 stub1,stub2;
				#if 0
				ret=rtl8651_addRoute((ipaddr_t)*myIp,(ipaddr_t)*myIpMask,(int8*)"eth0",(ipaddr_t)*pppObjId);
				#else
				/* bug fix for multiple pppoe's unnumbered case, 2004/10/04 */
				ret=rtl8651_addRoute((ipaddr_t)*myIp,(ipaddr_t)0xffffffff,(int8*)"eth0",(ipaddr_t)*pppObjId);
				#endif
				if (ret)
				{
					printf("rtl8651_addRoute %x: ret %d\n",*myIp,ret);
					fprintf(fp,"rtl8651_addRoute %x: ret %d\n",*myIp,ret);
				}
				
				memcpy(&stub1,pRomeCfgParam->pppoeCfgParam[*pppObjId].unnumberedIpAddr,4);
				memcpy(&stub2,pRomeCfgParam->pppoeCfgParam[*pppObjId].unnumberedIpMask,4);
				
				srcSubnet = (ipaddr_t)(stub1 & stub2);/* get subnet value */
				memset(&tmpRt, 0, sizeof(tmpRt));
				tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_SRCGLOBALIP;
				tmpRt.ip_alias=*myIp;
				tmpRt.ip_start=srcSubnet+1;
				tmpRt.ip_end=srcSubnet+(~stub2);
				if ((ret=rtl8651_addPolicyRoute(&tmpRt)) == SUCCESS) {
					{
					uint8 * pUint8=&(tmpRt.ip_start);
					printf("rtl8651_addPolicyRoute->ip_start: %u.%u.%u.%u\n",pUint8[0],pUint8[1],pUint8[2],pUint8[3]);
					fprintf(fp,"rtl8651_addPolicyRoute->ip_start: %u.%u.%u.%u\n",pUint8[0],pUint8[1],pUint8[2],pUint8[3]);
					}
					
					{
						uint8 * pUint8=&(tmpRt.ip_end);
						printf("rtl8651_addPolicyRoute->ip_end  : %u.%u.%u.%u\n",pUint8[0],pUint8[1],pUint8[2],pUint8[3]);
						fprintf(fp,"rtl8651_addPolicyRoute->ip_end  : %u.%u.%u.%u\n",pUint8[0],pUint8[1],pUint8[2],pUint8[3]);
					}
				}
				else {
					printf("rtl8651_addPolicyRoute() fail, retval=%d\n", ret);
					fprintf(fp, "rtl8651_addPolicyRoute() fail, retval=%d\n", ret);
				}
			}
				
			pRomeCfgParam->pppoeCfgParam[*pppObjId].dialState = PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS;
			rtl8651_flushDemandRoute(*pppObjId);
			if (pRomeCfgParam->pppoeCfgParam[*pppObjId].silentTimeout>0)
			{
				uint32 sec = pRomeCfgParam->pppoeCfgParam[*pppObjId].silentTimeout;
				if (pRomeCfgParam->pppoeCfgParam[*pppObjId].defaultSession)
					ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,*pppObjId,TRUE,sec);
				else
					ret=re865xIoctl("eth0",SET_SOFTPPPD_IDLE_TIME,*pppObjId,sec,0);
				if (ret)
				{
					printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
					fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				}
			}
			pRomeCfgParam->pppoeCfgParam[*pppObjId].dialState = PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS;
			rtl8651_setPppoeMtu(*pppObjId,pRomeCfgParam->pppoeCfgParam[*pppObjId].mtu);
			acl_tableDriverAccess(); /* set acl, if any */
		}

		/* need to set some protocol stack actions */
		remoteMgmt_tableDriverAccess();
}

void board_ipUp_unnumberedPppoe(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int32  ret;
		uint16   mySessionId;
		ipaddr_t myIp2;
		ether_addr_t myMac;
		rtl8651_tblDrvPolicyRoute_t tmpRt;

		
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);
		memcpy((void*)&myMac,pRomeCfgParam->pppoeCfgParam[0].svrMac,6);

		mySessionId = (uint16)pRomeCfgParam->pppoeCfgParam[0].sessionId;
		pRomeCfgParam->pppoeCfgParam[0].manualHangup=0; /* clear manual hangup flag */
		
		ret=rtl8651_setPppoeSessionProperty((uint32)0,(uint16)mySessionId,(ether_addr_t*)&myMac,memberToPortNum(pRomeCfgParam->vlanCfgParam[0].memberPort));
		if (ret)
		{
			printf("rtl8651_setPppoeSessionProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_setPppoeSessionProperty: ret %d\n",ret);
		}
		
		memcpy((void*)myIpMask,pRomeCfgParam->pppoeCfgParam[0].unnumberedIpMask,4);
		memcpy((void*)&myIp2,pRomeCfgParam->pppoeCfgParam[0].unnumberedIpAddr,4);
		if (*myIp!=myIp2)
		{
			ret=rtl8651_delIpIntf("eth1",(ipaddr_t)myIp2,(ipaddr_t)*myIpMask);
			if (ret)
			{
				printf("rtl8651_delIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
			}
			ret=rtl8651_addIpIntf("eth1",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
			if (ret)
			{
				printf("rtl8651_addIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
			}
		}else{
			#if 0
			/* don't know which one is better yet?? 2003/12/26 orlando
			 *  1. add again and let it fail
			 *  2. don't add again
			 * 2003/12/31: add again seems to be correct. but
			 * needs more testing to back me up!
			 */
			ret=rtl8651_addIpIntf("eth1",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
			if (ret)
			{
				printf("rtl8651_addIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
			}
			#endif
		}
		
		/* clear ip alias of protocol stack's lan interface */
		{
			char	*av[5];
			char	pname[]="/bin/ifconfig";
			av[0]=pname;
			av[1]="eth1:1";
			av[2]="0.0.0.0";
			//av[3]="netmask";
			//av[4]=ipmask_string;
			av[3]=NULL;
			runProgram(pname,av);
		}

		ret=rtl8651_setLanSideExternalIpInterface("eth1",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask,1/*true*/);
		if (ret)
		{
			printf("rtl8651_setLanSideExternalIpInterface: ret %d\n",ret);
			fprintf(fp,"rtl8651_setLanSideExternalIpInterface: ret %d\n",ret);
		}

		ret=rtl8651_bindPppoeSession((ipaddr_t)*myIp,0); /* unnumberd pppoe always uses pppoeCfgParam[0] */
		if (ret)
		{
			printf("rtl8651_bindPppoeSession: ret %d\n",ret);
			fprintf(fp,"rtl8651_bindPppoeSession: ret %d\n",ret);
		}

		if (pRomeCfgParam->pppoeCfgParam[0].silentTimeout>0)
		{
			uint32 sec = pRomeCfgParam->pppoeCfgParam[0].silentTimeout;
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,TRUE,sec);
			if (ret)
			{
				printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
			}
		}

#if 0		
		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",(ipaddr_t)0);
		if (ret)
		{
			printf("rtl8651_addRoute(default): ret %d\n",ret);
			fprintf(fp,"rtl8651_addRoute(default): ret %d\n",ret);
		}
#endif		

		/* No matter ""NAPT for LAN hosts" feature is turned on or off, we always add napt mapping. */		
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_addNaptMapping: ret %d\n",ret);
		}

		/* 2005.3.7 */
		/* When we dial up and get IP address successfully, we should add a policy route for outbound packets. */
		/* If we don't add this policy route, packets trapped to CPU cannot find the route to WAN. */
		/* See function '_rtl8651_l34PacketProcess()' for reference. */
#if 0
		memset(&tmpRt, 0, sizeof(tmpRt));
		tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_DSTIP;
		tmpRt.ip_alias=0;
		tmpRt.ip_start=0;
		tmpRt.ip_end=0xffffffff;
		ret = rtl8651_addPolicyRoute(&tmpRt);
		if(ret != SUCCESS) {
			printf("addPolicyRoute failed -- ret: %d\n", ret);
			return NOT_OK;
		}
#else
		if (pRomeCfgParam->pppoeCfgParam[0].demand == 1)
		{
			rtl8651_flushDemandRoute(0);
		}
#endif

		/* add global assigned network route to user protocol stack */
		{
			char *argv[6];
			uint8 networkRoute[4];
			uint8 netStr[20];
			uint8 netmaskStr[20];
			uint32 i;
		
			memcpy((void*)networkRoute,(void*)pRomeCfgParam->ifCfgParam[0].ipAddr,4);
			for (i=0;i<4;i++)
				networkRoute[i] &= pRomeCfgParam->ifCfgParam[0].ipMask[i];
				
			argv[0]="-net";
			
			//argv[1]="239.0.0.0"; // pRomeCfgParam->pppoeCfgParam[0].ipAddr
			sprintf(netStr,"%u.%u.%u.%u",
				networkRoute[0],
				networkRoute[1],
				networkRoute[2],
				networkRoute[3]);
			argv[1]=netStr;
			
			argv[2]="netmask";
			
			//argv[3]="255.0.0.0"; // pRomeCfgParam->pppoeCfgParam[0].ipMask
			sprintf(netmaskStr,"%u.%u.%u.%u",
				pRomeCfgParam->ifCfgParam[0].ipMask[0],
				pRomeCfgParam->ifCfgParam[0].ipMask[1],
				pRomeCfgParam->ifCfgParam[0].ipMask[2],
				pRomeCfgParam->ifCfgParam[0].ipMask[3]);
			argv[3]=netmaskStr;
			
			argv[4]="eth1";
			argv[5]=NULL;
								
			INET_setroute(RTACTION_ADD, 0, argv);
		} /* end block add user protocol stack network route */
			
		/* now update cfg values back to romeCfgParam
		 * for single pppoe, the assigned ip/ipMask/gw/dns is saved in ifCfgParam[0].ipAddr/ipMask/gwAddr/dnsAddr
		 */
		pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS;

		rtl8651_setPppoeMtu(0,pRomeCfgParam->pppoeCfgParam[0].mtu);

}
#ifdef CONFIG_RTL865XB_3G
void board_ipUp_3g(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns,unsigned char *bdinfo_mac)
{

		int32  ret;
		int i;
		char tempStr[64]={0};
		ether_addr_t myMac;
		
		memcpy(myMac.octet,bdinfo_mac,6);

		// eth0's mac = bdinfo's mac 
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);

		sprintf(tempStr,"ifconfig eth0 %u.%u.%u.%u",pRomeCfgParam->ifCfgParam[0].ipAddr[0],pRomeCfgParam->ifCfgParam[0].ipAddr[1]
											   ,pRomeCfgParam->ifCfgParam[0].ipAddr[2],pRomeCfgParam->ifCfgParam[0].ipAddr[3]);
		system(tempStr);
		fprintf(fp,"%s\n",tempStr);
		
		system("route del default");
		system("ifconfig eth0 netmask 255.255.255.248");

		send_signal("/var/run/priority.pid",9);

		// spoof ip mask for romeDriver( 255.255.255.255-->255.255.255.248)
		*myIpMask=0xfffffff8;

		ret=rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
		if (ret)
		{
			printf("rtl8651_addIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
		}

		// mac for ppp0 recv from eth0 to wan. (src mac = dest mac )
		// 0: for network, 7: for broadcast
		for(i=1;i<7;i++)
		{
			if((((pRomeCfgParam->ifCfgParam[0].ipAddr[3]&0xf8)+i)!=pRomeCfgParam->ifCfgParam[0].ipAddr[3]))
			{
				sprintf(tempStr,"arp -i eth0 -s %u.%u.%u.%u %02x:%02x:%02x:%02x:%02x:%02x"
					,pRomeCfgParam->ifCfgParam[0].ipAddr[0],pRomeCfgParam->ifCfgParam[0].ipAddr[1]
					,pRomeCfgParam->ifCfgParam[0].ipAddr[2],((pRomeCfgParam->ifCfgParam[0].ipAddr[3]&0xf8)+i)
					,myMac.octet[0],myMac.octet[1],myMac.octet[2],myMac.octet[3],myMac.octet[4],myMac.octet[5]);		
				system(tempStr);
				fprintf(fp,"%s\n",tempStr);
			}
		}
		
		for(i=1;i<7;i++)
		{

			if((((pRomeCfgParam->ifCfgParam[0].ipAddr[3]&0xf8)+i)!=pRomeCfgParam->ifCfgParam[0].ipAddr[3]))
			{
				unsigned char temp;

				temp= pRomeCfgParam->ifCfgParam[0].ipAddr[3];
				pRomeCfgParam->ifCfgParam[0].ipAddr[3]=((pRomeCfgParam->ifCfgParam[0].ipAddr[3]&0xf8)+i);
				// add default route for Protocol-Stack
				sprintf(tempStr,"route add default gw %u.%u.%u.%u eth0",pRomeCfgParam->ifCfgParam[0].ipAddr[0],pRomeCfgParam->ifCfgParam[0].ipAddr[1]
						 									   	 ,pRomeCfgParam->ifCfgParam[0].ipAddr[2],((pRomeCfgParam->ifCfgParam[0].ipAddr[3]&0xf8)+i));
				system(tempStr);

				memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
				
				// add default route for RomeDrvier (myIp = virtual gateway's IP)
				ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",*myIp);
				if (ret)	
				{
					printf("rtl8651_addRoute: ret %d\n",ret);
					fprintf(fp,"rtl8651_addRoute: ret %d\n",ret);			
				}

				// Register Virtual Gateway's ARP from RomeDriver (Virtual Gateway's MAC = eth0's MAC + 2 = bdinfo_mac + 2)
				myMac.octet[5]+=2;
				ret=rtl8651_addArp(*myIp,&myMac,"eth0",CONFIG_RTL865XB_3G_PORT);
				if(ret)
				{
					printf("rtl8651_addArp: ret %d\n",ret);
					fprintf(fp,"rtl8651_addArp: ret %d\n",ret);			
				}

				// recover myIp to real WAN ip (eth0/ppp0)
				pRomeCfgParam->ifCfgParam[0].ipAddr[3]=temp;
				memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);

				break;
			}
		}
		

		// add wan-side NAPT ip address (eth0/ppp0)
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
			fprintf(fp,"rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
		}

		fprintf(fp,"3g ip-up success!\n");

}
#endif
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
void board_ipUp_pptp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		char *argv[8];
		uint32 def_gw_ipAddr = 0;
		unsigned char  macStr[17];
		int32  ret;

		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->pptpCfgParam.gwAddr[3]);

		pRomeCfgParam->pptpCfgParam.dialState=PPTPCFGPARAM_DIALSTATE_DIALED_SUCCESS;		
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);		

		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->pptpCfgParam.gwAddr[0],
				pRomeCfgParam->pptpCfgParam.gwAddr[1],
				pRomeCfgParam->pptpCfgParam.gwAddr[2],
				pRomeCfgParam->pptpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_DEL, 0, argv);
		}
		/* ===================================== */



		rtl8651_flushDemandRoute(4); //for pptp
		
		ret=rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
		//fprintf(fp,"rtl8651_addIpIntf: ip=%x mask=%x\n",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_addIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_addIpIntf: ret %d\n",ret);
		}

		ret = rtl8651_setPptpProperty(1, 0, 0, *(uint32*)(&(pRomeCfgParam->pptpCfgParam.svAddr)), *(uint32*)(&(pRomeCfgParam->pptpCfgParam.gwAddr)));
		if (ret)
		{
			printf("rtl8651_setPptpProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_setPptpProperty: ret %d\n",ret);
		}
		
		ret=rtl8651_bindSession(*myIp, 1); // use myIp to separate sessions.
		if (ret)
		{
			printf("rtl8651_bindSession: ret %d\n",ret);
			fprintf(fp,"rtl8651_bindSession: ret %d\n",ret);
		}
	
		// ret=rtl8651_addNaptMapping((ipaddr_t)myIp);
				
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
			fprintf(fp,"rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
		}
		
		/* set time out option */
		if (pRomeCfgParam->pptpCfgParam.silentTimeout>0)
		{		
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,TRUE,pRomeCfgParam->pptpCfgParam.silentTimeout);
			if (ret)
			{
				printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
			}
		}
		
}

void board_ipUp_l2tp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		char *argv[8];
		uint32 def_gw_ipAddr = 0;
		unsigned char  macStr[17];
		int32  ret;

		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[0]) << 24;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[1]) << 16;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[2]) << 8;
		def_gw_ipAddr |= (pRomeCfgParam->l2tpCfgParam.gwAddr[3]);

		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_SUCCESS;
		
		memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
		memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);
		memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);

		/* ===================================== */
		if (def_gw_ipAddr != 0) {
			argv[0]="default";
			
			sprintf(macStr, "%u.%u.%u.%u",
				pRomeCfgParam->l2tpCfgParam.gwAddr[0],
				pRomeCfgParam->l2tpCfgParam.gwAddr[1],
				pRomeCfgParam->l2tpCfgParam.gwAddr[2],
				pRomeCfgParam->l2tpCfgParam.gwAddr[3]);
			argv[1]="gw";
			argv[2]=(char*)&macStr;
			argv[3]=NULL;
			INET_setroute(RTACTION_DEL, 0, argv);
		}
		/* ===================================== */


		rtl8651_flushDemandRoute(5); //for l2tp

		ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
		if (ret)
		{
			printf("rtl8651_addRoute: ret %d\n",ret);
			//fprintf(fp,"rtl8651_addRoute: ret %d\n",ret);
		}		
		
		ret=rtl8651_addIpIntf("eth0",(ipaddr_t)*myIp,(ipaddr_t)*myIpMask);
		if (ret)
		{
			printf("rtl8651_addIpIntf:ip=%u.%u.%u.%u:mask=%u.%u.%u.%u: ret %d\n",NIPQUAD(myIp),NIPQUAD(myIpMask),ret);
			fprintf(fp,"rtl8651_addIpIntf:ip=%u.%u.%u.%u:mask=%u.%u.%u.%u: ret %d\n",NIPQUAD(myIp),NIPQUAD(myIpMask),ret);
		}
		
		ret = rtl8651_setL2tpProperty(1, 0, 0, *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.svAddr)), *(uint32*)(&(pRomeCfgParam->l2tpCfgParam.gwAddr)));
		if (ret)
		{
			printf("rtl8651_setL2tpProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_setL2tpProperty: ret %d\n",ret);
		}
		
		ret=rtl8651_bindSession(*myIp, 1); // use myIp to separate sessions.
		if (ret)
		{
			printf("rtl8651_bindSession: ret %d\n",ret);
			fprintf(fp,"rtl8651_bindSession: ret %d\n",ret);
		}
	
		ret=rtl8651_addNaptMapping((ipaddr_t)*myIp);
		if (ret)
		{
			printf("rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
			fprintf(fp,"rtl8651_addNaptMapping(%u.%u.%u.%u): ret %d\n",NIPQUAD(*myIp),ret);
		}

		/* set time out option */
		if (pRomeCfgParam->l2tpCfgParam.silentTimeout>0)
		{		
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,TRUE,pRomeCfgParam->l2tpCfgParam.silentTimeout);
			if (ret)
			{
				printf("rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
				fprintf(fp,"rtl8651_setPppoeSessionHangUp: ret %d\n",ret);
			}
		}	

}
int32 board_ipUp_dhcpL2tp_init(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int8 strBuffer[128];			
		uint32 netmask=0;	
		int ret;			
		#if 0
				pRomeCfgParam->ifCfgParam[0].gwAddr[0]=192;
				pRomeCfgParam->ifCfgParam[0].gwAddr[1]=168;
				pRomeCfgParam->ifCfgParam[0].gwAddr[2]=154;
				pRomeCfgParam->ifCfgParam[0].gwAddr[3]=240;
				pRomeCfgParam->ifCfgParam[0].ipMask[0]=255;
				pRomeCfgParam->ifCfgParam[0].ipMask[1]=255;
				pRomeCfgParam->ifCfgParam[0].ipMask[2]=255;
				pRomeCfgParam->ifCfgParam[0].ipMask[3]=0;
		#endif

				if(memcmp(pRomeCfgParam->ifCfgParam[0].ipMask,&netmask,4)==0)
				{
					printf("the DHCP server may be BOOTP Server!\n");
					return -1;
				}
		
				memcpy((void*)myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
				memcpy((void*)myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);
				memcpy((void*)myGw,pRomeCfgParam->ifCfgParam[0].gwAddr,4);				
				memcpy((void*)myDns,pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,4);
				
				memcpy(pRomeCfgParam->l2tpCfgParam.ipAddr, (void*)myIp, 4);
				memcpy(pRomeCfgParam->l2tpCfgParam.ipMask, (void*)myIpMask, 4);
				memcpy(pRomeCfgParam->l2tpCfgParam.svAddr, (void*)myGw, 4);

				netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[0])<<24;
				netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[1])<<16;
				netmask|=(pRomeCfgParam->l2tpCfgParam.ipMask[2])<<8;
				netmask|=pRomeCfgParam->l2tpCfgParam.ipMask[3];

				ret=rtl8651_addNetworkIntf("eth0");	
				if(ret)
				{
					printf("rtl8651_addNetworkIntf: ret %d\n",ret);
//					fprintf(fp,"rtl8651_addNetworkIntf: ret %d\n",ret);				
				}

				ret=rtl8651_specifyNetworkIntfLinkLayerType("eth0",LL_L2TP, pRomeCfgParam->vlanCfgParam[0].vid);
				if (ret)
				{
					printf("rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
					fprintf(fp,"rtl8651_specifyNetworkIntfLinkLayerType: ret %d\n",ret);
				}		
		
				//addIpInterface				
				re865xIoctl("eth0",SET_VLAN_IP,*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)),0);

				/* linux if up */
				upInterface("eth0");

				ret=rtl8651_addExtNetworkInterface((int8*)"eth0");	
				if(ret)					
				{
					printf("rtl8651_addExtNetworkInterface: ret %d\n",ret);
					fprintf(fp,"rtl8651_addExtNetworkInterface: ret %d\n",ret);				
				}

				ret=rtl8651_addSession(RTL8651_L2TP, 1, "eth0",  pRomeCfgParam->vlanCfgParam[0].vid); 
				if (ret)
				{
					printf("rtl8651_addSession: ret %d\n",ret);
					fprintf(fp,"rtl8651_addSession: ret %d\n",ret);
				}				
				
				ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0);
				if (ret)
				{
					printf("rtl8651_addRoute: ret %d\n",ret);
					fprintf(fp,"rtl8651_addRoute: ret %d\n",ret);
				}				

				sprintf(strBuffer,"/sbin/ifconfig eth0 %d.%d.%d.%d netmask %d.%d.%d.%d",
					pRomeCfgParam->ifCfgParam[0].ipAddr[0],
					pRomeCfgParam->ifCfgParam[0].ipAddr[1],
					pRomeCfgParam->ifCfgParam[0].ipAddr[2],
					pRomeCfgParam->ifCfgParam[0].ipAddr[3],			
					pRomeCfgParam->ifCfgParam[0].ipMask[0],
					pRomeCfgParam->ifCfgParam[0].ipMask[1],
					pRomeCfgParam->ifCfgParam[0].ipMask[2],
					pRomeCfgParam->ifCfgParam[0].ipMask[3]
				);
				system(strBuffer);
			
				printf("DHCP Finish! IP:%u.%u.%u.%u Server IP:%u.%u.%u.%u\n",NIPQUAD(*myIp),NIPQUAD(*myGw));
				fprintf(fp, "DHCP Finish! IP:%u.%u.%u.%u Server IP:%u.%u.%u.%u\n",NIPQUAD(*myIp),NIPQUAD(*myGw));
				pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;

				return 0;				
}

void board_ipUp_dhcpL2tp(FILE *fp,ipaddr_t *myIp,ipaddr_t *myIpMask,ipaddr_t *myGw,ipaddr_t *myDns)
{
		int32  ret;
		if (pRomeCfgParam->l2tpCfgParam.dialState==L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER)
			{
				fprintf(fp, "DHCP OK......\n");
				ret=board_ipUp_dhcpL2tp_init(fp,myIp,myIpMask,myGw,myDns);
				if(ret) //dhcp client not get IP info.
				{
					udhcpc_start();
					return;
				}
				else
				{					
					pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;				
					l2tp_start(0);
				}
			}
			else 
			{
				fprintf(fp, "L2TP OK......\n");
				board_ipUp_l2tp(fp,myIp,myIpMask,myGw,myDns);
			}	
}
#endif

/*
 * Routine Name: board_ipUpEventTableDriverAccess
 * Description: when a wan interface got new ipAddr/ipMask/gwAddr/dnsAddr
 *              call this function to access rtl865x table driver APIs to
 *              configure rtl865x
 *              scenarios: dhcp client ip up event, pppoe ip up event
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 board_ipUpEventTableDriverAccess(void)
{
	FILE   *fp;
	char   tempStr[30];
	int32  ret;
	uint32 pppObjId=0;
	ipaddr_t myIp = 0;
	ipaddr_t myIpMask = 0;
	ipaddr_t myGw = 0;
	ipaddr_t myDns = 0;
#ifdef CONFIG_RTL865XB_3G	
	unsigned char mac[6];
#endif
	rtl8651_sem_wait(SEMAPHORE_IPEVENT);

	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
	case IFCFGPARAM_CONNTYPE_DHCPC:
		sprintf(tempStr,"/var/dhcpup.txt");
		break;
	case IFCFGPARAM_CONNTYPE_PPPOE:
		sprintf(tempStr,"/var/pppoeup.txt");
		break;		
	case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
		sprintf(tempStr,"/var/unnumup.txt");
		break;
	case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
		pppObjId = pRomeCfgParam->pppoeCfgParam[0].whichPppObjId;
		sprintf(tempStr,"/var/pppoeup%u.txt",pppObjId);
		break;
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)	
	case IFCFGPARAM_CONNTYPE_PPTP:
		sprintf(tempStr,"/var/pptpup.txt");
		break;
	case IFCFGPARAM_CONNTYPE_L2TP:
		sprintf(tempStr,"/var/l2tpup.txt");
		break;
	case IFCFGPARAM_CONNTYPE_DHCPL2TP:
		sprintf(tempStr, "/var/dhcpl2tpup.txt");
		break;		
		
#endif	//CONFIG_RTL865X(B)_PPTPL2TP
#ifdef CONFIG_RTL865XB_3G
	case IFCFGPARAM_CONNTYPE_3G:
		sprintf(tempStr, "/var/3gup.txt");
		break;	
#endif
	default:
		sprintf(tempStr,"/var/unkownup.txt");
	}


#ifdef CONFIG_RTL865XB_3G	
	fp = fopen("/var/bdinfo_mac.txt","rb");
	if(fp!=NULL)
	{
		int c;
		// uClibc can't read a unsigned char by fscanf, so we using an integer to convert unsigned char 
		fscanf(fp,"%u\n",&c); mac[0]=c&0xff;
		fscanf(fp,"%u\n",&c); mac[1]=c&0xff;
		fscanf(fp,"%u\n",&c); mac[2]=c&0xff;
		fscanf(fp,"%u\n",&c); mac[3]=c&0xff;
		fscanf(fp,"%u\n",&c); mac[4]=c&0xff;
		fscanf(fp,"%u\n",&c); mac[5]=c&0xff;
		fclose(fp);
	}
#endif	
	
	fp = fopen(tempStr,"r");
	if(fp==NULL)
		fp=fopen(tempStr,"w");
	fclose(fp);
	fp = fopen(tempStr,"a");
	fprintf(fp,"board_ipUpEventTableDriverAccess ...\n");	

	switch (pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_DHCPC:
		 	
			fprintf(fp,"connType: dhcpc\n");
			break;

		case IFCFGPARAM_CONNTYPE_PPPOE:

		 	

			fprintf(fp,"connType: pppoe\n");
			fprintf(fp,"servermac:%x:%x:%x:%x:%x:%x\n",
				pRomeCfgParam->pppoeCfgParam[0].svrMac[0],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[1],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[2],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[3],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[4],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[5]);

			break;

		case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
		 	
			fprintf(fp,"connType: unnumbered pppoe\n");
			fprintf(fp,"servermac:%x:%x:%x:%x:%x:%x\n",
				pRomeCfgParam->pppoeCfgParam[0].svrMac[0],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[1],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[2],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[3],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[4],
				pRomeCfgParam->pppoeCfgParam[0].svrMac[5]);
			break;

		case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
			fprintf(fp,"connType: multiple pppoe\n");
			fprintf(fp,"pppObjId: %u\n",pppObjId);
			fprintf(fp,"pppx: %u\n",pRomeCfgParam->pppoeCfgParam[pppObjId].pppx);
			fprintf(fp,"servermac:%x:%x:%x:%x:%x:%x\n",
				pRomeCfgParam->pppoeCfgParam[pppObjId].svrMac[0],
				pRomeCfgParam->pppoeCfgParam[pppObjId].svrMac[1],
				pRomeCfgParam->pppoeCfgParam[pppObjId].svrMac[2],
				pRomeCfgParam->pppoeCfgParam[pppObjId].svrMac[3],
				pRomeCfgParam->pppoeCfgParam[pppObjId].svrMac[4],
				pRomeCfgParam->pppoeCfgParam[pppObjId].svrMac[5]);
			memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr,  4);
			memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask,  4);
			memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr,  4);
			memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr,4);
			break;
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
		case IFCFGPARAM_CONNTYPE_PPTP:		 	
			fprintf(fp,"connType: pptp\n");
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:
			fprintf(fp,"connType: l2tp\n");
			break;
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
			fprintf(fp, "connType: DHCP + L2TP\n");
			break;
#endif //CONFIG_RTL865X(B)_PPTPL2TP
#ifdef CONFIG_RTL865XB_3G
		case IFCFGPARAM_CONNTYPE_3G:		 	
			fprintf(fp,"connType: 3G\n");
			break;
#endif
		default:
			break;
	}

	LogDebugInfo(fp);

	
#if 0
	fprintf(fp,"ipAddr:%u.%u.%u.%u\n",
		pRomeCfgParam->ifCfgParam[0].ipAddr[0],
		pRomeCfgParam->ifCfgParam[0].ipAddr[1],
		pRomeCfgParam->ifCfgParam[0].ipAddr[2],
		pRomeCfgParam->ifCfgParam[0].ipAddr[3]);

	fprintf(fp,"ipMask:%u.%u.%u.%u\n",
		pRomeCfgParam->ifCfgParam[0].ipMask[0],
		pRomeCfgParam->ifCfgParam[0].ipMask[1],
		pRomeCfgParam->ifCfgParam[0].ipMask[2],
		pRomeCfgParam->ifCfgParam[0].ipMask[3]);

	fprintf(fp,"gwAddr:%u.%u.%u.%u\n",
		pRomeCfgParam->ifCfgParam[0].gwAddr[0],
		pRomeCfgParam->ifCfgParam[0].gwAddr[1],
		pRomeCfgParam->ifCfgParam[0].gwAddr[2],
		pRomeCfgParam->ifCfgParam[0].gwAddr[3]);

	fprintf(fp,"dnsPrimaryAddr:%u.%u.%u.%u\n",
		pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0],
		pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1],
		pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2],
		pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);
#endif

	#if defined(CONFIG_RTL865X_DIAG_LED)
	{
		ipaddr_t gwLanIp,gwLanIpmask;
		memcpy((void*)&gwLanIp,pRomeCfgParam->ifCfgParam[1].ipAddr,4);
		memcpy((void*)&gwLanIpmask,pRomeCfgParam->ifCfgParam[1].ipMask,4);
		if ((myIp&myIpMask)==(gwLanIp&gwLanIpmask))
		re865xIoctl("eth0",RTL8651_IOCTL_DIAG_LED,5,0,0);
	}
	#endif

	switch (pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_DHCPC:
			board_ipUp_dhcp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;		
		case IFCFGPARAM_CONNTYPE_PPPOE:
			board_ipUp_pppoe(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;					
		case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
			board_ipUp_multiplePppoe(fp,&myIp,&myIpMask,&myGw,&myDns,&pppObjId);
			break;					
		case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
			board_ipUp_unnumberedPppoe(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)		
		case IFCFGPARAM_CONNTYPE_PPTP:
			board_ipUp_pptp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:
			board_ipUp_l2tp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;		
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
			board_ipUp_dhcpL2tp(fp,&myIp,&myIpMask,&myGw,&myDns);
			break;		
#endif // CONFIG_RTL865X(B)_PPTPL2TP
#ifdef CONFIG_RTL865XB_3G
		case IFCFGPARAM_CONNTYPE_3G:
			board_ipUp_3g(fp,&myIp,&myIpMask,&myGw,&myDns,mac);
			break;		
#endif
		default:
		/* don't know what to do now */
			printf("board_ipUpEventTableDriverAccess: unknown ifCfgParam[0].connType(%u)\n",pRomeCfgParam->ifCfgParam[0].connType);
			break;
	}/* switch(pRomeCfgParam->ifCfgParam[0].connType) */



	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_STATIC:
			/* do nothing */
			break;
		case IFCFGPARAM_CONNTYPE_DHCPC: /* fall through */
		case IFCFGPARAM_CONNTYPE_PPTP:  /* fall through */
		case IFCFGPARAM_CONNTYPE_L2TP:  /* fall through */
		case IFCFGPARAM_CONNTYPE_PPPOE: /* fall through */
		case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:

		case IFCFGPARAM_CONNTYPE_3G:
//		case IFCFGPARAM_CONNTYPE_DHCPL2TP:
#ifdef CONFIG_KU_KLIPS
		vpnIpsec_start(pRomeCfgParam->ifCfgParam[0].connType);
#endif
			rtl8651a_setAlgStatus(0,pRomeCfgParam->algCfgParam[0].algList,pRomeCfgParam->algCfgParam[0].localIp);
			serverp_tableDriverAccess(0);
			dmz_tableDriverAccess(0);
			udp_tableDriverAccess(0);
			rtl8651a_setWanStatus(0,TRUE);
			rtl8651a_setDosStatus(0,((pRomeCfgParam->dosCfgParam[0].enable)?(pRomeCfgParam->dosCfgParam[0].enableItem):0));			
			pbnat_ipup( 0, myIp ); /* Protocol-Based NAT */
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
			rtl8651a_setAlgStatus(pppObjId,pRomeCfgParam->algCfgParam[pppObjId].algList,pRomeCfgParam->algCfgParam[pppObjId].localIp);
			serverp_tableDriverAccess(pppObjId); 
			dmz_tableDriverAccess(pppObjId); /* config dmz host with newly-got ip */
			acl_tableDriverAccess(); /* set acl, if any */			
			rtl8651a_setDosStatus(pppObjId,((pRomeCfgParam->dosCfgParam[pppObjId].enable)?(pRomeCfgParam->dosCfgParam[pppObjId].enableItem):0));
			rtl8651a_setWanStatus(pppObjId,TRUE);			
			pbnat_ipup( pppObjId, myIp ); /* Protocol-Based NAT */
			break;
		default:
			break;
	}
	acl_tableDriverAccess();

	/*
		chenyl (2004/11/24)
		For multiple pppoe case, because ALL services have "restart" mechanism(kill old one and fork new deamon),
		so we don't need to check wan type anymore.
	*/
	// conntion type not multiple pppoe or multiple pppoe's default session.
	if((pRomeCfgParam->ifCfgParam[0].connType!=IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)||
		((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)&&
		(pRomeCfgParam->pppoeCfgParam[pppObjId].defaultSession == 1)))
	{
		FILE *f;
		f=fopen("/var/run/rdate.run","r");
		if(f==NULL)
		{
			time_start();			
			f=fopen("/var/run/rdate.run","w");
		}
		fclose(f);
		upnp_start();
		snmp_start();		
		syslogd_start();
		ddns_start();
		runDNSProxy();
	}
	fclose(fp);

	rtl8651_sem_post(SEMAPHORE_IPEVENT);

	return 0;
} /* end board_ipUpEventTableDriverAccess */

/*
 * Routine Name: board_ipDownEventTableDriverAccess
 * Description: when a wan interface got new ipAddr/ipMask/gwAddr/dnsAddr
 *              call this function to access rtl865x table driver APIs to
 *              configure rtl865x
 *              scenarios: dhcp client ip up event, pppoe ip up event
 * Input:  
 *   none
 * Output:
 *   none
 * Return:
 *   OK      if success
 *   NOT_OK  if fail
 * ThreadSafe: don't know yet
 */
uint32 board_ipDownEventTableDriverAccess(void)
{
	FILE   *fp;
	char   tempStr[30];
	int32  i,ret;
	uint32 pppObjId;
	ipaddr_t myIp;
	ipaddr_t myIpMask;
//	romeCfgParam_t * pRomeCfgParam;
	pppoeCfg_t	pppoeCfgPtr;

	rtl8651_sem_wait(SEMAPHORE_IPEVENT);
#if 0		
	if (getRomeCfgParamPtr(&pRomeCfgParam))
	{
		printf("read pRomeCfgParam failed\n");
		return 1; /* fail */
	}
#endif	

	pppObjId = (uint32)pRomeCfgParam->pppoeCfgParam[0].whichPppObjId;
			
	switch(pRomeCfgParam->ifCfgParam[0].connType)
	{
		case IFCFGPARAM_CONNTYPE_DHCPC:
			sprintf(tempStr,"/var/dhcpdown.txt");
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE:
			sprintf(tempStr,"/var/pppoedown.txt");
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:			
			sprintf(tempStr,"/var/unnumdown.txt");
			break;
		case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
			pppObjId = pRomeCfgParam->pppoeCfgParam[0].whichPppObjId;
			sprintf(tempStr,"/var/pppoedown%u.txt",pppObjId);
			break;
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
		case IFCFGPARAM_CONNTYPE_PPTP:
			sprintf(tempStr,"/var/pptpdown.txt");
			break;
		case IFCFGPARAM_CONNTYPE_L2TP:		
			sprintf(tempStr,"/var/l2tpdown.txt");
			break;
		case IFCFGPARAM_CONNTYPE_DHCPL2TP:		
			sprintf(tempStr,"/var/dhcpl2tpdown.txt");			
			break;
#endif			
		default:
			sprintf(tempStr,"/var/unkowndown.txt");
			break;
	}

	fp = fopen(tempStr,"r");
	if(fp==NULL)
		fp=fopen(tempStr,"w");
	fclose(fp);
	fp = fopen(tempStr,"a");
	fprintf(fp,"board_ipDownEventTableDriverAccess ...\n");

	//fp = stderr;

	if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC)
	{
		/* dhcp client renew case */
		rtl8651a_setWanStatus(0,FALSE);		
		pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_OFF;

		LogDebugInfo(fp);
		
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_delNaptMapping(myIp);
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

		//rtl8651_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
		ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
		if (ret)
		{
			printf("rtl8651_delRoute(default): ret %d\n",ret);
			fprintf(fp,"rtl8651_delRoute(default): ret %d\n",ret);
		}

		ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}
		
		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
	}	
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE)
	{

		/* single pppoe hangup case */
		rtl8651a_setWanStatus(0,FALSE);		
		pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_OFF;

		LogDebugInfo(fp);
	
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_delNaptMapping(myIp);
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

		//ret=rtl8651_resetPppoeSessionProperty((uint32)pppObjId);
		ret=rtl8651_resetPppoeSessionProperty((uint32)0);
		if (ret)
		{
			printf("rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
		}

		//rtl8651_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
		#if 0
		ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
		if (ret)
		{
			printf("rtl8651_delRoute(default): ret %d\n",ret);
			fprintf(fp,"rtl8651_delRoute(default): ret %d\n",ret);
		}
		#endif

		ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}

		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
		
		/* have to delete the pppdx.pid file, asp_pppoe will check it */		
		//unlink("/var/run/pppd0.pid");
		
		//fprintf(fp,"pppoeManualHangupFlag[0]:%u\n",pppoeManualHangupFlag[0]);
		ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,FALSE,0);
		if(ret)
		{
			fprintf(fp,"disable auto hang up failed.\n");
		}
		
		/* check autoReconnect to see if a pppd_start() is needed */
		if (   (pRomeCfgParam->pppoeCfgParam[0].manualHangup==0)
		    && (pRomeCfgParam->pppoeCfgParam[0].autoReconnect==1)
		   )
		{			
			fprintf(fp,"do pppd_start() due to autoreconnect\n");
			pppd_start(0);
		}
	}
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
	{
		/* multiple pppoe hangup case */
		
		rtl8651a_setWanStatus(pppObjId,FALSE);
		pRomeCfgParam->pppoeCfgParam[pppObjId].dialState = PPPOECFGPARAM_DIALSTATE_OFF;
		
		printf("pppoeCfgParam[%u].ipAddr: %u.%u.%u.%u\n"
			,pppObjId
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[3]);

		fprintf(fp,"pppoeCfgParam[%u].ipAddr: %u.%u.%u.%u\n"
			,pppObjId			
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr[3]);

		printf("pppoeCfgParam[%u].ipMask: %u.%u.%u.%u\n"
			,pppObjId
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[3]);

		fprintf(fp,"pppoeCfgParam[%u].ipMask: %u.%u.%u.%u\n"
			,pppObjId
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask[3]);

		printf("pppoeCfgParam[%u].gwAddr: %u.%u.%u.%u\n"
			,pppObjId
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[3]);

		fprintf(fp,"pppoeCfgParam[%u].gwAddr: %u.%u.%u.%u\n"
			,pppObjId
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr[3]);

		printf("pppoeCfgParam[%u].dnsAddr: %u.%u.%u.%u\n"
			,pppObjId
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[3]);

		fprintf(fp,"pppoeCfgParam[%u].dnsAddr: %u.%u.%u.%u\n"
			,pppObjId
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[0]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[1]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[2]
			,pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr[3]);
				
		memcpy((void*)&myIp,pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask,4);
		
		pppoeCfgPtr.defaultSession=pRomeCfgParam->pppoeCfgParam[pppObjId].defaultSession;	
		memcpy(&pppoeCfgPtr.ipAddr,(void*)&myIp,4);
		memcpy(&pppoeCfgPtr.ipMask,(void*)&myIpMask,4);
		memcpy(&pppoeCfgPtr.gwAddr,(void*)&pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr,4);
		memcpy(&(pppoeCfgPtr.lanType),&(pRomeCfgParam->pppoeCfgParam[pppObjId].lanType),4);
		re865xIoctl("eth0",PPPOEDOWN_CFG,(uint32)&pppoeCfgPtr,pppObjId,0);

		ret=0;
		if (pRomeCfgParam->pppoeCfgParam[pppObjId].defaultSession==1)
		{
		//	ret=rtl8651_delNaptMapping(myIp);
			if (ret)
			{
				printf("rtl8651_delNaptMapping: ret %d\n",ret);
				fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
			}
		}
		else
		{

//			ipaddr_t localHostIp;
//			memcpy((void*)&localHostIp,pRomeCfgParam->pppoeCfgParam[pppObjId].localHostIp,4);
	//		ret=rtl8651_delNaptMapping(myIp);
	//		ret=rtl8651_delRoute((ipaddr_t)myIp,(ipaddr_t)0xffffffff);
	//		rtl8651_flushPolicyRoute(myIp);
			if (ret)
			{
				printf("rtl8651_delRoute: ret %d\n",ret);
				fprintf(fp,"rtl8651_delRoute: ret %d\n",ret);
			}

#if 0
			ret=rtl8651_delNatMapping(myIp,localHostIp);
			if (ret)
			{
				printf("rtl8651_delNatMapping: ret %d\n",ret);
				fprintf(fp,"rtl8651_delNatMapping: ret %d\n",ret);
			}
#endif
		}

	//	ret=rtl8651_resetPppoeSessionProperty((uint32)pppObjId);
		if (ret)
		{
			printf("rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
		}

		if (pRomeCfgParam->pppoeCfgParam[pppObjId].defaultSession==1)
		{
			//rtl8651_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
			#if 0			
			ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
			if (ret)
			{
				printf("rtl8651_delRoute(default): ret %d\n",ret);
				fprintf(fp,"rtl8651_delRoute(default): ret %d\n",ret);
			}
			#endif
		}

	//	ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}

		#if 0
		/* pick another up session and set default route to it */
		{ /* emily */
			for (i=0; i<MAX_PPPOE_SESSION;i++){
				if (pRomeCfgParam->pppoeCfgParam[i].dialState == PPPOECFGPARAM_DIALSTATE_DIALED_SUCCESS){
					ret=rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,"eth0",0);
					if (ret){
						printf("rtl8651_addRoute(default): ret %d\n",ret);
						fprintf(fp,"rtl8651_addRoute(default): ret %d\n",ret);
					}
				}
			}
		}
		#endif
		
		i=0;			
		memcpy(pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr,&i,4);
		memcpy(pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask,&i,4);
		memcpy(pRomeCfgParam->pppoeCfgParam[pppObjId].gwAddr,&i,4);
		memcpy(pRomeCfgParam->pppoeCfgParam[pppObjId].dnsAddr,&i,4);

		{
			//uint8 fname[20];
			uint32 whichPppObjId=pRomeCfgParam->pppoeCfgParam[0].whichPppObjId;
			//sprintf(fname,"/var/run/pppd%u.pid",whichPppObjId);
			//unlink(fname);
			
			ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,whichPppObjId,FALSE,0);
			if(ret)
			{
				fprintf(fp,"disable auto hang up session%d failed.\n",whichPppObjId);
			}
		
			/* check autoReconnect to see if a pppd_start() is needed */
			if (   (pRomeCfgParam->pppoeCfgParam[whichPppObjId].manualHangup==0)
			    && (pRomeCfgParam->pppoeCfgParam[whichPppObjId].autoReconnect==1)
			   )
				pppd_start(whichPppObjId);
		}
	}		
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED)
	{
		/* ip unnumbered pppoe hangup case */
		rtl8651a_setWanStatus(0,FALSE);
		pRomeCfgParam->pppoeCfgParam[0].dialState = PPPOECFGPARAM_DIALSTATE_OFF;
		
		LogDebugInfo(fp);
		
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_delNaptMapping(myIp);
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

		//ret=rtl8651_resetPppoeSessionProperty((uint32)pppObjId);
		ret=rtl8651_resetPppoeSessionProperty((uint32)0);
		if (ret)
		{
			printf("rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_resetPppoeSessionProperty: ret %d\n",ret);
		}

		memcpy((void*)&myIpMask,pRomeCfgParam->pppoeCfgParam[0].unnumberedIpMask,4);
		ret=rtl8651_setLanSideExternalIpInterface("eth1",myIp,(ipaddr_t)myIpMask,0/*isExternal:false*/);
		if (ret)
		{
			printf("rtl8651_setLanSideExternalIpInterface: ret %d\n",ret);
			fprintf(fp,"rtl8651_setLanSideExternalIpInterface: ret %d\n",ret);
		}


		/*   2005.3.8
		  *   Delete the host route which is corresponding to the originally dialed-up PPPoE session.
		  */
		ret = rtl8651_delRoute(myIp, 0xffffffff);
		if (ret) {
			printf("rtl8651_delRoute(host route): ret %d\n", ret);
			fprintf(fp, "rtl8651_delRoute(host route): ret %d\n", ret);
		}

		
		//rtl8651_delRoute(ipaddr_t ipAddr, ipaddr_t ipMask);
		#if 0
		ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
		if (ret)
		{
			printf("rtl8651_delRoute(default): ret %d\n",ret);
			fprintf(fp,"rtl8651_delRoute(default): ret %d\n",ret);
		}
		#endif

		#if 0
		ret=rtl8651_delIpIntf("eth1",myIp,myIpMask);
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}
		#endif

#if 0
		/* Delete the policy route which is added in board_ipUp_unnumberedPppoe(). */
		ret = rtl8651_flushPolicyRoute(myIp);
		if(ret != SUCCESS) {
			printf("flushPolicyRoute failed -- ret: %d\n", ret);
			return NOT_OK;
		}
#endif



		
		/* set global ip address to lan side as ip alias */
		{
			int 	ipValue;
			char	*av[5];
			char	*ip_string;
			char	*ipmask_string;
			char	pname[]="/bin/ifconfig";

			ip_string     = malloc(MAX_IP_STRING_LEN);
			ipmask_string = malloc(MAX_IP_STRING_LEN);
			memcpy(&ipValue,pRomeCfgParam->pppoeCfgParam[0].unnumberedIpAddr,4);
			sprintf(ip_string,"%u.%u.%u.%u",(ipValue>>24)&0xff, (ipValue>>16)&0xff, (ipValue>>8)&0xff, ipValue&0xff);
			memcpy(&ipValue,pRomeCfgParam->pppoeCfgParam[0].unnumberedIpMask,4);
			sprintf(ipmask_string,"%u.%u.%u.%u",(ipValue>>24)&0xff, (ipValue>>16)&0xff, (ipValue>>8)&0xff, ipValue&0xff);
			
			av[0]=pname;
			av[1]="eth1:1";
			av[2]=ip_string;
			av[3]="netmask";
			av[4]=ipmask_string;
			av[5]=NULL;
			runProgram(pname,av);
			free(ip_string);
			free(ipmask_string);
		}

		/* delete global assigned network route to user protocol stack */
		{
			char *argv[6];
			uint8 networkRoute[4];
			uint8 netStr[20];
			uint8 netmaskStr[20];
		
			memcpy((void*)networkRoute,(void*)pRomeCfgParam->ifCfgParam[0].ipAddr,4);
			for (i=0;i<4;i++)
				networkRoute[i] &= pRomeCfgParam->ifCfgParam[0].ipMask[i];
				
			argv[0]="-net";
			
			sprintf(netStr,"%u.%u.%u.%u",
				networkRoute[0],
				networkRoute[1],
				networkRoute[2],
				networkRoute[3]);
			argv[1]=netStr;
			
			argv[2]="netmask";
			
			sprintf(netmaskStr,"%u.%u.%u.%u",
				pRomeCfgParam->ifCfgParam[0].ipMask[0],
				pRomeCfgParam->ifCfgParam[0].ipMask[1],
				pRomeCfgParam->ifCfgParam[0].ipMask[2],
				pRomeCfgParam->ifCfgParam[0].ipMask[3]);
			argv[3]=netmaskStr;
			
			argv[4]="eth1";
			argv[5]=NULL;
								
			INET_setroute(RTACTION_DEL, 0, argv);
		} /* end block delete user protocol stack network route */

		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);


		/* have to delete the pppdx.pid file, asp_pppoe will check it */		
		//unlink("/var/run/pppd0.pid");

		//disable idle timeout
		ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,FALSE,0);
		if(ret)
		{
			fprintf(fp,"disable auto hang up failed.\n");
		}		

		/* check autoReconnect to see if a pppd_start() is needed */
		if (   (pRomeCfgParam->pppoeCfgParam[0].manualHangup==0)
		    && (pRomeCfgParam->pppoeCfgParam[0].autoReconnect==1)
		   )
			pppd_start(0);
		
	}
#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
	else if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_PPTP)
	{
		/* single pppoe hangup case */
		rtl8651a_setWanStatus(0,FALSE);		
		pRomeCfgParam->pptpCfgParam.dialState = PPTPCFGPARAM_DIALSTATE_DISCONNECTING;

		LogDebugInfo(fp);
		
		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_resetPptpProperty(1);
		if (ret)
		{
			printf("rtl8651_resetPptpProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_resetPptpProperty: ret %d\n",ret);
		}

		system("/sbin/ifconfig ppp0 down");

		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);
		
		/* have to delete the pppdx.pid file, asp_pppoe will check it */		
		//unlink("/var/run/pppd0.pid");
		
		//fprintf(fp,"pppoeManualHangupFlag[0]:%u\n",pppoeManualHangupFlag[0]);
		ret=rtl8651_delNaptMapping(myIp);		
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

	
		ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);		
		if (ret)
		{
			printf("rtl8651_delIpIntf: ret %d\n",ret);
			fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
		}
		
		ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,FALSE,0);
		if(ret)
		{
			fprintf(fp,"disable auto hang up failed.\n");
		}	
		
		/* check autoReconnect to see if a pppd_start() is needed */
		if (   (pRomeCfgParam->pptpCfgParam.manualHangup==0)
		    && (pRomeCfgParam->pptpCfgParam.autoReconnect==1)
		   )
		{			
			fprintf(fp,"do pppd_start() due to autoreconnect\n");
			pptp_start(0);			
		}
	}	
	else if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_L2TP)||
		    (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP))
	{	
		if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)&&
			(pRomeCfgParam->l2tpCfgParam.dialState==L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER))
			{
				fprintf(fp,"DHCP IP-Down\n");
				fclose(fp);
				//pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_OFF;
				rtl8651_sem_post(SEMAPHORE_IPEVENT);
				return 0;
			}

		fprintf(fp,"L2TP IP-Down\n");
		
		pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;

		rtl8651a_setWanStatus(0,FALSE);
		//pRomeCfgParam->l2tpCfgParam.dialState = L2TPCFGPARAM_DIALSTATE_OFF;

		LogDebugInfo(fp);

		memcpy((void*)&myIp,pRomeCfgParam->ifCfgParam[0].ipAddr,4);
		memcpy((void*)&myIpMask,pRomeCfgParam->ifCfgParam[0].ipMask,4);

		ret=rtl8651_resetL2tpProperty(1);
		if (ret)
		{
			printf("rtl8651_resetL2tpProperty: ret %d\n",ret);
			fprintf(fp,"rtl8651_resetL2tpProperty: ret %d\n",ret);
		}



		
		/* have to delete the pppdx.pid file, asp_pppoe will check it */		
		
		//fprintf(fp,"pppoeManualHangupFlag[0]:%u\n",pppoeManualHangupFlag[0]);

#if 0
		/* rtl8651_delRoute() rtl8651_delNaptMapping() rtl8651_delIpIntf() by DEL_VLAN_IP */
		re865xIoctl("eth0",DEL_VLAN_IP,0,0,0);
#else
		ret=rtl8651_delNaptMapping(myIp);
		if (ret)
		{
			printf("rtl8651_delNaptMapping: ret %d\n",ret);
			fprintf(fp,"rtl8651_delNaptMapping: ret %d\n",ret);
		}

		if (pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP)
		{		
			ipaddr_t myGw=0,myDns=0;

			ret=rtl8651_delRoute((ipaddr_t)0,(ipaddr_t)0);
			if(ret)
			{
				printf("rtl8651_delRoute: ret %d\n",ret);
				fprintf(fp,"rtl8651_delRoute: ret %d\n",ret);		
			}

			ret=rtl8651_delExtNetworkInterface((int8*)"eth0");
			if (ret)
			{
				printf("rtl8651_delExtNetworkInterface: ret %d\n",ret);
				fprintf(fp,"rtl8651_delExtNetworkInterface: ret %d\n",ret);
			}
			
			ret=rtl8651_delSession(1); 
			if (ret)
			{
				printf("rtl8651_delSession: ret %d\n",ret);
				fprintf(fp,"rtl8651_delSession: ret %d\n",ret);
			}

			ret=rtl8651_delIpIntf("eth0",*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)));
			if (ret)
			{
				printf("rtl8651_delIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delIpIntf: %x %x ret %d\n",*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipAddr)),*(uint32*)(&(pRomeCfgParam->l2tpCfgParam.ipMask)),ret);
			}
		
			ret=rtl8651_delIpIntf("eth0", myIp, myIpMask);
			if (ret)
			{
				printf("rtl8651_delIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);			
			}

			ret=rtl8651_removeNetworkIntfLinkLayerType("eth0");
			if (ret)
			{
				printf("rtl8651_removeNetworkIntfLinkLayerType: ret %d\n",ret);
				fprintf(fp,"rtl8651_removeNetworkIntfLinkLayerType: ret %d\n",ret);
			}

			ret=rtl8651_delNetworkIntf("eth0");	
			if(ret)
			{
				printf("rtl8651_delNetworkIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delNetworkIntf: ret %d\n",ret);				
			}		
		

			pRomeCfgParam->l2tpCfgParam.dialState=L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER;

			setInterfaceIp("eth0",0,0);
		}
		else
		{
			ret=rtl8651_delIpIntf("eth0",myIp,myIpMask);
			if (ret)
			{
				printf("rtl8651_delIpIntf: ret %d\n",ret);
				fprintf(fp,"rtl8651_delIpIntf: ret %d\n",ret);
			}
		}
	
		system("/sbin/ifconfig ppp0 down");

		i=0;
		memcpy(pRomeCfgParam->ifCfgParam[0].ipAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].ipMask,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].gwAddr,&i,4);
		memcpy(pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,&i,4);

		unlink("/var/run/pppd0.pid");
		unlink("/var/run/l2tpd.pid");
		
		
#endif		

		//disable idle timeout
		ret=re865xIoctl("eth0",SET_PPPD_IDLE_TIME,0,FALSE,0);
		if(ret)
		{
			fprintf(fp,"disable auto hang up failed.\n");
		}	
		
		/* check autoReconnect to see if a pppd_start() is needed */
		if (   (pRomeCfgParam->l2tpCfgParam.manualHangup==0)
		    && (pRomeCfgParam->l2tpCfgParam.autoReconnect==1)
		   )
		{			
			fprintf(fp,"do l2tp_start() due to autoreconnect\n");
			l2tp_start(0);
		}
	}

#endif	
	/////////////////////
	/* end if pRomeCfgParam->ifCfgParam[0].connType */

	
	/*
	 *   Protocol-Based NAT
	 */
	{
		switch(pRomeCfgParam->ifCfgParam[0].connType)
		{
			case IFCFGPARAM_CONNTYPE_STATIC:
				/* do nothing */
				break;
			case IFCFGPARAM_CONNTYPE_DHCPC: /* fall through */
			case IFCFGPARAM_CONNTYPE_PPTP:  /* fall through */
			case IFCFGPARAM_CONNTYPE_L2TP:  /* fall through */
			case IFCFGPARAM_CONNTYPE_PPPOE: /* fall through */
			case IFCFGPARAM_CONNTYPE_DHCPL2TP: /* fall through */
			case IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED:
				pbnat_ipdown( 0, myIp );
				break;
			case IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE:
				pbnat_ipdown( pppObjId, myIp );
				break;
			default:
				break;
		}
	
	} /* end of pbnat */

	/* domain setting: its used only for DHCP related wan-type */
	if ((pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPC) ||
		(pRomeCfgParam->ifCfgParam[0].connType == IFCFGPARAM_CONNTYPE_DHCPL2TP))
	{
		if (pRomeCfgParam->dhcpsCfgParam.dhcpDomainFwd == 1)
		{
			memset(pRomeCfgParam->dhcpsCfgParam.domain, 0, sizeof(pRomeCfgParam->dhcpsCfgParam.domain));
		}
	}


	/* wins server setting */
	{
		if (pRomeCfgParam->ifCfgParam[0].fwdWins == 1)
		{
			pRomeCfgParam->ifCfgParam[0].winsPrimaryAddr = 0;
			pRomeCfgParam->ifCfgParam[0].winsSecondaryAddr = 0;
		}
	}

	fclose(fp);

	if((pRomeCfgParam->ifCfgParam[0].connType!=IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)||
		((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)&&
		(pRomeCfgParam->pppoeCfgParam[pppObjId].defaultSession == 1)))
	{
		/* stop services */
		upnp_stop();
		snmp_stop();		
	}

	rtl8651_sem_post(SEMAPHORE_IPEVENT);

	return 0;
} /* end board_ipDownEventTableDriverAccess(void) */

#if 0
uint32 getRomeCfgParamPtr(romeCfgParam_t ** ptr)
{
	uint32 i;
	FILE * fp;
	fp = fopen("/var/romecfg.txt","r");
	if (!fp)
		return 1;
	fscanf(fp,"%x",&i);
	*ptr = (romeCfgParam_t *)i;
	return 0;
}
#endif

void AddDemandRoute(int pppObjId,int defaultSession)
{
	rtl8651_tblDrvDemandRoute_t tmpRt;
	int32  i;
	uint32 ip_start,ip_end;
	uint16 port_start,port_end;
	
	rtl8651_flushDemandRoute(pppObjId);
	
	if (defaultSession){
		memset(&tmpRt, 0, sizeof(tmpRt));
		tmpRt.type=TRIGGER_DSTIP;
		tmpRt.ip_start=0;
		tmpRt.ip_end=0xffffffff;
		rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		return;
	}

	if (pRomeCfgParam->pppoeCfgParam[pppObjId].lanType == PPPOECFGPARAM_LANTYPE_UNNUMBERED){
		ipaddr_t stub1,stub2;
		uint32 srcSubnet;
		memcpy(&stub1,pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpAddr,4);
		memcpy(&stub2,pRomeCfgParam->pppoeCfgParam[pppObjId].unnumberedIpMask,4);
		srcSubnet = (ipaddr_t)(stub1 & stub2);/* get subnet value */
		memset(&tmpRt, 0, sizeof(tmpRt));
		tmpRt.type=STATIC_POLICY_ROUTE|TRIGGER_SRCIP;
		tmpRt.ip_start=srcSubnet+1;
		tmpRt.ip_end=srcSubnet+(~stub2);
		rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
	}
	
	for (i=0;i<4;i++){
		if (pRomeCfgParam->pppoeCfgParam[pppObjId].destnetType[i] == PPPOECFGPARAM_DESTNETTYPE_IP){
			parse_ipRange(pRomeCfgParam->pppoeCfgParam[pppObjId].destnet[i],&ip_start,&ip_end);
			memset(&tmpRt, 0, sizeof(tmpRt));
			tmpRt.type=TRIGGER_DSTIP;
			tmpRt.ip_start=ip_start;
			tmpRt.ip_end=ip_end;
			rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		} else if (pRomeCfgParam->pppoeCfgParam[pppObjId].destnetType[i] == PPPOECFGPARAM_DESTNETTYPE_TCPPORT){
					parse_portRange(pRomeCfgParam->pppoeCfgParam[pppObjId].destnet[i], &port_start ,&port_end);
					memset(&tmpRt, 0, sizeof(tmpRt));
					tmpRt.type=TRIGGER_DSTTCPPORT;
					tmpRt.trigger.dport.start=port_start;
					tmpRt.trigger.dport.end=port_end;
					rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		} else if (pRomeCfgParam->pppoeCfgParam[pppObjId].destnetType[i] ==	PPPOECFGPARAM_DESTNETTYPE_UDPPORT){
			parse_portRange( pRomeCfgParam->pppoeCfgParam[pppObjId].destnet[i], &port_start ,&port_end);
			memset(&tmpRt, 0, sizeof(tmpRt));
			tmpRt.type=TRIGGER_DSTUDPPORT;
			tmpRt.trigger.dport.start=port_start;
			tmpRt.trigger.dport.end=port_end;
			rtl8651_addDemandRoute(&tmpRt,pppObjId,0);
		}
	}

}

/*
 * start pppd on specified pppObjId (0,1,...,MAX_PPPOE_SESSION-1)
 */
void pppd_start(uint32 identity)
{
	FILE * f1, * f2;
	//romeCfgParam_t * pRomeCfgParam;
	char    idStr[4];
	char    papStr[20];
	char    pppOptionStr[20];
	char    chapStr[20];
	uint8   tmp[160];

#ifdef __uClinux__ 
#else //MMU
	sprintf(tmp,"/var/run/pppd%d.pid",identity);
	send_signal(tmp,9);
	unlink(tmp);
#endif

#if 0
	if (getRomeCfgParamPtr(&pRomeCfgParam))
	{
		printf("pppd_start: getRomeCfgParamPtr failed\n");
		return;
	}
#endif

	if (pRomeCfgParam->pppoeCfgParam[identity].enable==0)
	{
		printf("pppoe session #%u disabled ... \n", identity);
		return;
	}

	f1 = fopen("/etc/ppp.options","r");
	if (!f1)
	{
		printf("pppd_start: fopen /etc/ppp.options failed\n");
		return;
	}

	if(pRomeCfgParam->pppoeCfgParam[identity].authType==PPPPARAM_AUTHTYPE_PAP)
	{			
		sprintf(papStr,"/var/ppp/pap%u",identity);
		f2 = fopen(papStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",papStr);
			return;
		}
		
		sprintf(tmp,"%s * %s" ,pRomeCfgParam->pppoeCfgParam[identity].username,pRomeCfgParam->pppoeCfgParam[identity].password);
		fputs(tmp,f2);
		fclose(f2);

		sprintf(chapStr,"/var/ppp/chap%u",identity);
		unlink(chapStr);
	}

	if(pRomeCfgParam->pppoeCfgParam[identity].authType==PPPPARAM_AUTHTYPE_CHAP)
	{
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		f2 = fopen(chapStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",chapStr);
			return;
		}
		sprintf(tmp,"\"%s\" * \"%s\" \"*\"\n" ,pRomeCfgParam->pppoeCfgParam[identity].username,pRomeCfgParam->pppoeCfgParam[identity].password);
		fputs(tmp,f2);
		
#ifdef CONFIG_RTL865XB_PPTPSERVER	
		if(identity==0)
		{
			sprintf(tmp,"\"%s\" pptpd \"%s\" \"*\"\n" ,pRomeCfgParam->pptpServerCfgParam.username,pRomeCfgParam->pptpServerCfgParam.password);
			fputs(tmp,f2);
		}
#endif
		
		
		fclose(f2);

		sprintf(papStr,"/var/ppp/pap%u",identity);
		unlink(papStr);
		
	}	

		
	sprintf(pppOptionStr,"/var/ppp/options%u",identity);
	f2 = fopen(pppOptionStr,"w+");
	while (!feof(f1))
	{
		fgets(tmp,160,f1);

		if (!memcmp(tmp,"mtu",3))
			sprintf(tmp,"mtu %d\n",pRomeCfgParam->pppoeCfgParam[identity].mtu);
		
		if (!memcmp(tmp,"user",4))
			sprintf(tmp,"user %s\n",pRomeCfgParam->pppoeCfgParam[identity].username);


		/* generate dial-on-demand option for pppd's reference */
		if(!memcmp(tmp,"service_name",12))
		{
			if (pRomeCfgParam->pppoeCfgParam[identity].serviceName[0])
			{
				sprintf(tmp,"service_name \"%s\"\n",pRomeCfgParam->pppoeCfgParam[identity].serviceName);		
			}
			else
			{
				sprintf(tmp,"\n");		
			}
		}		


		/* generate dial-on-demand option for pppd's reference */
		if(!memcmp(tmp,"ac_name",7))
		{
			if (pRomeCfgParam->pppoeCfgParam[identity].acName[0])
			{
				sprintf(tmp,"ac_name \"%s\"\n",pRomeCfgParam->pppoeCfgParam[identity].acName);		
			}
			else
			{
				sprintf(tmp,"\n");		
			}
		}


	/* generate nodefaultroute option for pppd's reference */
		if((!memcmp(tmp,"defaultroute",12))||(!memcmp(tmp,"nodefaultroute",14)))
		{			
			if ((pRomeCfgParam->pppoeCfgParam[identity].defaultSession!=1)&&(pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE))
				sprintf(tmp,"nodefaultroute\n");
			else
				sprintf(tmp,"defaultroute\n");
		}
		
		fputs(tmp,f2);
	}		
		
	fclose(f1);


	/* put requested ip in the option file
	 * option format: <local IP address>:<remote IP address>
	 */
	if (   pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_UNNUMBERED
		|| (    pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE
		     && pRomeCfgParam->pppoeCfgParam[identity].lanType==PPPOECFGPARAM_LANTYPE_UNNUMBERED
		   ) )
		fprintf(f2,"%u.%u.%u.%u:0.0.0.0\n",
			pRomeCfgParam->pppoeCfgParam[identity].unnumberedIpAddr[0],
			pRomeCfgParam->pppoeCfgParam[identity].unnumberedIpAddr[1],
			pRomeCfgParam->pppoeCfgParam[identity].unnumberedIpAddr[2],
			pRomeCfgParam->pppoeCfgParam[identity].unnumberedIpAddr[3]);
	
	/* generate idle option (auto disconnect) for pppd's reference */
//	fprintf(f2,"idle %u\n",pRomeCfgParam->pppoeCfgParam[identity].silentTimeout);

	fclose(f2);

	sprintf(idStr,"%u",identity);
	if (pRomeCfgParam->pppoeCfgParam[identity].demand==1)
	{   
		pRomeCfgParam->pppoeCfgParam[identity].dialState=PPPOECFGPARAM_DIALSTATE_DIALED_WAITING;

		if (pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_PPPOE_MULTIPLE_PPPOE)
			AddDemandRoute(identity,pRomeCfgParam->pppoeCfgParam[identity].defaultSession);
		else
			AddDemandRoute(identity,1);
		return ;
	}

	pRomeCfgParam->pppoeCfgParam[identity].dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;

#ifdef __uClinux__ // non-MMU
	sprintf(tmp,"/var/run/pppd%u.pid",identity);
	f2=fopen(tmp,"r");
	if(f2)
	{
		fclose(f2);
		send_signal(tmp,16); //restart pppd
	}
	else // run first time	
#endif	
	{
#ifdef CONFIG_PPP_MPPE_MPPC	
		run_pppoe(identity);
#else
		do_exec("/bin/pppd",idStr);
#endif
	}

} /* end pppd_start */


/*
 * called by asp_setpppoe() only now. the table driver cannot call this
 * function directly, so cannot install this function as a callback in
 * rtl8651_setPppoeSessionHangUp().
 * note: pppd_stop can only be called by user thru asp engine, so there
 *       manual hangup must be true !!
 */
int32 pppd_stop(uint32 pppObjId)
{
	uint8 tempStr[20];
	pppoeCfg_t	pppoeCfgPtr;
	
	/* set flag to record the Mannual hangup event */	
	pRomeCfgParam->pppoeCfgParam[pppObjId].manualHangup = 1;
	sprintf(tempStr,"/var/run/pppd%u.pid",pppObjId);
	pRomeCfgParam->pppoeCfgParam[pppObjId].dialState=PPPOECFGPARAM_DIALSTATE_OFF;	
	
	pppoeCfgPtr.defaultSession=pRomeCfgParam->pppoeCfgParam[pppObjId].defaultSession;	
	pppoeCfgPtr.sessionId=pRomeCfgParam->pppoeCfgParam[pppObjId].sessionId;
	memcpy((char*)&pppoeCfgPtr.ipAddr,(char*)&pRomeCfgParam->pppoeCfgParam[pppObjId].ipAddr,4);
	memcpy((char*)&pppoeCfgPtr.ipMask,(char*)&pRomeCfgParam->pppoeCfgParam[pppObjId].ipMask,4);
	memcpy(&(pppoeCfgPtr.lanType),&(pRomeCfgParam->pppoeCfgParam[pppObjId].lanType),4);

	/*   Case 'PPPOEDOWN_CFG' in 're_core.c' does not take 'unnumbered PPPoE' into account. 
	  *   The current code seems to do the corresponding action (ex. delNaptMapping....)
	  *   in 'asp_setPppoe()'.
	  */
	re865xIoctl("eth0",PPPOEDOWN_CFG,(uint32)&pppoeCfgPtr,pppObjId,0);
	
	//do_kill(tempStr);
	send_signal(tempStr,1); //Hang Up

	return 0;
} /* end pppd_stop */


#ifdef CONFIG_RTL865XB_PPTPSERVER
void pptpServer_start(void)
{
	
	send_signal("/var/run/pptpd.pid", 9);
	send_signal("/var/run/ppp.pid", 9);
	

	if(pRomeCfgParam->pptpServerCfgParam.status==1)
	{
		FILE *f;

		f=fopen("/proc/sys/net/ipv4/ip_forward","w");
		fprintf(f,"1");
		fclose(f);

		f=fopen("/var/ppp/chap0","w");
		
		fprintf(f,"\"%s\" * \"%s\" \"*\"\n" ,pRomeCfgParam->pppoeCfgParam[0].username,pRomeCfgParam->pppoeCfgParam[0].password);		
		fprintf(f,"\"%s\" pptpd \"%s\" \"*\"\n",pRomeCfgParam->pptpServerCfgParam.username,pRomeCfgParam->pptpServerCfgParam.password);

			
		fclose(f);

#if 0		
		f=fopen("/var/ppp/pap0","w");
		fprintf(f,"\"%s\" * \"%s\" \"*\"\n",pRomeCfgParam->pptpServerCfgParam.username,pRomeCfgParam->pptpServerCfgParam.password);
		fclose(f);
#endif		

		f=fopen("/var/pptpd.conf","w");

		fprintf(f,"option /etc/options.pptpd\n");
		fprintf(f,"#debug\n");	
		fprintf(f,"localip %u.%u.%u.%u\n",pRomeCfgParam->ifCfgParam[1].gwAddr[0]
			,pRomeCfgParam->ifCfgParam[1].gwAddr[1]+1
			,pRomeCfgParam->ifCfgParam[1].gwAddr[2]
			,pRomeCfgParam->ifCfgParam[1].gwAddr[3]);
		
		fprintf(f,"remoteip %u.%u.%u.%u-%u\n",pRomeCfgParam->ifCfgParam[1].gwAddr[0]
			,pRomeCfgParam->ifCfgParam[1].gwAddr[1]+1
			,pRomeCfgParam->ifCfgParam[1].gwAddr[2]
			,pRomeCfgParam->pptpServerCfgParam.range1
			,pRomeCfgParam->pptpServerCfgParam.range2);

		fclose(f);		
		system("/bin/pptpd");
		
		printf("pptpServer starting...\n");
	}
	else
	{
		printf("pptpServer stop...\n");
	}

}
#endif
	


#if defined(CONFIG_RTL865X_PPTPL2TP)||defined(CONFIG_RTL865XB_PPTPL2TP)
/*
 * start pptp 
 */
void pptp_start(uint32 identity)
{
	FILE * f1, * f2;
	//romeCfgParam_t * pRomeCfgParam;
	char    idStr[4];
	char    papStr[20];
	char    pppOptionStr[20];
	char    chapStr[20];
	uint8   tmp[160];

#ifdef __uClinux__ 
#else //MMU
//	sprintf(tmp,"/var/run/pptp.pid");
//	send_signal(tmp,9);
//	unlink(tmp);
//	unlink("/var/run/pppd0.pid");
	send_signal("/var/run/pptp.pid", 9);
	send_signal("/var/run/pppd0.pid", 15);
	unlink("/var/run/pptp.pid");
	unlink("/var/run/pppd0.pid");
#endif	

#if 0
	if (getRomeCfgParamPtr(&pRomeCfgParam))
	{
		printf("pppd_start: getRomeCfgParamPtr failed\n");
		return;
	}
#endif
	
	f1 = fopen("/etc/pptp.options","r");
	if (!f1)
	{
		printf("pppd_start: fopen /etc/pptp.options failed\n");
		return;
	}

	if(pRomeCfgParam->pptpCfgParam.authType==PPPPARAM_AUTHTYPE_PAP)	
	{		
		sprintf(papStr,"/var/ppp/pap%u",identity);
		f2 = fopen(papStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",papStr);
			return;
		}
		
		sprintf(tmp,"%s * %s\n" ,pRomeCfgParam->pptpCfgParam.username,pRomeCfgParam->pptpCfgParam.password);
		fputs(tmp,f2);
		fclose(f2);

		sprintf(chapStr,"/var/ppp/chap%u",identity);
		unlink(chapStr);
		
	}
	
	if(pRomeCfgParam->pptpCfgParam.authType==PPPPARAM_AUTHTYPE_CHAP)	
	{
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		f2 = fopen(chapStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",chapStr);
			return;
		}
		sprintf(tmp,"NTDOMAIN %s %s\n" ,pRomeCfgParam->pptpCfgParam.username,pRomeCfgParam->pptpCfgParam.password);
		fputs(tmp,f2);
		sprintf(tmp,"%s NTDOMAIN %s\n" ,pRomeCfgParam->pptpCfgParam.username,pRomeCfgParam->pptpCfgParam.password);
		fputs(tmp,f2);			
		fclose(f2);

		sprintf(papStr,"/var/ppp/pap%u",identity);
		unlink(papStr);
		
	}
			
	sprintf(pppOptionStr,"/var/ppp/options%u",identity);
	f2 = fopen(pppOptionStr,"w+");
	while (!feof(f1))
	{
		fgets(tmp,160,f1);
		fputs(tmp,f2);
	}			
	fclose(f1);
	
	sprintf(tmp,"mtu %d mru %d\n",pRomeCfgParam->pptpCfgParam.mtu,pRomeCfgParam->pptpCfgParam.mtu);
	fputs(tmp,f2);	
	sprintf(tmp,"name %s\n",pRomeCfgParam->pptpCfgParam.username);	
	fputs(tmp,f2);
	
	fputs("remotename NTDOMAIN\n",f2);
	
	/* generate idle option (auto disconnect) for pppd's reference */
	fprintf(f2,"idle %u\n",pRomeCfgParam->pptpCfgParam.silentTimeout);

	fprintf(f2,"defaultroute\n");
		
	fclose(f2);

	rtl8651_setNetMtu("eth0",pRomeCfgParam->pptpCfgParam.mtu);

	if (pRomeCfgParam->pptpCfgParam.demand==1)
	{
		pRomeCfgParam->pptpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_WAITING;
		printf("Add Demand Route\n");
		AddDemandRoute(4,1); // 4: used for signal 44.		
	}
	else
	{
		pRomeCfgParam->pptpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;


	/* set auto redial options */
	f1 = fopen("/var/run/pptp_redial", "w");
	if (f1)
	{
		fprintf(f1, "%d", pRomeCfgParam->pptpCfgParam.autoReconnect?1:0);
		fclose(f1);
	}
	

		//sprintf(tempStr,"/bin/pptp %u.%u.%u.%u file /var/ppp/options0 &"
#ifdef __uClinux__		
		f2=fopen("/var/run/pptp.pid","r");
		if(f2)
		{		
			fclose(f2);
			send_signal("/var/run/pptp.pid",SIGUSR2);
		}
		else
#endif			
		{
			sprintf(tmp,"/bin/pptp %u.%u.%u.%u &"
			,pRomeCfgParam->pptpCfgParam.svAddr[0]
			,pRomeCfgParam->pptpCfgParam.svAddr[1]
			,pRomeCfgParam->pptpCfgParam.svAddr[2]
			,pRomeCfgParam->pptpCfgParam.svAddr[3]);
			system(tmp);
		}

		
	}
} /* end pptp_start */


/*
 * start pptp 
 */
void l2tp_start(uint32 identity)
{
	FILE * f1, * f2;
	//romeCfgParam_t * pRomeCfgParam;
	char    idStr[4];
	char    papStr[20];
	char    pppOptionStr[20];
	char    chapStr[20];
	char	tmp[160];


	if((pRomeCfgParam->ifCfgParam[0].connType==IFCFGPARAM_CONNTYPE_DHCPL2TP)&&
		(pRomeCfgParam->l2tpCfgParam.dialState==L2TPCFGPARAM_DIALSTATE_DIALED_DHCP_DISCOVER))
	{
		udhcpc_start();	
		return;
	}
	
#ifdef __uClinux__ 
#else //MMU
	sprintf(tmp,"/var/run/l2tpd.pid");
	send_signal(tmp,9);
	unlink(tmp);
	unlink("/var/run/pppd0.pid");

#endif	

#if 0
	if (getRomeCfgParamPtr(&pRomeCfgParam))
	{
		printf("pppd_start: getRomeCfgParamPtr failed\n");
		return;
	}
#endif
	
	f1 = fopen("/etc/l2tp.options","r");
	if (!f1)
	{
		printf("pppd_start: fopen /etc/l2tp.options failed\n");
		return;
	}

	if(pRomeCfgParam->l2tpCfgParam.authType==PPPPARAM_AUTHTYPE_PAP)	
	{			
		sprintf(papStr,"/var/ppp/pap%u",identity);
		f2 = fopen(papStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",papStr);
			return;
		}
		
		sprintf(tmp,"%s * %s\n" ,pRomeCfgParam->l2tpCfgParam.username,pRomeCfgParam->l2tpCfgParam.password);
		fputs(tmp,f2);
		fclose(f2);
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		unlink(chapStr);
	}	

	if(pRomeCfgParam->l2tpCfgParam.authType==PPPPARAM_AUTHTYPE_CHAP)
	{				
		sprintf(chapStr,"/var/ppp/chap%u",identity);
		f2 = fopen(chapStr,"w+");
		if (!f2)
		{
			printf("pppd_start: fopen %s failed\n",chapStr);
			return;
		}
		sprintf(tmp,"NTDOMAIN %s %s\n" ,pRomeCfgParam->l2tpCfgParam.username,pRomeCfgParam->l2tpCfgParam.password);
		fputs(tmp,f2);
		sprintf(tmp,"%s NTDOMAIN %s\n" ,pRomeCfgParam->l2tpCfgParam.username,pRomeCfgParam->l2tpCfgParam.password);
		fputs(tmp,f2);	
		fclose(f2);
		sprintf(papStr,"/var/ppp/pap%u",identity);
		unlink(papStr);
	}			
	sprintf(pppOptionStr,"/var/ppp/options%u",identity);
	f2 = fopen(pppOptionStr,"w+");
	while (!feof(f1))
	{
		fgets(tmp,160,f1);
		fputs(tmp,f2);
	}			
	fclose(f1);
	
	sprintf(tmp,"mtu %d mru %d\n",pRomeCfgParam->l2tpCfgParam.mtu,pRomeCfgParam->l2tpCfgParam.mtu);
	fputs(tmp,f2);	
	sprintf(tmp,"name %s\n",pRomeCfgParam->l2tpCfgParam.username);	
	fputs(tmp,f2);
	
	fputs("remotename NTDOMAIN\n",f2);
	
	/* generate idle option (auto disconnect) for pppd's reference */
	fprintf(f2,"idle %u\n",pRomeCfgParam->l2tpCfgParam.silentTimeout);

	fprintf(f2,"defaultroute\n");
		
	fclose(f2);

	// L2TP configuration file
	f2 = fopen("/var/l2tpd.conf","w+");
	fprintf(f2,"[lac test]\n");
	fprintf(f2,"lns=%u.%u.%u.%u\n",pRomeCfgParam->l2tpCfgParam.svAddr[0],pRomeCfgParam->l2tpCfgParam.svAddr[1],pRomeCfgParam->l2tpCfgParam.svAddr[2],pRomeCfgParam->l2tpCfgParam.svAddr[3]);
	fprintf(f2,"pppoptfile = /etc/config/l2tpd-pppd.conf\n");
	fprintf(f2,"length bit = yes\n");	
	fprintf(f2,"redial = no\n");
//	fprintf(f2,"redial timeout = 15\n");
	fprintf(f2,"autodial = yes\n");
	fclose(f2);

	// L2TP PPPD conifguration file
	f2 = fopen("/var/l2tpd-pppd.conf","w+");
	fprintf(f2,"user %s\n",pRomeCfgParam->l2tpCfgParam.username);
	fprintf(f2,"asyncmap 0\n");
	fprintf(f2,"noauth\n");
	fprintf(f2,"defaultroute\n");
	fprintf(f2,"mru %d\nmtu %d\n",pRomeCfgParam->l2tpCfgParam.mtu,pRomeCfgParam->l2tpCfgParam.mtu);
	fclose(f2);	

	rtl8651_setNetMtu("eth0",pRomeCfgParam->l2tpCfgParam.mtu);

	if (pRomeCfgParam->l2tpCfgParam.demand==1)
	{
		pRomeCfgParam->l2tpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_WAITING;
		AddDemandRoute(5,1); //used for signal 45
	}
	else
	{
		pRomeCfgParam->l2tpCfgParam.dialState=PPPOECFGPARAM_DIALSTATE_DIALED_TRYING;
#ifdef __uClinux__
		f2=fopen("/var/run/l2tpd.pid","r");
		if(f2)
		{		
			fclose(f2);
			send_signal("/var/run/l2tpd.pid",SIGUSR2);
		}		
		else
#endif			
		{
			sprintf(tmp,"/bin/l2tpd &");		
			system(tmp);
		}
		
	}
} /* end pptp_start */
#endif


void syslogd_start()
{
	send_signal("/var/run/syslogd.pid",9);
	send_signal("/var/run/klogd.pid",9);	
	if(pRomeCfgParam->logCfgParam[0].module&RTL8651_LOGMODULE_SYS)
	{
		rtl8651a_enableLogging(0,RTL8651_LOGMODULE_SYS,1);
		system("/bin/syslogd &");
		system("/bin/klogd &");
	}	
}

/* DNS Proxy*/
void runDNSProxy()
{
	char	pname[]="/bin/dnrd";
	ipaddr_t	ipAddr = 0;
	int		boundIP = 0;
	FILE *	f = NULL;
	int		pid = 0;

	// fill server list config file
	f = fopen("/var/run/dnrd.serv", "w");
	if (f == NULL)
	{
		printf("Can NOT set server list of DNRD daemon, exit.\n");
		return;
	}

	/* record primary DNS server */
	memcpy((void*)&ipAddr,(void*)&pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr,
			sizeof(ipaddr_t));

	if (ipAddr)
	{
		fprintf(f,"%u.%u.%u.%u\n", pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[0]
								, pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[1]
								, pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[2]
								, pRomeCfgParam->ifCfgParam[0].dnsPrimaryAddr[3]);
	}

	/* record secondary DNS server */
	memcpy((void*)&ipAddr,(void*)&pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr,
			sizeof(ipAddr));

	if (ipAddr)
	{
		fprintf(f,"%u.%u.%u.%u\n", pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[0]
								, pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[1]
								, pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[2]
								, pRomeCfgParam->ifCfgParam[0].dnsSecondaryAddr[3]);
	}

	/* close server file */
	fclose(f);

	f = fopen("/var/run/dnrd.pid","r");
	if (!f)
	{
		goto forkNew;
	}

	fscanf(f, "%d", &pid);

	/* remove exist process */
	kill(pid, 9);
	fclose(f);
	unlink("/var/run/dnrd.pid");

forkNew:
	{
		char tmp[32];
		sprintf(tmp,"%s &", pname);
		system(tmp);
	}
	return;
}
char *mgmtUserName()
{

	return (char*)&pRomeCfgParam->mgmtCfgParam[0].name;
}
char *mgmtPassword()
{
	return (char*)&pRomeCfgParam->mgmtCfgParam[0].password;
}
#ifndef __uClinux__
int  rtl865x_mmap(int base,int length) // for flash , register mapping
{
	int sg_fd;
	int new_base;
	if ((sg_fd = open("/dev/mem", O_RDWR)) < 0) 
	       printf("open fail\n");
    	new_base = mmap((void*)0x0, length, PROT_READ | PROT_WRITE | PROT_EXEC, MAP_SHARED, sg_fd, base);
	close(sg_fd);
	if (new_base==MAP_FAILED)
	{
		fprintf(stderr,"MAP FAIL\n");
		return 0;	
	}
	return new_base;
}

int  rtl865x_kmmap(int base,int length) //for kmalloc mapping
{
	int sg_fd;
	int new_base;
	if ((sg_fd = open("/dev/node1", O_RDWR)) < 0) 
	       printf("open fail\n");
    	new_base = mmap((void*)0x0, length, PROT_READ | PROT_WRITE | PROT_EXEC, MAP_SHARED, sg_fd, base);
	close(sg_fd);
	if (new_base==MAP_FAILED)
	{
		fprintf(stderr,"MAP FAIL\n");
		return 0;	
	}
	return new_base;
}

#endif
/* end board.c */
